{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 16384,0,655360}
Program Atari_2600_Emulator (Input,Output);
Uses
  Crt,
  Dos,
  HexWrite,
  Keyboard,
  AtariDbg,
  TIASound,
  MouseX,
  Time,
  SPUnit,
  Profile,
  GameStat,
  AtariMnu,
  AtariDis,
  Controls,
  Equation,
  Objects,
  G320,
  HandTIA,
  WriteAVI,
  Strings,
  INI,
  VGAGUI;

Const
  TIAClockRate = 262 * 60 * 228;  { 3584160 Hz }
(*
  Player1Fire    : Byte = 1;
  JoystickReset  : Byte = 2;   { Also Booster-Grip button 1 }
  Player2Fire    : Byte = 4;
  JoystickSelect : Byte = 8;   { Also Booster-Grip button 2 }
*)
  M0BugMove : Array[0..3] Of Word = (15,15,16,14);
  PadMax = 800;
{  playback_freq : Word = 31400;}
  sample_freq   : Word = 31400;
{  num_bufs      : Word = 2;}
  SoundBufSize  : Word = 4096;   { Default buffer size = 4k }

  SC_INDEX      = $3C4;   { Sequence Controller Index register   }
  GC_INDEX      = $3CE;   { Graphics Controller Index register   }
  CRTC_INDEX    = $3D4;   { CRT Controller Index register        }
  MISCELLANEOUS = 6;      { Moscellaneous register index in GC   }
  MEMORY_MODE   = 4;      { Memory Mode register index in SC     }
  GRAPHICS_MODE = 5;      { Graphics Mode register index in GC   }
  MAX_SCAN_LINE = 9;      { Maximum Scan Line reg index in CRTC  }
  UNDERLINE     = $14;    { Underline Location reg index in CRTC }
  MODE_CONTROL  = $17;    { Mode Control register index in CRTC  }
  MAP_MASK      = 2;      { Map Mask register index in SC        }

  HORZ_TOTAL         = 0; { CRTC registers }
  HORZ_DISPLAY_END   = 1;
  START_HORZ_BLANK   = 2;
  END_HORZ_BLANK     = 3;
  START_HORZ_RETRACE = 4;
  END_HORZ_RETRACE   = 5;
  VERT_TOTAL         = 6;
  OVERFLOW           = 7;
  START_VERT_RETRACE = $10;
  END_VERT_RETRACE   = $11;
  VERT_DISPLAY_END   = $12;
  CRTC_OFFSET        = $13;
  START_VERT_BLANK   = $15;
  END_VERT_BLANK     = $16;

  Version        = '2.5';
  Passes         = 50;
  SetLocDelay    = 5;
  Read_Delay     = 12500;
  ConfigFile     = 'PCAE.CFG';
  SBPort         = $220;
  SBInt          = 7;
  SBDMA          = 1;
  FMChip         = $388;
  SoundDiv       = 5.9;
  MaxScan        : Integer = 250;
(*
  FMDiv : Array[0..15] Of Word =
{   (1,1,15,1,2,2,31,2,1,1,31,1,6,6,93,6);}
{   (50,1,15,1,2,2,31,2,1,1,31,1,6,6,93,6);}
    (1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1);
*)
  PFDelay : Array[0..3] Of Byte = (5,2,3,4);
(*
  Coeff : Array[0..15] Of Word =
{   (0,13,120,32,2,2,62,62,1,62,69,0,6,6,186,64);}
{   (0,13,120,32,2,2,31,62,1,62,69,0,6,6,186,64);}
{   (0,13,8,32,1,1,1,31,1,62,2,0,1,1,2,11);}


{   (0,13,8,32,1,1,1,31,1,62,1,0,1,1,1,11);}

{   (1,13,8,32,1,1,1,31,1,62,1,0,1,1,1,11);}
    (1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1);
*)
  { TIA write registers }

  VSYNC   = 0;
  VBLANK  = 1;
  WSYNC   = 2;
  RSYNC   = 3;
  NUSIZ0  = 4;
  NUSIZ1  = 5;
  COLUP0  = 6;
  COLUP1  = 7;
  COLUPF  = 8;
  COLUBK  = 9;
  CTRLPF  = $0A;
  REFP0   = $0B;
  REFP1   = $0C;
  PF0     = $0D;
  PF1     = $0E;
  PF2     = $0F;
  RESP0   = $10;
  RESP1   = $11;
  RESM0   = $12;
  RESM1   = $13;
  RESBL   = $14;
  AUDC0   = $15;
  AUDC1   = $16;
  AUDF0   = $17;
  AUDF1   = $18;
  AUDV0   = $19;
  AUDV1   = $1A;
  GRP0    = $1B;
  GRP1    = $1C;
  ENAM0   = $1D;
  ENAM1   = $1E;
  ENABL   = $1F;
  HMP0    = $20;
  HMP1    = $21;
  HMM0    = $22;
  HMM1    = $23;
  HMBL    = $24;
  VDELP0  = $25;
  VDELP1  = $26;
  VDELBL  = $27;
  RESMP0  = $28;
  RESMP1  = $29;
  HMOVE   = $2A;
  HMCLR   = $2B;
  CXCLR   = $2C;
  SWCHA1  = $280;
  SWACNT1 = $281;
  SWCHB1  = $282;
  SWBCNT1 = $283;
  INTTIM1 = $284;
  INTTIM3 = $285;
  TIM1T1  = $294;
  TIM2T1  = $295;
  TIM3T1  = $296;
  TIM4T1  = $297;
  SWCHA2  = $380;
  SWACNT2 = $381;
  SWCHB2  = $382;
  SWBCNT2 = $383;
  INTTIM2 = $384;
  TIM1T2  = $394;
  TIM2T2  = $395;
  TIM3T2  = $396;
  TIM4T2  = $397;
(*
  TIA_Name : Array[0..$2C] Of String[6] =
   ('VSYNC' ,'VBLANK','WSYNC' ,'RSYNC' ,'NUSIZ0','NUSIZ1','COLUP0','COLUP1',
    'COLUPF','COLUBK','CTRLPF','REFP0' ,'REFP1' ,'PF0'   ,'PF1'   ,'PF2',
    'RESP0' ,'RESP1' ,'RESM0' ,'RESM1' ,'RESBL' ,'AUDC0' ,'AUDC1' ,'AUDF0',
    'AUDF1' ,'AUDV0' ,'AUDV1' ,'GRP0'  ,'GRP1'  ,'ENAM0' ,'ENAM1' ,'ENABL' ,
    'HMP0'  ,'HMP1'  ,'HMM0'  ,'HMM1'  ,'HMBL'  ,'VDELP0','VDELP1','VDELBL',
    'RESMP0','RESMP1','HMOVE' ,'HMCLR' ,'CXCLR');

  PIA_Name : Array[$280..$297] Of String[8] =
   ('SWCHA','SWACNT','SWCHB','SWBCNT','INTTIM','INTRPT','','','','','','','','',
    '','','','','','','TIM1T','TIM8T','TIM64T','TIM1024T');

  TIA_Read_Name : Array[0..$D] Of String[6] =
   ('CXM0P' ,'CXM1P', 'CXP0FB','CXP1FB','CXM0FB','CXM1FB','CXBLPF','CXPPMM',
    'INPUT0','INPUT1','INPUT2','INPUT3','INPUT4','INPUT5');
*)
  P0CBase = $7D8F;
  P1CBase = $8D7F;
  M0CBase = $FE33;
  M1CBase = $32FF;
  PFCBase = $D7D5;
  BLCBase = $EBEB;

  P0COr   = P0CBase Xor $FFFF;
  P1COr   = P1CBase Xor $FFFF;
  M0COr   = M0CBase Xor $FFFF;
  M1COr   = M1CBase Xor $FFFF;
  PFCOr   = PFCBase Xor $FFFF;
  BLCOr   = BLCBase Xor $FFFF;

  Player0Set  = 2;
  Player1Set  = 4;
  Missile0Set = 8;
  Missile1Set = 16;
  BallSet     = 32;

  TIA_And : Array[0..$7F] Of Byte =
   ($00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F,
    $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
    $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,
    $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F,
    $00,$01,$02,$03,$04,$05,$06,$07,$08,$09,$0A,$0B,$0C,$0D,$0E,$0F,
    $10,$11,$12,$13,$14,$15,$16,$17,$18,$19,$1A,$1B,$1C,$1D,$1E,$1F,
    $20,$21,$22,$23,$24,$25,$26,$27,$28,$29,$2A,$2B,$2C,$2D,$2E,$2F,
    $30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$3A,$3B,$3C,$3D,$3E,$3F);

  { TIA_Latches MUST terminate with a ZERO!!! }

{  TIA_Latches : Array[0..5] Of Byte = (NUSIZ0,NUSIZ1,CTRLPF,RESP0,RESP1,0);}

{  TIA_Latches : Array[0..8] Of Byte =
   (NUSIZ0,NUSIZ1,CTRLPF,RESP0,RESP1,RESM0,RESM1,RESBL,0);}

(*
  Timer_And : Array[$0..$1F] Of Byte =
   ($80,$81,$82,$83,$84,$85,$84,$85,$80,$81,$82,$83,$84,$85,$84,$85,
{    $94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97);}
    $94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97,$94,$95,$96,$97);
*)
  FMReg : Array[0..17] Of Byte =
   ($00,$01,$02,$08,$09,$0A,$10,$11,$12,$03,$04,$05,$0B,$0C,$0D,$13,$14,$15);

  MissileSize: Array[0..3] Of Byte = (1,2,4,8);
  PlayerSize:  Array[0..7] Of Word = (7,23,39,39,71,15,71,31);
  PlayerSizeD: Array[0..7] Of Word = (13,29,45,45,77,22,77,38);
  _PlayerSize: Array[0..7] Of Word = (8,8,8,8,8,16,8,32);

  PlayerZone1  : Array[0..7] Of Word = ( 3, 3, 3, 3, 3, 4, 3, 4);
  PlayerInc1   : Array[0..7] Of Word = ( 0, 2,18, 2,50, 0,18, 0);
  PlayerZone2  : Array[0..7] Of Word = ( 0, 4, 4, 4, 4, 0, 4, 0);
  PlayerInc2   : Array[0..7] Of Word = ( 0, 0, 0, 2, 0, 0,18, 0);

  MissileZone1 : Array[0..7] Of Word = ( 3, 3, 3, 3, 3, 3, 3, 3);
  MissileInc1  : Array[0..7] Of Word = ( 0, 2,18, 2,50, 0,18, 0);
  MissileZone2 : Array[0..7] Of Word = ( 0, 4, 4, 4, 4, 0, 4, 0);
  MissileInc2  : Array[0..7] Of Word = ( 0, 0, 0, 2, 0, 0,18, 0);


{
  Add1 : Array[0..7] Of Integer = (8,144,288,-272,  72,8,-544,8);
  Add2 : Array[0..7] Of Integer = (8, 16, 32,-128,-512,8,-256,8);
  Add3 : Array[0..7] Of Integer = (8,144,288,-256,  72,8,  32,8);

  Add1A : Array[0..7] Of Integer = (8,272,544,-528,   72,8,-1056,8);
  Add2A : Array[0..7] Of Integer = (8, 16, 32,-256,-1024,8, -512,8);
  Add3A : Array[0..7] Of Integer = (8,272,544,-512,   72,8,   32,8);

  Add1 : Array[0..7] Of Integer = (8,144,288,-272, 192,8,-544,8);
  Add2 : Array[0..7] Of Integer = (8, 16, 32,-128,-512,8,-256,8);
  Add3 : Array[0..7] Of Integer = (8,144,288,-256, 192,8,  32,8);
}
  Add1A : Array[0..7] Of Integer = (8,272,544,-528,  320,16,-1056,32);
  Add2A : Array[0..7] Of Integer = (8, 16, 32,-256,-1024,16, -512,32);
  Add3A : Array[0..7] Of Integer = (8,272,544,-512,  320,16,   32,32);

  MissileAdd1 : Array[0..7] Of Integer = (8,16,32,16,64,16,32,32);

{  Sep1 : Array[0..7] Of Integer = (228, 16, 32,16, 64,228,32,228);
  Sep2 : Array[0..7] Of Integer = (228,228,228,16,228,228,32,228);}
  SP1 : Array[0..7] Of Word = ($1000,$0000,$1000,$0000,$1000,$0800,$1000,$0800);
  SP2 : Array[0..7] Of Word = ($1800,$1800,$0000,$1000,$1800,$1800,$0800,$1000);

  { TIA read registers }

  INPUT0  = $8;
  INPUT1  = $9;
  INPUT2  = $A;
  INPUT3  = $B;
  INPUT4  = $C;
  INPUT5  = $D;

  { Cycles[] has been moved to SPUNIT.PAS }

Type
{  RGB = Record
    R,G,B: Byte;
  End;}
{  PDisArray    = ^TDisArray;
  TDisArray    = Array[0..62 * 1024 - 1] Of Boolean;}
  Strng4       = String[4];
  TSoundType = (stPureTone,stPolyphonic,stNoise);
{  TPalette   = Array[0..127] Of RGB;}
  PSetAdjust = ^TSetAdjust;
  TSetAdjust = Array[0..256{16} * 76{67} - 1] Of ShortInt;
(*
Const
  FMSoundType : Array[0..15] Of TSoundType =
{   (stNoise,   stPolyphonic,stPolyphonic,stPolyphonic,
    stPureTone,stPureTone,  stPureTone,  stPolyphonic,
    stNoise,   stPolyphonic,stPureTone,  stNoise,
    stPureTone,stPureTone,  stPureTone,  stPolyphonic);}
{
   (stPureTone,stPolyphonic,stPolyphonic,stPolyphonic,
    stPureTone,stPureTone,  stPureTone,  stPolyphonic,
    stNoise,   stPolyphonic,stPureTone,  stNoise,
    stPureTone,stPureTone,  stPureTone,  stPolyphonic);
}
   (stPureTone,stPureTone,stPureTone,stPureTone,
    stPureTone,stPureTone,stPureTone,stPureTone,
    stPureTone,stPureTone,stPureTone,stPureTone,
    stPureTone,stPureTone,stPureTone,stPureTone);
*)
(*
   (stPolyphonic,stPolyphonic,stPolyphonic,stPolyphonic,
    stPureTone,stPureTone,  stPureTone,  stPolyphonic,
    stPolyphonic,stPolyphonic,stPureTone,  stPolyphonic,
    stPureTone,stPureTone,  stPureTone,  stPolyphonic);
*)
Var
(*
  Dummy                          : Word; { Used to dword-align BitTest }
  Game                           : TSave;
  MissileTable                   : TMissileTable;
  BitSwap                        : Array[0..255] Of Byte;
  Limit                          : LongInt;
  ByteShift                      : TByteShift;
  BitTest                        : Array[0..127] Of LongInt;
  Handle_TIA_Jump                : Array[0..63] Of Word;
  Handle_TIA_Jump_Set            : Boolean;
  AtariSeg                       : TASeg;
  TIA_Latch_Check                : Boolean;
  Config                         : ConfigRec;
*)


  Time0                          : Double;{LongInt;}
  TimeErr                        : Double;{LongInt;}
  Locations                      : Array[0..255] Of Word;

  Handle_IO_Loc                  : Array[0..TIM4T2] Of Word;
  Handle_IO_Loc_After            : Array[0..CXCLR] Of Word;
  Handle_IO_Loc_Latch            : Array[0..CXCLR] Of Word;
  TIA_Delay                      : Array[0..CXCLR] Of Word;

  ExtraAdd                       : Array[-68..160] Of ShortInt;
  SetAdjust                      : PSetAdjust; (*Array[0..256{16} * 72{67} - 1] Of Integer;*)
  ASeg                           : Pointer;
  ROMBackup                      : Pointer;
{  BCDTable                       : Array[0..1,0..255] Of Byte;}
{
  GRP0Write                      : Integer;
  GRP1Write                      : Integer;
}
{  KBFlag                         : Byte;}



  Handle_IO_Set                  : Boolean;
  Handle_IO_Set_After            : Boolean;
  Handle_IO_Set_Latch            : Boolean;
  ColorOrBWChange                : Boolean;
  Difficulty1Change              : Boolean;
  Difficulty2Change              : Boolean;

  Debugger                       : Boolean;
  DebugLoad                      : Boolean;
  Pal                            : TPalette;
  Pal1                           : TPalette;
{
  UseKBControllers               : Boolean;
  VideoTouchPad                  : Boolean;
  UseIndy500                     : Boolean;
}
  Pos200                         : Integer;
  Pos204                         : Integer;
  Pos215                         : Integer;
  Pos250                         : Integer;
  Pos305                         : Integer;
  ProfileRec                     : PFileType;
{  Work_Real                      : Real;}
{  FMReg                          : Array[0..17] Of Byte;}

{  FMChanOn                       : Array[0..9] Of Byte;}
{  FMFeedBack                     : Array[0..9] Of Byte;}
{  FMBaseLevel                    : Array[0..21] Of Word;}
{  FMScale                        : Array[0..8] Of Word;}

{  FMSoundType                    : Array[0..15] Of TSoundType;}
{
  JoyCenterX                     : LongInt;
  JoyCenterY                     : LongInt;
  JoyMinX                        : LongInt;
  JoyMinY                        : LongInt;
  JoyMaxX                        : LongInt;
  JoyMaxY                        : LongInt;
  JoyCenterX2                    : LongInt;
  JoyCenterY2                    : LongInt;
  JoyMinX2                       : LongInt;
  JoyMinY2                       : LongInt;
  JoyMaxX2                       : LongInt;
  JoyMaxY2                       : LongInt;
}
{  Table                          : Array[0..511] Of Single;}
{  OldByte                        : Byte;}
{  KBWrite                        : Boolean;}
{
  ParkerBS                       : Boolean;
  Activision                     : Boolean;
  MNetwork                       : Boolean;
  Starpath                       : Boolean;
  CBS                            : Boolean;
  SuperChip                      : Boolean;
  TigerVision                    : Boolean;
  Pitfall2                       : Boolean;
}
{  LockXMS                        : Boolean;}
  UseMenu                        : Boolean;
  Disasm                         : Boolean;
  Top                            : Integer;
  Sel                            : Integer;

  Div3                           : Array[0..228] Of Byte;
{
  PhysAddr                       : DWord;
  TotalFree                      : Word;
  LargestFree                    : Word;
  Handle                         : XMS_XmBlk;
  MovePacket                     : XMS_MovePacket;
}
{  SoundBuf                       : TSoundBuf;}

{  SBuf                           : Array[0..1] Of Pointer;}
{
  PhysAddr0                      : DWord;
  PhysAddr1                      : DWord;
}
{
  PF2Read                        : Pointer;
  PF2ReadSize                    : Word;
}
  HaltLine                       : Integer;
  AutoCenter                     : Boolean;
  AutoCenterChange               : Boolean;
{  SendBuf                        : Pointer;}


  Exiting                        : Boolean;
  ControlFrame                   : Integer;
{ ------------------------------------------------------------------------- }
  _Intr_Num                      : Byte;
  _Voice_Status                  : Word;
  _IO_Addx                       : Word;
  _DMA                           : Word;
  _DSP_Version                   : Word;
  Org_Int_Addx                   : Pointer;
  BufPlaying                     : Byte;
  BufToFill                      : Byte;
  SmallSoundBuf                  : Array[0..259] Of Byte;
  PSmallSoundBuf                 : Pointer;
{  BufScan                        : LongInt;}
  PFillBuffer                    : Pointer;

  SoundQueue                     : Array[0..1025] Of Byte;
  SoundQueue_In                  : Word;
  SoundQueue_Out                 : Word;
  SoundQueue_Num                 : Word;

  ROMFileName                    : String;
  BreakExpColl                   : PCollection;
  ExpError                       : Boolean;

  Old_WaveLen : Array[1..4] Of Byte; { The fourth byte is unused in these arrays }
  Old_Pulse   : Array[1..4] Of Byte;
  Old_Phase   : Array[1..4] Of Byte;
  Old_Signal  : Array[1..4] Of Byte;
  Old_Wave    : Array[1..4] Of Byte;

  PF2Wave : Integer;

  AVIFile : TAVIFile;

{
  _Wave    : Array[1..3] Of Single;
  _WaveLen : Array[1..3] Of Single;
  _Pulse   : Array[1..3] Of Single;
}
{
  _Wave    : Array[1..3] Of Integer;
  _WaveLen : Array[1..3] Of Integer;
  _Pulse   : Array[1..3] Of Integer;
}
{
  NumFrames    : LongInt;
  ElapsedTime0 : LongInt;
  ElapsedTime1 : LongInt;
}


{$F+}
Function _CTV_Card_Here: Word; External;
Function _CTV_Detect: Word;    External;
Function _CTV_Output(Buf: Pointer; BufLen,SampleRate: Word): Word; External;
Function _CTV_Halt: Word;      External;
Function _CTV_Uninstall: Word; External;
{$F-}
{$L CTV-ATA6.OBJ}

Procedure CheckAVIStream;
Begin
  If AVIFile.Opened Then AVIFile.WriteFrame(Ptr($A000,0));
End; { CheckAVIStream }

Procedure QueueLatch(Latch: Byte; Value,Scan,Count: Integer);
Begin
  Asm
    DB    _32BIT_OPERAND
    PUSHA
    PUSHF
    MOV   AL,BYTE PTR Latch
    MOV   DX,WORD PTR Value
    MOV   BX,WORD PTR Scan
    MOV   CX,WORD PTR Count
    CMP   WORD PTR Game.TIA_Latch_Queue,LatchQueueSize
    JGE   @GetOut
    MOV   SI,WORD PTR Game.TIA_Latch_Queue
    INC   WORD PTR Game.TIA_Latch_Queue
    MOV   BYTE PTR Game.TIA_Latch_Reg[SI],AL
    ADD   SI,SI
    MOV   WORD PTR Game.TIA_Latch_Value[SI],DX
    MOV   WORD PTR Game.TIA_Latch_Scan[SI],BX
    MOV   WORD PTR Game.TIA_Latch_Count[SI],CX
    MOV   BL,AL
    SUB   BH,BH
    INC   BYTE PTR Game.TIA_Latch_RegCount[BX]
  @GetOut:
    POPF
    DB    _32BIT_OPERAND
    POPA
  End; { Asm }
End; { QueueLatch }

Procedure FillPf2Buf(Count: LongInt);
Const
  Smooth = 15;
  Fudge  = 1.0;

Var
  P         : Pointer;
  I         : LongInt;
  Amp       : Byte;
  LenRatio  : Single;
  Changed   : Boolean;

  Mult : Array[1..3] Of Single;

Begin

  { First see if any Pitfall II sound values have changed for the three }
  { channels.  If anything has changed, the sound parameters have to be }
  { recalculated.  The code below is actually comparing four bytes at a }
  { time, but the fourth byte is always left at zero, so it doesn't     }
  { matter.                                                             }

  Changed := False;
  Asm
    DB    _32BIT_OPERAND
    MOV   AX,WORD PTR Old_WaveLen
    DB    _32BIT_OPERAND
    CMP   AX,WORD PTR WaveLen
    JNE   @L1

    DB    _32BIT_OPERAND
    MOV   AX,WORD PTR Old_Pulse
    DB    _32BIT_OPERAND
    CMP   AX,WORD PTR Pulse
    JNE   @L1

    DB    _32BIT_OPERAND
    MOV   AX,WORD PTR Old_Phase
    DB    _32BIT_OPERAND
    CMP   AX,WORD PTR Phase
    JNE   @L1

    DB    _32BIT_OPERAND
    MOV   AX,WORD PTR Old_Signal
    DB    _32BIT_OPERAND
    CMP   AX,WORD PTR Signal
    JNE   @L1

    JMP   @L2
@L1:
    MOV   BYTE PTR Changed,1
@L2:
  End; { Asm }

  If Changed Then
  Begin

    { The mutipliers below are fudge factors to equalize the ratio between }
    { the Pitfall II's internal sample rate and the normal Atari rate of   }
    { 31.4 kHz.                                                            }

    Mult[1] := 1.75;
    Mult[2] := 1.75;
    Mult[3] := 1.75;
(*
    Case Signal[1] Of
  0,1,3: Mult[1] := 2.0;
      2: Mult[1] := 2.0;
    End; { Case }

    Case Signal[2] Of
  0,1,3: Mult[2] := 2.0;
      2: Mult[2] := 2.0;
    End; { Case }

    Case Signal[3] Of
  0,1,3: Mult[3] := 2.0;
      2: Mult[3] := 2.0;
    End; { Case }
*)
{
    If Signal[1] > 0 Then Mult[1] := 1.5 Else Mult[1] := 0;
    If Signal[2] > 0 Then Mult[2] := 1.5 Else Mult[2] := 0;
    If Signal[3] > 0 Then Mult[3] := 1.5 Else Mult[3] := 0;
}
{
    If Signal[1] = 2 Then Mult[1] := 2 Else Mult[1] := 1;
    If Signal[2] = 2 Then Mult[2] := 2 Else Mult[2] := 1;
    If Signal[3] = 2 Then Mult[3] := 2 Else Mult[3] := 1;
}

    { Account for the fact that the PC's playback rate (normally 44.1kHz, }
    { but can be otherwise) differs from the Atari's playback rate of     }
    { 31.4kHz.                                                            }

    LenRatio := Playback_Freq / 31400;
(*
    _WaveLen[1] := WaveLen[1] * LenRatio * Mult[1];
    _WaveLen[2] := WaveLen[2] * LenRatio * Mult[2];
    _WaveLen[3] := WaveLen[3] * LenRatio * Mult[3];

    _Pulse[1] := Pulse[1] * LenRatio * Mult[1];
    _Pulse[2] := Pulse[2] * LenRatio * Mult[2];
    _Pulse[3] := Pulse[3] * LenRatio * Mult[3];

    If (_WaveLen[1] > 0) And (_Pulse[1] >= _WaveLen[1]) Then
     _Pulse[1] := _Pulse[1] - _WaveLen[1] * Trunc(_Pulse[1] / _WaveLen[1]);
    If (_WaveLen[2] > 0) And (_Pulse[2] >= _WaveLen[2]) Then
     _Pulse[2] := _Pulse[2] - _WaveLen[2] * Trunc(_Pulse[2] / _WaveLen[2]);
    If (_WaveLen[3] > 0) And (_Pulse[3] >= _WaveLen[3]) Then
     _Pulse[3] := _Pulse[3] - _WaveLen[3] * Trunc(_Pulse[3] / _WaveLen[3]);

    _Wave[1] := (Wave[1] + Phase[1]) * LenRatio * Mult[1];
    _Wave[2] := (Wave[2] + Phase[2]) * LenRatio * Mult[2];
    _Wave[3] := (Wave[3] + Phase[3]) * LenRatio * Mult[3];

    If (_WaveLen[1] > 0) And (_Wave[1] >= _WaveLen[1])
     Then _Wave[1] := _Wave[1] - _WaveLen[1] * Trunc(_Wave[1] / _WaveLen[1])
     Else _Wave[1] := 0;
    If (_WaveLen[2] > 0) And (_Wave[2] >= _WaveLen[2])
     Then _Wave[2] := _Wave[2] - _WaveLen[2] * Trunc(_Wave[2] / _WaveLen[2])
     Else _Wave[2] := 0;
    If (_WaveLen[3] > 0) And (_Wave[3] >= _WaveLen[3])
     Then _Wave[3] := _Wave[3] - _WaveLen[3] * Trunc(_Wave[3] / _WaveLen[3])
     Else _Wave[3] := 0;

    _Wave[1] := _Wave[1] - 1;
    _Wave[2] := _Wave[2] - 1;
    _Wave[3] := _Wave[3] - 1;



    Asm
      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR WaveLen
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_WaveLen,AX

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Pulse
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Pulse,AX

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Phase
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Phase,AX

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Signal
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Signal,AX
{
      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Wave
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Wave,AX
}
    End; { Asm }
  End;

  Dec(Wave[1]);
  Dec(Wave[2]);
  Dec(Wave[3]);

  For I := 0 To 127 Do
  Begin

    Inc(Wave[1]);
    Inc(Wave[2]);
    Inc(Wave[3]);

    _Wave[1] := _Wave[1] + 1;
    _Wave[2] := _Wave[2] + 1;
    _Wave[3] := _Wave[3] + 1;

    If _Wave[1] >= _WaveLen[1] Then
    Begin
      _Wave[1] := _Wave[1] - _WaveLen[1];
      Wave[1]  := 0;
    End;
    If _Wave[2] >= _WaveLen[2] Then
    Begin
      _Wave[2] := _Wave[2] - _WaveLen[2];
      Wave[2]  := 0;
    End;
    If _Wave[3] >= _WaveLen[3] Then
    Begin
      _Wave[3] := _Wave[3] - _WaveLen[3];
      Wave[3]  := 0;
    End;

    Amp := 0;

    If _WaveLen[1] > 0 Then
    Begin
      Case Signal[1] Of
        1: Inc(Amp,$20);
        2,3: If _Wave[1] <= _Pulse[1] Then Inc(Amp,$20);
      End; { Case }
    End;
    If _WaveLen[2] > 0 Then
    Begin
      Case Signal[2] Of
        1: Inc(Amp,$28);
        2,3: If _Wave[2] <= _Pulse[2] Then Inc(Amp,$28);
      End; { Case }
    End;
    If _WaveLen[1] > 0 Then
    Begin
      Case Signal[3] Of
        1: Inc(Amp,$30);
        2,3: If _Wave[3] <= _Pulse[3] Then Inc(Amp,$30);
      End; { Case }
    End;
*)
{
    If (_WaveLen[1] > 0) And (_Wave[1] <= _Pulse[1]) Then Amp := $20;
    If (_WaveLen[2] > 0) And (_Wave[2] <= _Pulse[2]) Then Inc(Amp,$28);
    If (_WaveLen[3] > 0) And (_Wave[3] <= _Pulse[3]) Then Inc(Amp,$30);
}

(*
    Case Signal[1] Of
      1: Amp := $20;
      2,3: If _Wave[1] <= _Pulse[1] Then Amp := $20;
    End; { Case }

    Case Signal[2] Of
      1: Inc(Amp,$28);
      2,3: If _Wave[2] <= _Pulse[2] Then Inc(Amp,$28);
    End; { Case }

    Case Signal[3] Of
      1: Inc(Amp,$30);
      2,3: If _Wave[3] <= _Pulse[3] Then Inc(Amp,$30);
    End; { Case }
*)
(*
    _WaveLen[1] := WaveLen[1] * Fudge * LenRatio;
    _WaveLen[2] := WaveLen[2] * Fudge * LenRatio;
    _WaveLen[3] := WaveLen[3] * Fudge * LenRatio;

    _Pulse[1] := Pulse[1] * Fudge * LenRatio;
    _Pulse[2] := Pulse[2] * Fudge * LenRatio;
    _Pulse[3] := Pulse[3] * Fudge * LenRatio;

    If _WaveLen[1] > 0 Then
     _Pulse[1] := _Pulse[1] - _WaveLen[1] * Trunc(_Pulse[1] / _WaveLen[1]);
    If _WaveLen[2] > 0 Then
     _Pulse[2] := _Pulse[2] - _WaveLen[2] * Trunc(_Pulse[2] / _WaveLen[2]);
    If _WaveLen[3] > 0 Then
     _Pulse[3] := _Pulse[3] - _WaveLen[3] * Trunc(_Pulse[3] / _WaveLen[3]);

    _Wave[1] := Wave[1] + Phase[1] * LenRatio;
    _Wave[2] := Wave[2] + Phase[2] * LenRatio;
    _Wave[3] := Wave[3] + Phase[3] * LenRatio;

    If _WaveLen[1] > 0
     Then _Wave[1] := _Wave[1] - _WaveLen[1] * Trunc(_Wave[1] / _WaveLen[1])
     Else _Wave[1] := 0;
    If _WaveLen[2] > 0
     Then _Wave[2] := _Wave[2] - _WaveLen[2] * Trunc(_Wave[2] / _WaveLen[2])
     Else _Wave[2] := 0;
    If _WaveLen[3] > 0
     Then _Wave[3] := _Wave[3] - _WaveLen[3] * Trunc(_Wave[3] / _WaveLen[3])
     Else _Wave[3] := 0;

    _Wave[1] := _Wave[1] - 1;
    _Wave[2] := _Wave[2] - 1;
    _Wave[3] := _Wave[3] - 1;

    Asm
      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR WaveLen
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_WaveLen,AX

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Pulse
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Pulse,AX

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Phase
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Phase,AX

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Signal
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Signal,AX

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Wave
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Wave,AX
    End; { Asm }
  End;
  For I := 0 To 127 Do
  Begin

    _Wave[1] := _Wave[1] + 1;
    _Wave[2] := _Wave[2] + 1;
    _Wave[3] := _Wave[3] + 1;

    If _Wave[1] >= _WaveLen[1] Then _Wave[1] := _Wave[1] - _WaveLen[1];{0;}
    If _Wave[2] >= _WaveLen[2] Then _Wave[2] := _Wave[2] - _WaveLen[2];{0;}
    If _Wave[3] >= _WaveLen[3] Then _Wave[3] := _Wave[3] - _WaveLen[3];{0;}

    Amp := 0;

    Case Signal[1] Of
      1: Amp := $20;
      3: If _Wave[1] <= _Pulse[1] Then Amp := $20;
    End; { Case }

    Case Signal[2] Of
      1: Inc(Amp,$28);
      3: If _Wave[2] <= _Pulse[2] Then Inc(Amp,$28);
    End; { Case }

    Case Signal[3] Of
      1: Inc(Amp,$30);
      3: If _Wave[3] <= _Pulse[3] Then Inc(Amp,$30);
    End; { Case }
*)



(*
    { Original code }

    _WaveLen[1] := Round(WaveLen[1] * Mult[1] * LenRatio);
    _WaveLen[2] := Round(WaveLen[2] * Mult[2] * LenRatio);
    _WaveLen[3] := Round(WaveLen[3] * Mult[3] * LenRatio);

    _Pulse[1] := Round(Pulse[1] * Mult[1] * LenRatio);
    _Pulse[2] := Round(Pulse[2] * Mult[2] * LenRatio);
    _Pulse[3] := Round(Pulse[3] * Mult[3] * LenRatio);

    If _WaveLen[1] > 0 Then _Pulse[1] := _Pulse[1] Mod _WaveLen[1];
    If _WaveLen[2] > 0 Then _Pulse[2] := _Pulse[2] Mod _WaveLen[2];
    If _WaveLen[3] > 0 Then _Pulse[3] := _Pulse[3] Mod _WaveLen[3];

    If WaveLen[1] > 0 Then _Wave[1] := _Wave[1] Mod WaveLen[1] Else _Wave[1] := 0;
    If WaveLen[2] > 0 Then _Wave[2] := _Wave[2] Mod WaveLen[2] Else _Wave[2] := 0;
    If WaveLen[3] > 0 Then _Wave[3] := _Wave[3] Mod WaveLen[3] Else _Wave[3] := 0;

    Dec(_Wave[1]);
    Dec(_Wave[2]);
    Dec(_Wave[3]);
*)


    For I := 1 To 3 Do
    Begin
      _WaveLen[I] := WaveLen[I] * Mult[I] * LenRatio;
      _Pulse[I]   := Pulse[I]   * Mult[I] * LenRatio;
      If _WaveLen[I] > 0 Then
      Begin
        If _Pulse[I] >= _WaveLen[I] Then
         _Pulse[I] := _Pulse[I] - Trunc(_Pulse[I] / _WaveLen[I]) * _WaveLen[I];
        If _Wave[I] >= _WaveLen[I] Then
         _Wave[I] := _Wave[I] - Trunc(_Wave[I] / _WaveLen[I]) * _WaveLen[I];
      End
      Else _Wave[I] := 0;
      _Wave[I] := _Wave[I] - 1;
      Rem_Wave[I] := 0;
    End; { For I }



{
    _Wave[1] := Round((Wave[1] + Round(Phase[1] * LenRatio)) * Mult[1]);
    _Wave[2] := Round((Wave[2] + Round(Phase[2] * LenRatio)) * Mult[2]);
    _Wave[3] := Round((Wave[3] + Round(Phase[3] * LenRatio)) * Mult[3]);
}
(*
    _WaveLen[1] := Round(WaveLen[1] * 1.5 * LenRatio);
    _WaveLen[2] := Round(WaveLen[2] * 1.5 * LenRatio);
    _WaveLen[3] := Round(WaveLen[3] * 1.5 * LenRatio);

    _Pulse[1] := Round(Pulse[1] * 1.5 * LenRatio);
    _Pulse[2] := Round(Pulse[2] * 1.5 * LenRatio);
    _Pulse[3] := Round(Pulse[3] * 1.5 * LenRatio);

    _Wave[1] := Round((Wave[1] + Round(Phase[1] * LenRatio)) * 1.5);
    _Wave[2] := Round((Wave[2] + Round(Phase[2] * LenRatio)) * 1.5);
    _Wave[3] := Round((Wave[3] + Round(Phase[3] * LenRatio)) * 1.5);
*)


    Asm
      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR WaveLen
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_WaveLen,AX

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Pulse
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Pulse,AX

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Phase
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Phase,AX

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Signal
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Signal,AX

      DB    _32BIT_OPERAND
      MOV   AX,WORD PTR Wave
      DB    _32BIT_OPERAND
      MOV   WORD PTR Old_Wave,AX
    End; { Asm }
  End;
  For I := 0 To Count - 1{127} Do
  Begin

(*
    { Original code }

    Inc(_Wave[1]);
    Inc(_Wave[2]);
    Inc(_Wave[3]);
*)
    Inc(Pf2Wave);

    _Wave[1] := _Wave[1] + 1;
    _Wave[2] := _Wave[2] + 1;
    _Wave[3] := _Wave[3] + 1;



{
    If _Wave[1] >= _WaveLen[1] Then
    Begin
      _Wave[1] := 0;
      If Signal[1] = 2 Then
      Begin
        Signal[1] := 0;
        Old_Signal[1] := 0;
      End;
    End;
    If _Wave[2] >= _WaveLen[2] Then
    Begin
      _Wave[2] := 0;
      If Signal[2] = 2 Then
      Begin
        Signal[2] := 0;
        Old_Signal[2] := 0;
      End;
    End;
    If _Wave[3] >= _WaveLen[3] Then
    Begin
      _Wave[3] := 0;
      If Signal[3] = 2 Then
      Begin
        Signal[3] := 0;
        Old_Signal[3] := 0;
      End;
    End;
}

    If _Wave[1] + Rem_Wave[1] >= _WaveLen[1] Then
    Begin
      Rem_Wave[1] := _Wave[1] + Rem_Wave[1] - _WaveLen[1];
      _Wave[1]    := 0;
    End;
    If _Wave[2] + Rem_Wave[2] >= _WaveLen[2] Then
    Begin
      Rem_Wave[2] := _Wave[2] + Rem_Wave[2] - _WaveLen[2];
      _Wave[2]    := 0;
    End;
    If _Wave[3] + Rem_Wave[3] >= _WaveLen[3] Then
    Begin
      Rem_Wave[3] := _Wave[3] + Rem_Wave[3] - _WaveLen[3];
      _Wave[3]    := 0;
    End;

(*
    Asm
      MOV   DL,0

      TEST  BYTE PTR Signal[0],1
      JZ    @DoSignal2
      TEST  BYTE PTR Signal[0],2
      JNZ   @Signal1Is3
      MOV   DL,20h
      JMP   @DoSignal2
@Signal1Is3:
      MOV   AX,WORD PTR _Wave[0]
      CMP   AX,WORD PTR _Pulse[0]
      JG    @DoSignal2
      MOV   DL,20h

@DoSignal2:
      TEST  BYTE PTR Signal[1],1
      JZ    @DoSignal3
      TEST  BYTE PTR Signal[1],2
      JNZ   @Signal2Is3
      ADD   DL,28h
      JMP   @DoSignal3
@Signal2Is3:
      MOV   AX,WORD PTR _Wave[2]
      CMP   AX,WORD PTR _Pulse[2]
      JG    @DoSignal3
      ADD   DL,28h

@DoSignal3:
      TEST  BYTE PTR Signal[2],1
      JZ    @Done
      TEST  BYTE PTR Signal[2],2
      JNZ   @Signal3Is3
      ADD   DL,30h
      JMP   @Done
@Signal3Is3:
      MOV   AX,WORD PTR _Wave[4]
      CMP   AX,WORD PTR _Pulse[4]
      JG    @Done
      ADD   DL,30h
@Done:
      MOV   BYTE PTR Amp,DL
    End; { Asm }
*)

    Amp := 0;

    { DSP to simulate RF modulation and demodulation.  Results in "muddy" }
    { sound.                                                              }

    If Config.Pitfall2DSP Then
    Begin
      Case Signal[1] Of
        1: Amp := $20;
        3: If _Wave[1] + Rem_Wave[1] <= _Pulse[1] Then
           Begin
             Amp := $20;
             If _Wave[1] + Rem_Wave[1] <= Smooth
              Then Dec(Amp,Round(Smooth - (_Wave[1] + Rem_Wave[1])))
              Else If _Wave[1] + Rem_Wave[1] > _Pulse[1] - Smooth
                    Then Dec(Amp,Round((_Wave[1] + Rem_Wave[1]) - (_Pulse[1] - Smooth)));
           End;
      End; { Case }

      Case Signal[2] Of
        1: Inc(Amp,$28);
        3: If _Wave[2] + Rem_Wave[2] <= _Pulse[2] Then
           Begin
             Inc(Amp,$28);
             If _Wave[2] + Rem_Wave[2] <= Smooth
              Then Dec(Amp,Round(Smooth - (_Wave[2] + Rem_Wave[2])))
              Else If _Wave[2] + Rem_Wave[2] > _Pulse[2] - Smooth
                    Then Dec(Amp,Round((_Wave[2] + Rem_Wave[2]) - (_Pulse[2] - Smooth)));
           End;
      End; { Case }

      Case Signal[3] Of
        1: Inc(Amp,$30);
        3: If _Wave[3] + Rem_Wave[3] <= _Pulse[3] Then
           Begin
             Inc(Amp,$30);
             If _Wave[3] + Rem_Wave[3] <= Smooth
              Then Dec(Amp,Round(Smooth - (_Wave[3] + Rem_Wave[3])))
              Else If _Wave[3] + Rem_Wave[3] > _Pulse[3] - Smooth
                    Then Dec(Amp,Round((_Wave[3] + Rem_Wave[3]) - (_Pulse[3] - Smooth)));
           End;
      End; { Case }
    End
    Else
    Begin
      Case Signal[1] Of
        1: Amp := $20;
        3: If _Wave[1] + Rem_Wave[1] <= _Pulse[1] Then Amp := $20;
      End; { Case }

      Case Signal[2] Of
        1: Inc(Amp,$28);
        3: If _Wave[2] + Rem_Wave[2] <= _Pulse[2] Then Inc(Amp,$28);
      End; { Case }

      Case Signal[3] Of
        1: Inc(Amp,$30);
        3: If _Wave[3] + Rem_Wave[3] <= _Pulse[3] Then Inc(Amp,$30);
      End; { Case }
    End;
(*
    Case Signal[1] Of
      1: Amp := $20;
      3: If _Wave[1] <= _Pulse[1] Then{ Amp := $20;}
         Begin
           Amp := $20;
           If _Wave[1] <= Smooth Then Dec(Amp,Smooth - _Wave[1]);
         End
         Else If _Wave[1] <= _Pulse[1] + Smooth Then Amp := Smooth - (_Wave[1] - _Pulse[1]);
    End; { Case }

    Case Signal[2] Of
      1: Inc(Amp,$28);
      3: If _Wave[2] <= _Pulse[2] Then {Inc(Amp,$28);}
         Begin
           Inc(Amp,$28);
           If _Wave[2] <= Smooth Then Dec(Amp,Smooth - _Wave[2]);
         End
         Else If _Wave[2] <= _Pulse[2] + Smooth Then Inc(Amp,Smooth - (_Wave[2] - _Pulse[2]));
    End; { Case }

    Case Signal[3] Of
      1: Inc(Amp,$30);
      3: If _Wave[3] <= _Pulse[3] Then {Inc(Amp,$30);}
         Begin
           Inc(Amp,$30);
           If _Wave[3] <= Smooth Then Dec(Amp,Smooth - _Wave[3]);
         End
         Else If _Wave[3] <= _Pulse[3] + Smooth Then Inc(Amp,Smooth - (_Wave[3] - _Pulse[3]));
    End; { Case }
*)
    Pf2Buf[I] := Amp;
  End; { For I }
End; { FillPf2Buf }

Procedure QueueSoundSample;
Var B: Byte;
Begin
  Inc(SoundQueue_Num,2);
  If Game.Cart = ctPitfall2 Then
  Begin
    FillPf2Buf(2);
  End;
  ProcessSound(@(SoundQueue[SoundQueue_In]),2);
  SoundQueue_In := (SoundQueue_In + 2) And 1023;
End; { QueueSoundSample }

{$F+}
Procedure FillBuffer;

Var
  Queued : Word;
  P      : BPtr;
  W: Word;

Begin
{  If Config.DoSound Then
  Begin
    If BufToFill <> BufPlaying Then
    Begin}




      { Retrieve from the sound queue first }

      Queued := 0;
      P      := Pointer(LongInt(PSmallSoundBuf) + ((BufPlaying Xor 1) Shl 7));
      While (SoundQueue_Num > 0) And (Queued < 128) Do
      Begin
        P^ := SoundQueue[SoundQueue_Out];
        Inc(LongInt(P));
        Inc(Queued);
        SoundQueue_Out := (SoundQueue_Out + 1) And 1023;
        Dec(SoundQueue_Num);
      End; { While }






      If Queued < 128 Then
      Begin

        If Game.Cart = ctPitfall2 Then
        Begin
{          Inc(PF2Inc,128 - Queued);}
          FillPf2Buf(128 - Queued);
{          ProcessPF2 := True;}
        End;
{        Else ProcessPF2 := False;}
        ProcessSound(P,128 - Queued);
      End;

{      TIA_Process2(Pointer(LongInt(PSmallSoundBuf) + ((BufPlaying Xor 1) Shl 7)),128);}

{
      ProcessSound(Pointer(LongInt(PSmallSoundBuf) + (BufToFill Shl 7)),128);
      BufToFill := BufToFill Xor 1;
    End;
  End;}
End; { FillBuffer }
{$F-}

(*
Procedure Build_Table;
Var
  Freq  : Word;
  Kind  : Word;
  S3    : Single;
  Index : Word;

Begin
  Index := 0;
  Freq  := 0;
  While Freq < 32 Do
  Begin
    Kind := 0;
    While Kind < 16 Do
    Begin
      S3 := 0;
      If Coeff[Kind] <> 0 Then
      Begin
        S3 := 30000 / (Freq + 1);
        S3 := S3 / (Coeff[Kind] * FMDiv[Kind] * SoundDiv);
        If S3 > 1023 Then S3 := 1023;
      End;
      Table[Index] := S3;
      Inc(Index);
      Inc(Kind);
    End; { While }
    Inc(Freq);
  End; { While }
End; { Build_Table }


Procedure WriteFM(Reg,Data: Byte);
Var B: Byte;
Begin
  Port[FMChip] := Reg;
  B := Port[FMChip];
  Port[FMChip + 1] := Data;
  B := Port[FMChip];
  B := Port[FMChip];
  B := Port[FMChip];
  B := Port[FMChip];
End; { WriteFM }


Procedure InitFM;
Var I: Byte;
Begin
  For I := 1 To $F5 Do WriteFM(I,0);
  Build_Table;
End; { InitFM }
*)
(*
Procedure Digital(Chan: Byte);
Var I1,T: LongInt;


Type BPtr = ^Byte;
Const Smooth = 10;
Var
  P        : Pointer;
  I        : LongInt;
  _Wave    : Array[1..3] Of LongInt;
  Amp      : Byte;
  _WaveLen : Array[1..3] Of LongInt;
  _Pulse   : Array[1..3] Of LongInt;
  LenRatio : Real;

Begin
  If Chan = 0 Then
  Begin
    If Cart = ctPitfall2 Then
    Begin
      LenRatio := Playback_Freq / 31400;

      _WaveLen[1] := Round(WaveLen[1] * 1.5 * LenRatio);
      _WaveLen[2] := Round(WaveLen[2] * 1.5 * LenRatio);
      _WaveLen[3] := Round(WaveLen[3] * 1.5 * LenRatio);

      _Pulse[1] := Round(Pulse[1] * 1.5 * LenRatio);
      _Pulse[2] := Round(Pulse[2] * 1.5 * LenRatio);
      _Pulse[3] := Round(Pulse[3] * 1.5 * LenRatio);

      If _WaveLen[1] > 0 Then _Pulse[1] := _Pulse[1] Mod _WaveLen[1];
      If _WaveLen[2] > 0 Then _Pulse[2] := _Pulse[2] Mod _WaveLen[2];
      If _WaveLen[3] > 0 Then _Pulse[3] := _Pulse[3] Mod _WaveLen[3];

      _Wave[1] := Wave[1] + Round(Phase[1] * LenRatio);
      _Wave[2] := Wave[2] + Round(Phase[2] * LenRatio);
      _Wave[3] := Wave[3] + Round(Phase[3] * LenRatio);

      If WaveLen[1] > 0 Then _Wave[1] := _Wave[1] Mod WaveLen[1] Else _Wave[1] := 0;
      If WaveLen[2] > 0 Then _Wave[2] := _Wave[2] Mod WaveLen[2] Else _Wave[2] := 0;
      If WaveLen[3] > 0 Then _Wave[3] := _Wave[3] Mod WaveLen[3] Else _Wave[3] := 0;

      Dec(_Wave[1]);
      Dec(_Wave[2]);
      Dec(_Wave[3]);

      P := SoundBuf[0];

      For I := 0 To SoundBufSize - 1 Do
      Begin

        Inc(_Wave[1]);
        Inc(_Wave[2]);
        Inc(_Wave[3]);

        If _Wave[1] >= _WaveLen[1] Then _Wave[1] := 0;
        If _Wave[2] >= _WaveLen[2] Then _Wave[2] := 0;
        If _Wave[3] >= _WaveLen[3] Then _Wave[3] := 0;

        Amp := 0;

        Case Signal[1] Of
          1: Amp := $20;
          3: If _Wave[1] <= _Pulse[1] Then{ Amp := $20;}
             Begin
               Amp := $20;
               If _Wave[1] <= Smooth Then Dec(Amp,Smooth - _Wave[1]);
             End
             Else If _Wave[1] <= _Pulse[1] + Smooth Then Amp := Smooth - (_Wave[1] - _Pulse[1]);
        End; { Case }

        Case Signal[2] Of
          1: Inc(Amp,$28);
          3: If _Wave[2] <= _Pulse[2] Then {Inc(Amp,$28);}
             Begin
               Inc(Amp,$28);
               If _Wave[2] <= Smooth Then Dec(Amp,Smooth - _Wave[2]);
             End
             Else If _Wave[2] <= _Pulse[2] + Smooth Then Inc(Amp,Smooth - (_Wave[2] - _Pulse[2]));
        End; { Case }

        Case Signal[3] Of
          1: Inc(Amp,$30);
          3: If _Wave[3] <= _Pulse[3] Then {Inc(Amp,$30);}
             Begin
               Inc(Amp,$30);
               If _Wave[3] <= Smooth Then Dec(Amp,Smooth - _Wave[3]);
             End
             Else If _Wave[3] <= _Pulse[3] + Smooth Then Inc(Amp,Smooth - (_Wave[3] - _Pulse[3]));
        End; { Case }

        BPtr(P)^ := Amp;
        Inc(LongInt(P));
      End; { For I }
    End
    Else
    Begin
      Asm
        DB    _32BIT_OPERAND
        SUB   AX,AX
        DB    _32BIT_OPERAND
        SUB   BX,BX
        MOV   BX,WORD PTR SoundBufSize
        MOV   AL,BYTE PTR Game.FMVoc
        SHL   AX,5
        ADD   AX,WORD PTR Game.FMFreq
        DB    _32BIT_OPERAND
        MUL   BX
        DB    _32BIT_OPERAND
        MOV   WORD PTR I1,AX
      End; { Asm }

      { Handle channel 1 }

      If LockXMS Then XMS.RawMove(PhysAddr0,PhysAddr + I1,SoundBufSize) Else
      Begin
        MovePacket.Length     := SoundBufSize;
        MovePacket.srcHandle  := Handle.Handle;
        MovePacket.srcOffset  := I1;
        MovePacket.destHandle := 0;
        MovePacket.destOffset := DWord(SoundBuf[0]);
        XMS.MoveXM(MovePacket);
      End;
      Asm
        MOV   AL,BYTE PTR Game.FMRealScale
        SHL   AL,3
        MOV   BX,0FFFFh
        LES   DI,DWORD PTR SoundBuf[0 * 4]
        MOV   CX,WORD PTR SoundBufSize
        SHR   CX,2
    @L1:
        DB    _32BIT_OPERAND
        MOV   DX,WORD PTR [ES:DI]
        DB    _32BIT_OPERAND
        OR    DX,DX
        JZ    @L2
        TEST  DL,BL
        JZ    @L3
        MOV   DL,AL
    @L3:
        TEST  DH,BL
        JZ    @L4
        MOV   DH,AL
    @L4:
        DB    _32BIT_OPERAND
        ROR   DX,16
        TEST  DL,BL
        JZ    @L5
        MOV   DL,AL
    @L5:
        TEST  DH,BL
        JZ    @L6
        MOV   DH,AL
    @L6:
        DB    _32BIT_OPERAND
        ROR   DX,16
        DB    _32BIT_OPERAND
        MOV   WORD PTR [ES:DI],DX
    @L2:
        ADD   DI,4
        DEC   CX
        JNZ   @L1
      End; { Asm }
    End;
  End
  Else
  Begin
    Asm
      DB    _32BIT_OPERAND
      SUB   AX,AX
      DB    _32BIT_OPERAND
      SUB   BX,BX
      MOV   BX,WORD PTR SoundBufSize
      MOV   AL,BYTE PTR Game.FMVoc[1]
      SHL   AX,5
      ADD   AX,WORD PTR Game.FMFreq[2]
      DB    _32BIT_OPERAND
      MUL   BX
      DB    _32BIT_OPERAND
      MOV   WORD PTR I1,AX
    End; { Asm }

    { Handle channel 2 }

    If LockXMS Then XMS.RawMove(PhysAddr1,PhysAddr + I1,SoundBufSize) Else
    Begin
      MovePacket.Length     := SoundBufSize;
      MovePacket.srcHandle  := Handle.Handle;
      MovePacket.srcOffset  := I1;
      MovePacket.destHandle := 0;
      MovePacket.destOffset := DWord(Ptr(Seg(SoundBuf[0]^),Ofs(SoundBuf[0]^) + SoundBufSize));
      XMS.MoveXM(MovePacket);
    End;
    Asm
      MOV   AL,BYTE PTR Game.FMRealScale[2]
      SHL   AL,3
      MOV   BX,0FFFFh
      LES   DI,DWORD PTR SoundBuf[0 * 4]
      ADD   DI,WORD PTR SoundBufSize
      MOV   CX,WORD PTR SoundBufSize
      SHR   CX,2
  @L1:
      DB    _32BIT_OPERAND
      MOV   DX,WORD PTR [ES:DI]
      DB    _32BIT_OPERAND
      OR    DX,DX
      JZ    @L2
      TEST  DL,BL
      JZ    @L3
      MOV   DL,AL
  @L3:
      TEST  DH,BL
      JZ    @L4
      MOV   DH,AL
  @L4:
      DB    _32BIT_OPERAND
      ROR   DX,16
      TEST  DL,BL
      JZ    @L5
      MOV   DL,AL
  @L5:
      TEST  DH,BL
      JZ    @L6
      MOV   DH,AL
  @L6:
      DB    _32BIT_OPERAND
      ROR   DX,16
      DB    _32BIT_OPERAND
      MOV   WORD PTR [ES:DI],DX
  @L2:
      ADD   DI,4
      DEC   CX
      JNZ   @L1
    End; { Asm }
  End;
  Asm
    LES   DI,DWORD PTR SoundBuf[1 * 4]
    MOV   CX,WORD PTR SoundBufSize
    SHR   CX,2
    MOV   BX,WORD PTR SoundBufSize
    PUSH  DS
    LDS   SI,DWORD PTR SoundBuf[0 * 4]
@L1:
    DB    _32BIT_OPERAND
    MOV   AX,WORD PTR [SI]
    DB    _32BIT_OPERAND
    ADD   AX,WORD PTR [SI + BX]
    DB    _32BIT_OPERAND
    MOV   WORD PTR [ES:DI],AX
    ADD   SI,4
    ADD   DI,4
    DEC   CX
    JNZ   @L1
    POP   DS
  End; { Asm }
End; { Digital }
*)
(*
Procedure SetFM(Chan: Byte; On: Boolean);
Begin
  FMChanOn[Chan] := FMChanOn[Chan] And $DF;
  If On Then FMChanOn[Chan] := FMChanOn[Chan] Or $20;
  WriteFM(Chan + $B0,FMChanOn[Chan]);
End; { SetFM }


Procedure SetFMVoice(Chan,Voc: Word);
Var B,C,Index,Len,Oct,Freq: Word;
  F         : Single;
Begin
  If Not Config.DoSound Then Exit;
  Voc := Voc And $F;
  Game.FMVoc[Chan] := Voc;
  If FMSoundType[Voc] <> stNoise
   Then FMFeedback[Chan] := 0 Else FMFeedback[Chan] := 1;
  WriteFM(Chan + $C0,FMFeedBack[Chan]);

  { Operator 1 }

  B := FMReg[Chan];

  If FMSoundType[Voc] = stPureTone
   Then C := $3F - $0D
   Else C := $3F - 7;
  If FMFeedBack[Chan] <> 0 Then C := 0;
  C := 0;
  FMBaseLevel[B] := C;
  F   := Table[(Game.FMFreq[Chan] Shl 4) + Game.FMVoc[Chan]];
  Oct := 7;
  While (F < 512) And (Oct > 0) Do
  Begin
    Dec(Oct);
    F := F + F;
  End; { While }
  Freq := Round(F);
  If Freq > 1023 Then Freq := 1023;
  WriteFM(Chan + $A0,Freq And $FF);
  FMChanOn[Chan] := $20 Or ((((Freq Shr 8) And 3) Or (Oct Shl 2)) And $1F);
  WriteFM(Chan + $B0,FMChanOn[Chan]);
  If FMScale[Chan] = 0 Then C := $3F Else C := 15 - FMScale[Chan];
  WriteFM(B + $20,$21);    { AM/Vib/EG/KSR/Multiple     }
  WriteFM(B + $40,C);      { Total level                }
  WriteFM(B + $60,$80);    { Attack/decay rates         }
  WriteFM(B + $80,$08);    { Sustain level/release rate }
  WriteFM(B + $E0,0{2});      { Wave select                }

  { Operator 2 }

  B := FMReg[Chan + $09];
  C := 0;
  If FMFeedBack[Chan] <> 0 Then C := 0;
  FMBaseLevel[B] := C;
  If FMScale[Chan] = 0 Then C := $3F Else C := 15 - FMScale[Chan];
  WriteFM(B + $20,$21);                { AM/Vib/EG/KSR/Multiple     }
  WriteFM(B + $40,C);                  { Total level                }
  WriteFM(B + $60,$80);                { Attack/decay rates         }
  WriteFM(B + $80,$08);                { Sustain level/release rate }
  If FMSoundType[Voc] = stPureTone
   Then WriteFM(B + $E0,0)             { Wave select                }
   Else WriteFM(B + $E0,1);            { Wave select                }
End; { SetFMVoice }


Procedure SetGame.FMFreq(Chan: Byte; Freq: Word);
Var
  Index,Len : Word;
  F         : Single;
  Oct       : Word;

Begin
  If Not Config.DoSound Then Exit;
  Freq := Freq And $1F;
  Game.FMFreq[Chan] := Freq;
  F   := Table[(Freq Shl 4) + Game.FMVoc[Chan]];
  Oct := 7;
  While (F < 512) And (Oct > 0) Do
  Begin
    Dec(Oct);
    F := F + F;
  End; { While }
  Freq := Round(F);
  If Freq > 1023 Then Freq := 1023;
  WriteFM(Chan + $A0,Freq And $FF);
  FMChanOn[Chan] := $20 Or ((((Freq Shr 8) And 3) Or (Oct Shl 2)) And $1F);
  WriteFM(Chan + $B0,FMChanOn[Chan]);
End; { SetGame.FMFreq }


Procedure SetGame.FMFreq1(Chan: Byte; Freq: Word);
{ -------------------------------------------------------------------- }
{ Used only for Pitfall II.  Freq is really the wavelength.            }
{ -------------------------------------------------------------------- }
Var
  Index,Len : Word;
  F         : Single;
  Oct       : Word;

Begin
  If Game.FMFreq[Chan] <> Freq Then
  Begin
    Game.FMFreq[Chan] := Freq;
    Oct := 7;
    F := 3000 / Freq;
    While (F < 512) And (Oct > 0) Do
    Begin
      Dec(Oct);
      F := F + F;
    End; { While }
    Freq := Round(F);
    If Freq > 1023 Then Freq := 1023;
    WriteFM(Chan + $A0,Freq And $FF);
    FMChanOn[Chan] := $20 Or ((((Freq Shr 8) And 3) Or (Oct Shl 2)) And $1F);
    WriteFM(Chan + $B0,FMChanOn[Chan]);
  End;
End; { SetGame.FMFreq1 }


Procedure SetFMScale(Chan,Scale: Word);
Var B,C,Index,Len: Word;
Begin
  If Not Config.DoSound Then Exit;
  Scale := Scale And $F;
  Game.FMRealScale[Chan] := Scale;
  If Scale > 15 Then Scale := 15;
  FMScale[Chan] := Scale;

  { Operator 1 }

  B := FMReg[Chan];
  C := FMBaseLevel[B];
  If FMScale[Chan] = 0 Then C := $3F Else C := 15 - FMScale[Chan];
  If FMFeedBack[Chan] <> 0 Then C := $3F;
  C := $1F;
  WriteFM(B + $40,C);                   { Total level }

  { Operator 2 }

  B := FMReg[Chan + $09];
  C := FMBaseLevel[B];
  If FMScale[Chan] = 0 Then C := $3F Else C := 15 - FMScale[Chan];
  If FMFeedBack[Chan] <> 0 Then C := $3F;
  WriteFM(B + $40,C);                     { Total level }
End; { SetFMScale }


Procedure DSPWrite(B: Byte);
Var B1: Byte;
Begin
  Repeat
    B1 := Port[$22C];
  Until (B1 And $80) = 0;
  Port[$22C] := B;
End; { DSPWrite }
*)

Procedure SetVoice(Chan,Voc: Word);
Begin
  If Config.DoSound Then
  Begin
    Game.FMVoc[Chan] := Voc And $F;
    If AUDC[Chan] <> Game.FMVoc[Chan] Then
    Begin
      Update_TIA_Sound(AUDC0 + Chan,Game.FMVoc[Chan]);
{      FillBuffer;}
{      Digital(Chan);}
    End;
  End;
End; { SetVoice }


Procedure SetFrequency(Chan,Freq: Word);
Begin
  If Config.DoSound Then
  Begin
    Game.FMFreq[Chan] := Freq And $1F;
    If AUDF[Chan] <> Game.FMFreq[Chan] Then
    Begin
      Update_TIA_Sound(AUDF0 + Chan,Game.FMFreq[Chan]);
{      FillBuffer;}
{      Digital(Chan);}
    End;
  End;
End; { SetFrequency }


Procedure SetVolume(Chan,Scale: Word);
Begin
  If Config.DoSound Then
  Begin
    Game.FMRealScale[Chan] := Scale And $F;
    If (AUDV[Chan] Shr 3) <> Game.FMRealScale[Chan] Then
    Begin
      Update_TIA_Sound(AUDV0 + Chan,Game.FMRealScale[Chan]);
{      FillBuffer;}
{      Digital(Chan);}
    End;
  End;
End; { SetVolume }


Procedure ResetClock;
Begin
  Time0 := Clock;
End; { ResetClock }


Procedure SaveStatus;
Var
  F     : File;
  Save  : TSave;
  St    : String;
  App   : PVGAApplication;

Begin
  App := New(PVGAApplication,Init(Config.MaxCols,Game.MaxRows,False,False,True));
  St  := UpperCase(Trim(App^.FileDialog('Save game state','*.*','')));
  Dispose(App,Done);
  If CreateFile(Config.MaxCols,Game.MaxRows,F,St) Then
  Begin
    Move(Game,Save,SizeOf(Game));

  { --------------------- From SPUnit ------------------------ }

    Save.SPBank              := SPBank;
    Save.SPSearch            := SPSearch;
    Save.SPBoot              := SPBoot;

    Move(WaveLen,Save.WaveLen,SizeOf(WaveLen));
    Move(Pulse,Save.Pulse,SizeOf(Pulse));
    Move(Phase,Save.Phase,SizeOf(Phase));
    Move(Signal,Save.Signal,SizeOf(Signal));
    Move(Wave,Save.Wave,SizeOf(Wave));

    BlockWrite(F,Save,SizeOf(Save));
    BlockWrite(F,AtariSeg,SizeOf(AtariSeg));
    If Game.Cart = ctMNetwork
     Then BlockWrite(F,ROMBackup^,Game.ROMSize + 2048)
     Else BlockWrite(F,ROMBackup^,Game.ROMSize);
    SaveSPP2Status(F);
    Close(F);
  End;
  ResetClock;
End; { SaveStatus }


Procedure RestoreStatus;
Var
  F     : File;
  Save  : TSave;
  St    : String;
  App   : PVGAApplication;

Begin
  App := New(PVGAApplication,Init(Config.MaxCols,Game.MaxRows,False,False,True));
  St  := UpperCase(Trim(App^.FileDialog('Load game state','*.*','')));
  Dispose(App,Done);
  If CanOpenFile(Config.MaxCols,Game.MaxRows,St) Then
  Begin
    If Game.Cart = ctMNetwork
     Then FreeMem(ROMBackup,Game.ROMSize + 2048)
     Else FreeMem(ROMBackup,Game.ROMSize);
    Assign(F,St);
    Reset(F,1);
    BlockRead(F,Save,SizeOf(Save));
    BlockRead(F,AtariSeg,SizeOf(AtariSeg));
    If Save.Cart = ctMNetwork
     Then GetMem(ROMBackup,Save.ROMSize + 2048)
     Else GetMem(ROMBackup,Save.ROMSize);
    If Save.Cart = ctMNetwork
     Then BlockRead(F,ROMBackup^,Save.ROMSize + 2048)
     Else BlockRead(F,ROMBackup^,Save.ROMSize);
    RestoreSPP2Status(F);
    Close(F);

    Move(Save,Game,SizeOf(Game));

  { --------------------- From SPUnit ------------------------ }

    SPBank              := Save.SPBank;
    SPSearch            := Save.SPSearch;
    SPBoot              := Save.SPBoot;

    Move(Save.WaveLen,WaveLen,SizeOf(WaveLen));
    Move(Save.Pulse,Pulse,SizeOf(Pulse));
    Move(Save.Phase,Phase,SizeOf(Phase));
    Move(Save.Signal,Signal,SizeOf(Signal));
    Move(Save.Wave,Wave,SizeOf(Wave));

    If Config.DoSound Then
    Begin
      SetVolume(0,Game.FMRealScale[0]);
      SetFrequency(0,Game.FMFreq[0]);
      SetVoice(0,Game.FMVoc[0]);
      SetVolume(1,Game.FMRealScale[1]);
      SetFrequency(1,Game.FMFreq[1]);
      SetVoice(1,Game.FMVoc[1]);
    End;
  End;
  ResetClock;
End; { RestoreStatus }

(*
Procedure JoyStatus; Assembler;
{ ------------------------------------------------------------------------- }
{ Returns:                                                                  }
{    BL - JoyStatus                                                         }
{    ECX - X1  ESI - X2                                                       }
{    EDX - Y1  EDI - Y2                                                       }
{ ------------------------------------------------------------------------- }
Asm

{  CALL   FillBuffer}

  DB     _32BIT_OPERAND
  SUB    BX,BX
  DB     _32BIT_OPERAND
  SUB    CX,CX
  DB     _32BIT_OPERAND
  SUB    SI,SI
  DB     _32BIT_OPERAND
  SUB    DI,DI
  MOV    DX,0201h
{  CLI}
  SUB    AH,AH

  { Reset delays }

@L2:
  INC    BX
  CMP    BX,8000
  JE     @L2A
  IN     AL,DX
  TEST   AL,0Fh
  JNZ    @L2
@L2A:
  DB     _32BIT_OPERAND
  SUB    BX,BX

  OUT    DX,AL
  JMP    @L1
@L1:
  AAA

  { Get coordinates }

@L3:
  IN     AL,DX
  TEST   AL,1            { Player 1 X coordinate }
  JZ     @L4
  DB     _32BIT_OPERAND
  INC    BX
  JZ     @L6
{  CMP    BX,1000h
  JA     @L6}
@L4:
  TEST   AL,2            { Player 1 Y coordinate }
  JZ     @L5
  DB     _32BIT_OPERAND
  INC    CX
  JZ     @L6
{  JC     @L6}
{  CMP    CX,1000h
  JA     @L6}
@L5:
  IN     AL,DX
  TEST   AL,4            { Player 2 X coordinate }
  JZ     @L4A
  DB     _32BIT_OPERAND
  INC    SI
  JZ     @L6
{  CMP    SI,1000h
  JA     @L6}
@L4A:
  TEST   AL,8            { Player 2 Y coordinate }
  JZ     @L5A
  DB     _32BIT_OPERAND
  INC    DI
  JZ     @L6
{  JC     @L6}
{  CMP    DI,1000h
  JA     @L6}
@L5A:
  MOV    AH,0Fh
  TEST   BYTE PTR Config.UseJoystick2,0FFh
  JNZ    @Use2
{  TEST   BYTE PTR Config.UseRealControllers,0FFh
  JNZ    @Use2}
  MOV    AH,3
@Use2:
  TEST   AL,AH
  JNZ    @L3
@L6:
{  STI}
  DB     _32BIT_OPERAND
  MOV    DX,CX
  DB     _32BIT_OPERAND
  MOV    CX,BX
  MOV    BX,AX
  SUB    BH,BH
  SHR    BX,1
  SHR    BX,1
  SHR    BX,1
  SHR    BX,1
  XOR    BX,0Fh
{
  PUSHA
  CALL   FillBuffer
  POPA
}
End; { JoyStatus }
*)
(*
Function HexByte(B: Byte): String;
Const Digit: String = '0123456789ABCDEF';
Begin
  HexByte := Digit[(B Shr 4) + 1] +
             Digit[(B And $F) + 1];
End; { HexByte }


Function HexWord(W: Word): String;
Const Digit: String = '0123456789ABCDEF';
Begin
  HexWord := Digit[((W Shr 12) And $F) + 1] +
             Digit[((W Shr 8) And $F) + 1] +
             Digit[((W Shr 4) And $F) + 1] +
             Digit[(W And $F) + 1];
End; { HexWord }


Function Int2Str(L: LongInt): String;
Var St: String;
Begin
  Str(L,St);
  Int2Str := St;
End; {Int2Str }
*)

(*
Function Timer: Real;
Begin
  Timer := (Mem[0:$46F] * 1677722.0 + Mem[0:$46E] * 65536.0 +
            Mem[0:$46D] * 256       + Mem[0:$46C]) / 18.20648;
End; { Timer }
*)
(*
Procedure Unassemble(PC: Word; Var Bank: Word);
Var
  Addr     : Word;
  _Addr    : Word;
  B        : Byte;
  Instr    : String[3];
  Opcode   : Byte;
  _PC      : Word;
  NewBank  : Word;

Begin

  { Tally instructions }

  _PC            := PC - $1000 + Bank * 1024;
  Branched^[_PC] := True;
  While Not Executed^[_PC] Do
  Begin
    Executed^[_PC] := True;
    Opcode         := AtariSeg[PC];
    Instr          := Mnem[Opcode];

    { Handle some Game.BankSwitching }

    If ATyp[Opcode] = 'ABS' Then
    Begin
      Addr := MemW[Seg(AtariSeg):Ofs(AtariSeg) + PC + 1] And $1FFF;
      If Game.BankSwitch[Addr] <> 0 Then
      Begin
        Case Game.BankSwitch[Addr] Of
          1..13: Begin                             { 2k/4k/8k/16k }
                   NewBank := Game.BankSwitch[Addr] - 1;
                   Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + NewBank * 1024],AtariSeg[$1000],4096);
                   Unassemble(PC + Bytes[Opcode],NewBank);
                   Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + Bank * 1024],AtariSeg[$1000],4096);
                 End;
       $21..$29: Begin                             { CBS }
                   NewBank := Game.BankSwitch[Addr] - $21;
                   Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + NewBank * 1024],AtariSeg[$1000],4096);
                   Unassemble(PC + Bytes[Opcode],NewBank);
                   Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + Bank * 1024],AtariSeg[$1000],4096);
                 End;
       $40..$4F: Begin                             { SuperChip }
                   NewBank := (Game.BankSwitch[Addr] - $40) Shl 2;
                   Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + NewBank * 1024],AtariSeg[$1000],4096);
                   Unassemble(PC + Bytes[Opcode],NewBank);
                   Move(Mem[Seg(ROMBackup^):Ofs(ROMBackup^) + Bank * 1024],AtariSeg[$1000],4096);
                 End;
        End; { Case }
      End;
    End;

    { Look for control transfer instructions }

    If (Instr = 'JSR') Or
       (Instr = 'BPL') Or
       (Instr = 'BMI') Or
       (Instr = 'BVC') Or
       (Instr = 'BVS') Or
       (Instr = 'BEQ') Or
       (Instr = 'BNE') Or
       (Instr = 'BCC') Or
       (Instr = 'BCS') Then
    Begin
      If Instr = 'JSR'
       Then Addr := MemW[Seg(AtariSeg):Ofs(AtariSeg) + PC + 1] And $1FFF
       Else
       Begin
         B := AtariSeg[PC + 1];
         Asm
           MOV   BX,WORD PTR PC
           ADD   BX,2
           MOV   AL,BYTE PTR B
           CBW
           ADD   BX,AX
           MOV   WORD PTR Game.Addr,BX
         End; { Asm }
       End;
      _Addr            := Addr - $1000 + Bank * 1024;
{      Branched^[_Addr] := True;}
      Unassemble(Addr,Bank);
    End;
    If Instr <> 'RTS' Then
    Begin
      If Instr = 'JMP' Then
      Begin
        If ATyp[Opcode] = 'ABS'
         Then PC := MemW[Seg(AtariSeg):Ofs(AtariSeg) + PC + 1] And $1FFF
         Else PC := MemW[Seg(AtariSeg):Ofs(AtariSeg) +
                     MemW[Seg(AtariSeg):Ofs(AtariSeg) + PC + 1] And $1FFF] And $1FFF;
        _PC := PC - $1000 + Bank * 1024;
        Branched^[_PC] := True;
      End
      Else Inc(PC,Bytes[Opcode]);
    End;
    _PC := PC - $1000 + Bank * 1024;
  End; { While }
End; { Unassemble }
*)
{$F+}
{Procedure Handle_TIA; Far; External;}
{ $ L HAND_TIA.OBJ}
{$F-}

Procedure SwitchBank; Assembler;
Asm
  PUSH  DX
  PUSH  BX
  PUSH  AX
  PUSH  CX
  PUSH  DI
  PUSH  DS
  PUSH  SI

  MOV   BYTE PTR DebugLoad,0

  { Save the current bank to simulate RAM if necessary }

  CMP   BYTE PTR Game.Cart,ctMNetwork
{  TEST  BYTE PTR MNetwork,0FFh}
  JNE   @NoCopyBack{CheckStarpath}

  CMP   BYTE PTR Game.BankSwitch[BX],0DCh
  JAE   @NoCopyBack
  CMP   BYTE PTR Game.BankSwitch[BX],0D8h
  JAE   @CopyBack256
  CMP   BYTE PTR Game.CurrentBank,7
  JNE   @NoCopyBack



  MOV   SI,1000h
  MOV   CX,256
  MOV   AX,4000h
{  CMP   BYTE PTR Game.CurrentBank,7
  JE    @NotCopying256}
  JMP   @NotCopying256

@CopyBack256:
  MOV   CX,64
  MOV   AH,BYTE PTR Game.MNetworkRAM{Game.CurrentBank}
  SUB   AH,8
  SUB   AL,AL
  ADD   AX,4400h
  MOV   SI,1800h
  ADD   SI,OFFSET AtariSeg
@NotCopying256:
  LES   DI,DWORD PTR ROMBackup
  ADD   DI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  JMP   @NoCopyBack


(*
  MOV   AL,BYTE PTR Game.CurrentBank
  SUB   AH,AH
  SHL   AX,10
  MOV   SI,WORD PTR Game.BankStart
  LES   DI,DWORD PTR ROMBackup
  ADD   DI,AX
  CLD
  MOV   CX,WORD PTR Game.BankSize
  DB    _32BIT_OPERAND
  REP   MOVSW
  JMP   @NoCopyBack
*)


{@CheckStarpath:
  TEST  BYTE PTR Starpath,0FFh
  JZ    @NoCopyBack
  CMP   BX,1FF8h
  JNE   @NoCopyBack}


@NoCopyBack:

  { Find out which bank we're switching to }

  MOV   DL,CL  { Save accumulator }
  MOV   CX,AX  { Save X and Y }
  MOV   WORD PTR Game.BankStart,1000h
  MOV   AL,BYTE PTR Game.BankSwitch[BX]
  CMP   AL,29{16}
  JBE   @OneToFour

  { 30/31 means toggle between banks 1 and 2 }

  CMP   AL,0E0h
  JAE   @ParkerBros
  CMP   AL,0D0h
  JAE   @MNetwork

  CMP   AL,0CBh{0CEh}
  JAE   @Pitfall2

  CMP   AL,90h
  JAE   @CommaVid

  CMP   AL,80h
  JAE   @MegaBoy

  CMP   AL,070h
  JAE   @Starpath

  CMP   AL,060h
  JE    @TigerVision

{
  CMP   AL,060h
  JAE   @Pitfall2
}
  CMP   AL,040h
  JAE   @SuperChip
  CMP   AL,20h
  JAE   @CBS
{
  CMP   AL,21
  JE    @Act1
  CMP   AL,17
  JE    @Act1
  SUB   AL,AL
  DEC   BYTE PTR Game.BankSwitch[BX]
  JMP   @Act2
@Act1:
}
  XOR   BYTE PTR Game.BankSwitch[BX],1{4}
  SUB   AL,30
  SHL   AL,2
{  SUB   AL,17}
  XOR   AL,4
{
  JNZ   @Act2
  MOV   BYTE PTR Game.BankSwitch[BX],19
@Act2:
}
  INC   AL
  JMP   @OneToFour

  { Handle 32-in-1 MegaBoy }

@MegaBoy:
  INC   BYTE PTR Game.MegaBoyNum
  AND   BYTE PTR Game.MegaBoyNum,0Fh
  CMP   BYTE PTR Game.MegaBoyNum,0Fh
  JNE   @NotMBLast
  MOV   CX,3FCh
  MOV   AX,DS
  MOV   ES,AX
  MOV   DI,1000h
  ADD   DI,OFFSET AtariSeg
  CLD
  PUSH  DS
  SUB   AX,AX
  MOV   AL,BYTE PTR Game.MegaBoyNum
  SHL   AX,12
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS
  MOV   SI,OFFSET Game.MegaBoy
  MOV   CX,4
  DB    _32BIT_OPERAND
  REP   MOVSW
(*
  PUSH  DS
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS
  MOV   SI,OFFSET MegaBoy
  MOV   CX,4
  DB    _32BIT_OPERAND
  REP   MOVSW
*)
  JMP   @GetOut
@NotMBLast:
  MOV   CX,400h
  MOV   AX,DS
  MOV   ES,AX
  MOV   DI,1000h
  ADD   DI,OFFSET AtariSeg
  CLD
  PUSH  DS
  SUB   AX,AX
  MOV   AL,BYTE PTR Game.MegaBoyNum
  SHL   AX,12
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
{  PUSH  SI}
  DB    _32BIT_OPERAND
  REP   MOVSW
{  POP   SI}
(*
  MOV   CX,200h
  DB    _32BIT_OPERAND
  REP   MOVSW
*)
  POP   DS
  JMP   @GetOut

  { Handle Starpath Supercharger }

@Starpath:
(*  CMP   BYTE PTR [DI],0CDh   { Look for CMP abs/abs. x/abs. y }
  JE    @SPYes
  CMP   BYTE PTR [DI],0D9h
  JE    @SPYes
  CMP   BYTE PTR [DI],0DDh
  JE    @SPYes
  POP   SI
  POP   DS
  JMP   @NoDebug
@SPYes:*)
{  CMP   BX,11FEh
  JA    @Write}
{  CMP   WORD PTR Game.StarpathLastAddr,0
  JNE   @Write}
{@NoWrite:}

{  CMP   WORD PTR [DI + 1],0EFF0h
  JB    @NotRAM
  CMP   WORD PTR [DI + 1],0F0FFh
  JA    @Write
  JMP   @NoWrite}



{ -------------------------------------------------------- }
{ Intermediate Starpath code begins here                   }
{ -------------------------------------------------------- }

(*
  PUSH  BX
  TEST  BYTE PTR Game.StarpathWrite,1
  JNZ   @MustBeWriting
@GetAddress:

  { Check for indirect Y }

  MOV   AL,BYTE PTR [DI]
  PUSH  DS
  MOV   DS,WORD PTR Global_Save_DS
  MOV   SI,AX
  AND   SI,0FFh
  SHL   SI,2
  MOV   DX,WORD PTR ATyp[SI + 1]
  MOV   AL,BYTE PTR ATyp[SI + 3]
  POP   DS
  CMP   DL,'I'             { Indirect/Immediate }
  JNE   @NotIndY
  CMP   DH,'.'             { Indirect }
  JNE   @NotIndY
  CMP   AL,'Y'             { Indirect Y }
  JNE   @NotIndY
  MOV   CX,WORD PTR [DI + 1]
  CMP   CX,1000h
  JB    @NotIndY
  CMP   CX,10FFh
  JA    @NotIndY
  MOV   BX,CX
@NotIndY:
  CMP   BX,010FFh
  JA    @NotRAM
  MOV   BYTE PTR Game.StarpathWrite,1
  MOV   BYTE PTR Game.StarpathWriteValue,BL
  JMP   @NotRAM
@MustBeWriting:
  MOV   BYTE PTR Game.StarpathWrite,0
  CMP   BX,1100h
  JB    @GetAddress
  CMP   BX,1FF8h                            { Always write enabled }
  JE    @Writing
  TEST  BYTE PTR Game.SPBankNum,2         { If write isn't enabled, exit }
  JZ    @NotRAM
  CMP   BX,1800h
  JB    @Writing
  TEST  BYTE PTR Game.SPBankNum,8         { Can't write to the ROM area }
  JZ    @NotRAM
@Writing:
  MOV   AL,BYTE PTR Game.StarpathWriteValue
  MOV   BYTE PTR [BX],AL
  CMP   BX,1FF8h                            { Check for bank switch }
  JNE   @NotRAM                             { Exit if not }

  { Perform a bank switch }

  { Copy back to ROM backup to simulate RAM }

  PUSH  DI
  PUSH  BX

  TEST  BYTE PTR Debugger,0FFh
  JZ    @NoDebugA
  MOV   BX,WORD PTR Game.OldStart
  CMP   BX,1000h
  JL    @NoDebugA
  MOV   AL,BYTE PTR Game.OldByte
  MOV   BYTE PTR [BX],AL
@NoDebugA:

  MOV   BL,BYTE PTR Game.SPBankNum
  SHR   BL,1
  AND   BL,0Eh
  SUB   BH,BH

  MOV   AX,WORD PTR SP1[BX]       { Copy the low bank }
  MOV   CX,200h
  MOV   SI,1000h
  LES   DI,DWORD PTR ROMBackup
  ADD   DI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW

  MOV   AX,WORD PTR SP2[BX]       { Copy the high bank }
  MOV   CX,200h
  MOV   SI,1800h
  LES   DI,DWORD PTR ROMBackup
  ADD   DI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW

  POP   BX
  POP   DI

  { Copy in the new banks }

  MOV   BX,DS
  MOV   ES,BX
  MOV   BL,AtariSeg[1FF8h]
  MOV   DL,BL
  SHR   BL,1
  AND   BL,0Eh
  SUB   BH,BH

  MOV   AX,WORD PTR SP1[BX]       { Copy the low bank }
  MOV   CX,200h
  MOV   DI,1000h
  PUSH  DS
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS

  MOV   AX,WORD PTR SP2[BX]       { Copy the high bank }
  MOV   CX,200h
  MOV   DI,1800h
  PUSH  DS
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS

  MOV   BYTE PTR Game.SPBankNum,DL      { Set to the new bank }
  MOV   BYTE PTR AtariSeg[1FF8h],DL
  POP   BX
  JMP   @GetOut

@NotRAM:
  POP   BX
  POP   SI
  POP   DS
  JMP   @NoDebug
*)

{ -------------------------------------------------------- }
{ Intermediate Starpath code ends here                     }
{ -------------------------------------------------------- }


{ -------------------------------------------------------- }
{ New Starpath code begins here                            }
{ -------------------------------------------------------- }
{
  PUSH  OFFSET AtariSeg
  PUSH  DS

}  MOV   AX,WORD PTR Game.SPBankNum
{  MOV   DS,WORD PTR Global_Save_DS}
{
  DB    _32BIT_OPERAND
  PUSH  WORD PTR AtariSeg
}

  DB    _32BIT_OPERAND
  PUSH  WORD PTR ASeg

  DB    _32BIT_OPERAND
  PUSH  WORD PTR ROMBackup
  SUB   DI,OFFSET AtariSeg
  PUSH  DI
  PUSH  BX
  PUSH  AX


  PUSH  WORD PTR Game.TIA_Count
  PUSH  WORD PTR Game.TIA_Scan
  PUSH  WORD PTR Game.ROMSize

  TEST  BYTE PTR Debugger,0FFh
  JZ    @NoDebugA1
  MOV   BX,WORD PTR Game.OldStart
  CMP   BX,1000h
  JL    @NoDebugA1
  MOV   CL,BYTE PTR Game.OldByte
  MOV   BYTE PTR AtariSeg[BX],CL
@NoDebugA1:

  CALL  HandleStarpath
  MOV   CL,BYTE PTR SPBank

  MOV   BYTE PTR Game.SPBankNum,CL



  TEST  BYTE PTR Debugger,0FFh
  JZ    @NoDebugA
{  TEST  AL,0FFh
  JZ    @NoDebugA}
  MOV   BX,WORD PTR Game.OldStart
  CMP   BX,1000h
  JL    @NoDebugA
  MOV   CL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR Game.OldByte,CL
  MOV   BYTE PTR AtariSeg[BX],BreakInstruction
@NoDebugA:
  POP   SI
  POP   DS
  JMP   @NoDebug


{ -------------------------------------------------------- }
{ New Starpath code ends here                              }
{ -------------------------------------------------------- }

{ -------------------------------------------------------- }
{ Old Starpath code begins here                            }
{ -------------------------------------------------------- }

(*
  MOV   AL,BYTE PTR [DI]
  PUSH  DS
  MOV   DS,WORD PTR Global_Save_DS
  MOV   SI,AX
  AND   SI,0FFh
{  MOV   AH,BYTE PTR SPBank[SI]}
  SHL   SI,2
  MOV   DX,WORD PTR ATyp[SI + 1]
  MOV   AL,BYTE PTR ATyp[SI + 3]
  POP   DS
{  TEST  AH,0FFh
  JZ    @NotRAM}


  CMP   DL,'I'             { Indirect/Immediate }
  JE    @SPContI
  CMP   DL,'A'             { Absolute/Accumulator }
  JE    @SPContA
  JMP   @NotRAM
@SPContA:
  CMP   DH,'C'             { Accumulator }
  JE    @NotRAM
  JMP   @SPCont1
@SPContI:
  CMP   DH,'.'             { Indirect }
  JNE   @NotRAM
@SPCont1:


  CMP   BX,01000h
  JB    @NotRAM
  CMP   BX,010FFh
  JBE   @NoWrite
  CMP   BX,011FEh
  JA    @Write




  CMP   DL,'I'
  JE    @Indirect
  CMP   DL,'A'
  JNE   @NotRAM
  CMP   DH,'B'            { ABS/A.X/A.Y/ACC }
  JE    @Write
  CMP   DH,'C'
  JE    @NotRAM
  CMP   AL,'Y'
  JE    @SubY
  SUB   CH,CH             { Absolute X }
  MOV   SI,BX
  SUB   SI,CX
  CMP   SI,010FFh
  JA    @Write
  JMP   @NoWrite
@Indirect:                { IMP/I.X/I.Y/IMM/I+A }
  CMP   DH,'.'
  JNE   @NotRAM
  CMP   AL,'X'
  JE    @Write
@SubY:
  MOV   CL,CH             { Absolute Y }
  SUB   CH,CH
  MOV   SI,BX
  SUB   SI,CX
  CMP   SI,010FFh
  JA    @Write
  JMP   @NoWrite

@NoWrite:
  MOV   WORD PTR Game.StarpathLastAddr,BX
@NotRAM:
  POP   SI
  POP   DS
  JMP   @NoDebug
@Write:
  CMP   WORD PTR Game.StarpathLastAddr,0
  JE    @NotRAM
  CMP   BX,1FF8h
  JE    @SPCont
  TEST  BYTE PTR Game.SPBankNum,2{[1FF8h],2}
  JZ    @NotRAM
  MOV   AL,BYTE PTR Game.StarpathLastAddr
  MOV   BYTE PTR AtariSeg[BX],AL
  MOV   WORD PTR Game.StarpathLastAddr,0
  POP   SI
  POP   DS
  JMP   @NoDebug

@SPCont:

  { Copy back to ROM backup to simulate RAM }

  PUSH  DI
  PUSH  BX

  TEST  BYTE PTR Debugger,0FFh
  JZ    @NoDebugA
  MOV   BX,WORD PTR Game.OldStart
  CMP   BX,1000h
  JL    @NoDebugA
  MOV   AL,BYTE PTR Game.OldByte
  MOV   BYTE PTR AtariSeg[BX],AL
@NoDebugA:

  MOV   BL,BYTE PTR Game.SPBankNum{[1FF8h]}
  SHR   BL,1
  AND   BL,0Eh
  SUB   BH,BH
  MOV   AX,WORD PTR SP1[BX]
  MOV   CX,200h
  MOV   SI,1000h
  LES   DI,DWORD PTR ROMBackup
  ADD   DI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW

  MOV   AX,WORD PTR SP2[BX]
  MOV   CX,200h
  MOV   SI,1800h
  LES   DI,DWORD PTR ROMBackup
  ADD   DI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW

  POP   BX
  POP   DI

  { Copy in the new banks }

  MOV   BX,DS
  MOV   ES,BX
  MOV   BL,BYTE PTR Game.StarpathLastAddr
  MOV   DL,BL
  SHR   BL,1
  AND   BL,0Eh
  SUB   BH,BH

  MOV   AX,WORD PTR SP1[BX]
  MOV   CX,200h
  MOV   DI,1000h
  PUSH  DS
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS

  MOV   AX,WORD PTR SP2[BX]
  MOV   CX,200h
  MOV   DI,1800h
  PUSH  DS
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS

  MOV   BYTE PTR Game.SPBankNum,DL{[1FF8h],DL}
  MOV   WORD PTR Game.StarpathLastAddr,0
  JMP   @GetOut
*)
{ -------------------------------------------------------- }
{ Old Starpath code ends here                              }
{ -------------------------------------------------------- }


  { Handle TigerVision games }

@TigerVision:
  MOV   AL,BYTE PTR AtariSeg[003Fh]
  CMP   AL,BYTE PTR Game.TigerLimit
  JBE   @TigerLimitOk
  MOV   AL,BYTE PTR Game.TigerLimit
@TigerLimitOk:
{  AND   AX,3}
  MOV   BYTE PTR Game.CurrentBank,AL
  SHL   AX,11
  MOV   BX,DS
  MOV   ES,BX
  MOV   DI,1000h{WORD PTR Game.BankStart}
  ADD   DI,OFFSET AtariSeg
  MOV   CX,512{WORD PTR Game.BankSize}
  MOV   BYTE PTR DebugLoad,1
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  JMP   @GetOut


  { Handle Pitfall II }

@Pitfall2:

  CMP   AL,0CDh
  JB    @PF2Copy

  PUSH  AX
  PUSH  BX
  PUSH  CX
  PUSH  DX

  AND   AX,0FFh
  AND   DX,0FFh

{  PUSH  OFFSET AtariSeg
  PUSH  DS}

  DB    _32BIT_OPERAND
  PUSH  WORD PTR ASeg

{
  DB    _32BIT_OPERAND
  PUSH  WORD PTR AtariSeg
}
  PUSH  AX
  PUSH  BX
  PUSH  CX
  PUSH  DX
  SUB   DI,OFFSET AtariSeg
  PUSH  DI
  CALL  HandlePitfall2

  POP   DX
  POP   CX
  POP   BX
  POP   AX

  POP   SI
  POP   DS
  JMP   @NoDebug
@PF2Copy:

  MOV   BX,DS
  MOV   ES,BX
  MOV   SI,80h
  CMP   AL,0CCh
  JNE   @PF2C1
  MOV   SI,1080h
@PF2C1:
  MOV   DI,1080h
  ADD   DI,OFFSET AtariSeg
  MOV   CX,1E0h
  PUSH  DS
  MOV   BX,WORD PTR ROMBackup[2]
  ADD   SI,WORD PTR ROMBackup
  MOV   DS,BX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS
  ADD   SI,80h
  ADD   DI,80h
  MOV   CX,1E0h
  PUSH  DS
  MOV   BX,WORD PTR ROMBackup[2]
  MOV   DS,BX
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS

  MOV   BYTE PTR DebugLoad,1
  JMP   @GetOut
{
  POP   SI
  POP   DS
  MOV   BYTE PTR DebugLoad,1
  JMP   @NoDebug
}
(*
  CMP   AL,0CEh
  JE    @PF2Read
  MOV   AL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR AtariSeg[BX - 40h],AL
  XOR   BX,800h
  MOV   BYTE PTR AtariSeg[BX],AL
  MOV   BYTE PTR AtariSeg[BX - 40h],AL
  XOR   BX,800h
  POP   SI
  POP   DS
  JMP   @NoDebug
@PF2Read:
  AND   BX,03Fh
  INC   WORD PTR PF2ReadCount[BX]
  MOV   CX,WORD PTR PF2ReadCount[BX]
  CMP   CX,39Bh
  JB    @NoPF2Roll
  SUB   CX,CX
  MOV   WORD PTR PF2ReadCount[BX],CX
@NoPF2Roll:
{  AND   CX,3F00h}
  SHL   CX,10
  MOV   SI,CX
  ADD   SI,BX
  MOV   AX,WORD PTR PF2Read[2]
  MOV   ES,AX
  ADD   SI,WORD PTR PF2Read
  MOV   AL,ES:[SI]
  MOV   BYTE PTR AtariSeg[BX + 1000h],AL
  MOV   BYTE PTR AtariSeg[BX + 1800h],AL
*)
  POP   SI
  POP   DS
  JMP   @NoDebug

(*
  SUB   AL,060h
  DEC   AL
  MOV   BYTE PTR Game.CurrentBank,AL
  SUB   AH,AH
  SHL   AX,10
  MOV   BX,DS
  MOV   ES,BX
  MOV   DI,WORD PTR Game.BankStart
  ADD   DI,80h

  MOV   CX,WORD PTR Game.BankSize
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  ADD   SI,80h
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW

  MOV   CX,WORD PTR Game.BankSize
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  ADD   SI,880h
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW

  JMP   @GetOut
*)
  { Handle CommaVid RAM cart }

@CommaVid:

  { Copy RAM write area to the read area }

  MOV   AL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR AtariSeg[BX - 400h],AL
  JMP   @GetOut

  { Handle 16K Atari super chip }

@SuperChip:

  CMP   AL,5Fh
  JB    @SwitchSC

  { Copy RAM write area to the read area }

  MOV   AL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR AtariSeg[BX + 80h],AL
  JMP   @GetOut

  { Switch the bank, but don't copy over the RAM area }

@SwitchSC:
  SUB   AL,040h
{  DEC   AL}
  MOV   BYTE PTR Game.CurrentBank,AL
  SUB   AH,AH
  SHL   AX,12{10}
  MOV   BX,DS
  MOV   ES,BX
  MOV   DI,WORD PTR Game.BankStart
  ADD   DI,100h
  ADD   DI,OFFSET AtariSeg
  MOV   CX,WORD PTR Game.BankSize
  MOV   BYTE PTR DebugLoad,1
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  ADD   SI,100h
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  JMP   @GetOut

  { Handle Parker Brothers special bank switching }

@ParkerBros:
  SUB   AL,0E0h
  MOV   BL,AL
  AND   AL,7
  INC   AL
  AND   BX,18h
  SHL   BX,7
  ADD   BX,1000h
  MOV   WORD PTR Game.BankStart,BX
  JMP   @OneToFour

  { Handle M-Network bank switching }

@MNetwork:
  SUB   AL,0D0h
{
  CMP   BYTE PTR Game.CurrentBank,8
  JB    @NoCopyHiROM
  CMP   AL,8
  JAE   @NoCopyHiROM

  MOV   CX,DS
  MOV   ES,CX
  MOV   DI,1800h
  MOV   CX,512
  PUSH  DS
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,3800h
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS

@NoCopyHiROM:
}
  CMP   AL,0Ch
  JAE   @NoSaveBankNum
  MOV   BYTE PTR Game.CurrentBank,AL
@NoSaveBankNum:

  CMP   AL,7
  JB    @LoadROM
  CMP   AL,0Ch
  JNE   @Not1kWrite
  CMP   BYTE PTR Game.CurrentBank,7
  JNE   @GetOut
  MOV   AL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR AtariSeg[BX + 1024],AL
  JMP   @GetOut
@Not1kWrite:
  CMP   AL,0Dh
  JNE   @Not256Write
{  CMP   BYTE PTR Game.CurrentBank,8
  JB    @GetOut}
  MOV   AL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR AtariSeg[BX + 256],AL
  JMP   @GetOut
@Not256Write:
  MOV   CX,256
  MOV   DX,4000h
  MOV   DI,1000h
  CMP   AL,8
  JB    @Not256
  MOV   BYTE PTR Game.MNetworkRAM,AL
  SHR   CX,2
  MOV   DH,AL
  SUB   DH,8
  SUB   DL,DL
  ADD   DX,4400h
  MOV   DI,1800h
@Not256:
  ADD   DI,OFFSET AtariSeg
  MOV   BX,DS
  MOV   ES,BX

  { Load a 1k/256-byte RAM bank }

  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,DX
  CLD
  PUSH  SI
  PUSH  CX
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   CX
  POP   SI
  DB    _32BIT_OPERAND
  REP   MOVSW
  JMP   @GetOut
@LoadROM:
  SUB   AH,AH
  SHL   AX,11
  MOV   BX,DS
  MOV   ES,BX
  MOV   DI,1000h
  ADD   DI,OFFSET AtariSeg
  MOV   CX,512
  MOV   BYTE PTR DebugLoad,1
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  JMP   @GetOut

  { Handle CBS RAM-Plus bank switching }

@CBS:
  CMP   AL,30h
  JB    @Switch

  { Copy RAM write area to the read area }

  MOV   AL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR AtariSeg[BX + 100h],AL
  JMP   @GetOut

  { Switch the bank, but don't copy over the RAM area }

@Switch:
  SUB   AL,020h
  DEC   AL
  MOV   BYTE PTR Game.CurrentBank,AL
  SUB   AH,AH
  SHL   AX,10
  MOV   BX,DS
  MOV   ES,BX
  MOV   DI,WORD PTR Game.BankStart
  ADD   DI,200h
  ADD   DI,OFFSET AtariSeg
  MOV   CX,WORD PTR Game.BankSize
  MOV   BYTE PTR DebugLoad,1
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  ADD   SI,200h
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  JMP   @GetOut

  { Copy in the new bank }

@OneToFour:
  DEC   AL
  MOV   BYTE PTR Game.CurrentBank,AL
  SUB   AH,AH
  SHL   AX,10
  MOV   BX,DS
  MOV   ES,BX
  MOV   DI,WORD PTR Game.BankStart
  ADD   DI,OFFSET AtariSeg
  MOV   CX,WORD PTR Game.BankSize

  CMP   BYTE PTR Game.Cart,ctPitfall2
  JNE   @NotP2
  MOV   CX,01E0h
  ADD   AX,80h
  ADD   DI,80h

  MOV   BYTE PTR DebugLoad,1
  PUSH  DS
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
  POP   DS

  MOV   CX,01E0h
  ADD   DI,80h
  ADD   AX,800h

  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW

  JMP   @GetOut
@NotP2:
  MOV   BYTE PTR DebugLoad,1
  LDS   SI,DWORD PTR ROMBackup
  ADD   SI,AX
  CLD
  DB    _32BIT_OPERAND
  REP   MOVSW
@GetOut:
  POP   SI
  POP   DS
  TEST  BYTE PTR Debugger,0FFh
  JZ    @NoDebug
  MOV   BX,WORD PTR Game.OldStart
  CMP   BX,1000h
  JL    @NoDebug

  CMP   BYTE PTR Game.Cart,ctTigerVision
  JNE   @CheckMNetwork
  CMP   BX,1800h
  JAE   @NoDebug
  JMP   @DoDebug
@CheckMNetwork:
  CMP   BYTE PTR Game.Cart,ctMNetwork
  JNE   @CheckParkerBros
  CMP   BX,1800h
  JAE   @NoDebug
@CheckParkerBros:
  CMP   BYTE PTR Game.Cart,ctParkerBros
  JNE   @DoDebug
  CMP   BX,WORD PTR Game.BankStart
  JL    @NoDebug
  MOV   AX,WORD PTR Game.BankStart
  ADD   AX,1024
  CMP   BX,AX
  JGE   @NoDebug
@DoDebug:
  TEST  BYTE PTR DebugLoad,0FFh
  JZ    @NoDebug
{  CMP   BYTE PTR Game.CurrentBank,7}
{  JAE   @NoDebug}
  MOV   AL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR Game.OldByte,AL
  MOV   BYTE PTR AtariSeg[BX],BreakInstruction
@NoDebug:
  POP   DI
  POP   CX
  POP   AX
  POP   BX
  POP   DX
End; { SwitchBank }

(*
Procedure Read_Real; Assembler;
Asm
  MOV   DX,WORD PTR Config.LPT1Port
  ADD   DX,2
  TEST  BYTE PTR AtariSeg[SWACNT1],1
  JZ    @Input
  MOV   AL,0Bh
  OUT   DX,AL
  SUB   DX,2
  JMP   @LO1
@LO1:
  JMP   @LO2
@LO2:
  JMP   @LO3
@LO3:
  MOV   AL,BYTE PTR AtariSeg[SWCHA1]
  OUT   DX,AL
  JMP   @GetOut
@Input:
  MOV   AL,2Bh
  OUT   DX,AL
  SUB   DX,2
  JMP   @LI1
@LI1:
  JMP   @LI2
@LI2:
  JMP   @LI3
@LI3:
  IN    AL,DX
@GetOut:
  MOV   BYTE PTR AtariSeg[SWCHA1],AL
  MOV   BYTE PTR AtariSeg[SWCHA2],AL

  { Look at fire buttons }

  MOV   DX,201h
  SUB   AL,AL
  OUT   DX,AL

  JMP   @RR1
@RR1:
  JMP   @RR2
@RR2:
  JMP   @RR3
@RR3:

  IN    AL,DX
  SHR   AL,4
  XOR   AL,0Fh
  TEST  BYTE PTR Latched,1
  JNZ   @Latched
  XOR   AL,0FFh
  ROR   AL,1
  MOV   AH,AL
  AND   AH,80h
  MOV   BYTE PTR Game.Input_Byte[INPUT4],AH
  ROR   AL,1{2}
  AND   AL,80h
  MOV   BYTE PTR Game.Input_Byte[INPUT5],AL
  JMP   @NextTest

@Latched:
  TEST  AL,1
  JZ    @Button2
  AND   BYTE PTR Game.Input_Byte[INPUT4],7Fh
@Button2:
  TEST  AL,2{4}
  JZ    @NextTest
  AND   BYTE PTR Game.Input_Byte[INPUT5],7Fh
@NextTest:

  { Copy info }

  MOV   AL,BYTE PTR AtariSeg[SWCHB1]
  AND   AL,7
  OR    AL,BYTE PTR Game.ColorOrBW
  OR    AL,BYTE PTR Game.Difficulty1
  OR    AL,BYTE PTR Game.Difficulty2
  OR    AL,3
  AND   AL,0CFh

  OR    AL,14h      { Bits 2 and 4 are always 1 }
  MOV   AH,AL       { Bit 5 mirrors bit 6       }
  SHR   AH,1
  AND   AH,20h
  OR    AL,AH

  MOV   BYTE PTR AtariSeg[SWCHB1],AL
  MOV   BYTE PTR AtariSeg[SWCHB2],AL

  { Check function keys And CBS Booster-Grip keys }

  TEST  BYTE PTR Key[kF1],0FFh
  JZ    @CheckF2
{$IFDEF LOWRES}
  PUSH  160
{$ELSE}
  PUSH  320
{$ENDIF}
  PUSH  WORD PTR Game.MaxRows
  PUSH  DS
  PUSH  OFFSET Game.Difficulty1
  PUSH  DS
  PUSH  OFFSET Game.Difficulty2
  PUSH  DS
  PUSH  OFFSET AutoCenter
  CALL  GameStatus
  CALL  ResetClock
@CheckF2:
  TEST  BYTE PTR Key[kF2],0FFh
  JZ    @CheckF4
  AND   BYTE PTR AtariSeg[SWCHB1],0FEh
@CheckF4:
  TEST  BYTE PTR Key[kF4],0FFh
  JZ    @CheckF5
  AND   BYTE PTR AtariSeg[SWCHB1],0FDh
@CheckF5:
  TEST  BYTE PTR Key[kF5],0FFh
  JZ    @PreCheckF6
  TEST  BYTE PTR ColorOrBWChange,0FFh
  JZ    @CheckF6
  XOR   BYTE PTR Game.ColorOrBW,8
  MOV   BYTE PTR ColorOrBWChange,0
  JMP   @CheckF6
@PreCheckF6:
  MOV   BYTE PTR ColorOrBWChange,1
@CheckF6:
  TEST  BYTE PTR Key[kF6],0FFh
  JZ    @PreCheckF7
  TEST  BYTE PTR Difficulty1Change,0FFh
  JZ    @CheckF7
  XOR   BYTE PTR Game.Difficulty1,40h
  MOV   BYTE PTR Difficulty1Change,0
  JMP   @CheckF7
@PreCheckF7:
  MOV   BYTE PTR Difficulty1Change,1
@CheckF7:
  TEST  BYTE PTR Key[kF7],0FFh
  JZ    @PreCheckF9
  TEST  BYTE PTR Difficulty2Change,0FFh
  JZ    @CheckF9
  XOR   BYTE PTR Game.Difficulty2,80h
  MOV   BYTE PTR Difficulty2Change,0
  JMP   @CheckF9
@PreCheckF9:
  MOV   BYTE PTR Difficulty2Change,1
@CheckF9:
  TEST  BYTE PTR Key[kF9],0FFh
  JZ    @CheckF10
{$IFDEF LOWRES}
  PUSH  160
{$ELSE}
  PUSH  320
{$ENDIF}
  PUSH  WORD PTR Game.MaxRows
  MOV   AL,BYTE PTR Game.Palette
  SUB   AH,AH
  PUSH  AX
  PUSH  DS
  PUSH  OFFSET Pal
  PUSH  DS
  PUSH  OFFSET Pal1
  CALL  ScreenCapture
  CALL  ResetClock
@CheckF10:
  TEST  BYTE PTR Key[kF10],0FFh
  JZ    @PreCheckUp
  TEST  BYTE PTR AutoCenterChange,0FFh
  JZ    @CheckUp
  XOR   BYTE PTR AutoCenter,1
  MOV   BYTE PTR AutoCenterChange,0
  JMP   @CheckUp
@PreCheckUp:
  MOV   BYTE PTR AutoCenterChange,1
@CheckUp:
  TEST  BYTE PTR Key[kF11],0FFh
  JZ    @CheckF12
  MOV   BYTE PTR Key[kF11],0
  CALL  SaveStatus
@CheckF12:
  TEST  BYTE PTR Key[kF12],0FFh
  JZ    @Exiting
  MOV   BYTE PTR Key[kF12],0
  CALL  RestoreStatus
@Exiting:
End; { Read_Real }

Procedure CheckKBController; Assembler;
Asm
  CMP   BYTE PTR Game.Controller,crKeyboard
  JE    @CheckKB
  CMP   BYTE PTR Game.Controller,crVTP
  JE    @CheckKB
  JMP   @GetOut
@CheckKB:

  TEST  BYTE PTR Config.UseRealControllers,0FFh
  JZ    @NotReal
  CALL  Read_Real
{  TEST  BYTE PTR KBWrite,0FFh
  JNZ   @GetOut}

{
  CALL  JoyStatus
  OR    BYTE PTR Game.Input_Byte[INPUT0],80h
  OR    BYTE PTR Game.Input_Byte[INPUT1],80h
  OR    BYTE PTR Game.Input_Byte[INPUT2],80h
  OR    BYTE PTR Game.Input_Byte[INPUT3],80h
  CMP   DX,4097
  JNZ   @KB1
  AND   BYTE PTR Game.Input_Byte[INPUT0],7Fh
@KB1:
  CMP   CX,4097
  JNZ   @KB2
  AND   BYTE PTR Game.Input_Byte[INPUT1],7Fh
@KB2:
  CMP   DI,4097
  JNZ   @KB3
  AND   BYTE PTR Game.Input_Byte[INPUT2],7Fh
@KB3:
  CMP   SI,4097
  JNZ   @KB4
  AND   BYTE PTR Game.Input_Byte[INPUT3],7Fh
@KB4:
}



  OR    BYTE PTR Game.Input_Byte[INPUT0],80h
  OR    BYTE PTR Game.Input_Byte[INPUT1],80h
  OR    BYTE PTR Game.Input_Byte[INPUT2],80h
  OR    BYTE PTR Game.Input_Byte[INPUT3],80h

  MOV   DX,0201h
  SUB   AL,AL
  OUT   DX,AL

  MOV   CX,1000
@_KB1:
  LOOP  @_KB1

{
  JMP   @_KB1
@_KB1:
  JMP   @_KB2
@_KB2:
  JMP   @_KB3
@_KB3:
}

  IN    AL,DX

  TEST  AL,2
  JZ    @KB1
  AND   BYTE PTR Game.Input_Byte[INPUT0],7Fh
@KB1:
  TEST  AL,1
  JZ    @KB2
  AND   BYTE PTR Game.Input_Byte[INPUT1],7Fh
@KB2:
  TEST  AL,8
  JZ    @KB3
  AND   BYTE PTR Game.Input_Byte[INPUT2],7Fh
@KB3:
  TEST  AL,4
  JZ    @KB4
  AND   BYTE PTR Game.Input_Byte[INPUT3],7Fh
@KB4:


  JMP   @GetOut
@NotReal:

  MOV   BL,BYTE PTR AtariSeg[SWCHA1]
  MOV   AX,1001h
  MOV   CX,4
  MOV   BH,BYTE PTR AtariSeg[VBLANK]
@KeyLoop1:
  TEST  BL,AL
  JNZ   @NoTest

  CMP   BYTE PTR Game.Controller,crVTP
  JE    @Row4

  TEST  BYTE PTR Game.KeyColumn[0],AH
  JZ    @Off1
  TEST  BH,80h
  JNZ   @Off1
  AND   BYTE PTR Game.Input_Byte[INPUT0],7Fh
  JMP   @Row2
@Off1:
  OR    BYTE PTR Game.Input_Byte[INPUT0],80h
@Row2:

  TEST  BYTE PTR Game.KeyColumn[1],AH
  JZ    @Off2
  TEST  BH,80h
  JNZ   @Off2
  AND   BYTE PTR Game.Input_Byte[INPUT1],7Fh
  JMP   @Row3
@Off2:
  OR    BYTE PTR Game.Input_Byte[INPUT1],80h
@Row3:

  TEST  BYTE PTR Game.KeyColumn[2],AH
  JZ    @Off3
  AND   BYTE PTR Game.Input_Byte[INPUT4],7Fh
  JMP   @Row4
@Off3:
  OR    BYTE PTR Game.Input_Byte[INPUT4],80h
@Row4:

  TEST  BYTE PTR Game.KeyColumn[0],AL
  JZ    @Off4
  TEST  BH,80h
  JNZ   @Off4
  AND   BYTE PTR Game.Input_Byte[INPUT2],7Fh
  JMP   @Row5
@Off4:
  OR    BYTE PTR Game.Input_Byte[INPUT2],80h
@Row5:

  TEST  BYTE PTR Game.KeyColumn[1],AL
  JZ    @Off5
  TEST  BH,80h
  JNZ   @Off5
  AND   BYTE PTR Game.Input_Byte[INPUT3],7Fh
  JMP   @Row6
@Off5:
  OR    BYTE PTR Game.Input_Byte[INPUT3],80h
@Row6:

  TEST  BYTE PTR Game.KeyColumn[2],AL
  JZ    @Off6
  AND   BYTE PTR Game.Input_Byte[INPUT5],7Fh
  JMP   @NoTest
@Off6:
  OR    BYTE PTR Game.Input_Byte[INPUT5],80h

@NoTest:
  ADD    AL,AL
  ADD    AH,AH
  DEC    CX
  JNZ    @KeyLoop1
@GetOut:
End; { CheckKBController }
*)
Procedure CheckKBController; Assembler;
Asm
  CMP   BYTE PTR Game.Controller,crKeyboard
  JE    @CheckKB
  CMP   BYTE PTR Game.Controller,crVTP
  JE    @CheckKB
  JMP   @GetOut
@CheckKB:

  MOV   BL,BYTE PTR AtariSeg[SWCHA1]
  MOV   AX,1001h
  MOV   CX,4
  MOV   BH,BYTE PTR AtariSeg[VBLANK]
@KeyLoop1:
  TEST  BL,AL
  JNZ   @NoTest

  CMP   BYTE PTR Game.Controller,crVTP
  JE    @Row4

  TEST  BYTE PTR Game.KeyColumn[0],AH
  JZ    @Off1
  TEST  BH,80h
  JNZ   @Off1
  AND   BYTE PTR Game.Input_Byte[INPUT0],7Fh
  JMP   @Row2
@Off1:
  OR    BYTE PTR Game.Input_Byte[INPUT0],80h
@Row2:

  TEST  BYTE PTR Game.KeyColumn[1],AH
  JZ    @Off2
  TEST  BH,80h
  JNZ   @Off2
  AND   BYTE PTR Game.Input_Byte[INPUT1],7Fh
  JMP   @Row3
@Off2:
  OR    BYTE PTR Game.Input_Byte[INPUT1],80h
@Row3:

  TEST  BYTE PTR Game.KeyColumn[2],AH
  JZ    @Off3
  AND   BYTE PTR Game.Input_Byte[INPUT4],7Fh
  JMP   @Row4
@Off3:
  OR    BYTE PTR Game.Input_Byte[INPUT4],80h
@Row4:

  TEST  BYTE PTR Game.KeyColumn[0],AL
  JZ    @Off4
  TEST  BH,80h
  JNZ   @Off4
  AND   BYTE PTR Game.Input_Byte[INPUT2],7Fh
  JMP   @Row5
@Off4:
  OR    BYTE PTR Game.Input_Byte[INPUT2],80h
@Row5:

  TEST  BYTE PTR Game.KeyColumn[1],AL
  JZ    @Off5
  TEST  BH,80h
  JNZ   @Off5
  AND   BYTE PTR Game.Input_Byte[INPUT3],7Fh
  JMP   @Row6
@Off5:
  OR    BYTE PTR Game.Input_Byte[INPUT3],80h
@Row6:

  TEST  BYTE PTR Game.KeyColumn[2],AL
  JZ    @Off6
  AND   BYTE PTR Game.Input_Byte[INPUT5],7Fh
  JMP   @NoTest
@Off6:
  OR    BYTE PTR Game.Input_Byte[INPUT5],80h

@NoTest:
  ADD    AL,AL
  ADD    AH,AH
  DEC    CX
  JNZ    @KeyLoop1
@GetOut:
End; { CheckKBController }


Procedure NewPalette;
Begin
  If Game.Palette = 0 Then SetPalette(Pal) Else SetPalette(Pal1);
  Repeat Until Key[kF3] = 0;
End; { NewPalette }

(*
Procedure Handle_Input; Assembler;
{ ---------------------------------------------------------------------- }
{ Any variables this accesses must either be global or contained here!!! }
{ ---------------------------------------------------------------------- }
{ Joy ---- BL }
{ X ------ CX }
{ Y ------ DX }
{  Joy := JoyStatus(X,Y);}
Asm
  TEST  BYTE PTR Key[kF3],0FFh
  JZ    @CheckEqual
  XOR   BYTE PTR Game.Palette,1
  CALL  NewPalette
@CheckEqual:
  TEST  BYTE PTR Key[kEQUAL],0FFh
  JZ    @CheckMinus
  CMP   WORD PTR Game.VUserAdd,-40
  JLE   @CheckMinus
  DEC   WORD PTR Game.VUserAdd
@CheckMinus:
  TEST  BYTE PTR Key[kMINUS],0FFh
  JZ    @CheckReal
  CMP   WORD PTR Game.VUserAdd,40
  JGE   @CheckReal
  INC   WORD PTR Game.VUserAdd
@CheckReal:
  TEST  BYTE PTR Config.UseRealControllers,0FFh
  JZ    @NotReal
  CALL  Read_Real
  CMP   BYTE PTR Cart,ctCBS
  JNE   @NotRealCBS
  CALL  JoyStatus
  AND   WORD PTR Game.Input_Byte[INPUT0],7F7Fh
  CMP   DX,20
  JAE   @CheckCBS2
  OR    BYTE PTR Game.Input_Byte[INPUT0],80h
@CheckCBS2:
  CMP   CX,20
  JAE   @NotRealCBS
  OR    BYTE PTR Game.Input_Byte[INPUT1],80h
@NotRealCBS:
  JMP   @GetOut
@NotReal:

  SUB   BX,BX
{  MOV   CX,50
  MOV   DX,50}

  { If the keyboard controllers are being used, don't check the joysticks }

  CMP   BYTE PTR Game.Controller,crKeyboard
  JE    @CheckDone2

  { Check joysticks }

  TEST  BYTE PTR Config.UseJoystick1,0FFh
  JNZ   @CheckJoy
{  OR    BYTE PTR AtariSeg[SWCHA1],0FFh}
  JMP   @CheckDone2
@CheckJoy:
  CALL  JoyStatus
  MOV   AL,BL

  { Look at fire buttons }

  TEST  BYTE PTR Latched,1
  JNZ   @Latched
  XOR   AL,0FFh

  MOV   BYTE PTR Game.Input_Byte[INPUT4],0
  TEST  AL,BYTE PTR Config.Player1Fire
  JZ    @Button2NotLatched
  OR    BYTE PTR Game.Input_Byte[INPUT4],80h
@Button2NotLatched:
  CMP   BYTE PTR Game.Controller,crVTP
  JE    @NextTest
  MOV   BYTE PTR Game.Input_Byte[INPUT5],0
  TEST  AL,BYTE PTR Config.Player2Fire
  JZ    @NextTest
  OR    BYTE PTR Game.Input_Byte[INPUT5],80h
{
  ROR   AL,1
  MOV   AH,AL
  AND   AH,80h
  MOV   BYTE PTR Game.Input_Byte[INPUT4],AH

  CMP   BYTE PTR Game.Controller,crVTP
  JE    @NextTest
  ROR   AL,2
  AND   AL,80h
  MOV   BYTE PTR Game.Input_Byte[INPUT5],AL
}
  JMP   @NextTest

@Latched:
  TEST  AL,BYTE PTR Config.Player1Fire
  JZ    @Button2
  AND   BYTE PTR Game.Input_Byte[INPUT4],7Fh
@Button2:

  CMP   BYTE PTR Game.Controller,crVTP
  JE    @NextTest
  TEST  AL,BYTE PTR Config.Player2Fire
  JZ    @NextTest
  AND   BYTE PTR Game.Input_Byte[INPUT5],7Fh
@NextTest:

  { Emulate Indy 500 controllers }

  CMP   BYTE PTR Game.Controller,crVTP
  JE    @CheckJoysticks
  CMP   BYTE PTR Game.Controller,crDriving
  JNE   @CheckJoysticks

  { Player 1 }

  DB    _32BIT_OPERAND
  CMP   CX,WORD PTR JoyMinX
  JGE   @LeftFalseI500
  DEC   WORD PTR Game.Indy500
  JMP   @CheckDoneI500
@LeftFalseI500:
  DB    _32BIT_OPERAND
  CMP   CX,WORD PTR JoyMaxX
  JLE   @CheckDoneI500
  INC   WORD PTR Game.Indy500
@CheckDoneI500:

  { Player 2 }

  DB    _32BIT_OPERAND
  CMP   SI,WORD PTR JoyMinX2
  JGE   @LeftFalseI500A
  DEC   WORD PTR Game.Indy500[2]
  JMP   @CheckDoneI500A
@LeftFalseI500A:
  DB    _32BIT_OPERAND
  CMP   SI,WORD PTR JoyMaxX2
  JLE   @CheckDoneI500A
  INC   WORD PTR Game.Indy500[2]
@CheckDoneI500A:

  PUSH  SI
  OR    BYTE PTR AtariSeg[SWCHA1],0FFh
  MOV   SI,WORD PTR Game.Indy500
  AND   SI,3
  MOV   AL,BYTE PTR Indy500Trans[SI]
  MOV   SI,WORD PTR Game.Indy500[2]
  AND   SI,3
  MOV   AH,BYTE PTR Indy500Trans[SI]
  ROR   AH,4
  AND   AL,AH
  AND   BYTE PTR AtariSeg[SWCHA1],AL
  POP   SI
  JMP   @CheckDone2

@CheckJoysticks:

  CMP   BYTE PTR Game.Controller,crPaddle
  JE    @CheckDone2

  { Check player 1's joystick }

  MOV   AH,BYTE PTR AtariSeg[SWACNT1]
{
  TEST  AH,10h
  JNZ   @CheckDown
}
  DB    _32BIT_OPERAND
  CMP   DX,WORD PTR JoyMinY
  JGE   @UpFalse
  AND   BYTE PTR AtariSeg[SWCHA1],0EFh
  JMP   @CheckDown
@UpFalse:
  OR    BYTE PTR AtariSeg[SWCHA1],10h
@CheckDown:
{
  TEST  AH,20h
  JNZ   @CheckLeft
}
  DB    _32BIT_OPERAND
  CMP   DX,WORD PTR JoyMaxY
  JLE   @DownFalse
  AND   BYTE PTR AtariSeg[SWCHA1],0DFh
  JMP   @CheckLeft
@DownFalse:
  OR    BYTE PTR AtariSeg[SWCHA1],20h
@CheckLeft:
{
  TEST  AH,40h
  JNZ   @CheckRight
}
  DB    _32BIT_OPERAND
  CMP   CX,WORD PTR JoyMinX
  JGE   @LeftFalse
  AND   BYTE PTR AtariSeg[SWCHA1],0BFh
  JMP   @CheckRight
@LeftFalse:
  OR    BYTE PTR AtariSeg[SWCHA1],40h
@CheckRight:
{
  TEST  AH,80h
  JNZ   @CheckDone
}
  DB    _32BIT_OPERAND
  CMP   CX,WORD PTR JoyMaxX
  JLE   @RightFalse
  AND   BYTE PTR AtariSeg[SWCHA1],07Fh
  JMP   @CheckDone
@RightFalse:
  OR    BYTE PTR AtariSeg[SWCHA1],80h
@CheckDone:

  { Check player 2's joystick }

  CMP   BYTE PTR Game.Controller,crVTP
  JE    @CheckDone2
  TEST  BYTE PTR Config.UseJoystick2,0FFh
  JZ    @CheckDone2

  MOV   AH,BYTE PTR AtariSeg[SWACNT1]
  TEST  AH,1
  JNZ   @CheckDown2
  DB    _32BIT_OPERAND
  CMP   DI,WORD PTR JoyMinY2
  JGE   @UpFalse2
  AND   BYTE PTR AtariSeg[SWCHA1],0FEh
  JMP   @CheckDown2
@UpFalse2:
  OR    BYTE PTR AtariSeg[SWCHA1],1
@CheckDown2:
  TEST  AH,2
  JNZ   @CheckLeft2
  DB    _32BIT_OPERAND
  CMP   DI,WORD PTR JoyMaxY2
  JLE   @DownFalse2
  AND   BYTE PTR AtariSeg[SWCHA1],0FDh
  JMP   @CheckLeft2
@DownFalse2:
  OR    BYTE PTR AtariSeg[SWCHA1],2
@CheckLeft2:
  TEST  AH,4
  JNZ   @CheckRight2
  DB    _32BIT_OPERAND
  CMP   SI,WORD PTR JoyMinX2
  JGE   @LeftFalse2
  AND   BYTE PTR AtariSeg[SWCHA1],0FBh
  JMP   @CheckRight2
@LeftFalse2:
  OR    BYTE PTR AtariSeg[SWCHA1],4
@CheckRight2:
  TEST  AH,8
  JNZ   @CheckDone2
  DB    _32BIT_OPERAND
  CMP   SI,WORD PTR JoyMaxX2
  JLE   @RightFalse2
  AND   BYTE PTR AtariSeg[SWCHA1],0F7h
  JMP   @CheckDone2
@RightFalse2:
  OR    BYTE PTR AtariSeg[SWCHA1],8
@CheckDone2:

  { Copy info }

  MOV   AL,BYTE PTR AtariSeg[SWCHA1]
  MOV   BYTE PTR AtariSeg[SWCHA2],AL

  MOV   AL,BYTE PTR AtariSeg[SWCHB1]
  AND   AL,7
  OR    AL,BYTE PTR Game.ColorOrBW
  OR    AL,BYTE PTR Game.Difficulty1
  OR    AL,BYTE PTR Game.Difficulty2
  OR    AL,3
  AND   AL,0CFh

  CMP   BYTE PTR Cart,ctCBS
  JE    @BoosterGrip

  { Handle joystick select/reset functions }

  TEST  BL,BYTE PTR Config.JoystickReset
  JZ    @Button3
  AND   AL,0FEh
@Button3:
  TEST  BL,BYTE PTR Config.JoystickSelect
  JZ    @ButtonDone
  AND   AL,0FDh
  JMP   @ButtonDone

  { Handle joystick Booster-Grip buttons }

@BoosterGrip:

  TEST  BYTE PTR Config.UseJoystick1,0FFh
  JZ    @ButtonDone
  MOV   BYTE PTR Key[kLBRACE],0
  MOV   BYTE PTR Key[kRBRACE],0

{  OR    BYTE PTR Game.Input_Byte[INPUT0],80h}
  TEST  BL,BYTE PTR Config.JoystickReset {2}
  JZ    @Button3A
{  OR    BYTE PTR Game.Input_Byte[INPUT0],80h}
{  AND   BYTE PTR Game.Input_Byte[INPUT0],07Fh}
  MOV   BYTE PTR Key[kLBRACE],1
@Button3A:
{  OR    BYTE PTR Game.Input_Byte[INPUT1],80h}
  TEST  BL,BYTE PTR Config.JoystickSelect {8}
  JZ    @ButtonDone
{  OR    BYTE PTR Game.Input_Byte[INPUT1],80h}
{  AND   BYTE PTR Game.Input_Byte[INPUT1],07Fh}
  MOV   BYTE PTR Key[kRBRACE],1
@ButtonDone:

  OR    AL,14h      { Bits 2 and 4 are always 1 }
  MOV   AH,AL       { Bit 5 mirrors bit 6       }
  SHR   AH,1
  AND   AH,20h
  OR    AL,AH


  MOV   BYTE PTR AtariSeg[SWCHB1],AL
  MOV   BYTE PTR AtariSeg[SWCHB2],AL

  { Check function keys And CBS Booster-Grip keys }

  CMP   BYTE PTR Cart,ctCBS
  JNE   @CheckF1

  TEST  BYTE PTR AtariSeg[VBLANK],80h
  JNZ   @CheckF1

{  OR    BYTE PTR Game.Input_Byte[INPUT0],80h}
  AND   BYTE PTR Game.Input_Byte[INPUT0],07Fh
  TEST  BYTE PTR Key[kLBRACE],0FFh
  JZ    @CheckRBrace
  OR    BYTE PTR Game.Input_Byte[INPUT0],80h
{  AND   BYTE PTR Game.Input_Byte[INPUT0],07Fh}
@CheckRBrace:
{  OR    BYTE PTR Game.Input_Byte[INPUT1],80h}
  AND   BYTE PTR Game.Input_Byte[INPUT1],07Fh
  TEST  BYTE PTR Key[kRBRACE],0FFh
  JZ    @CheckF1
  OR    BYTE PTR Game.Input_Byte[INPUT1],80h
{  AND   BYTE PTR Game.Input_Byte[INPUT1],07Fh}
@CheckF1:
  TEST  BYTE PTR Key[kF1],0FFh
  JZ    @CheckF2
{$IFDEF LOWRES}
  PUSH  160
{$ELSE}
  PUSH  320
{$ENDIF}
  PUSH  WORD PTR Game.MaxRows
  PUSH  DS
  PUSH  OFFSET Game.Difficulty1
  PUSH  DS
  PUSH  OFFSET Game.Difficulty2
  PUSH  DS
  PUSH  OFFSET AutoCenter
  CALL  GameStatus
  CALL  ResetClock
@CheckF2:
  TEST  BYTE PTR Key[kF2],0FFh
  JZ    @CheckF4
  AND   BYTE PTR AtariSeg[SWCHB1],0FEh
@CheckF4:
  TEST  BYTE PTR Key[kF4],0FFh
  JZ    @CheckF5
  AND   BYTE PTR AtariSeg[SWCHB1],0FDh
@CheckF5:
  TEST  BYTE PTR Key[kF5],0FFh
  JZ    @PreCheckF6
  TEST  BYTE PTR ColorOrBWChange,0FFh
  JZ    @CheckF6
  XOR   BYTE PTR Game.ColorOrBW,8
  MOV   BYTE PTR ColorOrBWChange,0
  JMP   @CheckF6
@PreCheckF6:
  MOV   BYTE PTR ColorOrBWChange,1
@CheckF6:
  TEST  BYTE PTR Key[kF6],0FFh
  JZ    @PreCheckF7
  TEST  BYTE PTR Difficulty1Change,0FFh
  JZ    @CheckF7
  XOR   BYTE PTR Game.Difficulty1,40h
  MOV   BYTE PTR Difficulty1Change,0
  JMP   @CheckF7
@PreCheckF7:
  MOV   BYTE PTR Difficulty1Change,1
@CheckF7:
  TEST  BYTE PTR Key[kF7],0FFh
  JZ    @PreCheckF9
  TEST  BYTE PTR Difficulty2Change,0FFh
  JZ    @CheckF9
  XOR   BYTE PTR Game.Difficulty2,80h
  MOV   BYTE PTR Difficulty2Change,0
  JMP   @CheckF9
@PreCheckF9:
  MOV   BYTE PTR Difficulty2Change,1
@CheckF9:
  TEST  BYTE PTR Key[kF9],0FFh
  JZ    @CheckF10
{$IFDEF LOWRES}
  PUSH  160
{$ELSE}
  PUSH  320
{$ENDIF}
  PUSH  WORD PTR Game.MaxRows
  MOV   AL,BYTE PTR Game.Palette
  SUB   AH,AH
  PUSH  AX
  PUSH  DS
  PUSH  OFFSET Pal
  PUSH  DS
  PUSH  OFFSET Pal1
  CALL  ScreenCapture
  CALL  ResetClock
@CheckF10:
  TEST  BYTE PTR Key[kF10],0FFh
  JZ    @PreCheckF11
  TEST  BYTE PTR AutoCenterChange,0FFh
  JZ    @CheckF11
  XOR   BYTE PTR AutoCenter,1
  MOV   BYTE PTR AutoCenterChange,0
  JMP   @CheckF11
@PreCheckF11:
  MOV   BYTE PTR AutoCenterChange,1
@CheckF11:
  TEST  BYTE PTR Key[kF11],0FFh
  JZ    @CheckF12
  MOV   BYTE PTR Key[kF11],0
  CALL  SaveStatus
@CheckF12:
  TEST  BYTE PTR Key[kF12],0FFh
  JZ    @CheckUp
  MOV   BYTE PTR Key[kF12],0
  CALL  RestoreStatus
@CheckUp:

  { Check keyboard }

  CMP   BYTE PTR Game.Controller,crKeyboard
  JE    @KeyCont
  TEST  BYTE PTR Config.UseJoystick1,0FFh
  JNZ   @CheckP2Fire{@KeyCont}

  { Player 1 fire button }

  TEST  BYTE PTR Latched,1
  JNZ   @Latched1

  MOV   AL,BYTE PTR Key[kSPACE]
  OR    AL,BYTE PTR Key[kEENTER]
  DB    0Fh,94h,0C0h    { SETZ AL }
  ROR   AL,1
  MOV   BYTE PTR Game.Input_Byte[INPUT4],AL
  JMP   @CheckP2Fire
@Latched1:
  MOV   AL,BYTE PTR Key[kSPACE]
  OR    AL,BYTE PTR Key[kEENTER]
  JZ    @CheckP2Fire
{  MOV   BYTE PTR Game.Input_Byte[INPUT4],0}
  AND   BYTE PTR Game.Input_Byte[INPUT4],7Fh
@CheckP2Fire:

  { Player 2 fire button }

  TEST  BYTE PTR Config.UseJoystick2,0FFh
  JNZ   @CheckI500Keys
  CMP   BYTE PTR Game.Controller,crVTP
  JE    @CheckKeys
  TEST  BYTE PTR Latched,1
  JNZ   @Latched1A
  TEST  BYTE PTR Key[kENTER],0FFh
  DB    0Fh,94h,0C0h    { SETZ AL }
  ROR   AL,1
  MOV   BYTE PTR Game.Input_Byte[INPUT5],AL
  JMP   @CheckI500Keys
@Latched1A:
  TEST  BYTE PTR Key[kENTER],0FFh
  JZ    @CheckI500Keys
{  MOV   BYTE PTR Game.Input_Byte[INPUT5],0}
  AND   BYTE PTR Game.Input_Byte[INPUT5],7Fh

@CheckI500Keys:

  { Emulate Indy 500 controllers }

  CMP   BYTE PTR Game.Controller,crDriving
  JNE   @CheckKeys

  { Player 1 }

  TEST  BYTE PTR Config.UseJoystick1,0FFh
  JNZ   @CheckKeys
  MOV   AL,BYTE PTR Key[kLF]
  OR    AL,BYTE PTR Key[kP4]
  JZ    @LeftFalseI500K
  DEC   WORD PTR Game.Indy500
  JMP   @CheckDoneI500K
@LeftFalseI500K:
  MOV   AL,BYTE PTR Key[kRT]
  OR    AL,BYTE PTR Key[kP6]
  JZ    @CheckDoneI500K
  INC   WORD PTR Game.Indy500
@CheckDoneI500K:

  { Player 2 }

  TEST  BYTE PTR Key[kJ],0FFh
  JZ    @LeftFalseI500KA
  DEC   WORD PTR Game.Indy500[2]
  JMP   @CheckDoneI500KA
@LeftFalseI500KA:
  TEST  BYTE PTR Key[kL],0FFh
  JZ    @CheckDoneI500KA
  INC   WORD PTR Game.Indy500[2]
@CheckDoneI500KA:

  PUSH  SI
  OR    BYTE PTR AtariSeg[SWCHA1],0FFh
  MOV   SI,WORD PTR Game.Indy500
  AND   SI,3
  MOV   AL,BYTE PTR Indy500Trans[SI]
  MOV   SI,WORD PTR Game.Indy500[2]
  AND   SI,3
  MOV   AH,BYTE PTR Indy500Trans[SI]
  ROR   AH,4
  AND   AL,AH
  AND   BYTE PTR AtariSeg[SWCHA1],AL
  POP   SI
  JMP   @GetOut

@CheckKeys:

  { Player 1 }

  CMP   BYTE PTR Game.Controller,crPaddle
  JE    @CheckDone1A
  TEST  BYTE PTR Config.UseJoystick1,0FFh
  JNZ   @CheckDone1

  MOV   AH,BYTE PTR AtariSeg[SWACNT1]

{  OR    BYTE PTR AtariSeg[SWCHA1],0F0h}
  TEST  AH,10h
  JNZ   @CheckDown1
  MOV   AL,BYTE PTR Key[kUP]
  OR    AL,BYTE PTR Key[kP8]
  JZ    @Up1Off
  AND   BYTE PTR AtariSeg[SWCHA1],0EFh
  OR    BYTE PTR AtariSeg[SWCHA1],20h
  JMP   @CheckLeft1
@Up1Off:
  OR    BYTE PTR AtariSeg[SWCHA1],10h
@CheckDown1:
  TEST  AH,20h
  JNZ   @CheckLeft1
  MOV   AL,BYTE PTR Key[kDN]
  OR    AL,BYTE PTR Key[kP2]
  JZ    @Down1Off
  AND   BYTE PTR AtariSeg[SWCHA1],0DFh
  OR    BYTE PTR AtariSeg[SWCHA1],10h
  JMP   @CheckLeft1
@Down1Off:
  OR    BYTE PTR AtariSeg[SWCHA1],20h
@CheckLeft1:
  TEST  AH,40h
  JNZ   @CheckRight1
  MOV   AL,BYTE PTR Key[kLF]
  OR    AL,BYTE PTR Key[kP4]
  JZ    @Left1Off
  AND   BYTE PTR AtariSeg[SWCHA1],0BFh
  OR    BYTE PTR AtariSeg[SWCHA1],80h
  JMP   @CheckDone1
@Left1Off:
  OR    BYTE PTR AtariSeg[SWCHA1],40h
@CheckRight1:
  TEST  AH,80h
  JNZ   @CheckDone1
  MOV   AL,BYTE PTR Key[kRT]
  OR    AL,BYTE PTR Key[kP6]
  JZ    @Right1Off
  AND   BYTE PTR AtariSeg[SWCHA1],07Fh
  OR    BYTE PTR AtariSeg[SWCHA1],40h
  JMP   @CheckDone1
@Right1Off:
  OR    BYTE PTR AtariSeg[SWCHA1],80h
@CheckDone1:
  MOV   AL,BYTE PTR AtariSeg[SWCHA1]
  MOV   BYTE PTR AtariSeg[SWCHA2],AL

  { Player 2 }

  TEST  BYTE PTR Config.UseJoystick2,0FFh
  JNZ   @KeyCont
  CMP   BYTE PTR Game.Controller,crVTP
  JE    @KeyCont

  MOV   AH,BYTE PTR AtariSeg[SWACNT1]

{  OR    BYTE PTR AtariSeg[SWCHA1],0Fh}
  TEST  AH,1
  JNZ   @CheckDown1A
  TEST  BYTE PTR Key[kI],0FFh
  JZ    @Up2Off
  AND   BYTE PTR AtariSeg[SWCHA1],0FEh
  OR    BYTE PTR AtariSeg[SWCHA1],2
  JMP   @CheckLeft1A
@Up2Off:
  OR    BYTE PTR AtariSeg[SWCHA1],1
@CheckDown1A:
  TEST  AH,2
  JNZ   @CheckLeft1A
  TEST  BYTE PTR Key[kK],0FFh
  JZ    @Down2Off
  AND   BYTE PTR AtariSeg[SWCHA1],0FDh
  OR    BYTE PTR AtariSeg[SWCHA1],1
  JMP   @CheckLeft1A
@Down2Off:
  OR    BYTE PTR AtariSeg[SWCHA1],2
@CheckLeft1A:
  TEST  AH,4
  JNZ   @CheckRight1A
  TEST  BYTE PTR Key[kJ],0FFh
  JZ    @Left2Off
  AND   BYTE PTR AtariSeg[SWCHA1],0FBh
  OR    BYTE PTR AtariSeg[SWCHA1],8
  JMP   @CheckDone1A
@Left2Off:
  OR    BYTE PTR AtariSeg[SWCHA1],4
@CheckRight1A:
  TEST  AH,8
  JNZ   @CheckDone1A
  TEST  BYTE PTR Key[kL],0FFh
  JZ    @Right2Off
  AND   BYTE PTR AtariSeg[SWCHA1],0F7h
  OR    BYTE PTR AtariSeg[SWCHA1],4
  JMP   @CheckDone1A
@Right2Off:
  OR    BYTE PTR AtariSeg[SWCHA1],8
@CheckDone1A:
  MOV   AL,BYTE PTR AtariSeg[SWCHA1]
  MOV   BYTE PTR AtariSeg[SWCHA2],AL

  { Check keyboard controllers }

@KeyCont:
  CMP   BYTE PTR Game.Controller,crKeyboard
  JE    @CheckKBCont
  CMP   BYTE PTR Game.Controller,crVTP
  JE    @CheckKBCont
  JMP   @GetOut
@CheckKBCont:
  DB    _32BIT_OPERAND
  SUB   AX,AX
  MOV   BL,0FFh

  { Left controller }

  CMP   BYTE PTR Game.Controller,crVTP
  JE    @Check4
  TEST  BYTE PTR Key[kN1],BL
  JZ    @CheckQ
  OR    AX,10h
@CheckQ:
  TEST  BYTE PTR Key[kQ],BL
  JZ    @CheckA
  OR    AX,20h
@CheckA:
  TEST  BYTE PTR Key[kA],BL
  JZ    @CheckZ
  OR    AX,40h
@CheckZ:
  TEST  BYTE PTR Key[kZ],BL
  JZ    @Check2
  OR    AX,80h
@Check2:

  TEST  BYTE PTR Key[kN2],BL
  JZ    @CheckW
  OR    AX,1000h
@CheckW:
  TEST  BYTE PTR Key[kW],BL
  JZ    @CheckS
  OR    AX,2000h
@CheckS:
  TEST  BYTE PTR Key[kS],BL
  JZ    @CheckX
  OR    AX,4000h
@CheckX:
  TEST  BYTE PTR Key[kX],BL
  JZ    @Check3
  OR    AX,8000h
@Check3:

  TEST  BYTE PTR Key[kN3],BL
  JZ    @CheckE
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    10h
@CheckE:
  TEST  BYTE PTR Key[kE],BL
  JZ    @CheckD
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    20h
@CheckD:
  TEST  BYTE PTR Key[kD],BL
  JZ    @CheckC
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    40h
@CheckC:
  TEST  BYTE PTR Key[kC],BL
  JZ    @Check4
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    80h
@Check4:

  { Right controller }

  TEST  BYTE PTR Key[kN4],BL
  JZ    @CheckR
  OR    AX,1
@CheckR:
  TEST  BYTE PTR Key[kR],BL
  JZ    @CheckF
  OR    AX,2
@CheckF:
  TEST  BYTE PTR Key[kF],BL
  JZ    @CheckV
  OR    AX,4
@CheckV:
  TEST  BYTE PTR Key[kV],BL
  JZ    @Check5
  OR    AX,8
@Check5:

  TEST  BYTE PTR Key[kN5],BL
  JZ    @CheckT
  OR    AX,100h
@CheckT:
  TEST  BYTE PTR Key[kT],BL
  JZ    @CheckG
  OR    AX,200h
@CheckG:
  TEST  BYTE PTR Key[kG],BL
  JZ    @CheckB
  OR    AX,400h
@CheckB:
  TEST  BYTE PTR Key[kB],BL
  JZ    @Check6
  OR    AX,800h
@Check6:

  TEST  BYTE PTR Key[kN6],BL
  JZ    @CheckY
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    1
@CheckY:
  TEST  BYTE PTR Key[kY],BL
  JZ    @CheckH
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    2
@CheckH:
  TEST  BYTE PTR Key[kH],BL
  JZ    @CheckN
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    4
@CheckN:
  TEST  BYTE PTR Key[kN],BL
  JZ    @CheckKBDone
  DB    _32BIT_OPERAND
  OR    AX,0
  DW    8

@CheckKBDone:
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.KeyColumn,AX

{  MOV   BYTE PTR KBWrite,0}
  CALL  CheckKBController

@GetOut:
End; { Handle_Input }
*)
(*
Procedure GetMouseInfo;
Const PadSize = 800;
Var
  MX,MY,MB : Word;
  Paddle   : Array[0..3] Of LongInt;
  JB       : Byte;
  Mask1    : Byte;
  Mask2    : Byte;
  Mask3    : Byte;

  Procedure Swap(Var L1,L2: LongInt);
  Var L: LongInt;
  Begin
    L  := L1;
    L1 := L2;
    L2 := L;
  End; { Swap }

Begin
  If Config.UseRealControllers Then
  Begin
    Paddle[0] := 0;
    Paddle[1] := 0;
    Paddle[2] := 0;
    Paddle[3] := 0;
    Asm
      CALL  JoyStatus
      DB     _32BIT_OPERAND
      MOV   WORD PTR Paddle[0],DX
      DB     _32BIT_OPERAND
      MOV   WORD PTR Paddle[4],CX
      DB     _32BIT_OPERAND
      MOV   WORD PTR Paddle[8],DI
      DB     _32BIT_OPERAND
      MOV   WORD PTR Paddle[12],SI
    End; { Asm }
    Paddle[0] := Round(Paddle[0] * (PadMax / Config.PaddleMax));
    Paddle[1] := Round(Paddle[1] * (PadMax / Config.PaddleMax));
    Paddle[2] := Round(Paddle[2] * (PadMax / Config.PaddleMax));
    Paddle[3] := Round(Paddle[3] * (PadMax / Config.PaddleMax));
    If Paddle[0] > PadMax Then Paddle[0] := PadMax;
    If Paddle[1] > PadMax Then Paddle[1] := PadMax;
    If Paddle[2] > PadMax Then Paddle[2] := PadMax;
    If Paddle[3] > PadMax Then Paddle[3] := PadMax;
    Game.PaddleGround0 := Round(3.1 * 6.4 * Paddle[0]);
    Game.PaddleGround1 := Round(3.1 * 6.4 * Paddle[1]);
    Game.PaddleGround2 := Round(3.1 * 6.4 * Paddle[2]);
    Game.PaddleGround3 := Round(3.1 * 6.4 * Paddle[3]);
  End
  Else
  Begin
    GetMousePosition(Word(MX),Word(MY),Word(MB));
    Game.PaddleGround0 := Round(3.1 * 6.4 * (PadSize - MX * (PadSize / 640)));
    If Config.UseJoystick1 Then
    Begin
      Paddle[0] := 0;
      Paddle[1] := 0;
      Paddle[2] := 0;
      Paddle[3] := 0;
      Asm
        CALL  JoyStatus
        DB     _32BIT_OPERAND
        MOV   WORD PTR Paddle[0],DX
        DB     _32BIT_OPERAND
        MOV   WORD PTR Paddle[4],CX
        DB     _32BIT_OPERAND
        MOV   WORD PTR Paddle[8],DI
        DB     _32BIT_OPERAND
        MOV   WORD PTR Paddle[12],SI
        MOV   BYTE PTR JB,BL
      End; { Asm }
      If Paddle[1] > JoyMaxX Then Paddle[1] := JoyMaxX;
      If Paddle[1] < JoyMinX Then Paddle[1] := JoyMinX;
      Game.PaddleGround1 := Round(3.1 * 6.4 *
       (PadSize - ((Paddle[1] - JoyMinX) * PadSize / (JoyMaxX - JoyMinX))));
    End
    Else Game.PaddleGround1 := PadMax;
    If Config.UseJoystick2 Then
    Begin
      If Paddle[3] > JoyMaxX2 Then Paddle[3] := JoyMaxX2;
      If Paddle[3] < JoyMinX2 Then Paddle[3] := JoyMinX2;
      Game.PaddleGround2 := Round(3.1 * 6.4 *
       (PadSize - ((Paddle[3] - JoyMinX2) * PadSize / (JoyMaxX2 - JoyMinX2))));
    End
    Else Game.PaddleGround2 := PadMax;
    Game.PaddleGround3 := PadMax;
    Case Config.MousePaddle Of
      0: Begin
           Mask1 := $7F;
           Mask2 := $BF;
           Mask3 := $F7;
         End;
      1: Begin
           Swap(Game.PaddleGround0,Game.PaddleGround1);
           Mask1 := $BF;
           Mask2 := $7F;
           Mask3 := $F7;
         End;
      2: Begin
           Swap(Game.PaddleGround0,Game.PaddleGround2);
           Swap(Game.PaddleGround0,Game.PaddleGround1);
           Mask1 := $F7;
           Mask2 := $7F;
           Mask3 := $BF;
         End;
      3: Begin
           Swap(Game.PaddleGround0,Game.PaddleGround3);
           Swap(Game.PaddleGround0,Game.PaddleGround2);
           Swap(Game.PaddleGround0,Game.PaddleGround1);
           Mask1 := $FB;
           Mask2 := $7F;
           Mask3 := $BF;
         End;
    End; { Case }
    AtariSeg[SWCHA1] := AtariSeg[SWCHA1] Or $CC;
    If (MB And 1) <> 0 Then AtariSeg[SWCHA1] := AtariSeg[SWCHA1] And Mask1;
    If (JB And 1) <> 0 Then AtariSeg[SWCHA1] := AtariSeg[SWCHA1] And Mask2;
    If (JB And 4) <> 0 Then AtariSeg[SWCHA1] := AtariSeg[SWCHA1] And Mask3;
  End;
End; { GetMouseInfo }
*)

Procedure SlowDown;
Var
  T{,I} : LongInt;
  R     : Double;

Begin
{  SendScreen(SendBuf,Game.MaxRows,Game.Palette);}
{  R := Time0 + (TimeErr / 1000) + (1000 / Config.FrameRate);}
  R := Time0{ - TimeErr} + (1000{500} / Config.FrameRate);
{  I := Round(R);}
  Repeat
    T := Clock;
{    FillBuffer;}
    If T < (R - 1000) Then T := Trunc(R);
  Until (T >= R);
  Time0   := R;{T;}
{  TimeErr := Round(1000 * (T - R)) Mod 1000;}
{  TimeErr := T - R;}
End; { SlowDown }


Procedure Handle_Timer; Assembler;
Asm
  PUSH   AX
  PUSH   CX
  PUSH   DX
  PUSH   DI
  PUSH   BX

  DB     _32BIT_OPERAND           { EAX = # of elapsed clock cycles }
  MOV    AX,WORD PTR Game.TimerElapsed

  DB     _32BIT_OPERAND
  SUB    BX,BX

  DB     _32BIT_OPERAND
  ADD    AX,WORD PTR Game.TimerX

  MOV    BX,68                    { Include this instruction }
  ADD    BX,WORD PTR Game.TIA_Count
  MOV    BL,BYTE PTR Div3[BX]
  SUB    BH,BH
  ADD    BX,WORD PTR Game.AddCycle
{  DEC    BX
  DEC    BX}

  DB     _32BIT_OPERAND
  ADD    AX,BX

 { ------------------------ }

  DB     _32BIT_OPERAND
  SUB    BX,BX
  MOV    CL,BYTE PTR Game.TimerShift
  DB     _32BIT_OPERAND
  MOV    DX,AX


  MOV    BL,BYTE PTR Game.OrigTimer
  DB     _32BIT_OPERAND
  SHL    BX,CL
  DB     _32BIT_OPERAND
  SUB    BX,DX
  JS     @Depleted
  DB     _32BIT_OPERAND
  SAR    BX,CL
{
  DB     _32BIT_OPERAND
  SHR    DX,CL
  MOV    BL,BYTE PTR Game.OrigTimer
  DB     _32BIT_OPERAND
  SUB    BX,DX
  DB     _32BIT_OPERAND
  DEC    BX
  DB     _32BIT_OPERAND
  OR     BX,BX
  JL     @Depleted
}
  MOV    BYTE PTR AtariSeg[INTTIM1],BL
  MOV    BYTE PTR AtariSeg[INTTIM2],BL
  MOV    BYTE PTR AtariSeg[INTTIM3],0
  JMP    @GetOut
@Depleted:
{  MOV    BYTE PTR AtariSeg[INTTIM3],0
  CMP    BYTE PTR TimerDone,1
  JE     @NoTimerInterrupt}
  MOV    BYTE PTR AtariSeg[INTTIM3],80h
@NoTimerInterrupt:
{  MOV    BYTE PTR TimerDone,1}


  DB     _32BIT_OPERAND
  SAR    BX,CL

{
  DB     _32BIT_OPERAND
  SUB    BX,BX
  MOV    BL,BYTE PTR Game.OrigTimer
  MOV    CL,BYTE PTR Game.TimerShift
  DB     _32BIT_OPERAND
  SHL    BX,CL
  DB     _32BIT_OPERAND
  SUB    BX,AX
  DB     _32BIT_OPERAND
  DEC    BX
}
  { If we're at s/l. MaxScan and the timer has been depleted, then  }
  { the emulator must have not been able to resolve the timer.  Set }
  { the timer to make sure that zero is periodically returned when  }
  { the timer is depleted.                                          }

  MOV    DX,WORD PTR MaxScan
  CMP    WORD PTR Game.TIA_Scan,DX
  JNE    @NoFixTimer
{  CMP    BYTE PTR Game.FixTimer,1
  JE     @NoFixTimer}
  DEC    BYTE PTR Game.FixTimer
@NoFixTimer:

  CMP    BYTE PTR Game.FixTimer,1
  JNZ    @NotFixed
  MOV    BL,BYTE PTR Game.FixTimerNum
  SUB    BYTE PTR Game.FixTimerNum,7
@NotFixed:

(*
  DB     _32BIT_OPERAND   { Added 8-10-97 }
  DEC    BX
*)

  MOV    BYTE PTR AtariSeg[INTTIM1],BL
  MOV    BYTE PTR AtariSeg[INTTIM2],BL

  DB     _32BIT_OPERAND
  MOV    DX,BX
  DB     _32BIT_OPERAND
  INC    DX
  DB     _32BIT_OPERAND
  INC    DX
  DB     _32BIT_OPERAND
  SUB    AX,AX
{
  DB     _32BIT_OPERAND
  OR     DX,DX
}
  DB     _32BIT_OPERAND
  CMP    DX,AX
  JGE    @GetOut
  MOV    BYTE PTR Game.TimerDone,1
(*
  DB     _32BIT_OPERAND           { EBX = # of cycles required to   }
  MOV    BX,WORD PTR Game.TimerSize    {       deplete the timer         }
  DB     _32BIT_OPERAND
  CMP    AX,BX
  JAE    @Depleted
  DB     _32BIT_OPERAND
  SUB    DX,DX
  DB     _32BIT_OPERAND
  MOV    CX,WORD PTR Game.TimerInterval
  DB     _32BIT_OPERAND
  DIV    CX
  MOV    BL,BYTE PTR Game.OrigTimer
  SUB    BL,AL

  MOV    BYTE PTR AtariSeg[INTTIM1],BL
  MOV    BYTE PTR AtariSeg[INTTIM2],BL
  JMP    @GetOut
@Depleted:
  DB     _32BIT_OPERAND
  MOV    CX,BX
  DB     _32BIT_OPERAND
  ADD    CX,WORD PTR Game.TimerInterval
  DB     _32BIT_OPERAND
  CMP    CX,AX
  JBE    @Rollover
  MOV    BYTE PTR AtariSeg[INTTIM1],0  { Force the timer to hold zero for }
  MOV    BYTE PTR AtariSeg[INTTIM2],0  { one cycle                        }
  JMP    @GetOut
@Rollover:
  INC    AX
  SUB    CX,AX
  MOV    BYTE PTR AtariSeg[INTTIM1],CL { The timer changes each cycle }
  MOV    BYTE PTR AtariSeg[INTTIM2],CL
*)
@GetOut:





  POP    BX
  POP    DI
  POP    DX
  POP    CX
  POP    AX
End; { Handle_Timer }

(*
Procedure TurnPlayer0Off(After,Always: Word);
Var Game.Player0Size128Add: Word;
Begin
  Asm
    PUSH  SI
    PUSH  DI
    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    MOV   AL,BYTE PTR Game.OldNUSIZ0
    AND   AL,7
    JZ    @Cont

    TEST  BYTE PTR Always,0FFh
    JNZ   @Cont

    CMP   AL,1
    JE    @Cont


    CMP   AL,6
    JE    @Cont


    JMP   @GetOut
@Cont:
    MOV   AX,WORD PTR Game.OldPlayer0Size128
    MOV   WORD PTR Game.Player0Size128,AX
  { ---------------------------------------- }
    MOV   WORD PTR Game.Player0Size128Add,0
    MOV   DX,WORD PTR Game.TIA_Count

    MOV   BX,WORD PTR Game.AddCycle
    MOV   CX,BX
    ADD   BX,BX
    ADD   BX,CX

{    CMP   WORD PTR Game.ObjectPix[Missile0Set * 2],DX
    JL    @M0AddContinue}
    TEST  WORD PTR After,0FFFFh
    JNZ   @After
    MOV   DI,DX
    ADD   DI,BX
    JMP   @Continue
@After:
    MOV   DI,DX
    SUB   DX,BX
@Continue:
{    CMP   WORD PTR Game.ObjectPix[Missile0Set * 2],DX
    JGE   @M0AddContinue}
  { ---------------------------------------- }


    ADD   DX,5
    SUB   DI,3



  @M0AddLeft:
    MOV   SI,WORD PTR Game.Player0Size128
    MOV   AX,WORD PTR Game.ObjectLoc[Player0Set * 2]
    AND   SI,0700h
    MOV   CX,WORD PTR Game._Player0Size
    SHR   SI,7

    CMP   AX,DI
    JGE   @M0AddContinue
    ADD   CX,AX
{    CMP   CX,DX}
    CMP   AX,DX
    JL    @Ck2LM0
    MOV   BX,WORD PTR Add1A[SI]
    MOV   WORD PTR Game.Player0Size128Add,BX
    JMP   @M0AddContinue
  @Ck2LM0:
    ADD   AX,WORD PTR Sep1[SI]
    CMP   AX,DI
    JGE   @M0AddContinue
    ADD   CX,WORD PTR Sep1[SI]
{    CMP   CX,DX}
    CMP   AX,DX
    JL    @Ck3LM0
    MOV   BX,WORD PTR Add2A[SI]
    MOV   WORD PTR Game.Player0Size128Add,BX
    JMP   @M0AddContinue
  @Ck3LM0:
    ADD   AX,WORD PTR Sep2[SI]
    CMP   AX,DI
    JGE   @M0AddContinue
    ADD   CX,WORD PTR Sep2[SI]
{    CMP   CX,DX}
    CMP   AX,DX
    JL    @M0AddContinue
    MOV   BX,WORD PTR Add3A[SI]
    MOV   WORD PTR Game.Player0Size128Add,BX
  @M0AddContinue:
    MOV   AX,WORD PTR Game.Player0Size128Add
    ADD   WORD PTR Game.Player0Size128,AX
@GetOut:
    POP   DX
    POP   CX
    POP   BX
    POP   AX
    POP   DI
    POP   SI
  End; { Asm }
End; { TurnPlayer0Off }


Procedure TurnPlayer1Off(After,Always: Word);
Var Game.Player1Size128Add: Word;
Begin
  Asm
    PUSH  SI
    PUSH  DI
    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    MOV   AL,BYTE PTR Game.OldNUSIZ0
    AND   AL,7
    JZ    @Cont

    TEST  BYTE PTR Always,0FFh
    JNZ   @Cont

    CMP   AL,1
    JE    @Cont


    CMP   AL,6
    JE    @Cont


    JMP   @GetOut
@Cont:
    MOV   AX,WORD PTR Game.OldPlayer1Size128
    MOV   WORD PTR Game.Player1Size128,AX
  { ---------------------------------------- }
    MOV   WORD PTR Game.Player1Size128Add,0
    MOV   DX,WORD PTR Game.TIA_Count
    MOV   BX,WORD PTR Game.AddCycle
    MOV   CX,BX
    ADD   BX,BX
    ADD   BX,CX
{    CMP   WORD PTR Game.ObjectPix[Missile0Set * 2],DX
    JL    @M0AddContinue}
    TEST  WORD PTR After,0FFFFh
    JNZ   @After
    MOV   DI,DX
    ADD   DI,BX
    JMP   @Continue
@After:
    MOV   DI,DX
    SUB   DX,BX
@Continue:
{    CMP   WORD PTR Game.ObjectPix[Missile0Set * 2],DX
    JGE   @M0AddContinue}
  { ---------------------------------------- }

    ADD   DX,4
    SUB   DI,3

  @M0AddLeft:
    MOV   SI,WORD PTR Game.Player1Size128
    MOV   AX,WORD PTR Game.ObjectLoc[Player1Set * 2]
    AND   SI,0700h
    MOV   CX,WORD PTR Game._Player1Size
    SHR   SI,7

    CMP   AX,DI
    JGE   @M0AddContinue
    ADD   CX,AX
    CMP   CX,DX
    JL    @Ck2LM0
    MOV   BX,WORD PTR Add1A[SI]
    MOV   WORD PTR Game.Player1Size128Add,BX
    JMP   @M0AddContinue
  @Ck2LM0:
    ADD   AX,WORD PTR Sep1[SI]
    CMP   AX,DI
    JGE   @M0AddContinue
    ADD   CX,WORD PTR Sep1[SI]
    CMP   CX,DX
    JL    @Ck3LM0
    MOV   BX,WORD PTR Add2A[SI]
    MOV   WORD PTR Game.Player1Size128Add,BX
    JMP   @M0AddContinue
  @Ck3LM0:
    ADD   AX,WORD PTR Sep2[SI]
    CMP   AX,DI
    JGE   @M0AddContinue
    ADD   CX,WORD PTR Sep2[SI]
    CMP   CX,DX
    JL    @M0AddContinue
    MOV   BX,WORD PTR Add3A[SI]
    MOV   WORD PTR Game.Player1Size128Add,BX
  @M0AddContinue:
    MOV   AX,WORD PTR Game.Player1Size128Add
    ADD   WORD PTR Game.Player1Size128,AX
@GetOut:
    POP   DX
    POP   CX
    POP   BX
    POP   AX
    POP   DI
    POP   SI
  End; { Asm }
End; { TurnPlayer1Off }
*)

Procedure GetControllers;
Var
  Cap           : TCapability;
  Info          : TAtariControls;
  SwReset       : Byte;
  SwSelect      : Byte;
  Path          : PathStr;
  Dir           : DirStr;
  Name          : NameStr;
  Ext           : ExtStr;
  UPos          : Integer;
  RealName      : String;
  St            : String;
  App           : PVGAApplication;
  F             : File;

Begin
  Cap.A := 0;
  Cap.B := 0;
  Case Game.Controller Of
    crJoystick: Cap.A := imJoysticks;
      crPaddle: Cap.A := imPaddles;
         crVTP: Begin
                  Cap.A := imJoy1;
                  Cap.B := imKB2;
                End;
     crDriving: Cap.A := imDriving;
    crKeyboard: Cap.B := imKeyboard;
     crBooster: Cap.A := imJoysticks + imCBS;
  Else
    Cap.A := imJoysticks;
  End; { Case }
  Cap.B := Cap.B Or imConsole;

  { Initialize the info structure }

  Info.PortA   := $FF;
  Info.Console := 0;
  Info.Pad[1]  := Game.PaddleGround0;
  Info.Pad[2]  := Game.PaddleGround1;
  Info.Pad[3]  := Game.PaddleGround2;
  Info.Pad[4]  := Game.PaddleGround3;
  Info.Input4  := False;
  Info.Input5  := False;
  Info.Driv[1] := Game.Indy500[0];
  Info.Driv[2] := Game.Indy500[1];
  Info.CBS1    := False;
  Info.CBS2    := False;
  Info.KB      := 0;

  InterfaceHandler^.GetControllerInfo(Cap,Info);

  { Make sure that basic console switches work }

  If Key[kESC] <> 0 Then Info.Console := Info.Console Or cfPower;
  If Key[kF2]  <> 0 Then Info.Console := Info.Console Or cfReset;
  If Key[kF4]  <> 0 Then Info.Console := Info.Console Or cfSelect;
  If Key[kF5]  <> 0 Then Info.Console := Info.Console Or cfColorBW;
  If Key[kF6]  <> 0 Then Info.Console := Info.Console Or cfDiff1;
  If Key[kF7]  <> 0 Then Info.Console := Info.Console Or cfDiff2;
  If Key[kF8]  <> 0 Then
  Begin
    If Game.UserSetPos = NoPosSet Then UPos := 0 Else UPos := Game.UserSetPos;
    If Config.AutoCenter
     Then Game.UserSetPos := Game.VUserAdd + UPos + Game.VAdd
     Else Game.UserSetPos := Game.VUserAdd + UPos;
    Game.VUserAdd := 0;
    Case (Config.MaxRows - 200) Of
       0: Pos200 := Game.UserSetPos;
       4: Pos204 := Game.UserSetPos;
      15: Pos215 := Game.UserSetPos;
      50: Pos250 := Game.UserSetPos;
     105: Pos305 := Game.UserSetPos;
    Else
      Pos200 := Game.UserSetPos;
    End; { Case }
    PosSet := True;

    If ProfileRec <> Nil
     Then RealName := StrPas(ProfileRec^.RealName)
     Else RealName := '';

    App      := New(PVGAApplication,Init(Config.MaxCols,Game.MaxRows,False,False,True));
    RealName := Trim(App^.InputBox('Enter game title','Title:',RealName));
    Dispose(App,Done);
    If ProfileRec <> Nil Then
    Begin
      ProfileRec^.Cart     := Game.Cart;
      ProfileRec^.Cont     := Game.Controller;
      ProfileRec^.RealName := StrPCopyNew(RealName);
      ProfileRec^.Pos200   := Pos200;
      ProfileRec^.Pos204   := Pos204;
      ProfileRec^.Pos215   := Pos215;
      ProfileRec^.Pos250   := Pos250;
      ProfileRec^.Pos305   := Pos305;
    End
    Else
    Begin
      Path := FExpand(ROMFileName);
      FSplit(ROMFileName,Dir,Name,Ext);
      AddToProfile(Name + Ext,RealName,Game.Cart,Game.Controller,Pos200,Pos204,Pos215,Pos250,Pos305);
    End;

    { Wait until the key is released }

    Repeat Until Key[kF8] = 0;
  End;
  If Key[kF3]  <> 0 Then
  Begin
    Game.Palette := Game.Palette Xor 1;
    NewPalette;
  End;
  If (Key[kEQUAL] <> 0) And (Game.VUserAdd > -40) Then Dec(Game.VUserAdd);
  If (Key[kMINUS] <> 0) And (Game.VUserAdd <  40) Then Inc(Game.VUserAdd);

  { Get controller information }

  Case Game.Controller Of
    crJoystick,crBooster: Begin
                  AtariSeg[SWCHA1] := Info.PortA;
                  If Game.Latched Then
                  Begin
                    If Info.Input4 Then
                     Game.Input_Byte[INPUT4] := Game.Input_Byte[INPUT4] And $7F;
                    If Info.Input5 Then
                     Game.Input_Byte[INPUT5] := Game.Input_Byte[INPUT5] And $7F;
                  End
                  Else
                  Begin
                    If Info.Input4
                     Then Game.Input_Byte[INPUT4] := 0
                     Else Game.Input_Byte[INPUT4] := $80;
                    If Info.Input5
                     Then Game.Input_Byte[INPUT5] := 0
                     Else Game.Input_Byte[INPUT5] := $80;
                  End;
                  If Game.Controller = crBooster Then
                  Begin
                    If Info.CBS1
                     Then Game.Input_Byte[INPUT0] := Game.Input_Byte[INPUT0] Or  $80
                     Else Game.Input_Byte[INPUT0] := Game.Input_Byte[INPUT0] And $7F;
                    If Info.CBS2
                     Then Game.Input_Byte[INPUT1] := Game.Input_Byte[INPUT1] Or  $80
                     Else Game.Input_Byte[INPUT1] := Game.Input_Byte[INPUT1] And $7F;
                  End;
                End;
      crPaddle: Begin
{                  If (AtariSeg[VBLANK] And $80) = 0 Then
                  Begin
                    Game.PaddleGround0    := Info.Pad1;
                    Game.PaddleGround1    := Info.Pad2;
                    Game.PaddleGround2    := Info.Pad3;
                    Game.PaddleGround3    := Info.Pad4;}
                    Game.OldPaddleGround0 := Info.Pad[1];
                    Game.OldPaddleGround1 := Info.Pad[2];
                    Game.OldPaddleGround2 := Info.Pad[3];
                    Game.OldPaddleGround3 := Info.Pad[4];
{                  End;}
                  AtariSeg[SWCHA1] := Info.PortA;
                End;
         crVTP: Begin
                  AtariSeg[SWCHA1] := (AtariSeg[SWCHA1] And $F) Or (Info.PortA And $F0);
                  If Game.Latched Then
                  Begin
                    If Info.Input4 Then
                     Game.Input_Byte[INPUT4] := Game.Input_Byte[INPUT4] And $7F;
                    If Info.Input5 Then
                     Game.Input_Byte[INPUT5] := Game.Input_Byte[INPUT5] And $7F;
                  End
                  Else
                  Begin
                    If Info.Input4
                     Then Game.Input_Byte[INPUT4] := 0
                     Else Game.Input_Byte[INPUT4] := $80;
                    If Info.Input5
                     Then Game.Input_Byte[INPUT5] := 0
                     Else Game.Input_Byte[INPUT5] := $80;
                  End;
                  Game.KeyColumn   := Info.KB;
                  CheckKBController;
                End;
     crDriving: Begin
                  Game.Indy500[0] := Info.Driv[1];
                  Game.Indy500[1] := Info.Driv[2];
                  Asm
                    OR    BYTE PTR AtariSeg[SWCHA1],0FFh

                    MOV   SI,WORD PTR Game.Indy500
                    SHR   SI,2
                    AND   SI,3
                    MOV   AL,BYTE PTR Indy500Trans1[SI]

                    MOV   SI,WORD PTR Game.Indy500[2]
                    SHR   SI,2
                    AND   SI,3
                    MOV   AH,BYTE PTR Indy500Trans2[SI]

                    AND   AL,AH
                    AND   BYTE PTR AtariSeg[SWCHA1],AL
                  End;
                  If Game.Latched Then
                  Begin
                    If Info.Input4 Then
                     Game.Input_Byte[INPUT4] := Game.Input_Byte[INPUT4] And $7F;
                    If Info.Input5 Then
                     Game.Input_Byte[INPUT5] := Game.Input_Byte[INPUT5] And $7F;
                  End
                  Else
                  Begin
                    If Info.Input4
                     Then Game.Input_Byte[INPUT4] := 0
                     Else Game.Input_Byte[INPUT4] := $80;
                    If Info.Input5
                     Then Game.Input_Byte[INPUT5] := 0
                     Else Game.Input_Byte[INPUT5] := $80;
                  End;
                End;
    crKeyboard: Begin
                  Game.KeyColumn := Info.KB;
                  CheckKBController;
                End;
  Else
  End; { Case }

  { Get console switch information }

  If (Info.Console And cfPower) <> 0 Then Exiting := True;

  If (Info.Console And cfReset) <> 0
   Then SwReset := 0
   Else SwReset := 1;
  If (Info.Console And cfSelect) <> 0
   Then SwSelect := 0
   Else SwSelect := 2;

  If (Info.Console And cfColorBW) <> 0 Then
  Begin
    If ColorOrBWChange Then
    Begin
      Game.ColorOrBW := Game.ColorOrBW Xor 8;
      ColorOrBWChange := False;
    End;
  End
  Else ColorOrBWChange := True;

  If (Info.Console And cfDiff1) <> 0 Then
  Begin
    If Difficulty1Change Then
    Begin
      Game.Difficulty1 := Game.Difficulty1 Xor $40;
      Difficulty1Change := False;
    End;
  End
  Else Difficulty1Change := True;

  If (Info.Console And cfDiff2) <> 0 Then
  Begin
    If Difficulty2Change Then
    Begin
      Game.Difficulty2 := Game.Difficulty2 Xor $80;
      Difficulty2Change := False;
    End;
  End
  Else Difficulty2Change := True;

  { Copy info }

  AtariSeg[SWCHA2] := AtariSeg[SWCHA1];
  AtariSeg[SWCHB1] := (SwReset Or
                       SwSelect Or
                       Game.ColorOrBW Or
                       Game.Difficulty1 Or
                       Game.Difficulty2) And $CF;
  AtariSeg[SWCHB2] := AtariSeg[SWCHB1];

  { Check other special keys }

  If Key[kF1] <> 0 Then
  Begin
    GameStatus(Config.MaxCols,Game.MaxRows,Game.Difficulty1,Game.Difficulty2,AutoCenter);
    ResetClock;
  End;

  If Key[kF9] <> 0 Then
  Begin
    ScreenCapture(Config.MaxCols,Game.MaxRows,Game.Palette,@Pal,@Pal1);
    ResetClock;
  End;

  If Key[kF10] <> 0 Then
  Begin
    If AutoCenterChange Then
    Begin
      AutoCenter       := Not AutoCenter;
      AutoCenterChange := False;
    End;
  End
  Else AutoCenterChange := True;

  If Key[kF11] <> 0 Then SaveStatus;
  If Key[kF12] <> 0 Then RestoreStatus;
  If Key[kBACKSPC] <> 0 Then
  Begin
    Repeat Until Key[kBACKSPC] = 0;
    If Not AVIFile.Opened Then
    Begin
      St := UpperCase(FileDialog(Config.MaxCols,Game.MaxRows,'Save to .AVI','*.AVI'));
      If CreateFile(Config.MaxCols,Game.MaxRows,F,St) Then
      Begin
        Close(F);
        If Game.Palette = 0 Then
        Begin
          If Config.MaxCols = 320
           Then AVIFile.Open(St,Config.MaxCols,Game.MaxRows,acRLE,exNone,Pal)
           Else AVIFile.Open(St,Config.MaxCols,Game.MaxRows,acRLE,exHorz2x,Pal);
        End
        Else
        Begin
          If Config.MaxCols = 320
           Then AVIFile.Open(St,Config.MaxCols,Game.MaxRows,acRLE,exNone,Pal1)
           Else AVIFile.Open(St,Config.MaxCols,Game.MaxRows,acRLE,exHorz2x,Pal1);
        End;
      End;
    End
    Else AVIFile.Close;
    ResetClock;
  End;
End; { GetControllers }


Procedure SetReadMask;
Begin
  GetControllers;
  InterfaceHandler^.SetReadMask(AtariSeg[SWACNT1] Xor $FF);
End; { SetReadMask }

Procedure WriteToPortA;
Begin
  InterfaceHandler^.WriteToPort(AtariSeg[SWCHA1]);
  GetControllers;
End; { WriteToPortA }


Procedure DoP0Motion; Assembler;
Asm

  { Player 0 }

  MOV   AX,WORD PTR Game.ObjectMove[Player0Set * 2]
  ADD   WORD PTR Game.ObjectLoc[Player0Set * 2],AX

  MOV   CX,160
  OR    AL,AL
  JS    @P0
  NEG   CX
@P0:
  CMP   BYTE PTR Game.ObjectLoc[Player0Set * 2],160
  JB    @P0Ok
  ADD   WORD PTR Game.ObjectLoc[Player0Set * 2],CX
@P0Ok:
  MOV   AX,WORD PTR Game.OldPlayer0Size128
  MOV   WORD PTR Game.Player0Size128,AX
End; { DoP0Motion }


Procedure DoP1Motion; Assembler;
Asm

  { Player 1 }

  MOV   AX,WORD PTR Game.ObjectMove[Player1Set * 2]
  ADD   WORD PTR Game.ObjectLoc[Player1Set * 2],AX

  MOV   CX,160
  OR    AL,AL
  JS    @P1
  NEG   CX
@P1:
  CMP   BYTE PTR Game.ObjectLoc[Player1Set * 2],160
  JB    @P1Ok
  ADD   WORD PTR Game.ObjectLoc[Player1Set * 2],CX
@P1Ok:
  MOV   AX,WORD PTR Game.OldPlayer1Size128
  MOV   WORD PTR Game.Player1Size128,AX
End; { DoP1Motion }


Procedure DoM0Motion; Assembler;
Asm

  { Missile 0 }

  TEST  BYTE PTR AtariSeg[RESMP0],2
  JZ    @Missile0OkA
  MOV   AL,BYTE PTR Game.ObjectLoc[Player0Set * 2]
  MOV   AH,BYTE PTR Game._Player0Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH

  CMP   AX,160
  JB    @M0Ok1
  SUB   AX,160
@M0Ok1:
  MOV   WORD PTR Game.ObjectLoc[Missile0Set * 2],AX
  JMP   @M0Ok
@Missile0OkA:
  MOV   AX,WORD PTR Game.ObjectMove[Missile0Set * 2]
  MOV   BX,WORD PTR Game.ObjectLoc[Missile0Set * 2]
  ADD   WORD PTR Game.ObjectLoc[Missile0Set * 2],AX
  MOV   CX,160
  OR    AL,AL
  JS    @M0
  NEG   CX
@M0:
  CMP   WORD PTR Game.ObjectLoc[Missile0Set * 2],160
  JGE   @AddToM0
  CMP   WORD PTR Game.ObjectLoc[Missile0Set * 2],-68
  JL    @AddToM0
  CMP   WORD PTR Game.ObjectLoc[Missile0Set * 2],0
  JGE   @M0Ok
  CMP   AX,-1
  JG    @M0Ok
  CMP   BX,-8
  JL    @M0Ok
@AddToM0:
  ADD   WORD PTR Game.ObjectLoc[Missile0Set * 2],CX

@M0Ok:
End; { DoM0Motion }


Procedure DoM1Motion; Assembler;
Asm

  { Missile 1 }

  TEST  BYTE PTR AtariSeg[RESMP1],2
  JZ    @Missile1OkA
  MOV   AL,BYTE PTR Game.ObjectLoc[Player1Set * 2]
  MOV   AH,BYTE PTR Game._Player1Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH

  CMP   AX,160
  JB    @M1Ok1
  SUB   AX,160
@M1Ok1:
  MOV   WORD PTR Game.ObjectLoc[Missile1Set * 2],AX
  JMP   @M1Ok
@Missile1OkA:
  MOV   AX,WORD PTR Game.ObjectMove[Missile1Set * 2]
  MOV   BX,WORD PTR Game.ObjectLoc[Missile1Set * 2]
  ADD   WORD PTR Game.ObjectLoc[Missile1Set * 2],AX
  MOV   CX,160
  OR    AL,AL
  JS    @M1
  NEG   CX
@M1:
  CMP   WORD PTR Game.ObjectLoc[Missile1Set * 2],160
  JGE   @AddToM1
  CMP   WORD PTR Game.ObjectLoc[Missile1Set * 2],-68
  JL    @AddToM1
  CMP   WORD PTR Game.ObjectLoc[Missile1Set * 2],0
  JGE   @M1Ok
  CMP   AX,-1
  JG    @M1Ok
  CMP   BX,-8
  JL    @M1Ok
@AddToM1:
  ADD   WORD PTR Game.ObjectLoc[Missile1Set * 2],CX
@M1Ok:
End; { DoM1Motion }


Procedure DoBLMotion; Assembler;
Asm

  { Ball }

  MOV   AX,WORD PTR Game.ObjectMove[BallSet * 2]
  MOV   BX,WORD PTR Game.ObjectLoc[BallSet * 2]
  ADD   WORD PTR Game.ObjectLoc[BallSet * 2],AX
  MOV   CX,160
  OR    AL,AL
  JS    @BL
  NEG   CX
@BL:
  CMP   WORD PTR Game.ObjectLoc[BallSet * 2],160
  JGE   @AddToBL
  CMP   WORD PTR Game.ObjectLoc[BallSet * 2],-68
  JL    @AddToBL
  CMP   WORD PTR Game.ObjectLoc[BallSet * 2],0
  JGE   @BLOk
  CMP   AX,-1
  JG    @BLOk
  CMP   BX,-8
  JL    @BLOk
@AddToBL:
  ADD   WORD PTR Game.ObjectLoc[BallSet * 2],CX
@BLOk:
End; { DoBLMotion }


Procedure SetP0Motion; Assembler;
Asm
  TEST  BYTE PTR Game.DoHMOVE,0FFh
  JZ    @HMP01
  MOV   BX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   BX,CX
  ADD   BX,CX
  ADD   BX,CX
  CMP   BX,8
  JGE   @HMP01
  MOV   AL,BYTE PTR AtariSeg[HMP0]
  AND   AX,0F0h
  ADD   BX,68
  SHL   BX,8
  ADD   BX,AX
  MOV   AL,BYTE PTR Game.TIA_Regs[HMP0]
  SHR   AX,4
  AND   AX,0Fh
  ADD   BX,AX
{  ADD   BX,BX}
  PUSH  ES
  PUSH  DI
  LES   DI,DWORD PTR SetAdjust
  MOV   AL,BYTE PTR ES:[BX + DI]
  CBW
  POP   DI
  POP   ES
  MOV   WORD PTR Game.ObjectMove[Player0Set  * 2],AX
  CALL  DoP0Motion
@HMP01:
End; { SetP0Motion }


Procedure SetP1Motion; Assembler;
Asm
  TEST  BYTE PTR Game.DoHMOVE,0FFh
  JZ    @HMP01
  MOV   BX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   BX,CX
  ADD   BX,CX
  ADD   BX,CX
  CMP   BX,8
  JGE   @HMP01
  MOV   AL,BYTE PTR AtariSeg[HMP1]
  AND   AX,0F0h
  ADD   BX,68
  SHL   BX,8
  ADD   BX,AX
  MOV   AL,BYTE PTR Game.TIA_Regs[HMP1]
  SHR   AX,4
  AND   AX,0Fh
  ADD   BX,AX
{  ADD   BX,BX}
  PUSH  ES
  PUSH  DI
  LES   DI,DWORD PTR SetAdjust
  MOV   AL,BYTE PTR ES:[BX + DI]
  CBW
  POP   DI
  POP   ES
  MOV   WORD PTR Game.ObjectMove[Player1Set  * 2],AX
  CALL  DoP1Motion
@HMP01:
End; { SetP1Motion }


Procedure SetM0Motion; Assembler;
Asm
  TEST  BYTE PTR Game.DoHMOVE,0FFh
  JZ    @HMM01
  MOV   BX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   BX,CX
  ADD   BX,CX
  ADD   BX,CX
  CMP   BX,8
  JGE   @HMM01
  MOV   AL,BYTE PTR AtariSeg[HMM0]
  AND   AX,0F0h
  ADD   BX,68
  SHL   BX,8
  ADD   BX,AX
  MOV   AL,BYTE PTR Game.TIA_Regs[HMM0]
  SHR   AX,4
  AND   AX,0Fh
  ADD   BX,AX
{  ADD   BX,BX}
  PUSH  ES
  PUSH  DI
  LES   DI,DWORD PTR SetAdjust
  MOV   AL,BYTE PTR ES:[BX + DI]
  CBW
  POP   DI
  POP   ES
  MOV   WORD PTR Game.ObjectMove[Missile0Set  * 2],AX
  CALL  DoM0Motion
@HMM01:
End; { SetM0Motion }


Procedure SetM1Motion; Assembler;
Asm
  TEST  BYTE PTR Game.DoHMOVE,0FFh
  JZ    @HMM01
  MOV   BX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   BX,CX
  ADD   BX,CX
  ADD   BX,CX
  CMP   BX,8
  JGE   @HMM01
  MOV   AL,BYTE PTR AtariSeg[HMM1]
  AND   AX,0F0h
  ADD   BX,68
  SHL   BX,8
  ADD   BX,AX
  MOV   AL,BYTE PTR Game.TIA_Regs[HMM1]
  SHR   AX,4
  AND   AX,0Fh
  ADD   BX,AX
{  ADD   BX,BX}
  PUSH  ES
  PUSH  DI
  LES   DI,DWORD PTR SetAdjust
  MOV   AL,BYTE PTR ES:[BX + DI]
  CBW
  POP   DI
  POP   ES
  MOV   WORD PTR Game.ObjectMove[Missile1Set  * 2],AX
  CALL  DoM1Motion
@HMM01:
End; { SetM1Motion }


Procedure SetBLMotion; Assembler;
Asm
  TEST  BYTE PTR Game.DoHMOVE,0FFh
  JZ    @HMBL1
  MOV   BX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   BX,CX
  ADD   BX,CX
  ADD   BX,CX
  CMP   BX,8
  JGE   @HMBL1
  MOV   AL,BYTE PTR AtariSeg[HMBL]
  AND   AX,0F0h
  ADD   BX,68
  SHL   BX,8
  ADD   BX,AX
  MOV   AL,BYTE PTR Game.TIA_Regs[HMBL]
  SHR   AX,4
  AND   AX,0Fh
  ADD   BX,AX
{  ADD   BX,BX}
  PUSH  ES
  PUSH  DI
  LES   DI,DWORD PTR SetAdjust
  MOV   AL,BYTE PTR ES:[BX + DI]
  CBW
{  MOV   AX,WORD PTR ES:[BX + DI]}
  POP   DI
  POP   ES
  MOV   WORD PTR Game.ObjectMove[BallSet  * 2],AX
  CALL  DoBLMotion
@HMBL1:
End; { SetBLMotion }


Procedure GetPlayerDelay; Assembler;
{ Input values:  AX = player (0 or 1) }
{ Output values: AX = delay (bit 7 set if deleting player) }
Asm

    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    MOV   SI,AX
    CMP   AX,0
    JNE   @Player1
    MOV   DI,Player0Set * 2
    JMP   @ChosePlayer
@Player1:
    MOV   DI,Player1Set * 2
@ChosePlayer:
    MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ0 + SI]
    AND   BX,7
    SHL   BX,1
    MOV   AX,WORD PTR Game.OldObjectLoc[DI]
    SUB   AX,5
    MOV   CX,WORD PTR Game.ObjectLoc[DI]
    SUB   CX,5
    CMP   CX,AX
    JL    @TurnOff
    MOV   DX,CX
    SUB   DX,AX
    JNS   @NoCarry
    ADD   DX,160
@NoCarry:
    CMP   DX,WORD PTR PlayerSizeD[BX]
    JA    @TurnOff

    ADD   AX,WORD PTR PlayerZone1[BX]
    CMP   AX,160
    JL    @NoCarry1
    SUB   AX,160
@NoCarry1:
    CMP   CX,AX
    JL    @NoTurnOff
{    MOV   CX,AX}
    ADD   AX,WORD PTR _PlayerSize[BX]
    ADD   AX,2
    CMP   AX,160
    JL    @NoCarry2
    SUB   AX,160
@NoCarry2:
    CMP   CX,AX
    JLE   @Delay

    CMP   WORD PTR PlayerInc1[BX],0
    JE    @TurnOff
    ADD   AX,WORD PTR PlayerInc1[BX]
    CMP   AX,160
    JL    @NoCarry3
    SUB   AX,160
@NoCarry3:
    CMP   CX,AX
    JL    @TurnOff
    ADD   AX,WORD PTR PlayerZone2[BX]
    CMP   AX,160
    JL    @NoCarry4
    SUB   AX,160
@NoCarry4:
    CMP   CX,AX
    JL    @NoTurnOff
{    MOV   CX,AX}
    ADD   AX,WORD PTR _PlayerSize[BX]
    ADD   AX,2
    CMP   AX,160
    JL    @NoCarry5
    SUB   AX,160
@NoCarry5:
    CMP   CX,AX
    JLE   @Delay

    CMP   WORD PTR PlayerInc2[BX],0
    JE    @TurnOff
    ADD   AX,WORD PTR PlayerInc2[BX]
    CMP   AX,160
    JL    @NoCarry6
    SUB   AX,160
@NoCarry6:
    CMP   CX,AX
    JL    @TurnOff
    ADD   AX,WORD PTR PlayerZone2[BX]
    CMP   AX,160
    JL    @NoCarry7
    SUB   AX,160
@NoCarry7:
    CMP   CX,AX
    JL    @NoTurnOff
{    MOV   CX,AX}
    ADD   AX,WORD PTR _PlayerSize[BX]
    ADD   AX,2
    CMP   AX,160
    JL    @NoCarry8
    SUB   AX,160
@NoCarry8:
    CMP   CX,AX
    JLE   @Delay

@TurnOff:
{    MOV   AX,WORD PTR _PlayerSize[BX]}
    SUB   AX,AX
    JMP   @TurnOffDone
@NoTurnOff:
    MOV   AX,80h
    JMP   @TurnOffDone
@Delay:
    SUB   AX,CX
@TurnOffDone:
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
End; { GetPlayerDelay }


Procedure GetMissileDelay; Assembler;
{ Input values:  AX = missile (0 or 1) }
{ Output values: AX = delay (bit 7 set if deleting player) }
Asm
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    MOV   SI,AX
    CMP   AX,0
    JNE   @Missile1
    MOV   DI,Missile0Set * 2
    JMP   @ChoseMissile
@Missile1:
    MOV   DI,Missile1Set * 2
@ChoseMissile:
    MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ0 + SI]
    AND   BX,7
    SHL   BX,1
    MOV   AX,WORD PTR Game.OldObjectLoc[DI]
    SUB   AX,4
    MOV   CX,WORD PTR Game.ObjectLoc[DI]
    SUB   CX,4
    CMP   CX,AX
    JL    @NoTurnOff
    MOV   DX,CX
    SUB   DX,AX
    JNS   @NoCarry
    ADD   DX,160
@NoCarry:
    CMP   DX,WORD PTR PlayerSizeD[BX]
    JA    @TurnOff

    ADD   AX,WORD PTR MissileZone1[BX]
    CMP   AX,160
    JL    @NoCarry1
    SUB   AX,160
@NoCarry1:
    CMP   CX,AX
    JL    @NoTurnOff
{    MOV   CX,AX}
    ADD   AX,9
    CMP   AX,160
    JL    @NoCarry2
    SUB   AX,160
@NoCarry2:
    CMP   CX,AX
    JLE   @Delay

    CMP   WORD PTR MissileInc1[BX],0
    JE    @TurnOff
    ADD   AX,WORD PTR MissileInc1[BX]
    CMP   AX,160
    JL    @NoCarry3
    SUB   AX,160
@NoCarry3:
    CMP   CX,AX
    JL    @TurnOff
    ADD   AX,2
    CMP   AX,160
    JL    @NoCarry4
    SUB   AX,160
@NoCarry4:
    CMP   CX,AX
    JGE   @NoDelay1
    MOV   AX,CX
    JMP   @Delay
@NoDelay1:
    ADD   AX,WORD PTR MissileZone2[BX]
    CMP   AX,160
    JL    @NoCarry5
    SUB   AX,160
@NoCarry5:
    CMP   CX,AX
    JL    @NoTurnOff
{    MOV   CX,AX}
    ADD   AX,9
    CMP   AX,160
    JL    @NoCarry6
    SUB   AX,160
@NoCarry6:
    CMP   CX,AX
    JLE   @Delay

    CMP   WORD PTR MissileInc2[BX],0
    JE    @TurnOff
    ADD   AX,WORD PTR MissileInc2[BX]
    CMP   AX,160
    JL    @NoCarry7
    SUB   AX,160
@NoCarry7:
    CMP   CX,AX
    JL    @TurnOff
    ADD   AX,2
    CMP   AX,160
    JL    @NoCarry8
    SUB   AX,160
@NoCarry8:
    CMP   CX,AX
    JGE   @NoDelay2
    MOV   AX,CX
    JMP   @Delay
@NoDelay2:
    ADD   AX,WORD PTR MissileZone2[BX]
    CMP   AX,160
    JL    @NoCarry9
    SUB   AX,160
@NoCarry9:
    CMP   CX,AX
    JL    @NoTurnOff
{    MOV   CX,AX}
    ADD   AX,9
    CMP   AX,160
    JL    @NoCarry10
    SUB   AX,160
@NoCarry10:
    CMP   CX,AX
    JLE   @Delay

@TurnOff:
    MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ0 + SI]
    SHR   BX,3
    AND   BX,6
    MOV   AL,BYTE PTR MissileSize[BX]
    SUB   AH,AH
    JMP   @TurnOffDone
@NoTurnOff:
    MOV   AX,80h
    JMP   @TurnOffDone
@Delay:
    SUB   AX,CX
    CMP   AX,8
    JBE   @TurnOffDone
    SUB   AX,AX
@TurnOffDone:
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
End; { GetMissileDelay }


Procedure GetBallDelay; Assembler;
{ Output values: AX = delay (bit 7 set if deleting player) }
Asm
    PUSH  BX
    PUSH  CX
    PUSH  DX
    MOV   AX,WORD PTR Game.OldObjectLoc[BallSet * 2]
    SUB   AX,4
    MOV   CX,WORD PTR Game.ObjectLoc[BallSet * 2]
    SUB   CX,4
    CMP   CX,AX
    JL    @TurnOff
    MOV   DX,CX
    SUB   DX,AX
    JNC   @NoCarry
    ADD   DX,160
@NoCarry:
    CMP   DX,WORD PTR Game.BallSize
    JA    @TurnOff

    ADD   AX,WORD PTR MissileZone1[0]
    CMP   AX,160
    JL    @NoCarry1
    SUB   AX,160
@NoCarry1:
    CMP   CX,AX
    JL    @NoTurnOff
    MOV   CX,AX
    ADD   AX,9
    CMP   AX,160
    JL    @NoCarry2
    SUB   AX,160
@NoCarry2:
    CMP   CX,AX
    JLE   @Delay

@TurnOff:
    MOV   AX,WORD PTR Game.BallSize
    JMP   @TurnOffDone
@NoTurnOff:
    MOV   AX,80h
    JMP   @TurnOffDone
@Delay:
    SUB   AX,CX
    CMP   AX,8
    JBE   @TurnOffDone
    SUB   AX,AX
@TurnOffDone:
    POP   DX
    POP   CX
    POP   BX
End; { GetBallDelay }


Procedure Handle_IO; Assembler;
{ ---------------------------------------------------------------------- }
{ On entry:                                                              }
{ BX = Game.Save_BX                                                           }
{ ---------------------------------------------------------------------- }
Label LVSYNC,LVBLANK,LWSYNC,LRSYNC,LAUDV0,LAUDC0,LAUDF0,LNUSIZ0,LNUSIZ1,
      LAUDV1,LAUDC1,LAUDF1,LHMP0,LHMP1,LHMM0,LHMM1,LHMBL,
      LRESP0,LRESP1,LRESM0,LRESM1,LRESBL,LGRP0,LGRP1,LENABL,LCTRLPF,
{      LCOLUPF,LCOLUBK,}
      LHMCLR,LSWCHA1,LSWACNT1,LSWCHB1,LSWBCNT1,
      LINTTIM1,LINTTIM3,LTIM1T1,LTIM2T1,LTIM3T1,LTIM4T1,LSWCHA2,LSWACNT2,LSWCHB2,
      LSWBCNT2,LINTTIM2,LTIM1T2,LTIM2T2,LTIM3T2,LTIM4T2,GetOut;
Asm
    PUSH   AX
    PUSH   CX
    PUSH   DX
    PUSH   DI

  TEST  BYTE PTR Handle_IO_Set,0FFh
  JNZ   @L2
  MOV   AX,OFFSET GetOut
  MOV   CX,TIM4T2
  SUB   BX,BX
@L1:
  MOV   WORD PTR Handle_IO_Loc[BX],AX
  ADD   BX,2
  LOOP  @L1

  MOV   WORD PTR Handle_IO_Loc[GRP0    * 2],OFFSET LGRP0
  MOV   WORD PTR Handle_IO_Loc[GRP1    * 2],OFFSET LGRP1
  MOV   WORD PTR Handle_IO_Loc[ENABL   * 2],OFFSET LENABL

  MOV   WORD PTR Handle_IO_Loc[AUDV0   * 2],OFFSET LAUDV0
  MOV   WORD PTR Handle_IO_Loc[AUDC0   * 2],OFFSET LAUDC0
  MOV   WORD PTR Handle_IO_Loc[AUDF0   * 2],OFFSET LAUDF0
  MOV   WORD PTR Handle_IO_Loc[AUDV1   * 2],OFFSET LAUDV1
  MOV   WORD PTR Handle_IO_Loc[AUDC1   * 2],OFFSET LAUDC1
  MOV   WORD PTR Handle_IO_Loc[AUDF1   * 2],OFFSET LAUDF1

  MOV   WORD PTR Handle_IO_Loc[CTRLPF  * 2],OFFSET LCTRLPF
{
  MOV   WORD PTR Handle_IO_Loc[COLUPF  * 2],OFFSET LCOLUPF
  MOV   WORD PTR Handle_IO_Loc[COLUBK  * 2],OFFSET LCOLUBK
}
  MOV   WORD PTR Handle_IO_Loc[HMP0    * 2],OFFSET LHMP0
  MOV   WORD PTR Handle_IO_Loc[HMP1    * 2],OFFSET LHMP1
  MOV   WORD PTR Handle_IO_Loc[HMM0    * 2],OFFSET LHMM0
  MOV   WORD PTR Handle_IO_Loc[HMM1    * 2],OFFSET LHMM1
  MOV   WORD PTR Handle_IO_Loc[HMBL    * 2],OFFSET LHMBL

  MOV   WORD PTR Handle_IO_Loc[NUSIZ0  * 2],OFFSET LNUSIZ0
  MOV   WORD PTR Handle_IO_Loc[NUSIZ1  * 2],OFFSET LNUSIZ1

  MOV   WORD PTR Handle_IO_Loc[VSYNC   * 2],OFFSET LVSYNC
  MOV   WORD PTR Handle_IO_Loc[VBLANK  * 2],OFFSET LVBLANK
  MOV   WORD PTR Handle_IO_Loc[WSYNC   * 2],OFFSET LWSYNC
  MOV   WORD PTR Handle_IO_Loc[RSYNC   * 2],OFFSET LRSYNC
  MOV   WORD PTR Handle_IO_Loc[RESP0   * 2],OFFSET LRESP0
  MOV   WORD PTR Handle_IO_Loc[RESP1   * 2],OFFSET LRESP1
  MOV   WORD PTR Handle_IO_Loc[RESM0   * 2],OFFSET LRESM0
  MOV   WORD PTR Handle_IO_Loc[RESM1   * 2],OFFSET LRESM1
  MOV   WORD PTR Handle_IO_Loc[RESBL   * 2],OFFSET LRESBL
  MOV   WORD PTR Handle_IO_Loc[HMCLR   * 2],OFFSET LHMCLR
  MOV   WORD PTR Handle_IO_Loc[SWCHA1  * 2],OFFSET LSWCHA1
  MOV   WORD PTR Handle_IO_Loc[SWACNT1 * 2],OFFSET LSWACNT1
  MOV   WORD PTR Handle_IO_Loc[SWCHB1  * 2],OFFSET LSWCHB1
  MOV   WORD PTR Handle_IO_Loc[SWBCNT1 * 2],OFFSET LSWBCNT1
  MOV   WORD PTR Handle_IO_Loc[INTTIM1 * 2],OFFSET LINTTIM1
  MOV   WORD PTR Handle_IO_Loc[INTTIM3 * 2],OFFSET LINTTIM3
  MOV   WORD PTR Handle_IO_Loc[TIM1T1  * 2],OFFSET LTIM1T1
  MOV   WORD PTR Handle_IO_Loc[TIM2T1  * 2],OFFSET LTIM2T1
  MOV   WORD PTR Handle_IO_Loc[TIM3T1  * 2],OFFSET LTIM3T1
  MOV   WORD PTR Handle_IO_Loc[TIM4T1  * 2],OFFSET LTIM4T1
  MOV   WORD PTR Handle_IO_Loc[SWCHA2  * 2],OFFSET LSWCHA2
  MOV   WORD PTR Handle_IO_Loc[SWACNT2 * 2],OFFSET LSWACNT2
  MOV   WORD PTR Handle_IO_Loc[SWCHB2  * 2],OFFSET LSWCHB2
  MOV   WORD PTR Handle_IO_Loc[SWBCNT2 * 2],OFFSET LSWBCNT2
  MOV   WORD PTR Handle_IO_Loc[INTTIM2 * 2],OFFSET LINTTIM2
  MOV   WORD PTR Handle_IO_Loc[TIM1T2  * 2],OFFSET LTIM1T2
  MOV   WORD PTR Handle_IO_Loc[TIM2T2  * 2],OFFSET LTIM2T2
  MOV   WORD PTR Handle_IO_Loc[TIM3T2  * 2],OFFSET LTIM3T2
  MOV   WORD PTR Handle_IO_Loc[TIM4T2  * 2],OFFSET LTIM4T2
  MOV   BYTE PTR Handle_IO_Set,1
  MOV   BX,WORD PTR Game.Save_BX
@L2:
  CMP   BX,TIM4T2
  JA    GetOut
  CMP   BX,2Ch
  JA    @NotTIA
  MOV   BYTE PTR Game.Write_TIA,1
@NotTIA:
  ADD   BX,BX
  JMP   WORD PTR Handle_IO_Loc[BX]
{
LCOLUPF:

  MOV   AL,BYTE PTR AtariSeg[COLUPF]
  MOV   AH,BYTE PTR Game.TIA_Regs[COLUPF]
  MOV   BYTE PTR COLUPFLatch,AL
  MOV   BYTE PTR AtariSeg[COLUPF],AH
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  MOV   WORD PTR COLUPFCount,AX
  MOV   AX,WORD PTR Game.TIA_Scan
  MOV   WORD PTR COLUPFScan,AX
  JMP   GetOut

LCOLUBK:

  MOV   AL,BYTE PTR AtariSeg[COLUBK]
  MOV   AH,BYTE PTR Game.TIA_Regs[COLUBK]
  MOV   BYTE PTR COLUBKLatch,AL
  MOV   BYTE PTR AtariSeg[COLUBK],AH
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  MOV   WORD PTR COLUBKCount,AX
  MOV   AX,WORD PTR Game.TIA_Scan
  MOV   WORD PTR COLUBKScan,AX
  JMP   GetOut
}
LHMP0:
  CALL  SetP0Motion
  JMP   GetOut

LHMP1:
  CALL  SetP1Motion
  JMP   GetOut

LHMM0:

  MOV   AX,WORD PTR Game.HMOVECount
  ADD   AX,63 - 9
  CMP   AX,WORD PTR Game.TIA_Count
  JNE   @HMM01_A
  MOV   AL,BYTE PTR Game.TIA_Regs[HMM0]
  AND   AL,0F0h
  CMP   AL,70h
  JNE   @HMM01_A
  MOV   AL,BYTE PTR AtariSeg[HMM0]
  AND   AL,0F0h
  CMP   AL,60h
  JNE   @HMM01_A
  MOV   BYTE PTR Game.M0Bug,1
  MOV   BYTE PTR Game.M0BugCount,0
@HMM01_A:

  CALL  SetM0Motion
  JMP   GetOut

LHMM1:

  CALL  SetM1Motion
  JMP   GetOut

LHMBL:

  CALL  SetBLMotion
  JMP   GetOut

LNUSIZ0:

  MOV   AL,BYTE PTR Game.TIA_Regs[NUSIZ0]
  MOV   BYTE PTR Game.OldNUSIZ0,AL

  { Set the emulator latch values -- we can't use the normal TIA_Delay  }
  { method because the delay is greater than 9 pixels and can interfere }
  { with something else, e.g. RealSports Boxing.                        }

  MOV   AL,BYTE PTR Game.TIA_Regs[NUSIZ0]
  MOV   BL,BYTE PTR AtariSeg[NUSIZ0]

  SUB   BH,BH
  PUSH  NUSIZ0
  PUSH  BX

{  MOV   BYTE PTR AtariSeg[NUSIZ0],AL}
  MOV   DX,WORD PTR Game.TIA_Scan

  MOV   AX,WORD PTR Game.ObjectLoc[Player0Set * 2]
  MOV   WORD PTR Game.OldObjectLoc[Player0Set * 2],AX

  { --------------- }

  PUSH  WORD PTR Game.ObjectLoc[Player0Set * 2]
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,5
  MOV   WORD PTR Game.ObjectLoc[Player0Set * 2],AX

  SUB   AX,AX
  CALL  GetPlayerDelay

  POP   WORD PTR Game.ObjectLoc[Player0Set * 2]

  TEST  AX,80h
  JZ    @Delay0
@NoDelay0:
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  JMP   @Delay0Done
@Delay0:
  AND   AX,7Fh
  MOV   BX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   BX,CX
  ADD   BX,CX
  ADD   BX,CX
{  CMP   BX,WORD PTR Game.ObjectLoc[Player0Set * 2]
  JL    @NoDelay0}
  ADD   AX,BX
  JGE   @Delay0Done
  MOV   AX,BX
@Delay0Done:
  CMP   AX,160
  JL    @NoWrap0
  INC   DX
  SUB   AX,160
@NoWrap0:
  PUSH  AX  { Count }
  PUSH  DX  { Scan  }

  { --------------- }

  PUSH  WORD PTR Game.TIA_Regs[NUSIZ0]
  PUSH  WORD PTR Game.ObjectLoc[Player0Set * 2]

  MOV   BL,BYTE PTR AtariSeg[NUSIZ0]
  MOV   BYTE PTR Game.TIA_Regs[NUSIZ0],BL

  MOV   DX,WORD PTR Game.TIA_Scan

  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,5
  MOV   WORD PTR Game.ObjectLoc[Player0Set * 2],AX

  SUB   AX,AX
  CALL  GetPlayerDelay

  POP   WORD PTR Game.ObjectLoc[Player0Set * 2]
  POP   WORD PTR Game.TIA_Regs[NUSIZ0]

  TEST  AX,80h
  JZ    @Delay1
@NoDelay1:
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  JMP   @Delay1Done
@Delay1:
  AND   AX,7Fh
  MOV   BX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   BX,CX
  ADD   BX,CX
  ADD   BX,CX
{  CMP   BX,WORD PTR Game.ObjectLoc[Player0Set * 2]
  JL    @NoDelay1}
  ADD   AX,BX
  JGE   @Delay1Done
  MOV   AX,BX
@Delay1Done:
  CMP   AX,160
  JL    @NoWrap1
  INC   DX
  SUB   AX,160
@NoWrap1:

  { --------------- }

  POP   BX  { Scan  }
  POP   CX  { Count }

  CMP   BX,DX
  JG    @Copy1
  JL    @NoCopy1
  CMP   AX,CX
  JGE   @NoCopy1
@Copy1:
  MOV   AX,CX
  MOV   DX,BX
@NoCopy1:

  { --------------- }

  PUSH  DX
  PUSH  AX
  CALL  QueueLatch

  MOV   AL,BYTE PTR Game.TIA_Regs[NUSIZ0]
  MOV   BYTE PTR AtariSeg[NUSIZ0],AL

  JMP   GetOut

LNUSIZ1:

  MOV   AL,BYTE PTR Game.TIA_Regs[NUSIZ1]
  MOV   BYTE PTR Game.OldNUSIZ1,AL

  { Set the emulator latch values -- we can't use the normal TIA_Delay  }
  { method because the delay is greater than 9 pixels and can interfere }
  { with something else, e.g. RealSports Boxing.                        }

  MOV   AL,BYTE PTR Game.TIA_Regs[NUSIZ1]
  MOV   BL,BYTE PTR AtariSeg[NUSIZ1]

  SUB   BH,BH
  PUSH  NUSIZ1
  PUSH  BX

{  MOV   BYTE PTR AtariSeg[NUSIZ1],AL}
  MOV   DX,WORD PTR Game.TIA_Scan

  MOV   AX,WORD PTR Game.ObjectLoc[Player1Set * 2]
  MOV   WORD PTR Game.OldObjectLoc[Player1Set * 2],AX

  { --------------- }

  PUSH  WORD PTR Game.ObjectLoc[Player1Set * 2]
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,5
  MOV   WORD PTR Game.ObjectLoc[Player1Set * 2],AX

  MOV   AX,1
  CALL  GetPlayerDelay

  POP   WORD PTR Game.ObjectLoc[Player1Set * 2]

  TEST  AX,80h
  JZ    @Delay0A
@NoDelay0A:
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  JMP   @Delay0DoneA
@Delay0A:
  AND   AX,7Fh
  MOV   BX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   BX,CX
  ADD   BX,CX
  ADD   BX,CX
{  CMP   BX,WORD PTR Game.ObjectLoc[Player1Set * 2]
  JL    @NoDelay0A}
  ADD   AX,BX
  JGE   @Delay0DoneA
  MOV   AX,BX
@Delay0DoneA:
  CMP   AX,160
  JL    @NoWrap0A
  INC   DX
  SUB   AX,160
@NoWrap0A:
  PUSH  AX  { Count }
  PUSH  DX  { Scan  }

  { --------------- }

  PUSH  WORD PTR Game.TIA_Regs[NUSIZ1]
  PUSH  WORD PTR Game.ObjectLoc[Player1Set * 2]

  MOV   BL,BYTE PTR AtariSeg[NUSIZ1]
  MOV   BYTE PTR Game.TIA_Regs[NUSIZ1],BL

  MOV   DX,WORD PTR Game.TIA_Scan

  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,5
  MOV   WORD PTR Game.ObjectLoc[Player1Set * 2],AX

  MOV   AX,1
  CALL  GetPlayerDelay

  POP   WORD PTR Game.ObjectLoc[Player1Set * 2]
  POP   WORD PTR Game.TIA_Regs[NUSIZ1]

  TEST  AX,80h
  JZ    @Delay1A
@NoDelay1A:
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  JMP   @Delay1DoneA
@Delay1A:
  AND   AX,7Fh
  MOV   BX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   BX,CX
  ADD   BX,CX
  ADD   BX,CX
{  CMP   BX,WORD PTR Game.ObjectLoc[Player1Set * 2]
  JL    @NoDelay1A}
  ADD   AX,BX
  JGE   @Delay1DoneA
  MOV   AX,BX
@Delay1DoneA:
  CMP   AX,160
  JL    @NoWrap1A
  INC   DX
  SUB   AX,160
@NoWrap1A:

  { --------------- }

  POP   BX  { Scan  }
  POP   CX  { Count }

  CMP   BX,DX
  JG    @Copy1A
  JL    @NoCopy1A
  CMP   AX,CX
  JGE   @NoCopy1A
@Copy1A:
  MOV   AX,CX
  MOV   DX,BX
@NoCopy1A:

  { --------------- }

  PUSH  DX
  PUSH  AX
  CALL  QueueLatch

  MOV   AL,BYTE PTR Game.TIA_Regs[NUSIZ1]
  MOV   BYTE PTR AtariSeg[NUSIZ1],AL

  JMP   GetOut

(*
  MOV   AL,BYTE PTR Game.TIA_Regs[NUSIZ1]
  MOV   BYTE PTR Game.OldNUSIZ1,AL

  { Set the emulator latch values -- we can't use the normal TIA_Delay  }
  { method because the delay is greater than 9 pixels and can interfere }
  { with something else, e..g RealSports Boxing.                        }

  MOV   AL,BYTE PTR Game.TIA_Regs[NUSIZ1]
  MOV   BL,BYTE PTR AtariSeg[NUSIZ1]
  SUB   BH,BH
  PUSH  NUSIZ1
  PUSH  BX
  MOV   BYTE PTR AtariSeg[NUSIZ1],AL
  MOV   DX,WORD PTR Game.TIA_Scan
  MOV   AX,WORD PTR Game.ObjectLoc[Player1Set * 2]
  MOV   WORD PTR Game.OldObjectLoc[Player1Set * 2],AX
  PUSH  WORD PTR Game.TIA_Regs[NUSIZ1]
  PUSH  WORD PTR Game.ObjectLoc[Player1Set * 2]
  MOV   BYTE PTR Game.TIA_Regs[NUSIZ1],BL{AL}
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  MOV   WORD PTR Game.ObjectLoc[Player1Set * 2],AX
  MOV   AX,1
  CALL  GetPlayerDelay
  POP   WORD PTR Game.ObjectLoc[Player1Set * 2]
  POP   WORD PTR Game.TIA_Regs[NUSIZ1]
  TEST  AX,80h
  JZ    @Delay1
@NoDelay1:
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  JMP   @Delay1Done
@Delay1:
  AND   AX,7Fh
  MOV   BX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   BX,CX
  ADD   BX,CX
  ADD   BX,CX
  CMP   BX,WORD PTR Game.ObjectLoc[Player1Set * 2]
  JL    @NoDelay1
  ADD   AX,BX
  JGE   @Delay1Done
  MOV   AX,BX
@Delay1Done:
  CMP   AX,160
  JL    @NoWrap2
  INC   DX
  SUB   AX,160
@NoWrap2:
  PUSH  DX
  PUSH  AX
  CALL  QueueLatch
  JMP   GetOut
*)
(*
  MOV   AL,BYTE PTR Game.TIA_Regs[NUSIZ1]
  MOV   AH,BYTE PTR AtariSeg[NUSIZ1]
  MOV   BYTE PTR TIA_Latch[NUSIZ1],AH
  MOV   BYTE PTR AtariSeg[NUSIZ1],AL
  MOV   AX,WORD PTR Game.TIA_Scan
  MOV   WORD PTR Game.TIA_Latch_Scan[NUSIZ1 * 2],AX
  MOV   AX,WORD PTR Game.ObjectLoc[Player1Set * 2]
  MOV   WORD PTR Game.OldObjectLoc[Player1Set * 2],AX
  PUSH  WORD PTR Game.TIA_Regs[NUSIZ1]
  PUSH  WORD PTR Game.ObjectLoc[Player1Set * 2]
  MOV   AL,BYTE PTR TIA_Latch[NUSIZ1]
  MOV   BYTE PTR Game.TIA_Regs[NUSIZ1],AL
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  MOV   WORD PTR Game.ObjectLoc[Player1Set * 2],AX
  MOV   AX,1
  CALL  GetPlayerDelay
  POP   WORD PTR Game.ObjectLoc[Player1Set * 2]
  POP   WORD PTR Game.TIA_Regs[NUSIZ1]
  TEST  AX,80h
  JZ    @Delay1
@NoDelay1:
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  JMP   @Delay1Done
@Delay1:
  AND   AX,7Fh
  MOV   BX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   BX,CX
  ADD   BX,CX
  ADD   BX,CX
  CMP   BX,WORD PTR Game.ObjectLoc[Player1Set * 2]
  JL    @NoDelay1
  ADD   AX,BX
  JGE   @Delay1Done
  MOV   AX,BX
@Delay1Done:
  CMP   AX,160
  JL    @NoWrap2
  INC   WORD PTR Game.TIA_Latch_Scan[NUSIZ1 * 2]
  SUB   AX,160
@NoWrap2:
  MOV   WORD PTR Game.TIA_Latch_Count[NUSIZ1 * 2],AX { When the change happens }
  JMP   GetOut
*)
LAUDC0:

  PUSH  AX
  PUSH  DX
  PUSH  CX
  PUSH  DI
  MOV   AL,BYTE PTR AtariSeg[AUDC0]
  AND   AX,0Fh
  PUSH  0
  PUSH  AX
  CALL  SetVoice
  POP   DI
  POP   CX
  POP   DX
  POP   AX
  JMP   GetOut

LAUDV0:

  PUSH  AX
  PUSH  DX
  PUSH  CX
  PUSH  DI
  MOV   AL,BYTE PTR AtariSeg[AUDV0]
  AND   AX,0Fh
  PUSH  0
  PUSH  AX
  CALL  SetVolume
  POP   DI
  POP   CX
  POP   DX
  POP   AX
  JMP   GetOut

LAUDF0:

  PUSH  AX
  PUSH  DX
  PUSH  CX
  PUSH  DI
  MOV   AL,BYTE PTR AtariSeg[AUDF0]
  AND   AX,1Fh
  PUSH  0
  PUSH  AX
  CALL  SetFrequency
  POP   DI
  POP   CX
  POP   DX
  POP   AX
  JMP   GetOut

LAUDC1:

  PUSH  AX
  PUSH  DX
  PUSH  CX
  PUSH  DI
  MOV   AL,BYTE PTR AtariSeg[AUDC1]
  AND   AX,0Fh
  PUSH  1
  PUSH  AX
  CALL  SetVoice
  POP   DI
  POP   CX
  POP   DX
  POP   AX
  JMP   GetOut

LAUDV1:

  PUSH  AX
  PUSH  DX
  PUSH  CX
  PUSH  DI
  MOV   AL,BYTE PTR AtariSeg[AUDV1]
  AND   AX,0Fh
  PUSH  1
  PUSH  AX
  CALL  SetVolume
  POP   DI
  POP   CX
  POP   DX
  POP   AX
  JMP   GetOut

LAUDF1:

  PUSH  AX
  PUSH  DX
  PUSH  CX
  PUSH  DI
  MOV   AL,BYTE PTR AtariSeg[AUDF1]
  AND   AX,1Fh
  PUSH  1
  PUSH  AX
  CALL  SetFrequency
  POP   DI
  POP   CX
  POP   DX
  POP   AX
  JMP   GetOut

LCTRLPF:
  MOV   AL,BYTE PTR AtariSeg[CTRLPF]
  MOV   BL,BYTE PTR Game.TIA_Regs[CTRLPF]
  SUB   AH,AH
  PUSH  CTRLPF
  PUSH  AX
{  MOV   BYTE PTR TIA_Latch[CTRLPF],AL}
  MOV   BYTE PTR AtariSeg[CTRLPF],BL

  { Set the emulator latch values -- we can't use the normal TIA_Delay  }
  { method because the delay is greater than 9 pixels and can interfere }
  { with something else, e..g RealSports Boxing.                        }

  PUSH  WORD PTR Game.TIA_Scan
{  MOV   AX,WORD PTR Game.TIA_Scan
  MOV   WORD PTR Game.TIA_Latch_Scan[CTRLPF * 2],AX}
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX

  SUB   BX,BX
  CMP   AX,0
  JL    @DoCompare
  MOV   BX,80
  CMP   AX,80
  JL    @DoCompare
  MOV   BX,160
@DoCompare:
  PUSH  BX
  CALL  QueueLatch
{  MOV   WORD PTR Game.TIA_Latch_Count[CTRLPF * 2],BX}  { When the change happens }
  JMP   GetOut

LVSYNC:
{
  MOV   BX,DI
  SUB   BX,OFFSET AtariSeg
  ADD   BX,WORD PTR Bytes[SI]
  MOV   WORD PTR Game.OldStart,BX
  MOV   AL,BYTE PTR AtariSeg[BX]
  MOV   BYTE PTR Game.OldByte,AL
  MOV   BYTE PTR AtariSeg[BX],0FFh
}
(*
  MOV   AL,BYTE PTR AtariSeg[VSYNC]  { This works for Bowling and Codebreaker, but turns off CubiColor }
  TEST  AL,07Fh
  JNZ   @NotGoingOff
*)
{
  CMP   WORD PTR Game.TIA_Scan,190
  JGE   @Cont}
{  MOV   AL,BYTE PTR AtariSeg[VSYNC]}  { This turns off Bowling and Codebreaker }
{  TEST  AL,2}{07Eh}
{  JNZ   @NotGoingOff}{JZ @NotGoingOff}
{  CMP   WORD PTR Game.TIA_Scan,0
  JE    @Cont}
{  CMP   WORD PTR Game.TIA_Scan,200
  JB    @NotGoingOff}

{  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @Cont
  CMP   WORD PTR Game.TIA_Scan,20
  JB    @Cont}

  MOV   BYTE PTR Game.VBLANKOff,0


{  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @NotGoingOff}
  MOV   AX,WORD PTR Game.MaxRows
  CMP   WORD PTR Game.TIA_Scan,AX
  JG    @NotGoingOff
  MOV   AL,BYTE PTR AtariSeg[VSYNC]
  TEST  AL,2
  JNZ   @NotGoingOff
  TEST  BYTE PTR Game.TIA_Regs[VSYNC],2
  JZ    GetOut
{
  TEST  BYTE PTR Game.TIA_Regs[VSYNC],2
  JZ    @NotGoingOff
}


{  MOV   BYTE PTR Game.VBLANKOff,0}

{
  MOV   BX,WORD PTR Game.TIA_Scan
  CMP   BX,50
  JGE   @NoAdd
  CMP   BX,27
  JG    @Add2
  CMP   BX,-40
  JL    @Add1
  JMP   @NoAdd
@Add2:
  MOV   WORD PTR Game.VAddAdjust,1
  JMP   @Add3
@Add1:
  MOV   WORD PTR Game.VAddAdjust,-1
@Add3:
  MOV   AX,WORD PTR Game.VAddAdjust
  CMP   WORD PTR Game.VAdd,60
  JGE   @NoAdd
  CMP   WORD PTR Game.VAdd,-60
  JLE   @NoAdd
  ADD   WORD PTR Game.VAdd,AX
@NoAdd:
}
  JMP   GetOut
@NotGoingOff:
{  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @Cont
  MOV   CX,WORD PTR Game.TIA_Scan
  CMP   CX,0
  JL    @Cont
  CMP   CX,WORD PTR Game.MaxRows
  JGE   @Cont
  JMP   GetOut
@Cont:}




{  MOV   AL,BYTE PTR AtariSeg[VSYNC]
  MOV   BYTE PTR Game.TIA_Regs[VSYNC],AL}
  CALL  Handle_TIA
  MOV   BYTE PTR Game.Write_TIA,0
  MOV   AX,WORD PTR Game.TIA_Scan

  CMP   WORD PTR Game.LastVBLANK,100
  JGE   @NoSetVBLANK
  MOV   WORD PTR Game.LastVBLANK,AX
@NoSetVBLANK:
(*
  { Display to the end of the screen }

  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @BlankRest

  MOV   WORD PTR Game.TIA_Count,160
  CALL  Handle_TIA
@DispLoop:
  INC   WORD PTR Game.TIA_Scan
  MOV   AX,WORD PTR Game.TIA_Scan
  CMP   AX,WORD PTR Game.MaxRows
  JGE   @ResetVSYNC
  CMP   WORD PTR Game.TIA_Scan,0
  JGE   @NotMove
  MOV   WORD PTR Game.TIA_Scan,0
@NotMove:

  MOV   BX,WORD PTR Game.TIA_Scan
  MOV   AX,BX
  SHL   AX,6
  ADD   AH,BL
{$IFDEF LOWRES}
  SHR   AX,1
{$ENDIF}
  MOV   WORD PTR Game.Addr,AX
  MOV   WORD PTR Game.LineStart,AX
  MOV   BYTE PTR Game.DoHMOVE,0


  MOV   WORD PTR Game.Old_TIA_Count,-68
  MOV   WORD PTR Game.TIA_Count,160
  CALL  Handle_TIA
  JMP   @DispLoop
@BlankRest:

  MOV   BX,WORD PTR Game.MaxRows
  MOV   AX,BX
  SHL   AX,6
  ADD   AH,BL
{$IFDEF LOWRES}
  SHR   AX,1
{$ENDIF}

  CMP   AX,WORD PTR Addr
  JBE   @ResetVSYNC
  SUB   AX,WORD PTR Addr
  INC   AX
  MOV   CX,AX
  SUB   AX,AX
  CLD
  PUSH  DI
  MOV   BX,0A000h
  MOV   ES,BX
  MOV   DI,WORD PTR Addr
  REP   STOSB
  POP   DI
@ResetVSYNC:
*)

  { Handle slowdown if necessary }
{
  DB    _32BIT_OPERAND
  INC   WORD PTR NumFrames
}
  TEST  BYTE PTR AtariSeg[VSYNC],2
  JZ    @DoSlow
  TEST  BYTE PTR Game.TIA_Regs[VSYNC],2
  JNZ   @NoSlowDown
@DoSlow:
  CMP   WORD PTR Config.FrameRate,0
  JZ    @NoSlowDown
  CALL  SlowDown
@NoSlowDown:

  { Check to see if we are streaming to an .AVI file }

  DB    _32BIT_OPERAND
  PUSHA
  CALL  CheckAVIStream
  DB    _32BIT_OPERAND
  POPA

  MOV   AL,BYTE PTR AtariSeg[VSYNC]
  MOV   BYTE PTR Game.TIA_Regs[VSYNC],AL

  { For purposes of delaying the emulator, look at when the VSYNC took }
  { place to determine if the game is NTSC/60Hz or PAL/50Hz            }

  TEST  BYTE PTR Game.LineDelayFirst,0FFh
  JNZ   @AlreadyTested
  CMP   WORD PTR Game.LineDelay,252
  JL    @AlreadyTested                                { Can't tell yet }
  CMP   WORD PTR Game.LineDelay,324
  JG    @AlreadyTested                                { Can't tell yet }
  CMP   WORD PTR Game.LineDelay,272
  JL    @GameIsNTSC                                   { NTSC is at 262 }
  CMP   WORD PTR Game.LineDelay,304
  JG    @GameIsPAL                                    { NTSC is at 262 }
  JMP   @AlreadyTested                                { Can't tell yet }
@GameIsNTSC:
  MOV   WORD PTR Game.LineDelayMax,262
{  MOV   BYTE PTR Game.LineDelayFirst,1}
  JMP   @AlreadyTested
@GameIsPAL:
  MOV   WORD PTR Game.LineDelayMax,314
{  MOV   BYTE PTR Game.LineDelayFirst,1}
@AlreadyTested:

  { If the VSYNC has arrived, don't force a slowdown next time (assume that }
  { another VSYNC will come.  If one doesn't come, we'll eventually force a }
  { slowdown)                                                               }

  MOV   BYTE PTR Game.LineDelayFirst,0

  { Clear the line delay variable.  Since VSYNC is being asserted, we  }
  { don't need to force the emulator to slow down every 262 scan lines }

  MOV   WORD PTR Game.LineDelay,0

  { Reset the scan line counter }

  MOV   WORD PTR Game.TIA_Scan,-40
{
  CMP   WORD PTR Config.MaxRows,215
  JB    @NotPAL
  CMP   BYTE PTR Game.Palette,1
  JNE   @NotPAL
  MOV   WORD PTR Game.TIA_Scan,-68
@NotPAL:
}
  { See if the position was retrieved from the profile file }

  MOV   AX,WORD PTR Game.UserSetPos
  CMP   AX,NoPosSet
  JE    @DoAutoCenter
  ADD   WORD PTR Game.TIA_Scan,AX
  JMP   @NoAutoCenter
@DoAutoCenter:
  MOV   AX,WORD PTR Game.VAdd
  TEST  BYTE PTR AutoCenter,0FFh
  JZ    @NoAutoCenter
  ADD   WORD PTR Game.TIA_Scan,AX
@NoAutoCenter:
  MOV   AX,WORD PTR Game.VUserAdd
  ADD   WORD PTR Game.TIA_Scan,AX
  MOV   WORD PTR Game.LineStart,0
  MOV   WORD PTR Game.Addr,0
  JMP   GetOut



(*
  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @Cont
  CMP   WORD PTR Game.TIA_Scan,222
  JAE   @Cont
  MOV   AL,BYTE PTR AtariSeg[VSYNC]
  TEST  AL,2
  JZ   @NotGoingOff
  CMP   WORD PTR Game.TIA_Scan,0
  JL    @Cont1
  MOV   CX,WORD PTR Game.MaxRows
  CMP   WORD PTR Game.TIA_Scan,CX{200}
  JGE   @Cont1
  JMP   @NotGoingOff
@Cont1:
  TEST  BYTE PTR AtariSeg[VBLANK],2
  JZ    @NotGoingOff


{  TEST  BYTE PTR AtariSeg[VBLANK],2
  JZ    @Cont
  CMP   WORD PTR Game.TIA_Scan,215
  JAE   @Cont}
  TEST  BYTE PTR Game.TIA_Regs[VSYNC],2
  JNZ   @NotGoingOff
{  TEST  BYTE PTR AtariSeg[VBLANK],2
  JZ    @NotGoingOff}
{  CMP   WORD PTR Game.TIA_Scan,200
  JB    @NotGoingOff}
{  CMP   WORD PTR Game.TIA_Scan,215
  JB    @NotGoingOff}


{  TEST  BYTE PTR Game.TIA_Regs[VSYNC],2
  JZ    @NotGoingOff}



{  TEST  BYTE PTR Game.TIA_Regs[VSYNC],2
  JZ    @NotGoingOff}

@Cont:

{  CMP   WORD PTR Game.TIA_Scan,190
  JB    @NotGoingOff}
{  TEST  BYTE PTR AtariSeg[VBLANK],2
  JZ    @NotGoingOff}

  MOV   BX,WORD PTR Game.TIA_Scan
  CMP   BX,100
  JL    @NoAdd
  CMP   BX,222
  JL    @Add2
  CMP   BX,230
  JG    @Add1
  JMP   @NoAdd
@Add2:
{  CMP   WORD PTR Game.VAddAdjust,-1
  JE    @NoAdd}
  MOV   WORD PTR Game.VAddAdjust,1
  JMP   @Add3
@Add1:
{  CMP   WORD PTR Game.VAddAdjust,1
  JE    @NoAdd}
  MOV   WORD PTR Game.VAddAdjust,-1
@Add3:
  MOV   AX,WORD PTR Game.VAddAdjust
  CMP   WORD PTR Game.VAdd,60
  JGE   @NoAdd
  CMP   WORD PTR Game.VAdd,-60
  JLE   @NoAdd
  ADD   WORD PTR Game.VAdd,AX
@NoAdd:

  MOV   AL,BYTE PTR AtariSeg[VSYNC]
  MOV   BYTE PTR Game.TIA_Regs[VSYNC],AL
  CALL  Handle_TIA
  MOV   BYTE PTR Game.Write_TIA,0


  MOV   WORD PTR Game.TIA_Scan,-37

  MOV   AX,WORD PTR Game.VAdd
  ADD   WORD PTR Game.TIA_Scan,AX

  MOV   WORD PTR Game.LineStart,0
  MOV   WORD PTR Game.Addr,0

  { Handle slowdown if necessary }

  CMP   WORD PTR Config.FrameRate,0
  JZ    @NoSlowDown
  CALL  SlowDown
@NoSlowDown:
  JMP   GetOut
@NotGoingOff:
  MOV   BYTE PTR Game.TIA_Regs[VSYNC],AL
{  TEST  AL,2
  JZ    @LVSYNC1
  CALL  Handle_TIA
  MOV   BYTE PTR Game.Write_TIA,0
@LVSYNC1:}
  JMP   GetOut
*)
LENABL:

  MOV   AL,BYTE PTR AtariSeg[ENABL]
  MOV   BL,BYTE PTR Game.TIA_Regs[ENABL]
  MOV   BYTE PTR AtariSeg[ENABL],BL
  MOV   BYTE PTR Game.BallLatch,AL
(*
  MOV   BL,BYTE PTR Game.BallLatch
  MOV   BYTE PTR AtariSeg[ENABL],BL
  MOV   BYTE PTR Game.BallLatch,AL
  TEST  BYTE PTR AtariSeg[VDELBL],1
  JNZ   @DelayedBL
@NotDelayedBL:
  MOV   BYTE PTR AtariSeg[ENABL],AL
@DelayedBL:
  MOV   AL,BYTE PTR AtariSeg[ENABL]
*)
  JMP   GetOut

LGRP0:
  MOV   AL,BYTE PTR AtariSeg[GRP0]
  MOV   BL,BYTE PTR Game.TIA_Regs[GRP0]
  MOV   BYTE PTR AtariSeg[GRP0],BL
  MOV   BYTE PTR Game.GRP0Latch,AL
  JMP   GetOut

LGRP1:
  MOV   AL,BYTE PTR AtariSeg[GRP1]
  MOV   BL,BYTE PTR Game.TIA_Regs[GRP1]
  MOV   BYTE PTR AtariSeg[GRP1],BL
  MOV   BYTE PTR Game.GRP1Latch,AL
  JMP   GetOut

LVBLANK:

  TEST  BYTE PTR AtariSeg[VBLANK],2
  JZ    @NotLast
  TEST  BYTE PTR Game.TIA_Regs[VBLANK],2
  JNZ   @NotLast

  MOV   BX,WORD PTR Game.TIA_Scan
  CMP   BX,100
  JL    @NotLast
{  CMP   WORD PTR Game.LastVBLANK,100
  JGE   @SAveLast
  TEST  BYTE PTR AtariSeg[VSYNC],2
  JZ    @SaveLast
@SaveLast:
}
  MOV   WORD PTR Game.LastVBLANK,BX
@NotLast:




  MOV   AH,BYTE PTR AtariSeg[VBLANK]
  TEST  AH,80h
  JZ    @NoGround1

  CMP   BYTE PTR Game.Cart,ctCBS
  JE    @NoGround1

  MOV   WORD PTR Game.Input_Byte[INPUT0],8{0}
  MOV   WORD PTR Game.Input_Byte[INPUT2],0
@NoGround1:
  TEST  BYTE PTR Game.TIA_Regs[VBLANK],80h
  JZ    @NoGround
  DB    _32BIT_OPERAND
  SUB   BX,BX

  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.PaddleGround0,BX
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.PaddleGround1,BX
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.PaddleGround2,BX
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.PaddleGround3,BX
{
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.OldPaddleGround0,BX
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.OldPaddleGround1,BX
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.OldPaddleGround2,BX
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.OldPaddleGround3,BX
}
  CMP   BYTE PTR Game.Cart,ctCBS
  JE    @NoGround2
  MOV   WORD PTR Game.Input_Byte[INPUT0],8{0}
  MOV   WORD PTR Game.Input_Byte[INPUT2],0
@NoGround2:
{
  PUSH  DS
  MOV   DS,WORD PTR Global_Save_DS[_Base]
}






{
  CMP   BYTE PTR Game.Controller,crPaddle
  JNE   @NoGround
  PUSH  AX
  CALL  GetMouseInfo}   { Removed 3-14-99 }
{  CALL GetControllers;}

{
  POP   AX
}







{
  DB    _32BIT_OPERAND
  MOV   BX,WORD PTR Game.PaddleGround0
  DB    _32BIT_OPERAND
  MOV   CX,WORD PTR Game.PaddleGround1
  DB    _32BIT_OPERAND
  MOV   DX,WORD PTR Game.PaddleGround2
  DB    _32BIT_OPERAND
  MOV   DI,WORD PTR Game.PaddleGround3
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.PaddleGround0[_Base],BX
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.PaddleGround1[_Base],CX
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.PaddleGround2[_Base],DX
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.PaddleGround3[_Base],DI
}
{
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.PaddleGround,BX
  MOV   WORD PTR Game.Input_Byte[INPUT0],0
  MOV   WORD PTR Game.Input_Byte[INPUT2],0
  CALL  GetMouseInfo
}
{
  DB    _32BIT_OPERAND
  MOV   BX,WORD PTR Game.PaddleGround
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.PaddleGround,BX
}
@NoGround:


(*
  INC   WORD PTR ControlFrame
  CMP   WORD PTR ControlFrame,1{3}
  JB    @NoGetControllers
*)
  TEST  BYTE PTR Game.TIA_Regs[VBLANK],80h
  JZ    @NoGetControllers
  TEST  BYTE PTR AtariSeg[VBLANK],80h
  JNZ   @NoGetControllers


(*
  DB    _32BIT_OPERAND
  PUSH  AX
  DB    _32BIT_OPERAND
  PUSH  BX
  DB    _32BIT_OPERAND
  PUSH  CX
  DB    _32BIT_OPERAND
  PUSH  DX
  DB    _32BIT_OPERAND
  PUSH  SI
  DB    _32BIT_OPERAND
  PUSH  DI
  DB    _32BIT_OPERAND
  PUSH  BP
  PUSH  DS
  PUSH  ES
  PUSHF
  CALL  GetControllers
  POPF
  POP   ES
  POP   DS
  DB    _32BIT_OPERAND
  POP   BP
  DB    _32BIT_OPERAND
  POP   DI
  DB    _32BIT_OPERAND
  POP   SI
  DB    _32BIT_OPERAND
  POP   DX
  DB    _32BIT_OPERAND
  POP   CX
  DB    _32BIT_OPERAND
  POP   BX
  DB    _32BIT_OPERAND
  POP   AX
*)

  DB    _32BIT_OPERAND
  MOV   AX,WORD PTR Game.OldPaddleGround0
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.PaddleGround0,AX
  DB    _32BIT_OPERAND
  MOV   AX,WORD PTR Game.OldPaddleGround1
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.PaddleGround1,AX
  DB    _32BIT_OPERAND
  MOV   AX,WORD PTR Game.OldPaddleGround2
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.PaddleGround2,AX
  DB    _32BIT_OPERAND
  MOV   AX,WORD PTR Game.OldPaddleGround3
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.PaddleGround3,AX

{  MOV   WORD PTR ControlFrame,0}

@NoGetControllers:



  AND   AH,40h
  ROL   AH,2
  MOV   BYTE PTR Game.Latched,AH
  TEST  AH,1
  JZ    @NotLatched
@NotLatched:


  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @NotOff
  TEST  BYTE PTR Game.TIA_Regs[VBLANK],2
  JZ    @NotOff
{  CMP   WORD PTR Game.TIA_Scan,-11
  JL    @Resync
  CMP   WORD PTR Game.TIA_Scan,11
  JG    @NotOff
  SUB   CX,CX
  JMP   @RS2}

  CMP   WORD PTR Game.TIA_Scan,-11
  JGE   @NotOff
{  CMP   WORD PTR Game.TIA_Scan,-45
  JL    @NotOff}


(*  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @NotOff
  TEST  BYTE PTR Game.TIA_Regs[VBLANK],2
  JZ    @NotOff
{  CMP   WORD PTR Game.TIA_Scan,100
  JGE   @Resync}

  CMP   WORD PTR Game.TIA_Scan,223
  JE    @Below
  CMP   WORD PTR Game.TIA_Scan,200
  JGE   @Resync

@Below:
  CMP   WORD PTR Game.TIA_Scan,-25
  JL    @NotOff
  CMP   WORD PTR Game.TIA_Scan,25
  JG    @NotOff*)
@Resync:
{  MOV   CX,WORD PTR Game.TIA_Scan}
{  MOV   CX,WORD PTR Game.VAdd
  CMP   CX,0
  JL    @RS1
  ADD   CX,8
  AND   CX,0FFF0h
  JMP   @RS2
@RS1:
  NEG   CX
  ADD   CX,8
  AND   CX,0FFF0h
  NEG   CX
@RS2:}
{
  MOV   CX,WORD PTR Game.TIA_Scan
  ADD   CX,WORD PTR Game.VAdd
}

{
  SUB   CX,CX
  CMP   WORD PTR Game.TIA_Scan,-11
  JGE   @RS1
  MOV   CX,WORD PTR Game.TIA_Scan
  NEG   CX
  SHR   CX,3
  MOV   BX,WORD PTR Game.TIA_Scan
  NEG   BX
  AND   BX,0FFF0h
  NEG   BX
  ADD   CX,BX
@RS1:}
  MOV   BYTE PTR Game.TopVBLANK,0
(*  MOV   AX,WORD PTR Game.TIA_Scan
  MOV   BH,AL
  SUB   BL,BL
  SHL   AX,6
  ADD   AX,BX
  MOV   BX,WORD PTR Addr
  SUB   BX,AX
  MOV   WORD PTR Game.TIA_Scan,CX{0}
  MOV   WORD PTR Game.Addr,BX*)
@NotOff:


  { Auto-centering routine }

  TEST  BYTE PTR AtariSeg[VBLANK],2
  JNZ   @NoAdd
  TEST  BYTE PTR Game.TIA_Regs[VBLANK],2
  JZ    @NoAdd
  TEST  BYTE PTR Game.VBLANKOff,0FFh
  JNZ   @NoAdd
  MOV   BYTE PTR Game.VBLANKOff,1

  MOV   CX,WORD PTR Game.MaxRows
  SHR   CX,1
  MOV   DX,CX
  MOV   BX,WORD PTR Game.LastVBLANK
  SUB   BX,WORD PTR Game.TIA_Scan
  MOV   AX,WORD PTR Game.MaxRows
  CMP   BX,AX
  JLE   @NoWiden
  ADD   AX,10
  CMP   BX,AX
  JGE   @Average
  MOV   CX,0
  MOV   DX,10

  ADD   DX,WORD PTR Game.VUserAdd
  ADD   CX,WORD PTR Game.VUserAdd

  MOV   BX,WORD PTR Game.TIA_Scan
  CMP   BX,DX
  JG    @Add2
  CMP   BX,CX
  JL    @Add1
  JMP   @NoAdd
@Average:
  SUB   CX,2
  ADD   DX,3
@NoWiden:

  ADD   DX,WORD PTR Game.VUserAdd
  ADD   CX,WORD PTR Game.VUserAdd

  MOV   BX,WORD PTR Game.LastVBLANK
  ADD   BX,WORD PTR Game.TIA_Scan
  SHR   BX,1
  CMP   BX,DX
  JG    @Add2
  CMP   BX,CX
  JL    @Add1
  JMP   @NoAdd
{
  MOV   BX,WORD PTR Game.TIA_Scan
  CMP   BX,10
  JG    @Add2
  CMP   BX,0
  JL    @Add1
  JMP   @NoAdd
}
@Add2:
  MOV   WORD PTR Game.VAddAdjust,-1
  JMP   @Add3
@Add1:
  MOV   WORD PTR Game.VAddAdjust,1
@Add3:
  MOV   AX,WORD PTR Game.VAddAdjust
  CMP   WORD PTR Game.VAdd,20
  JGE   @NoAdd
  CMP   WORD PTR Game.VAdd,-20
  JLE   @NoAdd

  TEST  BYTE PTR AutoCenter,0FFh
  JZ    @NoAdd

  ADD   WORD PTR Game.VAdd,AX
@NoAdd:








  JMP   GetOut

LWSYNC:
    SUB   DX,DX
    MOV   BX,160
    SUB   BX,WORD PTR Game.TIA_Count
    MOV   DL,BYTE PTR Div3[BX]
    SUB   DX,WORD PTR Game.AddCycle
    MOV   AX,WORD PTR Game.TIA_Count
    MOV   CX,WORD PTR Game.AddCycle
    ADD   AX,CX
    ADD   AX,CX
    ADD   AX,CX
    CMP   AX,160
    JLE   @NoExtraLine

    ADD   DX,76

    DB    _32BIT_OPERAND
    PUSHA
{    PUSH  WORD PTR Game.TIA_Count}
    MOV   WORD PTR Game.TIA_Count,160{AX}
    CALL  Handle_TIA
{    POP   WORD PTR Game.TIA_Count}
    DB    _32BIT_OPERAND
    POPA
    MOV   WORD PTR Game.Old_TIA_Count,0
    MOV   WORD PTR Game.TIA_Count,160

    MOV   AX,WORD PTR Game.TIA_Scan
    CMP   AX,WORD PTR MaxScan
    JGE   @DoneLines
    INC   AX
@DoneLines:
    MOV   WORD PTR Game.TIA_Scan,AX

    ADD   WORD PTR Game.TimerElapsed,76
    ADC   WORD PTR Game.TimerElapsed[2],0
    DB    _32BIT_OPERAND
    MOV   BX,WORD PTR Game.TimerX
    DB    _32BIT_OPERAND
    ADD   WORD PTR Game.TimerElapsed,BX
    DB    _32BIT_OPERAND
    SUB   BX,BX
    DB    _32BIT_OPERAND
    MOV   WORD PTR Game.TimerX,BX

@NoExtraLine:


{
    DB    _32BIT_OPERAND
    SUB   AX,AX
    MOV   BX,160
    SUB   BX,WORD PTR Game.TIA_Count
    MOV   AL,BYTE PTR Div3[BX]
    SUB   AX,WORD PTR Game.AddCycle
    JLE   @GetOut
}



    CMP   BYTE PTR Game.Controller,crPaddle
    JNE   @NoPaddle

    TEST  BYTE PTR AtariSeg[VBLANK],80h
    JNZ   @NoPaddle

    DB    _32BIT_OPERAND
    SUB   AX,AX
    MOV   AX,DX

    TEST  BYTE PTR Game.Input_Byte[INPUT0],80h
    JNZ   @NoPaddle0
    DB    _32BIT_OPERAND
    SUB   WORD PTR Game.PaddleGround0,AX
    JNC   @NoPaddle0
    MOV   BYTE PTR Game.Input_Byte[INPUT0],80h
@NoPaddle0:

    TEST  BYTE PTR Game.Input_Byte[INPUT1],80h
    JNZ   @NoPaddle1
    DB    _32BIT_OPERAND
    SUB   WORD PTR Game.PaddleGround1,AX
    JNC   @NoPaddle1
    MOV   BYTE PTR Game.Input_Byte[INPUT1],80h
@NoPaddle1:

    TEST  BYTE PTR Game.Input_Byte[INPUT2],80h
    JNZ   @NoPaddle2
    DB    _32BIT_OPERAND
    SUB   WORD PTR Game.PaddleGround2,AX
    JNC   @NoPaddle2
    MOV   BYTE PTR Game.Input_Byte[INPUT2],80h
@NoPaddle2:

    TEST  BYTE PTR Game.Input_Byte[INPUT3],80h
    JNZ   @NoPaddle3
    DB    _32BIT_OPERAND
    SUB   WORD PTR Game.PaddleGround3,AX
    JNC   @NoPaddle3
    MOV   BYTE PTR Game.Input_Byte[INPUT3],80h
@NoPaddle3:
@NoPaddle:




@GetOut:
(*
    MOV   BX,160
    SUB   BX,WORD PTR Game.TIA_Count
    MOV   BL,BYTE PTR Div3[BX]
    SUB   BX,WORD PTR Game.AddCycle
    JLE   @GetOut
*)

{
    JG    @EOLOk
    ADD   BX,228
@EOLOk:
}
{    CMP   WORD PTR Game.TimerInterval,0
    JE    @GetOut}
(*
    TEST  BYTE PTR TimerDone,0FFh
    JNZ   @LTimerDone
    MOV   SI,WORD PTR Game.TimerInterval
    ADD   WORD PTR Game.TimerValue,BX
@DoAgain:
    MOV   BX,WORD PTR Game.TimerValue
    CMP   BX,SI
    JL    @GetOut
    MOV   WORD PTR Game.TimerValue,0
    SUB   BX,SI
    SUB   WORD PTR AtariSeg[INTTIM1],1
    JC    @Done
    ADD   WORD PTR Game.TimerValue,BX
    JMP   @DoAgain
@Done:
    MOV   BYTE PTR TimerDone,1
@LTimerDone:
    SUB   BYTE PTR AtariSeg[INTTIM1],BL
@GetOut:
*)
  MOV   AX,160
  MOV   WORD PTR Game.TIA_Count,AX
  MOV   BYTE PTR Game.Write_TIA,2
  JMP   GetOut

LRSYNC:
{
  MOV   WORD PTR Game.TIA_Count,160
  CALL  Handle_TIA
  MOV   AL,BYTE PTR AtariSeg[RSYNC]
  MOV   BYTE PTR Game.TIA_Regs[RSYNC],AL
  SUB   WORD PTR Game.Addr,320
  MOV   BYTE PTR Game.Write_TIA,0
  MOV   WORD PTR Game.TIA_Count,-68
  MOV   WORD PTR Game.Old_TIA_Count,-68
}
  JMP   GetOut

LRESP0:

  MOV   AX,WORD PTR Game.ResetOfs
  MOV   WORD PTR Game.ResetOffset[0],AX
  ADD   WORD PTR Game.ResetOfs,3

  MOV   AX,WORD PTR Game.ObjectLoc[Player0Set * 2]
  MOV   WORD PTR Game.OldObjectLoc[Player0Set * 2],AX
{
  MOV   AX,WORD PTR Game.OldPlayer0Size128
  MOV   WORD PTR Game.ResetPlayer0Size128,AX
}
  OR    BYTE PTR Game.ObjectSet,Player0Set
(*
  { Set the emulator latch values -- we can't use the normal TIA_Delay  }
  { method because the delay is greater than 9 pixels and can interfere }
  { with something else, e..g RealSports Boxing.                        }

  MOV   AL,BYTE PTR AtariSeg[RESP0]
  INC   AL                            { Do anything to make it different }
  MOV   BYTE PTR TIA_Latch[RESP0],AL
  MOV   AX,WORD PTR Game.TIA_Scan
  MOV   WORD PTR Game.TIA_Latch_Scan[RESP0 * 2],AX
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,13
  CMP   AX,160
  JL    @NoWrap3
  INC   WORD PTR Game.TIA_Latch_Scan[RESP0 * 2]
  SUB   AX,228
@NoWrap3:
  MOV   WORD PTR Game.TIA_Latch_Count[RESP0 * 2],AX { When the change happens }
*)
  JMP   GetOut

LRESP1:

  MOV   AX,WORD PTR Game.ResetOfs
  MOV   WORD PTR Game.ResetOffset[2],AX
  ADD   WORD PTR Game.ResetOfs,3

  MOV   AX,WORD PTR Game.ObjectLoc[Player1Set * 2]
  MOV   WORD PTR Game.OldObjectLoc[Player1Set * 2],AX
{
  MOV   AX,WORD PTR Game.OldPlayer1Size128
  MOV   WORD PTR Game.ResetPlayer1Size128,AX
}
  OR    BYTE PTR Game.ObjectSet,Player1Set
(*
  { Set the emulator latch values -- we can't use the normal TIA_Delay  }
  { method because the delay is greater than 9 pixels and can interfere }
  { with something else, e..g RealSports Boxing.                        }

  MOV   AL,BYTE PTR AtariSeg[RESP1]
  INC   AL                            { Do anything to make it different }
  MOV   BYTE PTR TIA_Latch[RESP1],AL
  MOV   AX,WORD PTR Game.TIA_Scan
  MOV   WORD PTR Game.TIA_Latch_Scan[RESP1 * 2],AX
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,CX
  ADD   AX,13
  CMP   AX,160
  JL    @NoWrap4
  INC   WORD PTR Game.TIA_Latch_Scan[RESP1 * 2]
  SUB   AX,228
@NoWrap4:
  MOV   WORD PTR Game.TIA_Latch_Count[RESP1 * 2],AX { When the change happens }
*)
  JMP   GetOut

LRESM0:

  TEST  BYTE PTR AtariSeg[RESMP0],2
  JZ    @Missile0Ok
  MOV   AL,BYTE PTR Game.ObjectLoc[Player0Set * 2]
  MOV   AH,BYTE PTR Game._Player0Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH
  CMP   AX,160
  JB    @M0Ok1A
  SUB   AX,160
@M0Ok1A:
  MOV   WORD PTR Game.ObjectLoc[Missile0Set * 2],AX
  JMP   GetOut
@Missile0Ok:

  MOV   AX,WORD PTR Game.ResetOfs
  MOV   WORD PTR Game.ResetOffset[4],AX
  ADD   WORD PTR Game.ResetOfs,3

  MOV   AX,WORD PTR Game.ObjectLoc[Missile0Set * 2]
  MOV   WORD PTR Game.OldObjectLoc[Missile0Set * 2],AX

  OR    BYTE PTR Game.ObjectSet,Missile0Set
  JMP   GetOut

LRESM1:

  TEST  BYTE PTR AtariSeg[RESMP1],2
  JZ    @Missile1Ok
  MOV   AL,BYTE PTR Game.ObjectLoc[Player1Set * 2]
  MOV   AH,BYTE PTR Game._Player1Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH
  CMP   AX,160
  JB    @M1Ok1A
  SUB   AX,160
@M1Ok1A:
  MOV   WORD PTR Game.ObjectLoc[Missile1Set * 2],AX
  JMP   GetOut
@Missile1Ok:

  MOV   AX,WORD PTR Game.ResetOfs
  MOV   WORD PTR Game.ResetOffset[6],AX
  ADD   WORD PTR Game.ResetOfs,3

  MOV   AX,WORD PTR Game.ObjectLoc[Missile1Set * 2]
  MOV   WORD PTR Game.OldObjectLoc[Missile1Set * 2],AX

  OR    BYTE PTR Game.ObjectSet,Missile1Set
  JMP   GetOut

LRESBL:

  MOV   AX,WORD PTR Game.ResetOfs
  MOV   WORD PTR Game.ResetOffset[8],AX
  ADD   WORD PTR Game.ResetOfs,3

  MOV   AX,WORD PTR Game.ObjectLoc[BallSet * 2]
  MOV   WORD PTR Game.OldObjectLoc[BallSet * 2],AX

  OR    BYTE PTR Game.ObjectSet,BallSet
  JMP   GetOut

LHMCLR:
  DB    _32BIT_OPERAND
  SUB   AX,AX
  DB    _32BIT_OPERAND
  MOV   WORD PTR AtariSeg[HMP0],AX
  MOV   BYTE PTR AtariSeg[HMBL],AL

  CALL  SetP0Motion
  CALL  SetP1Motion
  CALL  SetM0Motion
  CALL  SetM1Motion
  CALL  SetBLMotion

  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TIA_Regs[HMP0],AX
  MOV   BYTE PTR Game.TIA_Regs[HMBL],AL
  MOV   BYTE PTR Game.Write_TIA,0

  MOV   AX,WORD PTR Game.HMOVECount
  ADD   AX,60 - 9
  CMP   AX,WORD PTR Game.TIA_Count
  JNE   @HMM01A
  TEST  BYTE PTR Game.DoHMOVE,0FFh
  JZ    @HMM01A
  MOV   BYTE PTR Game.M0Bug,1
  MOV   BYTE PTR Game.M0BugCount,0
@HMM01A:
(*
  TEST  BYTE PTR Game.DoHMOVE,0FFh
  JZ    @HMCLRBLB
  MOV   BX,WORD PTR Game.TIA_Count
  MOV   CX,WORD PTR Game.AddCycle
  ADD   BX,CX
  ADD   BX,CX
  ADD   BX,CX
  CMP   BX,-35{-14}{-8}{8}
  JGE   @HMCLRBLB

  { Player 0 }

  MOV   AX,WORD PTR Game.ObjectMove[Player0Set * 2]
  SUB   WORD PTR Game.ObjectLoc[Player0Set * 2],AX
  CMP   WORD PTR Game.ObjectLoc[Player0Set * 2],0{-68}
  JGE   @HMCLRP0A
  ADD   WORD PTR Game.ObjectLoc[Player0Set * 2],160{228}
@HMCLRP0A:
  CMP   WORD PTR Game.ObjectLoc[Player0Set * 2],160{-68}
  JL    @HMCLRP0B
  SUB   WORD PTR Game.ObjectLoc[Player0Set * 2],160{228}
@HMCLRP0B:

  { Player 1 }

  MOV   AX,WORD PTR Game.ObjectMove[Player1Set * 2]
  SUB   WORD PTR Game.ObjectLoc[Player1Set * 2],AX
  CMP   WORD PTR Game.ObjectLoc[Player1Set * 2],0{-68}
  JGE   @HMCLRP1A
  ADD   WORD PTR Game.ObjectLoc[Player1Set * 2],160{228}
@HMCLRP1A:
  CMP   WORD PTR Game.ObjectLoc[Player1Set * 2],160{-68}
  JL    @HMCLRP1B
  SUB   WORD PTR Game.ObjectLoc[Player1Set * 2],160{228}
@HMCLRP1B:

  { Missile 0 }

  MOV   AX,WORD PTR Game.ObjectMove[Missile0Set * 2]
  SUB   WORD PTR Game.ObjectLoc[Missile0Set * 2],AX
  CMP   WORD PTR Game.ObjectLoc[Missile0Set * 2],0{-68}
  JGE   @HMCLRM0A
  ADD   WORD PTR Game.ObjectLoc[Missile0Set * 2],160{228}
@HMCLRM0A:
  CMP   WORD PTR Game.ObjectLoc[Missile0Set * 2],160{-68}
  JL    @HMCLRM0B
  SUB   WORD PTR Game.ObjectLoc[Missile0Set * 2],160{228}
@HMCLRM0B:

  { Missile 1 }

  MOV   AX,WORD PTR Game.ObjectMove[Missile1Set * 2]
  SUB   WORD PTR Game.ObjectLoc[Missile1Set * 2],AX
  CMP   WORD PTR Game.ObjectLoc[Missile1Set * 2],0{-68}
  JGE   @HMCLRM1A
  ADD   WORD PTR Game.ObjectLoc[Missile1Set * 2],160{228}
@HMCLRM1A:
  CMP   WORD PTR Game.ObjectLoc[Missile1Set * 2],160{-68}
  JL    @HMCLRM1B
  SUB   WORD PTR Game.ObjectLoc[Missile1Set * 2],160{228}
@HMCLRM1B:

  { Ball }

  MOV   AX,WORD PTR Game.ObjectMove[BallSet * 2]
  SUB   WORD PTR Game.ObjectLoc[BallSet * 2],AX
  CMP   WORD PTR Game.ObjectLoc[BallSet * 2],0{-68}
  JGE   @HMCLRBLA
  ADD   WORD PTR Game.ObjectLoc[BallSet * 2],160{228}
@HMCLRBLA:
  CMP   WORD PTR Game.ObjectLoc[BallSet * 2],160{-68}
  JL    @HMCLRBLB
  SUB   WORD PTR Game.ObjectLoc[BallSet * 2],160{228}
@HMCLRBLB:
*)
  JMP   GetOut

LSWCHA1:

{  MOV   BYTE PTR UseKBControllers,1}
  MOV   AL,BYTE PTR AtariSeg[SWACNT1]
  MOV   BL,BYTE PTR AtariSeg[SWCHA1]
  MOV   BH,BYTE PTR AtariSeg[SWCHA2]
  MOV   CX,BX
  MOV   AH,AL
  NOT   AL
  AND   BH,AL
  AND   BL,AH
  OR    BH,BL
  MOV   BYTE PTR AtariSeg[SWCHA2],BH
  AND   CL,AH
  AND   CH,AL
  OR    CL,CH
  MOV   BYTE PTR AtariSeg[SWCHA1],CL

  DB    _32BIT_OPERAND
  PUSH  AX
  DB    _32BIT_OPERAND
  PUSH  BX
  DB    _32BIT_OPERAND
  PUSH  CX
  DB    _32BIT_OPERAND
  PUSH  DX
  DB    _32BIT_OPERAND
  PUSH  SI
  DB    _32BIT_OPERAND
  PUSH  DI
  DB    _32BIT_OPERAND
  PUSH  BP
  PUSH  DS
  PUSH  ES
  PUSHF
  CALL  WriteToPortA
  POPF
  POP   ES
  POP   DS
  DB    _32BIT_OPERAND
  POP   BP
  DB    _32BIT_OPERAND
  POP   DI
  DB    _32BIT_OPERAND
  POP   SI
  DB    _32BIT_OPERAND
  POP   DX
  DB    _32BIT_OPERAND
  POP   CX
  DB    _32BIT_OPERAND
  POP   BX
  DB    _32BIT_OPERAND
  POP   AX

  { If we're writing to this port, we must be attempting to use the  }
  { keyboard controllers.  Turn on the respective bits of INPUT0/1/4 }

{  MOV   BYTE PTR KBWrite,1}
{  CALL  CheckKBController}
  JMP   GetOut

LSWACNT1:

  MOV   AL,BYTE PTR AtariSeg[SWACNT1]
  MOV   BYTE PTR AtariSeg[SWACNT2],AL

  DB    _32BIT_OPERAND
  PUSH  AX
  DB    _32BIT_OPERAND
  PUSH  BX
  DB    _32BIT_OPERAND
  PUSH  CX
  DB    _32BIT_OPERAND
  PUSH  DX
  DB    _32BIT_OPERAND
  PUSH  SI
  DB    _32BIT_OPERAND
  PUSH  DI
  DB    _32BIT_OPERAND
  PUSH  BP
  PUSH  DS
  PUSH  ES
  PUSHF
  CALL  SetReadMask
  POPF
  POP   ES
  POP   DS
  DB    _32BIT_OPERAND
  POP   BP
  DB    _32BIT_OPERAND
  POP   DI
  DB    _32BIT_OPERAND
  POP   SI
  DB    _32BIT_OPERAND
  POP   DX
  DB    _32BIT_OPERAND
  POP   CX
  DB    _32BIT_OPERAND
  POP   BX
  DB    _32BIT_OPERAND
  POP   AX

  JMP   GetOut

LSWCHB1:

  MOV   AL,BYTE PTR AtariSeg[SWCHB2]
  MOV   BYTE PTR AtariSeg[SWCHB1],AL
  JMP   GetOut

LSWBCNT1:

  MOV   AL,BYTE PTR AtariSeg[SWBCNT2]
  MOV   BYTE PTR AtariSeg[SWBCNT1],AL
  JMP   GetOut

LINTTIM1:
  MOV   AL,BYTE PTR AtariSeg[INTTIM2]
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  JMP   GetOut

LINTTIM3:

  MOV   BYTE PTR AtariSeg[INTTIM3],0
{  MOV   AL,BYTE PTR AtariSeg[INTTIM3]
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR AtariSeg[INTTIM2],AL}
  JMP   GetOut

LTIM1T1:

  MOV   AL,BYTE PTR AtariSeg[TIM1T1]
  MOV   BYTE PTR AtariSeg[TIM1T2],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR Game.TimerDone,0
  MOV   WORD PTR Game.TimerInterval,1
  MOV   WORD PTR Game.TimerShift,0
  MOV   AX,WORD PTR Game.AddCycle
  NEG   AX
  MOV   WORD PTR Game.TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX
{
  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR Game.AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX
}
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR Game.OrigTimer,AL
{  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerSize,AX}
  MOV   BX,WORD PTR Game.TIA_Count
  ADD   BX,68
  MOV   AL,BYTE PTR Div3[BX]
  SUB   AH,AH
  ADD   AX,WORD PTR Game.AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerX,AX

  JMP   GetOut

LTIM2T1:

  MOV   AL,BYTE PTR AtariSeg[TIM2T1]
  MOV   BYTE PTR AtariSeg[TIM2T2],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR Game.TimerDone,0
  MOV   WORD PTR Game.TimerInterval,8
  MOV   WORD PTR Game.TimerShift,3
  MOV   AX,WORD PTR Game.AddCycle
  NEG   AX
  MOV   WORD PTR Game.TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX
{
  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR Game.AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX
}
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR Game.OrigTimer,AL
  DB    _32BIT_OPERAND
{  SHL   AX,3
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerSize,AX}
  MOV   BX,WORD PTR Game.TIA_Count
  ADD   BX,68
  MOV   AL,BYTE PTR Div3[BX]
  SUB   AH,AH
  ADD   AX,WORD PTR Game.AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerX,AX

  JMP   GetOut

LTIM3T1:

  MOV   AL,BYTE PTR AtariSeg[TIM3T1]
  MOV   BYTE PTR AtariSeg[TIM3T2],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR Game.TimerDone,0
  MOV   WORD PTR Game.TimerInterval,64
  MOV   WORD PTR Game.TimerShift,6
  MOV   AX,WORD PTR Game.AddCycle
  NEG   AX
  MOV   WORD PTR Game.TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX
{
  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR Game.AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX
}
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR Game.OrigTimer,AL
  DB    _32BIT_OPERAND
{  SHL   AX,6
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerSize,AX}
  MOV   BX,WORD PTR Game.TIA_Count
  ADD   BX,68
  MOV   AL,BYTE PTR Div3[BX]
  SUB   AH,AH
  ADD   AX,WORD PTR Game.AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerX,AX

  JMP   GetOut

LTIM4T1:

  MOV   AL,BYTE PTR AtariSeg[TIM4T1]
  MOV   BYTE PTR AtariSeg[TIM4T2],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR Game.TimerDone,0
  MOV   WORD PTR Game.TimerInterval,1024
  MOV   WORD PTR Game.TimerShift,10
  MOV   AX,WORD PTR Game.AddCycle
  NEG   AX
  MOV   WORD PTR Game.TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX
{
  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR Game.AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX
}
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR Game.OrigTimer,AL
  DB    _32BIT_OPERAND
{  SHL   AX,10
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerSize,AX}
  MOV   BX,WORD PTR Game.TIA_Count
  ADD   BX,68
  DB    _32BIT_OPERAND
  SUB   AX,AX
  MOV   AL,BYTE PTR Div3[BX]
  ADD   AX,WORD PTR Game.AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerX,AX

  JMP   GetOut

LSWCHA2:

{  MOV   BYTE PTR UseKBControllers,1}
  MOV   AL,BYTE PTR AtariSeg[SWACNT1]
  MOV   BL,BYTE PTR AtariSeg[SWCHA2]
  MOV   BH,BYTE PTR AtariSeg[SWCHA1]
  MOV   CX,BX
  MOV   AH,AL
  NOT   AL
  AND   BH,AL
  AND   BL,AH
  OR    BH,BL
  MOV   BYTE PTR AtariSeg[SWCHA1],BH
  AND   CL,AH
  AND   CH,AL
  OR    CL,CH
  MOV   BYTE PTR AtariSeg[SWCHA2],CL

  DB    _32BIT_OPERAND
  PUSH  AX
  DB    _32BIT_OPERAND
  PUSH  BX
  DB    _32BIT_OPERAND
  PUSH  CX
  DB    _32BIT_OPERAND
  PUSH  DX
  DB    _32BIT_OPERAND
  PUSH  SI
  DB    _32BIT_OPERAND
  PUSH  DI
  DB    _32BIT_OPERAND
  PUSH  BP
  PUSH  DS
  PUSH  ES
  PUSHF
  CALL  WriteToPortA
  POPF
  POP   ES
  POP   DS
  DB    _32BIT_OPERAND
  POP   BP
  DB    _32BIT_OPERAND
  POP   DI
  DB    _32BIT_OPERAND
  POP   SI
  DB    _32BIT_OPERAND
  POP   DX
  DB    _32BIT_OPERAND
  POP   CX
  DB    _32BIT_OPERAND
  POP   BX
  DB    _32BIT_OPERAND
  POP   AX

  { If we're writing to this port, we must be attempting to use the  }
  { keyboard controllers.  Turn on the respective bits of INPUT0/1/4 }

{  MOV   BYTE PTR KBWrite,1}
{  CALL  CheckKBController}
  JMP   GetOut

LSWACNT2:

  MOV   AL,BYTE PTR AtariSeg[SWACNT2]
  MOV   BYTE PTR AtariSeg[SWACNT1],AL

  DB    _32BIT_OPERAND
  PUSH  AX
  DB    _32BIT_OPERAND
  PUSH  BX
  DB    _32BIT_OPERAND
  PUSH  CX
  DB    _32BIT_OPERAND
  PUSH  DX
  DB    _32BIT_OPERAND
  PUSH  SI
  DB    _32BIT_OPERAND
  PUSH  DI
  DB    _32BIT_OPERAND
  PUSH  BP
  PUSH  DS
  PUSH  ES
  PUSHF
  CALL  SetReadMask
  POPF
  POP   ES
  POP   DS
  DB    _32BIT_OPERAND
  POP   BP
  DB    _32BIT_OPERAND
  POP   DI
  DB    _32BIT_OPERAND
  POP   SI
  DB    _32BIT_OPERAND
  POP   DX
  DB    _32BIT_OPERAND
  POP   CX
  DB    _32BIT_OPERAND
  POP   BX
  DB    _32BIT_OPERAND
  POP   AX

  JMP   GetOut

LSWCHB2:

  MOV   AL,BYTE PTR AtariSeg[SWCHB1]
  MOV   BYTE PTR AtariSeg[SWCHB2],AL
  JMP   GetOut

LSWBCNT2:

  MOV   AL,BYTE PTR AtariSeg[SWBCNT1]
  MOV   BYTE PTR AtariSeg[SWBCNT2],AL
  JMP   GetOut

LINTTIM2:

  MOV   AL,BYTE PTR AtariSeg[INTTIM2]
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
{  MOV   BYTE PTR AtariSeg[INTTIM3],AL}
  JMP   GetOut

LTIM1T2:

  MOV   AL,BYTE PTR AtariSeg[TIM1T2]
  MOV   BYTE PTR AtariSeg[TIM1T1],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR Game.TimerDone,0
  MOV   WORD PTR Game.TimerInterval,1
  MOV   WORD PTR Game.TimerShift,0
  MOV   AX,WORD PTR Game.AddCycle
  NEG   AX
  MOV   WORD PTR Game.TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX
{
  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR Game.AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX
}
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR Game.OrigTimer,AL
{  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerSize,AX}
  MOV   BX,WORD PTR Game.TIA_Count
  ADD   BX,68
  MOV   AL,BYTE PTR Div3[BX]
  SUB   AH,AH
  ADD   AX,WORD PTR Game.AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerX,AX

  JMP   GetOut

LTIM2T2:

  MOV   AL,BYTE PTR AtariSeg[TIM2T2]
  MOV   BYTE PTR AtariSeg[TIM2T1],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR Game.TimerDone,0
  MOV   WORD PTR Game.TimerInterval,8
  MOV   WORD PTR Game.TimerShift,3
  MOV   AX,WORD PTR Game.AddCycle
  NEG   AX
  MOV   WORD PTR Game.TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX
{
  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR Game.AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX
}
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR Game.OrigTimer,AL
  DB    _32BIT_OPERAND
{  SHL   AX,3
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerSize,AX}
  MOV   BX,WORD PTR Game.TIA_Count
  ADD   BX,68
  MOV   AL,BYTE PTR Div3[BX]
  SUB   AH,AH
  ADD   AX,WORD PTR Game.AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerX,AX

  JMP   GetOut

LTIM3T2:

  MOV   AL,BYTE PTR AtariSeg[TIM3T2]
  MOV   BYTE PTR AtariSeg[TIM3T1],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR Game.TimerDone,0
  MOV   WORD PTR Game.TimerInterval,64
  MOV   WORD PTR Game.TimerShift,6
  MOV   AX,WORD PTR Game.AddCycle
  NEG   AX
  MOV   WORD PTR Game.TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX
{
  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR Game.AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX
}
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR Game.OrigTimer,AL
  DB    _32BIT_OPERAND
{  SHL   AX,6
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerSize,AX}
  MOV   BX,WORD PTR Game.TIA_Count
  ADD   BX,68
  MOV   AL,BYTE PTR Div3[BX]
  SUB   AH,AH
  ADD   AX,WORD PTR Game.AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerX,AX

  JMP   GetOut

LTIM4T2:

  MOV   AL,BYTE PTR AtariSeg[TIM4T2]
  MOV   BYTE PTR AtariSeg[TIM4T1],AL
  MOV   BYTE PTR AtariSeg[INTTIM1],AL
  MOV   BYTE PTR Game.TimerDone,0
  MOV   WORD PTR Game.TimerInterval,1024
  MOV   WORD PTR Game.TimerShift,10
  MOV   AX,WORD PTR Game.AddCycle
  NEG   AX
  MOV   WORD PTR Game.TimerValue,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX
{
  DB    _32BIT_OPERAND
  SUB   BX,BX
  MOV   BL,BYTE PTR Game.AddCycle
  DB    _32BIT_OPERAND
  SUB   AX,BX
}
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerElapsed,AX

  MOV   AL,BYTE PTR AtariSeg[INTTIM1]
  MOV   BYTE PTR Game.OrigTimer,AL
  DB    _32BIT_OPERAND
{  SHL   AX,10
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerSize,AX}
  MOV   BX,WORD PTR Game.TIA_Count
  ADD   BX,68
  DB    _32BIT_OPERAND
  SUB   AX,AX
  MOV   AL,BYTE PTR Div3[BX]
  ADD   AX,WORD PTR Game.AddCycle
  NEG   AX
  DB    _32BIT_OPERAND
  CBW
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.TimerX,AX

GetOut:
    POP    DI
    POP    DX
    POP    CX
    POP    AX
End; { Handle_IO }


Procedure Handle_IO_After; Assembler;
{ ------------------------------------------------------------------------- }
{ On entry:                                                                 }
{ BX = Game.Save_BX                                                       }
{ ------------------------------------------------------------------------- }
Label LVBLANK,LGRP0,LGRP1,LENAM0,LENAM1,LENABL,LRESMP0,LRESMP1,LVDELP0,LVDELP1,
      {LNUSIZ0,LNUSIZ1,}LCOLUP0,LCOLUP1,
      LCOLUPF,LCOLUBK,
      LCTRLPF,LREFP0,LREFP1,

{      LRESP0,LRESP1,}

      LCXCLR,LHMOVE,LWSYNC,GetOut;
Asm
  TEST  BYTE PTR Handle_IO_Set_After,0FFh
  JNZ   @L2

  MOV   AX,OFFSET GetOut
  MOV   CX,CXCLR
  SUB   BX,BX
@L1:
  MOV   WORD PTR Handle_IO_Loc_After[BX],AX
  ADD   BX,2
  LOOP  @L1

  MOV   WORD PTR Handle_IO_Loc_After[VBLANK  * 2],OFFSET LVBLANK
  MOV   WORD PTR Handle_IO_Loc_After[GRP0    * 2],OFFSET LGRP0
  MOV   WORD PTR Handle_IO_Loc_After[GRP1    * 2],OFFSET LGRP1
  MOV   WORD PTR Handle_IO_Loc_After[ENAM0   * 2],OFFSET LENAM0
  MOV   WORD PTR Handle_IO_Loc_After[ENAM1   * 2],OFFSET LENAM1
  MOV   WORD PTR Handle_IO_Loc_After[ENABL   * 2],OFFSET LENABL
  MOV   WORD PTR Handle_IO_Loc_After[RESMP0  * 2],OFFSET LRESMP0
  MOV   WORD PTR Handle_IO_Loc_After[RESMP1  * 2],OFFSET LRESMP1
{
  MOV   WORD PTR Handle_IO_Loc_After[NUSIZ0  * 2],OFFSET LNUSIZ0
  MOV   WORD PTR Handle_IO_Loc_After[NUSIZ1  * 2],OFFSET LNUSIZ1
}
  MOV   WORD PTR Handle_IO_Loc_After[COLUP0  * 2],OFFSET LCOLUP0
  MOV   WORD PTR Handle_IO_Loc_After[COLUP1  * 2],OFFSET LCOLUP1
  MOV   WORD PTR Handle_IO_Loc_After[COLUPF  * 2],OFFSET LCOLUPF
  MOV   WORD PTR Handle_IO_Loc_After[COLUBK  * 2],OFFSET LCOLUBK
  MOV   WORD PTR Handle_IO_Loc_After[CTRLPF  * 2],OFFSET LCTRLPF
  MOV   WORD PTR Handle_IO_Loc_After[REFP0   * 2],OFFSET LREFP0
  MOV   WORD PTR Handle_IO_Loc_After[REFP1   * 2],OFFSET LREFP1
  MOV   WORD PTR Handle_IO_Loc_After[HMOVE   * 2],OFFSET LHMOVE
  MOV   WORD PTR Handle_IO_Loc_After[CXCLR   * 2],OFFSET LCXCLR
  MOV   WORD PTR Handle_IO_Loc_After[WSYNC   * 2],OFFSET LWSYNC

  MOV   WORD PTR Handle_IO_Loc_After[VDELP0  * 2],OFFSET LVDELP0
  MOV   WORD PTR Handle_IO_Loc_After[VDELP1  * 2],OFFSET LVDELP1
{
  MOV   WORD PTR Handle_IO_Loc_After[RESP0   * 2],OFFSET LRESP0
  MOV   WORD PTR Handle_IO_Loc_After[RESP1   * 2],OFFSET LRESP1
}
  MOV   BYTE PTR Handle_IO_Set_After,1
  MOV   BX,WORD PTR Game.Save_BX
@L2:
  CMP   BX,CXCLR
  JA    GetOut
  ADD   BX,BX
  JMP   WORD PTR Handle_IO_Loc_After[BX]

{LRESP0:}

    MOV   WORD PTR Game.ResetPlayer0Size128,0
    MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ0]
    AND   BX,7
    SHL   BX,1

    MOV   AX,WORD PTR Game.OldObjectLoc[Player0Set * 2]
    MOV   CX,WORD PTR Game.ObjectLoc[Player0Set * 2]{Game.TIA_Count}

    CMP   CX,AX
    JLE   @NoTurnP0Off
{
    ADD   AX,3
    CMP   CX,AX
    JG    @NoTurnP0Off
}
(*
    ADD   CX,11{WORD PTR TIA_Delay[RESP0 * 2]}
    CMP   CX,AX
    JL    @TurnP0Off

    ADD   AX,WORD PTR PlayerSize[BX]
    CMP   CX,AX
{    JL    @NoTurnP0Off}
*)
@TurnP0Off:
    MOV   AX,WORD PTR Add1A[BX]
    MOV   WORD PTR Game.ResetPlayer0Size128,AX
@NoTurnP0Off:
    JMP   GetOut

(*
    MOV   AX,WORD PTR Game.OldObjectLoc[Player0Set * 2]
    SUB   AX,5
    MOV   CX,WORD PTR Game.ObjectLoc[Player0Set * 2]
    SUB   CX,5
    CMP   CX,AX
    JLE   @NoTurnP0Off
    MOV   DX,CX
    SUB   DX,AX
    JNC   @NoP0Carry
    ADD   DX,160
@NoP0Carry:
    CMP   DX,WORD PTR PlayerSize[BX]
    JA    @NoTurnP0Off

    ADD   AX,WORD PTR PlayerZone1[BX]
    CMP   CX,AX
    JL    @TurnP0Off
    ADD   AX,WORD PTR _PlayerSize[BX]
    ADD   AX,2
    CMP   CX,AX
    JL    @DelayP0

    CMP   WORD PTR PlayerInc1[BX],0
    JE    @NoTurnP0Off
    ADD   AX,WORD PTR PlayerInc1[BX]
    CMP   CX,AX
    JL    @NoTurnP0Off
    ADD   AX,WORD PTR PlayerZone2[BX]
    CMP   CX,AX
    JL    @TurnP0Off
    ADD   AX,WORD PTR _PlayerSize[BX]
    ADD   AX,2
    CMP   CX,AX
    JL    @DelayP0

    CMP   WORD PTR PlayerInc2[BX],0
    JE    @NoTurnP0Off
    ADD   AX,WORD PTR PlayerInc2[BX]
    CMP   CX,AX
    JL    @NoTurnP0Off
    ADD   AX,WORD PTR PlayerZone2[BX]
    CMP   CX,AX
    JL    @TurnP0Off
    ADD   AX,WORD PTR _PlayerSize[BX]
    ADD   AX,2
    CMP   CX,AX
    JL    @DelayP0

    JMP   @NoTurnP0Off
@TurnP0Off:
    MOV   AX,WORD PTR Add1A[BX]
    MOV   WORD PTR Game.ResetPlayer0Size128,AX
    JMP   @NoTurnP0Off
@DelayP0:
    DEC   AX
    SUB   AX,CX
{    ADD   WORD PTR Game.ObjectLoc[Player0Set * 2],AX}
@NoTurnP0Off:
    JMP   GetOut
*)

{LRESP1:}

    MOV   WORD PTR Game.ResetPlayer1Size128,0
    MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ1]
    AND   BX,7
    SHL   BX,1

    MOV   AX,WORD PTR Game.OldObjectLoc[Player1Set * 2]
    MOV   CX,WORD PTR Game.TIA_Count

    CMP   CX,AX
    JL    @NoTurnP1Off

    ADD   CX,11{WORD PTR TIA_Delay[RESP1 * 2]}
    CMP   CX,AX
    JL    @TurnP1Off
    ADD   AX,WORD PTR PlayerSize[BX]
    CMP   CX,AX
{    JL    @NoTurnP1Off}
@TurnP1Off:
    MOV   AX,WORD PTR Add1A[BX]
    MOV   WORD PTR Game.ResetPlayer1Size128,AX
@NoTurnP1Off:
    JMP   GetOut

LWSYNC:
    TEST  BYTE PTR Game.M0Bug,0FFh
    JZ    @NoM0Bug
    INC   BYTE PTR Game.M0BugCount
    AND   BYTE PTR Game.M0BugCount,3
    MOV   AL,BYTE PTR AtariSeg[ENAM0]
    CMP   BYTE PTR Game.M0BugCount,3
    JNE   @LWSYNC1
    SUB   AL,AL
@LWSYNC1:
    AND   BYTE PTR Game.DispJump,0EFh
    TEST  AL,2
    JZ    @LWSYNC2
    TEST  BYTE PTR AtariSeg[RESMP0],2
    JNZ   @LWSYNC2
    OR    BYTE PTR Game.DispJump,10h
@LWSYNC2:

    MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ0]
    CMP   BYTE PTR Game.M0BugCount,2
    JNE   @LWSYNC3
    MOV   AL,BL
    SHR   AL,4
    AND   AL,3
    INC   AL
    CMP   AL,4
    JB    @LWSYNC4
    MOV   AL,3
@LWSYNC4:
    SHL   AL,4
    AND   BL,0CFh
    OR    BL,AL
@LWSYNC3:
    MOV   AL,BL
    MOV   AH,AL
    SHR   AL,1
    AND   AX,0718h
    OR    AL,AH
    AND   AH,0
    SHL   AX,7
    MOV   WORD PTR Game.Missile0SizeNum,AX
    MOV   WORD PTR Game.OldMissile0SizeNum,AX

    MOV   SI,BX
    SHR   SI,4
    AND   SI,3
    MOV   CL,BYTE PTR MissileSize[SI]
    SUB   CH,CH
    MOV   WORD PTR Game.Missile0Size,CX
    MOV   DX,CX
    DEC   CX
    SHR   CX,1
    MOV   WORD PTR Game.Missile0Adjust,CX
    SUB   DX,160
    MOV   WORD PTR Game.Missile0Size160,DX

    MOV   BL,BYTE PTR Game.M0BugCount
    SUB   BH,BH
    ADD   BX,BX
    MOV   AX,WORD PTR M0BugMove[BX]
{    SUB   WORD PTR Game.ObjectLoc[Missile0Set * 2],15}
    SUB   WORD PTR Game.ObjectLoc[Missile0Set * 2],AX
    CMP   WORD PTR Game.ObjectLoc[Missile0Set * 2],0
    JGE   @NoM0Bug
    ADD   WORD PTR Game.ObjectLoc[Missile0Set * 2],160
@NoM0Bug:
    CMP   WORD PTR Game.TIA_Count,8
    JL    @NoClearHMOVE
    MOV   BYTE PTR Game.DoHMOVE,0
    MOV   BYTE PTR Game.OldDoHMOVE,0
@NoClearHMOVE:
    JMP   GetOut

LVDELP0:
  TEST  BYTE PTR AtariSeg[VDELP0],1
  JNZ   GetOut
  MOV   BL,BYTE PTR Game.GRP0Latch
  MOV   BYTE PTR AtariSeg[GRP0],BL
  MOV   BYTE PTR Game.TIA_Regs[GRP0],BL

  AND   BYTE PTR Game.DispJump,0DFh
  TEST  BL,0FFh
  JZ    @LVDELP0A
  OR    BYTE PTR Game.DispJump,20h
@LVDELP0A:
  JMP   GetOut

LVDELP1:
  TEST  BYTE PTR AtariSeg[VDELP1],1
  JNZ   GetOut
  MOV   BL,BYTE PTR Game.GRP1Latch
  MOV   BYTE PTR AtariSeg[GRP1],BL
  MOV   BYTE PTR Game.TIA_Regs[GRP1],BL

  AND   BYTE PTR Game.DispJump,0F7h
  TEST  BL,0FFh
  JZ    @LVDELP1A
  OR    BYTE PTR Game.DispJump,8
@LVDELP1A:
  JMP   GetOut

LCXCLR:
  DB    _32BIT_OPERAND
  SUB   AX,AX
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.Input_Byte[0],AX
  DB    _32BIT_OPERAND
  MOV   WORD PTR Game.Input_Byte[4],AX
  MOV   AL,BYTE PTR AtariSeg[CXCLR]
  MOV   BYTE PTR Game.TIA_Regs[CXCLR],AL
  JMP   GetOut

LVBLANK:
  TEST  BYTE PTR AtariSeg[VBLANK],80h
  JNZ   @NoCheckControllers
  CMP   BYTE PTR Game.Controller,crKeyboard
  JE    @CheckControllers
  CMP   BYTE PTR Game.Controller,crVTP
  JE    @CheckControllers
  JMP   @NoCheckControllers
@CheckControllers:



{  CALL  Handle_Input}  { Removed 3-14-99 }



@NoCheckControllers:
{  AND   BYTE PTR Game.DispJump,0FDh
  TEST  BYTE PTR AtariSeg[ENABL],2
  JZ    @LVBLANKA
  OR    BYTE PTR Game.DispJump,2
@LVBLANKA:}
  TEST  BYTE PTR AtariSeg[VBLANK],80h
  JZ    @NoGround
  CMP   BYTE PTR Game.Cart,ctCBS
  JE    @NoGround
  MOV   WORD PTR Game.Input_Byte[INPUT0],8{0}
  MOV   WORD PTR Game.Input_Byte[INPUT2],0
@NoGround:

  MOV   BX,WORD PTR Game.TIA_Scan
  TEST  BYTE PTR AtariSeg[VBLANK],2
  JZ    @NoClear
{  CMP   BX,WORD PTR Game.LastScan
  JGE   @ClearExit
  CMP   BX,200
  JGE   @ClearExit
  MOV   DX,WORD PTR Game.LastScan
  CMP   DX,200
  JL    @ContBlank
  MOV   DX,200

@ContBlank:
  SUB   DX,BX
  MOV   AX,0A000h
  MOV   ES,AX
  MOV   DI,BX
  MOV   AX,DI
  SHL   DI,6
  SHL   AX,8
  ADD   DI,AX
  DB    _32BIT_OPERAND
  SUB   AX,AX
  CLD
@ClearLoop:}
{  MOV   CX,80
  DB    _32BIT_OPERAND
  REP   STOSW
  DEC   DX
  JNZ   @ClearLoop}
@ClearExit:
  MOV   WORD PTR Game.LastScan,BX
@NoClear:



  JMP   GetOut

LGRP0:
{
  MOV   AX,WORD PTR Game.TIA_Count
  ADD   AX,WORD PTR TIA_Delay[GRP0 * 2]
  MOV   WORD PTR GRP0Write,AX
}

  TEST  BYTE PTR AtariSeg[VDELP0],1
  JNZ   @DelayedP0
@NotDelayedP0:
  MOV   AL,BYTE PTR Game.GRP0Latch
  MOV   BYTE PTR AtariSeg[GRP0],AL
  MOV   BYTE PTR Game.TIA_Regs[GRP0],AL
@DelayedP0:
  MOV   BL,BYTE PTR Game.GRP1Latch
  MOV   BYTE PTR AtariSeg[GRP1],BL
  MOV   BYTE PTR Game.TIA_Regs[GRP1],BL
{  MOV   BL,BYTE PTR Game.TIA_Regs[GRP1]}
  AND   BYTE PTR Game.DispJump,0F7h
  TEST  BL,0FFh
  JZ    @LGRP0B
  OR    BYTE PTR Game.DispJump,8
@LGRP0B:
  AND   BYTE PTR Game.DispJump,0DFh
  TEST  BYTE PTR Game.TIA_Regs[GRP0],0FFh  { New }
  JZ    @LGRP0A
  OR    BYTE PTR Game.DispJump,20h
@LGRP0A:
  JMP   GetOut

LGRP1:
{
  MOV   AX,WORD PTR Game.TIA_Count
  ADD   AX,WORD PTR TIA_Delay[GRP1 * 2]
  MOV   WORD PTR GRP1Write,AX
}

  TEST  BYTE PTR AtariSeg[VDELP1],1
  JNZ   @DelayedP1
@NotDelayedP1:
  MOV   AL,BYTE PTR Game.GRP1Latch
  MOV   BYTE PTR AtariSeg[GRP1],AL
  MOV   BYTE PTR Game.TIA_Regs[GRP1],AL
@DelayedP1:
  MOV   BL,BYTE PTR Game.GRP0Latch
  MOV   BYTE PTR AtariSeg[GRP0],BL
  MOV   BYTE PTR Game.TIA_Regs[GRP0],BL
{  MOV   BL,BYTE PTR Game.TIA_Regs[GRP0]}
  AND   BYTE PTR Game.DispJump,0DFh
  TEST  BL,0FFh
  JZ    @LGRP1B
  OR    BYTE PTR Game.DispJump,20h
@LGRP1B:
  MOV   BL,BYTE PTR Game.BallLatch
  MOV   BYTE PTR AtariSeg[ENABL],BL
  MOV   BYTE PTR Game.TIA_Regs[ENABL],BL

  AND   BYTE PTR Game.DispJump,0FDh
  TEST  BL,2h
  JZ    @LGRP1C
  OR    BYTE PTR Game.DispJump,2h
@LGRP1C:

  AND   BYTE PTR Game.DispJump,0F7h
  TEST  BYTE PTR Game.TIA_Regs[GRP1],0FFh
  JZ    @LGRP1A
  OR    BYTE PTR Game.DispJump,8
@LGRP1A:
  JMP   GetOut

LENAM0:

  AND   BYTE PTR Game.DispJump,0EFh
  TEST  BYTE PTR AtariSeg[ENAM0],2
  JZ    @LENAM0A
  TEST  BYTE PTR AtariSeg[RESMP0],2
  JNZ   @LENAM0A
  OR    BYTE PTR Game.DispJump,10h
@LENAM0A:
  JMP   GetOut

LENAM1:
  AND   BYTE PTR Game.DispJump,0FBh
  TEST  BYTE PTR AtariSeg[ENAM1],2
  JZ    @LENAM1A
  TEST  BYTE PTR AtariSeg[RESMP1],2
  JNZ   @LENAM1A
  OR    BYTE PTR Game.DispJump,4
@LENAM1A:
  JMP   GetOut

LENABL:

  TEST  BYTE PTR AtariSeg[VDELBL],1
  JNZ   @DelayedBL
  MOV   AL,BYTE PTR Game.BallLatch
  MOV   BYTE PTR AtariSeg[ENABL],AL
  MOV   BYTE PTR Game.TIA_Regs[ENABL],AL
@DelayedBL:
  AND   BYTE PTR Game.DispJump,0FDh
  TEST  BYTE PTR AtariSeg[ENABL],2
  JZ    @LENABLA
  OR    BYTE PTR Game.DispJump,2
@LENABLA:
  JMP   GetOut

LRESMP0:

  TEST  BYTE PTR AtariSeg[RESMP0],2
  JZ    @Missile0Ok
  MOV   AL,BYTE PTR Game.ObjectLoc[Player0Set * 2]
  MOV   AH,BYTE PTR Game._Player0Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH
  CMP   AX,160
  JB    @M0Ok1B
  SUB   AX,160
@M0Ok1B:
  MOV   WORD PTR Game.ObjectLoc[Missile0Set * 2],AX
@Missile0Ok:

  AND   BYTE PTR Game.DispJump,0EFh
  TEST  BYTE PTR AtariSeg[ENAM0],2
  JZ    @LRESMP0A
  TEST  BYTE PTR AtariSeg[RESMP0],2
  JNZ   @LRESMP0A
  OR    BYTE PTR Game.DispJump,10h
@LRESMP0A:
  JMP   GetOut

LRESMP1:

  TEST  BYTE PTR AtariSeg[RESMP1],2
  JZ    @Missile1Ok
  MOV   AL,BYTE PTR Game.ObjectLoc[Player1Set * 2]
  MOV   AH,BYTE PTR Game._Player1Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH
  CMP   AX,160
  JB    @M1Ok1B
  SUB   AX,160
@M1Ok1B:
  MOV   WORD PTR Game.ObjectLoc[Missile1Set * 2],AX
@Missile1Ok:

  AND   BYTE PTR Game.DispJump,0FBh
  TEST  BYTE PTR AtariSeg[ENAM1],2
  JZ    @LRESMP1A
  TEST  BYTE PTR AtariSeg[RESMP1],2
  JNZ   @LRESMP1A
  OR    BYTE PTR Game.DispJump,4
@LRESMP1A:
  JMP   GetOut



LCOLUP0:

  MOV   AL,BYTE PTR Game.TIA_Regs[COLUP0]
  MOV   AH,AL
  MOV   WORD PTR Game.ColorLum[0],AX
  MOV   BX,WORD PTR Game.ColorLum[4]
  MOV   DX,WORD PTR Game.ColorLum[2]
  TEST  BYTE PTR Game.TIA_Regs[CTRLPF],2
  JZ    @LP01

  MOV   CL,BYTE PTR Game.TIA_Regs[CTRLPF]
  AND   CL,0Fh
  CMP   CL,0Fh
  JZ    @LP01

  MOV   WORD PTR Game.CLW,AX
  MOV   WORD PTR Game.CLW[2],AX
  MOV   WORD PTR Game.CRW,DX
  MOV   WORD PTR Game.CRW[2],DX
  JMP   @LP02
@LP01:
  MOV   WORD PTR Game.CLW,BX
  MOV   WORD PTR Game.CLW[2],BX
  MOV   WORD PTR Game.CRW,BX
  MOV   WORD PTR Game.CRW[2],BX
@LP02:
  JMP   GetOut

LCOLUP1:

  MOV   AL,BYTE PTR Game.TIA_Regs[COLUP1]
  MOV   AH,AL
  MOV   WORD PTR Game.ColorLum[2],AX
  MOV   BX,WORD PTR Game.ColorLum[4]
  MOV   CX,WORD PTR Game.ColorLum[0]
  TEST  BYTE PTR Game.TIA_Regs[CTRLPF],2
  JZ    @LP11

  MOV   DL,BYTE PTR Game.TIA_Regs[CTRLPF]
  AND   DL,0Fh
  CMP   DL,0Fh
  JZ    @LP11

  MOV   WORD PTR Game.CLW,CX
  MOV   WORD PTR Game.CLW[2],CX
  MOV   WORD PTR Game.CRW,AX
  MOV   WORD PTR Game.CRW[2],AX
  JMP   @LP12
@LP11:
  MOV   WORD PTR Game.CLW,BX
  MOV   WORD PTR Game.CLW[2],BX
  MOV   WORD PTR Game.CRW,BX
  MOV   WORD PTR Game.CRW[2],BX
@LP12:
  JMP   GetOut

LCOLUPF:

  MOV   AL,BYTE PTR Game.TIA_Regs[COLUPF]
  MOV   AH,AL
  MOV   WORD PTR Game.ColorLum[4],AX
  MOV   CX,WORD PTR Game.ColorLum[0]
  MOV   DX,WORD PTR Game.ColorLum[2]
  TEST  BYTE PTR Game.TIA_Regs[CTRLPF],2
  JZ    @LPF1

  MOV   BL,BYTE PTR Game.TIA_Regs[CTRLPF]
  AND   BL,0Fh
  CMP   BL,0Fh
  JZ    @LPF1

  MOV   WORD PTR Game.CLW,CX
  MOV   WORD PTR Game.CLW[2],CX
  MOV   WORD PTR Game.CRW,DX
  MOV   WORD PTR Game.CRW[2],DX
  JMP   @LPF2
@LPF1:
  MOV   WORD PTR Game.CLW,AX
  MOV   WORD PTR Game.CLW[2],AX
  MOV   WORD PTR Game.CRW,AX
  MOV   WORD PTR Game.CRW[2],AX
@LPF2:
  JMP   GetOut

LCOLUBK:

  MOV   AL,BYTE PTR Game.TIA_Regs[COLUBK]
  MOV   AH,AL
  MOV   WORD PTR Game.ColorLum[6],AX
  JMP   GetOut

LCTRLPF:
{  MOV   AL,BYTE PTR Game._CTRLPF
  MOV   BYTE PTR Game.TIA_Regs[CTRLPF],AL}

  { Handle everything but reflection immediately }

  MOV   DI,WORD PTR Game.TIA_Latch_Queue
  DEC   DI
  ADD   DI,DI
  MOV   AL,BYTE PTR Game.TIA_Latch_Value[DI]
{  MOV   AL,BYTE PTR TIA_Latch[CTRLPF]}
  MOV   SI,AX
  SHR   SI,4
  AND   SI,3
  MOV   CL,BYTE PTR MissileSize[SI]
  SUB   CH,CH
  MOV   WORD PTR Game.BallSize,CX

  SUB   CX,160
  MOV   WORD PTR Game.BallSize160,CX
  MOV   CX,WORD PTR Game.ColorLum[0]
  MOV   DX,WORD PTR Game.ColorLum[2]
  MOV   BX,WORD PTR Game.ColorLum[4]
  TEST  AL,2
  JZ    @LCPF1
  MOV   WORD PTR Game.CLW,CX
  MOV   WORD PTR Game.CLW[2],CX
  MOV   WORD PTR Game.CRW,DX
  MOV   WORD PTR Game.CRW[2],DX
  JMP   @LCPF2
@LCPF1:
  MOV   WORD PTR Game.CLW,BX
  MOV   WORD PTR Game.CLW[2],BX
  MOV   WORD PTR Game.CRW,BX
  MOV   WORD PTR Game.CRW[2],BX
@LCPF2:

  CMP   WORD PTR Game.ObjectLoc[BallSet * 2],0
  JGE   GetOut

  MOV   AL,BYTE PTR Game.TIA_Latch_Value[DI]{BYTE PTR TIA_Latch[CTRLPF]}
  SHR   AX,4
  AND   AX,3
  CMP   AX,3
  JE    @CPF1
  SUB   AX,AX
@CPF1:
  NEG   AX
  SUB   AX,6
  CMP   WORD PTR Game.ObjectLoc[BallSet * 2],AX
  JNE   GetOut

  MOV   BL,BYTE PTR Game.TIA_Latch_Value[DI]{BYTE PTR TIA_Latch[CTRLPF]}
  SHR   BX,4
  AND   BX,3
  MOV   CX,-9
  CMP   BX,3
  JE    @CPF1A
  ADD   CX,3
{  SUB   BX,BX}
@CPF1A:
{  NEG   BX
  SUB   BX,6}
  MOV   WORD PTR Game.ObjectLoc[BallSet * 2],CX

  JMP   GetOut

LREFP0:

  MOV   CL,BYTE PTR Game.TIA_Regs[REFP0]
  MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ0]
  AND   BX,7
  ADD   BX,BX
  MOV   AX,BX
  SHL   AX,7
  SHL   CL,4
  AND   CL,80h
  OR    AL,CL
  MOV   WORD PTR Game.Player0Size128,AX
  MOV   WORD PTR Game.OldPlayer0Size128,AX
  MOV   AX,WORD PTR PlayerSize[BX]
  MOV   WORD PTR Game.Player0Size,AX
  SUB   AX,160
  MOV   WORD PTR Game.Player0Size160,AX
  JMP   GetOut

LREFP1:

  MOV   CL,BYTE PTR Game.TIA_Regs[REFP1]
  MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ1]
  AND   BX,7
  ADD   BX,BX
  MOV   AX,BX
  SHL   AX,7
  SHL   CL,4
  AND   CL,80h
  OR    AL,CL
  MOV   WORD PTR Game.Player1Size128,AX
  MOV   WORD PTR Game.OldPlayer1Size128,AX
  MOV   AX,WORD PTR PlayerSize[BX]
  MOV   WORD PTR Game.Player1Size,AX
  SUB   AX,160
  MOV   WORD PTR Game.Player1Size160,AX
  JMP   GetOut
(*
LVDELBL:

  TEST  BYTE PTR Game.TIA_Regs[VDELBL],1
  DB    0Fh,94h,0C0h   { SETZ  AL }

  AND   BYTE PTR Game.DispJump,0FDh
  TEST  BYTE PTR AtariSeg[ENABL],2
  JZ    @LVDELBLA
{  TEST  AL,1
  JNZ   @LVDELBLA}
  OR    BYTE PTR Game.DispJump,2
@LVDELBLA:
  JMP   GetOut
*)
LHMOVE:

  AND   BYTE PTR Game.DispJump,0EFh
  TEST  BYTE PTR AtariSeg[ENAM0],2
  JZ    @LHMOVEA
  TEST  BYTE PTR AtariSeg[RESMP0],2
  JNZ   @LHMOVEA
  OR    BYTE PTR Game.DispJump,10h
@LHMOVEA:

  MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ0]

  MOV   AL,BL
  MOV   AH,AL
  SHR   AL,1
  AND   AX,0718h
  OR    AL,AH
  AND   AH,0
  SHL   AX,7
  MOV   WORD PTR Game.Missile0SizeNum,AX
  MOV   WORD PTR Game.OldMissile0SizeNum,AX

  MOV   SI,BX
  SHR   SI,4
  AND   SI,3
  MOV   CL,BYTE PTR MissileSize[SI]
  SUB   CH,CH
  MOV   WORD PTR Game.Missile0Size,CX
  MOV   DX,CX
  DEC   CX
  SHR   CX,1
  MOV   WORD PTR Game.Missile0Adjust,CX
  SUB   DX,160
  MOV   WORD PTR Game.Missile0Size160,DX


  MOV   BYTE PTR Game.M0Bug,0
  MOV   BYTE PTR Game.DoHMOVE,1
  MOV   BYTE PTR Game.OldDoHMOVE,1
  MOV   AX,WORD PTR Game.TIA_Count
  MOV   WORD PTR Game.HMOVECount,AX

  { Retrieve all of the move values }

  MOV   AL,BYTE PTR Game.TIA_Regs[HMP0]
  CBW
  SAR   AX,4
  MOV   BX,AX   { Player 0 movement value }
  NEG   BX

  MOV   AL,BYTE PTR Game.TIA_Regs[HMP1]
  CBW
  SAR   AX,4
  MOV   CX,AX   { Player 1 movement value }
  NEG   CX

  MOV   AL,BYTE PTR Game.TIA_Regs[HMM0]
  CBW
  SAR   AX,4
  MOV   DX,AX   { Missile 0 movement value }
  NEG   DX

  MOV   AL,BYTE PTR Game.TIA_Regs[HMM1]
  CBW
  SAR   AX,4
  MOV   SI,AX   { Missile 1 movement value }
  NEG   SI

  MOV   AL,BYTE PTR Game.TIA_Regs[HMBL]
  CBW
  SAR   AX,4
  MOV   DI,AX   { Ball movement value }
  NEG   DI

  { Adjust the move values based on when the HMOVE took place }

  MOV   AX,WORD PTR Game.TIA_Count
  CMP   AX,-59
  JL    @NoAdjust
  CMP   AX,-7
  JG    @NotRegionOne

  { Region 1: keep value at or above a certain minimum }

  ADD   AX,59
  SHR   AX,2
  SUB   AX,7

  CMP   BX,AX
  JGE   @MinP1
  MOV   BX,AX
@MinP1:
  CMP   CX,AX
  JGE   @MinM0
  MOV   CX,AX
@MinM0:
  CMP   DX,AX
  JGE   @MinM1
  MOV   DX,AX
@MinM1:
  CMP   SI,AX
  JGE   @MinBL
  MOV   SI,AX
@MinBL:
  CMP   DI,AX
  JGE   @NoAdjust
  MOV   DI,AX
  JMP   @NoAdjust

@NotRegionOne:
  CMP   AX,93
  JL    @NoAdjust
  CMP   AX,157
  JGE   @NoAdjust

  { Region 2: add or subtract an offset, with 0 as the maximum value }

  SUB   AX,93
  SHR   AX,2
  NEG   AX
  ADD   AX,7

  ADD   BX,AX
  JS    @MaxP1
  SUB   BX,BX
@MaxP1:
  ADD   CX,AX
  JS    @MaxM0
  SUB   CX,CX
@MaxM0:
  ADD   DX,AX
  JS    @MaxM1
  SUB   DX,DX
@MaxM1:
  ADD   SI,AX
  JS    @MaxBL
  SUB   SI,SI
@MaxBL:
  ADD   DI,AX
  JS    @NoAdjust
  SUB   DI,DI

@NoAdjust:

  { Save the movement values }

  MOV   WORD PTR Game.ObjectMove[Player0Set  * 2],BX
  MOV   WORD PTR Game.ObjectMove[Player1Set  * 2],CX
  MOV   WORD PTR Game.ObjectMove[Missile0Set * 2],DX
  MOV   WORD PTR Game.ObjectMove[Missile1Set * 2],SI
  MOV   WORD PTR Game.ObjectMove[BallSet     * 2],DI

  { See if we are going to miss the HMOVE because of a pending set }

  SUB   AL,AL
  CMP   BYTE PTR Game.TIA_Latch_RegCount[RESP0],0
  JE    @NoMissP0
  INC   AL
@NoMissP0:
  MOV   BYTE PTR Game.MissedHMOVE[Player0Set],AL

  SUB   AL,AL
  CMP   BYTE PTR Game.TIA_Latch_RegCount[RESP1],0
  JE    @NoMissP1
  INC   AL
@NoMissP1:
  MOV   BYTE PTR Game.MissedHMOVE[Player1Set],AL

  SUB   AL,AL
  CMP   BYTE PTR Game.TIA_Latch_RegCount[RESM0],0
  JE    @NoMissM0
  INC   AL
@NoMissM0:
  MOV   BYTE PTR Game.MissedHMOVE[Missile0Set],AL

  SUB   AL,AL
  CMP   BYTE PTR Game.TIA_Latch_RegCount[RESM1],0
  JE    @NoMissM1
  INC   AL
@NoMissM1:
  MOV   BYTE PTR Game.MissedHMOVE[Missile1Set],AL

  SUB   AL,AL
  CMP   BYTE PTR Game.TIA_Latch_RegCount[RESBL],0
  JE    @NoMissBL
  INC   AL
@NoMissBL:
  MOV   BYTE PTR Game.MissedHMOVE[BallSet],AL

  { Add the movement values to each object's position }

  CALL  DoP0Motion
  CALL  DoP1Motion
  CALL  DoM0Motion
  CALL  DoM1Motion
  CALL  DoBLMotion

GetOut:
End; { Handle_IO_After }

{$F+}
Procedure Handle_IO_Latch; Assembler;
{ ------------------------------------------------------------------------- }
{ On entry:                                                                 }
{ BX = TIA register                                                         }
{ DX = New latch value                                                      }
{ ------------------------------------------------------------------------- }
Label LCTRLPF,LRESP0,LRESP1,LRESM0,LRESM1,LRESBL,LNUSIZ0,LNUSIZ1,GetOut;
Asm
  PUSH  BX

  TEST  BYTE PTR Handle_IO_Set_Latch,0FFh
  JNZ   @L2

  MOV   AX,OFFSET GetOut
  MOV   CX,CXCLR
  SUB   BX,BX
@L1:
  MOV   WORD PTR Handle_IO_Loc_Latch[BX],AX
  ADD   BX,2
  LOOP  @L1

  MOV   WORD PTR Handle_IO_Loc_Latch[CTRLPF  * 2],OFFSET LCTRLPF
  MOV   WORD PTR Handle_IO_Loc_Latch[NUSIZ0  * 2],OFFSET LNUSIZ0
  MOV   WORD PTR Handle_IO_Loc_Latch[NUSIZ1  * 2],OFFSET LNUSIZ1
  MOV   WORD PTR Handle_IO_Loc_Latch[RESP0   * 2],OFFSET LRESP0
  MOV   WORD PTR Handle_IO_Loc_Latch[RESP1   * 2],OFFSET LRESP1
  MOV   WORD PTR Handle_IO_Loc_Latch[RESM0   * 2],OFFSET LRESM0
  MOV   WORD PTR Handle_IO_Loc_Latch[RESM1   * 2],OFFSET LRESM1
  MOV   WORD PTR Handle_IO_Loc_Latch[RESBL   * 2],OFFSET LRESBL

  MOV   BYTE PTR Handle_IO_Set_Latch,1
@L2:
  POP   BX
  CMP   BX,CXCLR
  JA    GetOut
  ADD   BX,BX
  JMP   WORD PTR Handle_IO_Loc_Latch[BX]

LCTRLPF:

  CMP   WORD PTR Game.ObjectLoc[BallSet * 2],0
  JGE   @BallNotOffScreen

  MOV   AL,BYTE PTR Game.TIA_Regs[CTRLPF]
  SHR   AX,4
  AND   AX,3
  CMP   AX,3
  JE    @CPF1
  SUB   AX,AX
@CPF1:
  NEG   AX
  SUB   AX,6
  CMP   WORD PTR Game.ObjectLoc[BallSet * 2],AX
  JNE   @BallNotOffScreen

  MOV   BL,BYTE PTR Game.TIA_Regs[CTRLPF]
  SHR   BX,4
  AND   BX,3
  MOV   CX,-9
  CMP   BX,3
  JE    @CPF1A
  ADD   CX,3
{  SUB   BX,BX}
@CPF1A:
{  NEG   BX
  SUB   BX,6}
  MOV   WORD PTR Game.ObjectLoc[BallSet * 2],CX
@BallNotOffScreen:
{ ----- }

  MOV   AL,BYTE PTR Game.TIA_Regs[CTRLPF]
  MOV   SI,AX
  SHR   SI,4
  AND   SI,3
  MOV   CL,BYTE PTR MissileSize[SI]
  SUB   CH,CH
  MOV   WORD PTR Game.BallSize,CX

  SUB   CX,160
  MOV   WORD PTR Game.BallSize160,CX
  MOV   CX,WORD PTR Game.ColorLum[0]
  MOV   DX,WORD PTR Game.ColorLum[2]
  MOV   BX,WORD PTR Game.ColorLum[4]
  TEST  AL,2
  JZ    @LCPF1

  AND   AL,0Fh
  CMP   AL,0Fh
  JZ    @LCPF1

  MOV   WORD PTR Game.CLW,CX
  MOV   WORD PTR Game.CLW[2],CX
  MOV   WORD PTR Game.CRW,DX
  MOV   WORD PTR Game.CRW[2],DX
  JMP   @LCPF2
@LCPF1:
  MOV   WORD PTR Game.CLW,BX
  MOV   WORD PTR Game.CLW[2],BX
  MOV   WORD PTR Game.CRW,BX
  MOV   WORD PTR Game.CRW[2],BX
@LCPF2:

  JMP   GetOut

LRESP0:
  MOV   WORD PTR Game.ObjectLoc[Player0Set * 2],DX
  MOV   WORD PTR Game.OldObjectLoc[Player0Set * 2],DX
{
  MOV   AX,WORD PTR Game.NewObjectLoc[Player0Set * 2]
  MOV   WORD PTR Game.ObjectLoc[Player0Set * 2],AX
}
{
  MOV   AX,WORD PTR Game.OldPlayer0Size128
  MOV   WORD PTR Game.Player0Size128,AX
}
  MOV   AX,WORD PTR Game.TIA_Latch_ResetPlayer0Size128
  MOV   WORD PTR Game.ResetPlayer0Size128,AX
  ADD   AX,WORD PTR Game.OldPlayer0Size128
{  ADD   AX,WORD PTR Game.Player0Size128}
  MOV   WORD PTR Game.Player0Size128,AX
  TEST  BYTE PTR Game.MissedHMOVE[Player0Set],0FFh
  JZ    @NoP0Move
  CALL  DoP0Motion
  MOV   BYTE PTR Game.MissedHMOVE[Player0Set],0
@NoP0Move:
  JMP   GetOut

LRESP1:
  MOV   WORD PTR Game.ObjectLoc[Player1Set * 2],DX
  MOV   WORD PTR Game.OldObjectLoc[Player1Set * 2],DX
{
  MOV   AX,WORD PTR Game.NewObjectLoc[Player1Set * 2]
  MOV   WORD PTR Game.ObjectLoc[Player1Set * 2],AX
}
{
  MOV   AX,WORD PTR Game.OldPlayer1Size128
  MOV   WORD PTR Game.Player1Size128,AX
}
  MOV   AX,WORD PTR Game.TIA_Latch_ResetPlayer1Size128
  MOV   WORD PTR Game.ResetPlayer1Size128,AX
  ADD   AX,WORD PTR Game.OldPlayer1Size128
  MOV   WORD PTR Game.Player1Size128,AX
  TEST  BYTE PTR Game.MissedHMOVE[Player1Set],0FFh
  JZ    @NoP1Move
  CALL  DoP1Motion
  MOV   BYTE PTR Game.MissedHMOVE[Player1Set],0
@NoP1Move:
  JMP   GetOut

LRESM0:
  MOV   WORD PTR Game.ObjectLoc[Missile0Set * 2],DX
  MOV   WORD PTR Game.OldObjectLoc[Missile0Set * 2],DX
{  MOV   AX,WORD PTR Game.NewObjectLoc[Missile0Set * 2]
  MOV   WORD PTR Game.ObjectLoc[Missile0Set * 2],AX}
  MOV   AX,WORD PTR Game.TIA_Latch_Missile0SizeNum
  MOV   WORD PTR Game.Missile0SizeNum,AX
  TEST  BYTE PTR Game.MissedHMOVE[Missile0Set],0FFh
  JZ    @NoM0Move
  CALL  DoM0Motion
  MOV   BYTE PTR Game.MissedHMOVE[Missile0Set],0
@NoM0Move:
  JMP   GetOut

LRESM1:
  MOV   WORD PTR Game.ObjectLoc[Missile1Set * 2],DX
  MOV   WORD PTR Game.OldObjectLoc[Missile1Set * 2],DX
{  MOV   AX,WORD PTR Game.NewObjectLoc[Missile1Set * 2]
  MOV   WORD PTR Game.ObjectLoc[Missile1Set * 2],AX}
  MOV   AX,WORD PTR Game.TIA_Latch_Missile1SizeNum
  MOV   WORD PTR Game.Missile1SizeNum,AX
  TEST  BYTE PTR Game.MissedHMOVE[Missile1Set],0FFh
  JZ    @NoM1Move
  CALL  DoM1Motion
  MOV   BYTE PTR Game.MissedHMOVE[Missile1Set],0
@NoM1Move:
  JMP   GetOut

LRESBL:
  MOV   WORD PTR Game.ObjectLoc[BallSet * 2],DX
  MOV   WORD PTR Game.OldObjectLoc[BallSet * 2],DX
{  MOV   AX,WORD PTR Game.NewObjectLoc[BallSet * 2]
  MOV   WORD PTR Game.ObjectLoc[BallSet * 2],AX}
  TEST  BYTE PTR Game.MissedHMOVE[BallSet],0FFh
  JZ    @NoBLMove
  CALL  DoBLMotion
  MOV   BYTE PTR Game.MissedHMOVE[BallSet],0
@NoBLMove:
  JMP   GetOut

LNUSIZ0:
(*
  MOV   AL,BYTE PTR Game.TIA_Regs[NUSIZ0]
  MOV   AH,BYTE PTR Game.OldNUSIZ0
  MOV   DX,1
  MOV   CX,1
  CMP   AH,5
  JNE   @P0Not5A
  INC   CX
  JMP   @P0CheckNew
@P0Not5A:
  CMP   AH,7
  JNE   @P0CheckNew
{  ADD   CX,3}
@P0CheckNew:
  CMP   AL,5
  JNE   @P0Not5B
  INC   DX
  JMP   @P0CheckDone
@P0Not5B:
  CMP   AL,7
  JNE   @P0CheckDone
{  ADD   DX,3}
@P0CheckDone:
  SUB   DX,CX
  ADD   WORD PTR Game.ObjectLoc[Player0Set * 2],DX
*)
  MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ0]

  MOV   AL,BL
  MOV   AH,AL
  SHR   AL,1
  AND   AX,0718h
  OR    AL,AH
  AND   AH,0
  SHL   AX,7
  MOV   WORD PTR Game.Missile0SizeNum,AX
  MOV   WORD PTR Game.OldMissile0SizeNum,AX

  MOV   SI,BX
  SHR   SI,4
  AND   SI,3
  MOV   CL,BYTE PTR MissileSize[SI]
  SUB   CH,CH
  MOV   WORD PTR Game.Missile0Size,CX
  MOV   DX,CX

  DEC   CX
  SHR   CX,1
  MOV   WORD PTR Game.Missile0Adjust,CX

  SUB   DX,160
  MOV   WORD PTR Game.Missile0Size160,DX
  AND   BX,7
  ADD   BX,BX
  MOV   AX,BX
  SHL   AX,7
  MOV   CL,BYTE PTR Game.TIA_Regs[REFP0]
  SHL   CL,4
  AND   CL,80h
  OR    AL,CL
  MOV   WORD PTR Game.Player0Size128,AX
  MOV   WORD PTR Game.OldPlayer0Size128,AX

  { If previously writing to RESP0 caused a player copy to disappear, }
  { make sure that the copy doesn't reappear                          }

  CMP   WORD PTR Game.ResetPlayer0Size128,0
  JE    @NoReset0Add
  MOV   AX,WORD PTR Add1A[BX]
  MOV   WORD PTR Game.ResetPlayer0Size128,AX
  ADD   WORD PTR Game.Player0Size128,AX
@NoReset0Add:

  MOV   AX,WORD PTR _PlayerSize[BX]
  MOV   WORD PTR Game._Player0Size,AX
  MOV   AX,WORD PTR PlayerSize[BX]
  MOV   WORD PTR Game.Player0Size,AX
  SUB   AX,160
  MOV   WORD PTR Game.Player0Size160,AX
{
  PUSH  1
  PUSH  0
  CALL  TurnPlayer0Off
}
  CMP   WORD PTR Game.ObjectLoc[Missile0Set * 2],0
  JGE   @CheckBlank0{GetOut}

  MOV   AL,BYTE PTR Game.TIA_Regs[NUSIZ0]{Game.OldNUSIZ0}
  SHR   AX,4
  AND   AX,3
  CMP   AX,3
  JE    @NSZ0
  SUB   AX,AX
@NSZ0:
  NEG   AX
  SUB   AX,6
  CMP   WORD PTR Game.ObjectLoc[Missile0Set * 2],AX
  JNE   @CheckBlank0{GetOut}

  MOV   BL,BYTE PTR AtariSeg[NUSIZ0]
  SHR   BX,4
  AND   BX,3
  MOV   CX,-9
  CMP   BX,3
  JE    @NSZ0A
  ADD   CX,3
{  SUB   BX,BX}
@NSZ0A:
{  NEG   BX
  SUB   BX,6}
  MOV   WORD PTR Game.ObjectLoc[Missile0Set * 2],CX

@CheckBlank0:
(*
  CMP   WORD PTR Game.ResetPlayer0Size128,0
  JNE   @NoTurnP0OffNSZ
  MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ0]
  AND   BX,7
  MOV   AL,BYTE PTR Game.OldNUSIZ0
  AND   AX,7
  CMP   BL,5
  JNE   @Check7P0
  CMP   AL,0
  JNE   @NoTurnP0OffNSZ
  JMP   @ContNSZ0
@Check7P0:
  CMP   BL,7
  JNE   @NoTurnP0OffNSZ
  CMP   AL,0
  JE    @ContNSZ0
  CMP   AL,1
  JE    @ContNSZ0
  CMP   AL,5
  JE    @ContNSZ0
  JMP   @NoTurnP0OffNSZ
@ContNSZ0:
  SHL   BX,1

  MOV   AX,WORD PTR Game.OldObjectLoc[Player0Set * 2]
  MOV   CX,WORD PTR Game.TIA_Count
  ADD   CX,WORD PTR TIA_Delay[NUSIZ0 * 2]
  CMP   CX,AX
  JL    @NoTurnP0OffNSZ
  ADD   AX,WORD PTR PlayerSize[BX]
  CMP   CX,AX
  JGE   @NoTurnP0OffNSZ
@TurnP0OffNSZ:
  MOV   AX,WORD PTR Add1A[BX]
  MOV   WORD PTR Game.ResetPlayer0Size128,AX
  ADD   WORD PTR Game.Player0Size128,AX
@NoTurnP0OffNSZ:
*)

  JMP   GetOut

LNUSIZ1:
(*
  MOV   AL,BYTE PTR Game.TIA_Regs[NUSIZ1]
  MOV   AH,BYTE PTR Game.OldNUSIZ1
  MOV   DX,1
  MOV   CX,1
  CMP   AH,5
  JNE   @P1Not5A
  INC   CX
  JMP   @P1CheckNew
@P1Not5A:
  CMP   AH,7
  JNE   @P1CheckNew
{  ADD   CX,3}
@P1CheckNew:
  CMP   AL,5
  JNE   @P1Not5B
  INC   DX
  JMP   @P1CheckDone
@P1Not5B:
  CMP   AL,7
  JNE   @P1CheckDone
{  ADD   DX,3}
@P1CheckDone:
  SUB   DX,CX
  ADD   WORD PTR Game.ObjectLoc[Player1Set * 2],DX
*)
  MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ1]

  MOV   AL,BL
  MOV   AH,AL
  SHR   AL,1
  AND   AX,0718h
  OR    AL,AH
  AND   AH,0
  SHL   AX,7
  MOV   WORD PTR Game.Missile1SizeNum,AX
  MOV   WORD PTR Game.OldMissile1SizeNum,AX

  MOV   SI,BX
  SHR   SI,4
  AND   SI,3
  MOV   CL,BYTE PTR MissileSize[SI]
  SUB   CH,CH
  MOV   WORD PTR Game.Missile1Size,CX
  MOV   DX,CX

  DEC   CX
  SHR   CX,1
  MOV   WORD PTR Game.Missile1Adjust,CX

  SUB   DX,160
  MOV   WORD PTR Game.Missile1Size160,DX
  AND   BX,7
  ADD   BX,BX
  MOV   AX,BX
  SHL   AX,7
  MOV   CL,BYTE PTR Game.TIA_Regs[REFP1]
  SHL   CL,4
  AND   CL,80h
  OR    AL,CL
  MOV   WORD PTR Game.Player1Size128,AX
  MOV   WORD PTR Game.OldPlayer1Size128,AX

  { If previously writing to RESP1 caused a player copy to disappear, }
  { make sure that the copy doesn't reappear                          }

  CMP   WORD PTR Game.ResetPlayer1Size128,0
  JE    @NoReset1Add
  MOV   AX,WORD PTR Add1A[BX]
  MOV   WORD PTR Game.ResetPlayer1Size128,AX
  ADD   WORD PTR Game.Player1Size128,AX
@NoReset1Add:

  MOV   AX,WORD PTR _PlayerSize[BX]
  MOV   WORD PTR Game._Player1Size,AX
  MOV   AX,WORD PTR PlayerSize[BX]
  MOV   WORD PTR Game.Player1Size,AX
  SUB   AX,160
  MOV   WORD PTR Game.Player1Size160,AX
{
  PUSH  1
  PUSH  0
  CALL  TurnPlayer1Off
}
  CMP   WORD PTR Game.ObjectLoc[Missile1Set * 2],0
  JGE   @CheckBlank1{GetOut}

  MOV   AL,BYTE PTR Game.TIA_Regs[NUSIZ1]{Game.OldNUSIZ1}
  SHR   AX,4
  AND   AX,3
  CMP   AX,3
  JE    @NSZ1
  SUB   AX,AX
@NSZ1:
  NEG   AX
  SUB   AX,6
  CMP   WORD PTR Game.ObjectLoc[Missile1Set * 2],AX
  JNE   @CheckBlank1{GetOut}

  MOV   BL,BYTE PTR AtariSeg[NUSIZ1]
  SHR   BX,4
  AND   BX,3
  MOV   CX,-9
  CMP   BX,3
  JE    @NSZ1A
  ADD   CX,3
{  SUB   BX,BX}
@NSZ1A:
{  NEG   BX
  SUB   BX,6}
  MOV   WORD PTR Game.ObjectLoc[Missile1Set * 2],CX

@CheckBlank1:
(*
  CMP   WORD PTR Game.ResetPlayer1Size128,0
  JNE   @NoTurnP1OffNSZ
  MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ1]
  AND   BX,7
  MOV   AL,BYTE PTR Game.OldNUSIZ1
  AND   AX,7
  CMP   BL,5
  JNE   @Check7P1
  CMP   AL,0
  JNE   @NoTurnP1OffNSZ
  JMP   @ContNSZ1
@Check7P1:
  CMP   BL,7
  JNE   @NoTurnP1OffNSZ
  CMP   AL,0
  JE    @ContNSZ1
  CMP   AL,1
  JE    @ContNSZ1
  CMP   AL,5
  JE    @ContNSZ1
  JMP   @NoTurnP1OffNSZ
@ContNSZ1:
  SHL   BX,1

  MOV   AX,WORD PTR Game.OldObjectLoc[Player1Set * 2]
  MOV   CX,WORD PTR Game.TIA_Count
  ADD   CX,WORD PTR TIA_Delay[NUSIZ1 * 2]
  CMP   CX,AX
  JL    @NoTurnP1OffNSZ
  ADD   AX,WORD PTR PlayerSize[BX]
  CMP   CX,AX
  JGE   @NoTurnP1OffNSZ
@TurnP1OffNSZ:
  MOV   AX,WORD PTR Add1A[BX]
  MOV   WORD PTR Game.ResetPlayer1Size128,AX
  ADD   WORD PTR Game.Player1Size128,AX
@NoTurnP1OffNSZ:
*)

  JMP   GetOut

GetOut:
End; { Handle_IO_Latch }
{$F-}

Procedure InitEmulator;
Var I: Integer;
Begin
  PF2Wave                  := 0;
  Game.LineDelay           := 0;
  Game.LineDelayFirst      := False;
  Game.LineDelayMax        := 262;       { Can become 314 for PAL games }
  AutoCenter          := Config.AutoCenter; { Copy so it can be changed }
                                            { locally without affecting }
                                            { overall preferences       }
  Game.FixTimer            := 0;
  Game.FixTimerNum         := 0;
  FillChar(Game.ResetOffset,SizeOf(Game.ResetOffset),#0);
  FillChar(Game.MissedHMOVE,SizeOf(Game.MissedHMOVE),#0);
  Game.ResetOfs            := 0;

  Game.VBLANKOff           := False;
  Game.LastVBLANK          := 200;

{  Game.MegaBoyNum          := 0;}

  Game.Missile0SizeNum     := 0;
  Game.Missile1SizeNum     := 0;
  Game.OldMissile0SizeNum  := 0;
  Game.OldMissile1SizeNum  := 0;
  Game.OldPlayer0Size128   := 0;
  Game.OldPlayer1Size128   := 0;
  Game.M0Bug               := False;
  Game.M0BugCount          := 0;
  Game.StarpathWriteValue  := 0;
  Game.VAdd                := 0;
  Game.VAddAdjust          := 0;
  Game.VUserAdd            := 0;
  FillChar(Game.TIA_Latch_Value,SizeOf(Game.TIA_Latch_Value),#0);
  FillChar(Game.TIA_Latch_Reg,SizeOf(Game.TIA_Latch_Reg),#0);
  FillChar(Game.TIA_Latch_Scan,SizeOf(Game.TIA_Latch_Scan),#0);
  FillChar(Game.TIA_Latch_Count,SizeOf(Game.TIA_Latch_Count),#0);
  FillChar(Game.TIA_Latch_RegCount,SizeOf(Game.TIA_Latch_RegCount),#0);
  TIA_Latch_Check          := True;
  Game.TIA_Latch_Queue     := 0;

{
  CTRLPFLatch         := 0;
  CTRLPFScan          := -37;
  CTRLPFCount         := -68;
  COLUPFLatch         := 0;
  COLUPFScan          := -37;
  COLUPFCount         := -68;
  COLUBKLatch         := 0;
  COLUBKScan          := -37;
  COLUBKCount         := -68;
}
  Game.Indy500[0]          := 0;
  Game.Indy500[1]          := 0;
  Game.LastScan            := 0;
  Game.NewScan             := 0;
  Game.PaddleGround0       := PadMax;
  Game.PaddleGround1       := PadMax;
  Game.PaddleGround2       := PadMax;
  Game.PaddleGround3       := PadMax;
  Game.OldPaddleGround0    := PadMax;
  Game.OldPaddleGround1    := PadMax;
  Game.OldPaddleGround2    := PadMax;
  Game.OldPaddleGround3    := PadMax;
  Game.GRP0Latch           := 0;
  Game.GRP1Latch           := 0;
{
  GRP0Write           := -68;
  GRP1Write           := -68;
}
  Game.BallLatch           := 0;
  Game.TIA_Scan            := -40;


{  BufScan             := Game.TIA_Scan;}


  Game.DoHMOVE             := False;
  Game.OldDoHMOVE          := False;
  Game.LineStart           := 0;
  Game.TimerDone           := False;
  Game.TimerInterval       := 1024{0};
  Game.TimerValue          := 0;
  Game.TimerShift          := 10;

  Game.TimerX              := 0;
{  Game.TimerSize           := 1024 * 256;}
  Game.OrigTimer           := $14;
  Game.TimerElapsed        := 0;

  AtariSeg[INTTIM1]   := $14;
{  AtariSeg[INTTIM2]   := $14;
  AtariSeg[INTTIM3]   := 0;}
  Game.ColorOrBW           := 8;
  Game.Difficulty1         := 0;
  Game.Difficulty2         := 0;
  ColorOrBWChange     := True;
  Difficulty1Change   := True;
  Difficulty2Change   := True;
  AutoCenterChange    := True;
  Game.TopVBLANK           := True;
  AtariSeg[SWCHB1]    := Game.ColorOrBW Or Game.Difficulty1 Or Game.Difficulty2 Or 3;
  AtariSeg[SWCHB2]    := Game.ColorOrBW Or Game.Difficulty1 Or Game.Difficulty2 Or 3;
  Game.TIA_Count           := -68;
  Game.Old_TIA_Count       := -68;
  FillChar(Game.ObjectLoc,SizeOf(Game.ObjectLoc),#0);
  FillChar(Game.OldObjectLoc,SizeOf(Game.OldObjectLoc),#0);
  FillChar(Game.NewObjectLoc,SizeOf(Game.NewObjectLoc),#0);
  Game.Addr                := 0;
  Game.Latched             := False;
  Game.ReadTime            := 1;
  Game.Write_TIA           := 0;
  Handle_IO_Set       := False;
  Handle_IO_Set_After := False;
  Handle_IO_Set_Latch := False;
  Game.StarpathWrite       := False;
  Game.AddCycle            := 0;
  Game.Player0Size         := 7;
  Game.Player1Size         := 7;
  Game.Player0Size160      := -153;
  Game.Player1Size160      := -153;
  Game.Player0Size128      := 0;
  Game.Player1Size128      := 0;
  Game.ResetPlayer0Size128 := 0;
  Game.ResetPlayer1Size128 := 0;
  Game.Missile0Size        := 1;
  Game.Missile1Size        := 1;
  Game.Missile0Size160     := -159;
  Game.Missile1Size160     := -159;
  Game.BallSize            := 1;
  Game.BallSize160         := -159;
  Game.ObjectSet           := 0;
  Handle_TIA_Jump_Set      := False;
  Game.DispJump            := 0;
  FillChar(Game.Input_Byte,SizeOf(Game.Input_Byte),#0);

  Game.Input_Byte[INPUT0]  := 8;

  Game.Input_Byte[INPUT4]  := $80;
  Game.Input_Byte[INPUT5]  := $80;
  Game.Input_Byte[$E]      := $F;
  Game.Input_Byte[$F]      := $F;
  Game.Missile0Adjust      := 0;
  Game.Missile1Adjust      := 0;
  FillChar(Handle_IO_Loc,SizeOf(Handle_IO_Loc),#0);
  FillChar(Handle_IO_Loc_After,SizeOf(Handle_IO_Loc_After),#0);
  FillChar(Handle_IO_Loc_Latch,SizeOf(Handle_IO_Loc_Latch),#0);
  FillChar(Game.ColorLum,SizeOf(Game.ColorLum),#0);
  FillChar(TIA_Delay,SizeOf(TIA_Delay),#0);
  TIA_Delay[GRP0]  := 1;
  TIA_Delay[GRP1]  := 1;
  TIA_Delay[REFP0] := 1;
  TIA_Delay[REFP1] := 1;
  TIA_Delay[PF0]   := 4;
  TIA_Delay[PF1]   := 4;
  TIA_Delay[PF2]   := 4;
{
  TIA_Delay[RESP0] := 13;
  TIA_Delay[RESP1] := 13;

  TIA_Delay[NUSIZ0] := 12;
  TIA_Delay[NUSIZ1] := 12;
}
  TIA_Delay[VBLANK] := 1;
  TIA_Delay[ENAM0]  := 1;
  TIA_Delay[ENAM1]  := 1;
  TIA_Delay[ENABL]  := 1;
End; { InitEmulator }


Var
  BCD_A     : Byte;
  BCD_Add   : Byte;
  BCD_Flags : Byte;

(*
Procedure ADC_BCD_A(Flags: Word);
Var
  OldA : Byte;
  Sum  : Word;
  V    : Boolean;
  A1   : Word;
  A2   : Word;

Begin
  OldA := BCD_A;
  A1   := BCDTable[0,BCD_A];
  A2   := BCDTable[0,BCD_Add];
  Sum  := A1 + A2 + (Flags And 1);
  If Sum > 99
   Then BCD_Flags := BCD_Flags Or 1
   Else BCD_Flags := BCD_Flags And $FE;
  BCD_A := BCDTable[1,(Sum And $FF)];
  If BCD_A = 0
   Then BCD_Flags := BCD_Flags Or 2
   Else BCD_Flags := BCD_Flags And $FD;
  BCD_Flags := (BCD_Flags And $7F) Or (BCD_A And $80);
  V         := ((((OldA  Xor BCD_A)   And $80) And
                 ((BCD_A Xor BCD_Add) And $80)) <> 0);
  If V
   Then BCD_Flags := BCD_Flags Or $40
   Else BCD_Flags := BCD_Flags And $BF;
End; { ADC_BCD_A }


Procedure SBC_BCD_A(Flags: Word);
Var
  OldA : Byte;
  Diff : Integer;
  V    : Boolean;
  A1   : Integer;
  A2   : Integer;

Begin
  OldA := BCD_A;
  A1   := BCDTable[0,BCD_A];
  A2   := BCDTable[0,BCD_Add];
  Diff := A1 - A2 - ((Flags And 1){ Xor 1});
  If Diff < 0 Then Inc(Diff,100);
  BCD_A := BCDTable[1,(Diff And $FF)];
  If BCD_A = 0
   Then BCD_Flags := BCD_Flags Or 2
   Else BCD_Flags := BCD_Flags And $FD;
  BCD_Flags := (BCD_Flags And $7F) Or (BCD_A And $80);

  If OldA >= BCD_Add + ((Flags And 1){ Xor 1})
   Then BCD_Flags := BCD_Flags Or 1
   Else BCD_Flags := BCD_Flags And $FE;
  V := ((((OldA  Xor BCD_A)   And $80) And
         ((BCD_A Xor BCD_Add) And $80)) <> 0);
  If V
   Then BCD_Flags := BCD_Flags Or $40
   Else BCD_Flags := BCD_Flags And $BF;
End; { SBC_BCD_A }
*)

Procedure ADC_BCD; Assembler;
{ In:   CL    - accumulator            }
{       DL    - value to add           }
{       Flags - carry is set correctly }
{ Out:  CL    - set on exit            }
{       CH    - set on exit            }
Asm
(*
  PUSHF
  PUSHA
  MOV    BYTE PTR BCD_A,CL
  MOV    BYTE PTR BCD_Add,DL
  MOV    BYTE PTR BCD_Flags,CH
  PUSHF
  CALL   ADC_BCD_A
  POPA
  POPF
  MOV    CL,BYTE PTR BCD_A
  MOV    CH,BYTE PTR BCD_Flags
*)
  PUSHF
  PUSH   DX
  PUSHF
  AND    CH,03Ch
  MOV    BL,CL
  MOV    BH,CL
  SHR    BH,4
  AND    DL,0Fh
  AND    BL,0Fh
  POPF
  ADC    BL,DL
  POP    DX
  PUSH   DX
  SHR    DL,4
(*
  TEST   BL,0F0h      { TEST clears the carry flag }
  JZ     @L6
  STC
@L6:
  ADC    BH,DL
*)
  ADD    BH,DL

  CMP    BL,9
  JBE    @L1
  ADD    BL,6         { Fixup the low nibble }
@L1:
  POP    DX
  POPF
  PUSH   DX

  ADC    DL,CL
  JNZ    @L2
  OR     CH,2         { Set the zero flag }
@L2:
  MOV    DL,BH
  SHL    DL,4
  AND    DL,80h
  OR     CH,DL        { Set the negative flag }

  MOV    DL,BH
  SHL    DL,4
  XOR    DL,CL
  AND    DL,80h
  JZ     @L3
  POP    DX
  PUSH   DX
  XOR    DL,CL
  AND    DL,80h
  JNZ    @L3
  OR     CH,40h       { Set the overflow flag }
@L3:
  POP    DX

  TEST   BL,0F0h
  JZ     @L7
  INC    BH
@L7:
  CMP    BH,9
  JBE    @L4
  ADD    BH,6         { Fixup the high nibble }
@L4:

  TEST   BH,0F0h
  JZ     @L5
  OR     CH,1         { Set the carry flag }
@L5:

  SHL    BH,4
  AND    BL,0Fh
  OR     BL,BH
  MOV    CL,BL        { Set the result }
End; { ADC_BCD }


Procedure SBC_BCD; Assembler;
{ In:   CL    - accumulator            }
{       DL    - value to subtract      }
{       Flags - carry is set correctly }
{ Out:  CL    - set on exit            }
{       CH    - set on exit            }

Asm
(*
  PUSHF
  PUSHA
  MOV    BYTE PTR BCD_A,CL
  MOV    BYTE PTR BCD_Add,DL
  MOV    BYTE PTR BCD_Flags,CH
  PUSHF
  CALL   SBC_BCD_A
  POPA
  POPF
  MOV    CL,BYTE PTR BCD_A
  MOV    CH,BYTE PTR BCD_Flags
*)
  PUSHF
  PUSH   DX
  PUSHF
  AND    CH,03Ch
  MOV    BL,CL
  MOV    BH,CL
  SHR    BH,4
  AND    DL,0Fh
  AND    BL,0Fh
  POPF
  SBB    BL,DL
  TEST   BL,0F0h      { TEST clears the carry flag }
  JZ     @L1
  SUB    BL,6
  AND    BL,0Fh
  STC
@L1:
  POP    DX
  PUSH   DX
  PUSHF
  SHR    DL,4
  POPF
  SBB    BH,DL
  TEST   BH,0F0h
  JZ     @L2
  SUB    BH,6
@L2:
  SHL    BH,4
  OR     BL,BH
  POP    DX
  POPF
  MOV    BH,CL
  SBB    BH,DL
  JC     @L6          { Note the difference! }
  PUSHF
  OR     CH,1
  POPF
@L6:
  JNO    @L7
  OR     CH,40h
@L7:
  OR     BH,BH
  JNZ    @L8
  OR     CH,2
@L8:
  MOV    DL,BH
  AND    DL,80h
  ADD    CH,DL
  MOV    CL,BL
End; { SBC_BCD }

Procedure HandleStarpathRTS; Assembler;
Asm
  PUSH   AX
  PUSH   BX
  PUSH   CX
  PUSH   DX
  PUSH   DI

  DB     _32BIT_OPERAND
  PUSH   WORD PTR ASeg
  DB     _32BIT_OPERAND
  PUSH   WORD PTR ROMBackup
  PUSH   1FF8h
  PUSH   1FF8h
  PUSH   WORD PTR Game.SPBankNum
  PUSH   WORD PTR Game.TIA_Count
  PUSH   WORD PTR Game.TIA_Scan
  PUSH   WORD PTR Game.ROMSize

  CALL   HandleStarpath
  MOV    CL,BYTE PTR SPBank
  MOV    BYTE PTR Game.SPBankNum,CL

  POP    DI
  POP    DX
  POP    CX
  POP    BX
  POP    AX
End; { HandleStarpathRTS }

Procedure ResetMissile0; Assembler;
Asm
  TEST  BYTE PTR AtariSeg[RESMP0],2
  JZ    @Missile0Ok
  MOV   AL,BYTE PTR Game.ObjectLoc[Player0Set * 2]
  MOV   AH,BYTE PTR Game._Player0Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH
  CMP   AX,160
  JB    @M0Ok1A
  SUB   AX,160
@M0Ok1A:
  MOV   WORD PTR Game.ObjectLoc[Missile0Set * 2],AX
@Missile0Ok:
End; { ResetMissile0 }


Procedure ResetMissile1; Assembler;
Asm
  TEST  BYTE PTR AtariSeg[RESMP1],2
  JZ    @Missile1Ok
  MOV   AL,BYTE PTR Game.ObjectLoc[Player1Set * 2]
  MOV   AH,BYTE PTR Game._Player1Size
  SHR   AH,1
  ADD   AL,AH

  SUB   AH,AH
  CMP   AX,160
  JB    @M1Ok1A
  SUB   AX,160
@M1Ok1A:
  MOV   WORD PTR Game.ObjectLoc[Missile1Set * 2],AX
@Missile1Ok:
End; { ResetMissile1 }


Procedure SetPaddlePositions; Assembler;
Asm
  DB    _32BIT_OPERAND
  PUSH  BX
  DB    _32BIT_OPERAND
  MOV   BX,WORD PTR Game.AddCycle

  TEST  BYTE PTR Game.Input_Byte[INPUT0],80h
  JNZ   @NoPaddle0
  DB    _32BIT_OPERAND
  SUB   WORD PTR Game.PaddleGround0,BX
  JNC   @NoPaddle0
  MOV   BYTE PTR Game.Input_Byte[INPUT0],80h
@NoPaddle0:

  TEST  BYTE PTR Game.Input_Byte[INPUT1],80h
  JNZ   @NoPaddle1
  DB    _32BIT_OPERAND
  SUB   WORD PTR Game.PaddleGround1,BX
  JNC   @NoPaddle1
  MOV   BYTE PTR Game.Input_Byte[INPUT1],80h
@NoPaddle1:

  TEST  BYTE PTR Game.Input_Byte[INPUT2],80h
  JNZ   @NoPaddle2
  DB    _32BIT_OPERAND
  SUB   WORD PTR Game.PaddleGround2,BX
  JNC   @NoPaddle2
  MOV   BYTE PTR Game.Input_Byte[INPUT2],80h
@NoPaddle2:

  TEST  BYTE PTR Game.Input_Byte[INPUT3],80h
  JNZ   @NoPaddle3
  DB    _32BIT_OPERAND
  SUB   WORD PTR Game.PaddleGround3,BX
  JNC   @NoPaddle3
  MOV   BYTE PTR Game.Input_Byte[INPUT3],80h
@NoPaddle3:

  DB    _32BIT_OPERAND
  POP   BX

{
  TEST  BYTE PTR Game.Input_Byte[INPUT0],80h
  JNZ   @NoPaddle
  TEST  BYTE PTR AtariSeg[VBLANK],80h
  JNZ   @NoPaddle
  DB    _32BIT_OPERAND
  PUSH  BX
  DB    _32BIT_OPERAND
  MOV   BX,WORD PTR Game.AddCycle
  DB    _32BIT_OPERAND
  SUB   WORD PTR Game.PaddleGround,BX
  JNC   @NoPaddle1
  MOV   BYTE PTR Game.Input_Byte[INPUT0],80h
@NoPaddle1:
  DB    _32BIT_OPERAND
  POP   BX
}
End; { SetPaddlePositions }


Procedure SetObjectLocations; Assembler;
Asm
    SUB   SI,SI
    MOV   CX,WORD PTR Game.TIA_Count
    TEST  BYTE PTR Game.OldDoHMOVE,0FFh
    JZ    @NoExtraAdd
    MOV   BX,WORD PTR Game.TIA_Count
    ADD   BX,2
    MOV   AL,BYTE PTR ExtraAdd[BX + 68]
    CBW
    MOV   SI,AX
@NoExtraAdd:

    MOV   BX,WORD PTR Game.ObjectSet

    { Player 0 }

    TEST  BX,Player0Set
    JZ    @NotP0Set
    MOV   AX,CX
    ADD   AX,WORD PTR Game.ResetOffset[0]
    CMP   AX,160
    JB    @SignOk1
    SUB   AX,AX
    JMP   @SetP0Loc
@SignOk1:
    MOV   AX,CX
    ADD   AX,WORD PTR Game.ResetOffset[0]
    ADD   AX,SetLocDelay
@SetP0Loc:
    CMP   WORD PTR Game.TIA_Count,7
    JGE   @NoP0Inc
    TEST  BYTE PTR Game.OldDoHMOVE,0FFh
    JNZ   @DoP0Move
    CMP   WORD PTR Game.TIA_Count,0
    JGE   @NoP0Inc
    MOV   AX,3
    JMP   @NoP0Inc
@DoP0Move:
    MOV   AX,SI
    ADD   AX,WORD PTR Game.ObjectMove[Player0Set * 2]
@NoP0Move:
    CMP   AX,8
    JL    @P0IncOk
    MOV   AX,8
@P0IncOk:
    ADD   AX,3
@NoP0Inc:
    MOV   WORD PTR Game.ObjectLoc[Player0Set * 2],AX

    SUB   AX,AX
    CALL  GetPlayerDelay
    TEST  AX,80h
    JZ    @DelayP0

    MOV   AX,0{WORD PTR Game.OldPlayer0Size128}{Game.ResetPlayer0Size128}
    MOV   WORD PTR Game.TIA_Latch_ResetPlayer0Size128,AX
    MOV   AX,WORD PTR Game.TIA_Count
{    ADD   AX,5}
    JMP   @DoP0Delay

@DelayP0:
    ADD   AX,WORD PTR Game.ObjectLoc[Player0Set * 2]
    PUSH  BX
    MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ0]
    AND   BX,7
    SHL   BX,1
    MOV   DX,WORD PTR Add1A[BX]
    MOV   WORD PTR Game.TIA_Latch_ResetPlayer0Size128,DX
    POP   BX
@DoP0Delay:
    PUSH  BX
    MOV   BX,WORD PTR Game.TIA_Scan
    MOV   DX,BX
{    MOV   WORD PTR Game.TIA_Latch_Scan[RESP0 * 2],BX}
    MOV   BL,BYTE PTR Game.TIA_Regs[RESP0]
{    INC   BL}                            { Do anything to make it different }

    PUSH  RESP0
    PUSH  WORD PTR Game.ObjectLoc[Player0Set * 2]
{    SUB   BH,BH
    PUSH  BX}

{    MOV   BYTE PTR TIA_Latch[RESP0],BL}
    MOV   BX,AX
    CMP   BX,160
    JL    @NoP0DelayWrap
    SUB   BX,160
{    INC   WORD PTR Game.TIA_Latch_Scan[RESP0 * 2]}
    INC   DX
@NoP0DelayWrap:
    PUSH  DX
    PUSH  BX
    CALL  QueueLatch

{    MOV   WORD PTR Game.TIA_Latch_Count[RESP0 * 2],BX}
    MOV   AX,WORD PTR Game.ObjectLoc[Player0Set * 2]
    MOV   WORD PTR Game.NewObjectLoc[Player0Set * 2],AX
    MOV   AX,WORD PTR Game.OldObjectLoc[Player0Set * 2]
    MOV   WORD PTR Game.ObjectLoc[Player0Set * 2],AX
    POP   BX
@TurnP0OffDone:
{
    MOV   AX,WORD PTR Game.OldPlayer0Size128
    ADD   AX,WORD PTR Game.ResetPlayer0Size128
    MOV   WORD PTR Game.Player0Size128,AX
}
    CALL  ResetMissile0

@NotP0Set:

    { Player 1 }

    TEST  BX,Player1Set
    JZ    @NotP1Set
    MOV   AX,CX
    ADD   AX,WORD PTR Game.ResetOffset[2]
    CMP   AX,160
    JB    @SignOk2
    SUB   AX,AX
    JMP   @SetP1Loc
@SignOk2:
    MOV   AX,CX
    ADD   AX,WORD PTR Game.ResetOffset[2]
    ADD   AX,SetLocDelay
@SetP1Loc:
    CMP   WORD PTR Game.TIA_Count,7
    JGE   @NoP1Inc
    TEST  BYTE PTR Game.OldDoHMOVE,0FFh
    JNZ   @DoP1Move
    CMP   WORD PTR Game.TIA_Count,0
    JGE   @NoP1Inc
    MOV   AX,3
    JMP   @NoP1Inc
@DoP1Move:
    MOV   AX,SI
    ADD   AX,WORD PTR Game.ObjectMove[Player1Set * 2]
@NoP1Move:
    CMP   AX,8
    JL    @P1IncOk
    MOV   AX,8
@P1IncOk:
    ADD   AX,3
@NoP1Inc:
    MOV   WORD PTR Game.ObjectLoc[Player1Set * 2],AX

    MOV   AX,1
    CALL  GetPlayerDelay
    TEST  AX,80h
    JZ    @DelayP1

    MOV   AX,0{WORD PTR Game.OldPlayer1Size128}{Game.ResetPlayer1Size128}
    MOV   WORD PTR Game.TIA_Latch_ResetPlayer1Size128,AX
    MOV   AX,WORD PTR Game.TIA_Count
{    ADD   AX,5}
    JMP   @DoP1Delay

@DelayP1:
    ADD   AX,WORD PTR Game.ObjectLoc[Player1Set * 2]
    PUSH  BX
    MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ1]
    AND   BX,7
    SHL   BX,1
    MOV   DX,WORD PTR Add1A[BX]
    MOV   WORD PTR Game.TIA_Latch_ResetPlayer1Size128,DX
    POP   BX
@DoP1Delay:
    PUSH  BX
    MOV   BX,WORD PTR Game.TIA_Scan
    MOV   DX,BX
{    MOV   WORD PTR Game.TIA_Latch_Scan[RESP1 * 2],BX}
    MOV   BL,BYTE PTR Game.TIA_Regs[RESP1]
{    INC   BL}                            { Do anything to make it different }

    PUSH  RESP1
    PUSH  WORD PTR Game.ObjectLoc[Player1Set * 2]
{    SUB   BH,BH
    PUSH  BX}

{    MOV   BYTE PTR TIA_Latch[RESP1],BL}
    MOV   BX,AX
    CMP   BX,160
    JL    @NoP1DelayWrap
    SUB   BX,160
{    INC   WORD PTR Game.TIA_Latch_Scan[RESP1 * 2]}
    INC   DX
@NoP1DelayWrap:
    PUSH  DX
    PUSH  BX
    CALL  QueueLatch

{    MOV   WORD PTR Game.TIA_Latch_Count[RESP1 * 2],BX}
    MOV   AX,WORD PTR Game.ObjectLoc[Player1Set * 2]
    MOV   WORD PTR Game.NewObjectLoc[Player1Set * 2],AX
    MOV   AX,WORD PTR Game.OldObjectLoc[Player1Set * 2]
    MOV   WORD PTR Game.ObjectLoc[Player1Set * 2],AX
    POP   BX
@TurnP1OffDone:
{
    MOV   AX,WORD PTR Game.OldPlayer1Size128
    ADD   AX,WORD PTR Game.ResetPlayer1Size128
    MOV   WORD PTR Game.Player1Size128,AX
}
    CALL  ResetMissile1

@NotP1Set:

    { Missile 0 }

    TEST  BX,Missile0Set
    JZ    @NotM0Set
    MOV   AX,CX
    ADD   AX,WORD PTR Game.ResetOffset[4]
    CMP   AX,160
    JB    @SignOk3
    MOV   AX,2
    JMP   @SetM0Loc
@SignOk3:
    MOV   AX,CX
    ADD   AX,WORD PTR Game.ResetOffset[4]
    ADD   AX,SetLocDelay - 1
@SetM0Loc:
    CMP   WORD PTR Game.TIA_Count,7
    JGE   @NoM0Inc
    TEST  BYTE PTR Game.OldDoHMOVE,0FFh
    JNZ   @DoM0Move
    CMP   WORD PTR Game.TIA_Count,0
    JGE   @NoM0Inc
    MOV   AX,2
    JMP   @NoM0Inc
@DoM0Move:
    MOV   AX,SI
    ADD   AX,WORD PTR Game.ObjectMove[Missile0Set * 2]
@NoM0Move:
    CMP   AX,8
    JL    @M0IncOk
    MOV   AX,8
@M0IncOk:
    ADD   AX,2
@NoM0Inc:
    MOV   WORD PTR Game.ObjectLoc[Missile0Set * 2],AX

    SUB   AX,AX
    CALL  GetMissileDelay
    TEST  AX,80h
    JZ    @DelayM0

    MOV   AX,WORD PTR Game.Missile0SizeNum
    MOV   WORD PTR Game.TIA_Latch_Missile0SizeNum,AX
    MOV   AX,WORD PTR Game.TIA_Count
{    ADD   AX,4}
    JMP   @DoM0Delay

@DelayM0:
    ADD   AX,WORD PTR Game.ObjectLoc[Missile0Set * 2]
    PUSH  BX
    MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ0]
    AND   BX,7
    SHL   BX,1
    MOV   DX,WORD PTR MissileAdd1[BX]
    MOV   WORD PTR Game.TIA_Latch_Missile0SizeNum,DX
    POP   BX
@DoM0Delay:
    PUSH  BX
    MOV   BX,WORD PTR Game.TIA_Scan
    MOV   DX,BX
{    MOV   WORD PTR Game.TIA_Latch_Scan[RESM0 * 2],BX}
    MOV   BL,BYTE PTR Game.TIA_Regs[RESM0]
{    INC   BL}                            { Do anything to make it different }

    PUSH  RESM0
    PUSH  WORD PTR Game.ObjectLoc[Missile0Set * 2]
{    SUB   BH,BH
    PUSH  BX}

{    MOV   BYTE PTR TIA_Latch[RESM0],BL}
    MOV   BX,AX
    CMP   BX,160
    JL    @NoM0DelayWrap
    SUB   BX,160
{    INC   WORD PTR Game.TIA_Latch_Scan[RESM0 * 2]}
    INC   DX
@NoM0DelayWrap:

    PUSH  DX
    PUSH  BX
    CALL  QueueLatch

{    MOV   WORD PTR Game.TIA_Latch_Count[RESM0 * 2],BX}
    MOV   AX,WORD PTR Game.ObjectLoc[Missile0Set * 2]
    MOV   WORD PTR Game.NewObjectLoc[Missile0Set * 2],AX
    MOV   AX,WORD PTR Game.OldObjectLoc[Missile0Set * 2]
    MOV   WORD PTR Game.ObjectLoc[Missile0Set * 2],AX
    POP   BX
@TurnM0OffDone:

@NotM0Set:

    { Missile 1 }

    TEST  BX,Missile1Set
    JZ    @NotM1Set
    MOV   AX,CX
    ADD   AX,WORD PTR Game.ResetOffset[6]
    CMP   AX,160
    JB    @SignOk4
    MOV   AX,2
    JMP   @SetM1Loc
@SignOk4:
    MOV   AX,CX
    ADD   AX,WORD PTR Game.ResetOffset[6]
    ADD   AX,SetLocDelay - 1
@SetM1Loc:
    CMP   WORD PTR Game.TIA_Count,7
    JGE   @NoM1Inc
    TEST  BYTE PTR Game.OldDoHMOVE,0FFh
    JNZ   @DoM1Move
    CMP   WORD PTR Game.TIA_Count,0
    JGE   @NoM1Inc
    MOV   AX,2
    JMP   @NoM1Inc
@DoM1Move:
    MOV   AX,SI
    ADD   AX,WORD PTR Game.ObjectMove[Missile1Set * 2]
@NoM1Move:
    CMP   AX,8
    JL    @M1IncOk
    MOV   AX,8
@M1IncOk:
    ADD   AX,2
@NoM1Inc:
    MOV   WORD PTR Game.ObjectLoc[Missile1Set * 2],AX

    MOV   AX,1
    CALL  GetMissileDelay
    TEST  AX,80h
    JZ    @DelayM1

    MOV   AX,WORD PTR Game.Missile1SizeNum
    MOV   WORD PTR Game.TIA_Latch_Missile1SizeNum,AX
    MOV   AX,WORD PTR Game.TIA_Count
{    ADD   AX,4}
    JMP   @DoM1Delay

@DelayM1:
    ADD   AX,WORD PTR Game.ObjectLoc[Missile1Set * 2]
    PUSH  BX
    MOV   BL,BYTE PTR Game.TIA_Regs[NUSIZ1]
    AND   BX,7
    SHL   BX,1
    MOV   DX,WORD PTR MissileAdd1[BX]
    MOV   WORD PTR Game.TIA_Latch_Missile1SizeNum,DX
    POP   BX
@DoM1Delay:
    PUSH  BX
    MOV   BX,WORD PTR Game.TIA_Scan
    MOV   DX,BX
{    MOV   WORD PTR Game.TIA_Latch_Scan[RESM1 * 2],BX}
    MOV   BL,BYTE PTR Game.TIA_Regs[RESM1]
{    INC   BL}                            { Do anything to make it different }

    PUSH  RESM1
    PUSH  WORD PTR Game.ObjectLoc[Missile1Set * 2]
{    SUB   BH,BH
    PUSH  BX}

{    MOV   BYTE PTR TIA_Latch[RESM1],BL}
    MOV   BX,AX
    CMP   BX,160
    JL    @NoM1DelayWrap
    SUB   BX,160
{    INC   WORD PTR Game.TIA_Latch_Scan[RESM1 * 2]}
    INC   DX
@NoM1DelayWrap:

    PUSH  DX
    PUSH  BX
    CALL  QueueLatch

{    MOV   WORD PTR Game.TIA_Latch_Count[RESM1 * 2],BX}
    MOV   AX,WORD PTR Game.ObjectLoc[Missile1Set * 2]
    MOV   WORD PTR Game.NewObjectLoc[Missile1Set * 2],AX
    MOV   AX,WORD PTR Game.OldObjectLoc[Missile1Set * 2]
    MOV   WORD PTR Game.ObjectLoc[Missile1Set * 2],AX
    POP   BX
@TurnM1OffDone:


@NotM1Set:

    { Ball }

    TEST  BX,BallSet
    JZ    @NotBLSet
    MOV   AX,CX
    ADD   AX,WORD PTR Game.ResetOffset[8]
    CMP   AX,160
    JB    @SignOk5
    MOV   AX,2
    JMP   @SetBLLoc
@SignOk5:
    MOV   AX,CX
    ADD   AX,WORD PTR Game.ResetOffset[8]
    ADD   AX,SetLocDelay - 1
@SetBLLoc:
    CMP   WORD PTR Game.TIA_Count,7
    JGE   @NoBLInc
    TEST  BYTE PTR Game.OldDoHMOVE,0FFh
    JNZ   @DoBLMove
    CMP   WORD PTR Game.TIA_Count,0
    JGE   @NoBLInc
    MOV   AX,2
    JMP   @NoBLInc
@DoBLMove:
    MOV   AX,SI
    ADD   AX,WORD PTR Game.ObjectMove[BallSet * 2]
@NoBLMove:
    CMP   AX,8
    JL    @BLIncOk
    MOV   AX,8
@BLIncOk:
    ADD   AX,2
@NoBLInc:
    MOV   WORD PTR Game.ObjectLoc[BallSet * 2],AX

    CALL  GetBallDelay
    TEST  AX,80h
    JNZ   @DelayBL

    MOV   AX,WORD PTR Game.TIA_Count
{    ADD   AX,4}
    JMP   @DoBLDelay

@DelayBL:
    AND   AX,7Fh
    ADD   AX,WORD PTR Game.ObjectLoc[BallSet * 2]
    ADD   AX,4
@DoBLDelay:
    PUSH  BX
    MOV   BX,WORD PTR Game.TIA_Scan
    MOV   DX,BX
{    MOV   WORD PTR Game.TIA_Latch_Scan[RESBL * 2],BX}
    MOV   BL,BYTE PTR Game.TIA_Regs[RESBL]
{    INC   BL}                            { Do anything to make it different }

    PUSH  RESBL
    PUSH  WORD PTR Game.ObjectLoc[BallSet * 2]
{    SUB   BH,BH
    PUSH  BX}

{    MOV   BYTE PTR TIA_Latch[RESBL],BL}
    MOV   BX,AX
    CMP   BX,160
    JL    @NoBLDelayWrap
    SUB   BX,160
{    INC   WORD PTR Game.TIA_Latch_Scan[RESBL * 2]}
    INC   DX
@NoBLDelayWrap:

    PUSH  DX
    PUSH  BX
    CALL  QueueLatch

{    MOV   WORD PTR Game.TIA_Latch_Count[RESBL * 2],BX}
    MOV   AX,WORD PTR Game.ObjectLoc[BallSet * 2]
    MOV   WORD PTR Game.NewObjectLoc[BallSet * 2],AX
    MOV   AX,WORD PTR Game.OldObjectLoc[BallSet * 2]
    MOV   WORD PTR Game.ObjectLoc[BallSet * 2],AX
    POP   BX
@TurnBLOffDone:




@NotBLSet:

{
    DB    _32BIT_OPERAND
    SUB   AX,AX
    DB    _32BIT_OPERAND
    MOV   WORD PTR Game.ResetOffset[0],AX
    DB    _32BIT_OPERAND
    MOV   WORD PTR Game.ResetOffset[4],AX
    MOV   WORD PTR Game.ResetOffset[8],AX
}

{
    ADD   BX,BX
    MOV   WORD PTR Game.ObjectLoc[BX],SI
}
    MOV   WORD PTR Game.ObjectSet,0


{    MOV   BYTE PTR Game.OldDoHMOVE,0}
End; { SetObjectLocations }


Procedure Interpret(Var _Start: Word; Var _P,_A,_X,_Y,_S: Byte);
Var
  P,A,X,Y,S : Byte;
  Start     : Word;

Label DoNothing,EmulateLoop,NoReadTime,DoneReadTime,BackToLoop,GetOut,
      L00,L01,L02,L03,L04,L05,L06,L07,L08,L09,L0A,L0B,L0C,L0D,L0E,L0F,
      L10,L11,L12,L13,L14,L15,L16,L17,L18,L19,L1A,L1B,L1C,L1D,L1E,L1F,
      L20,L21,L22,L23,L24,L25,L26,L27,L28,L29,L2A,L2B,L2C,L2D,L2E,L2F,
      L30,L31,L32,L33,L34,L35,L36,L37,L38,L39,L3A,L3B,L3C,L3D,L3E,L3F,
      L40,L41,L42,L43,L44,L45,L46,L47,L48,L49,L4A,L4B,L4C,L4D,L4E,L4F,
      L50,L51,L52,L53,L54,L55,L56,L57,L58,L59,L5A,L5B,L5C,L5D,L5E,L5F,
      L60,L61,L62,L63,L64,L65,L66,L67,L68,L69,L6A,L6B,L6C,L6D,L6E,L6F,
      L70,L71,L72,L73,L74,L75,L76,L77,L78,L79,L7A,L7B,L7C,L7D,L7E,L7F,
      L80,L81,L82,L83,L84,L85,L86,L87,L88,L89,L8A,L8B,L8C,L8D,L8E,L8F,
      L90,L91,L92,L93,L94,L95,L96,L97,L98,L99,L9A,L9B,L9C,L9D,L9E,L9F,
      LA0,LA1,LA2,LA3,LA4,LA5,LA6,LA7,LA8,LA9,LAA,LAB,LAC,LAD,LAE,LAF,
      LB0,LB1,LB2,LB3,LB4,LB5,LB6,LB7,LB8,LB9,LBA,LBB,LBC,LBD,LBE,LBF,
      LC0,LC1,LC2,LC3,LC4,LC5,LC6,LC7,LC8,LC9,LCA,LCB,LCC,LCD,LCE,LCF,
      LD0,LD1,LD2,LD3,LD4,LD5,LD6,LD7,LD8,LD9,LDA,LDB,LDC,LDD,LDE,LDF,
      LE0,LE1,LE2,LE3,LE4,LE5,LE6,LE7,LE8,LE9,LEA,LEB,LEC,LED,LEE,LEF,
      LF0,LF1,LF2,LF3,LF4,LF5,LF6,LF7,LF8,LF9,LFA,LFB,LFC,LFD,LFE,LFF;

Begin

  { AL - X reg            AH - Y reg    }
  { BL - work             BH - work     }
  { CL - Accumulator      CH - Flags    }
  { DL - work             DH - Stack    }
  { SI - unused           DI - PC Reg   }
  { BP - used             SP - not used }

  P                   := _P;
  A                   := _A;
  X                   := _X;
  Y                   := _Y;
  S                   := _S;
  Start               := _Start;
  Move(AtariSeg,Game.TIA_Regs,SizeOf(Game.TIA_Regs));
  Exiting      := False;
  ControlFrame := 0;

  { Load locations here }

  Asm
    JMP   @Fill
@FillStart:
    DW    OFFSET L00
    DW    OFFSET L01
    DW    OFFSET L02
    DW    OFFSET L03
    DW    OFFSET L04
    DW    OFFSET L05
    DW    OFFSET L06
    DW    OFFSET L07
    DW    OFFSET L08
    DW    OFFSET L09
    DW    OFFSET L0A
    DW    OFFSET L0B
    DW    OFFSET L0C
    DW    OFFSET L0D
    DW    OFFSET L0E
    DW    OFFSET L0F

    DW    OFFSET L10
    DW    OFFSET L11
    DW    OFFSET DoNothing
    DW    OFFSET L13
    DW    OFFSET L14
    DW    OFFSET L15
    DW    OFFSET L16
    DW    OFFSET L17
    DW    OFFSET L18
    DW    OFFSET L19
    DW    OFFSET DoNothing
    DW    OFFSET L1B
    DW    OFFSET L1C
    DW    OFFSET L1D
    DW    OFFSET L1E
    DW    OFFSET L1F

    DW    OFFSET L20
    DW    OFFSET L21
    DW    OFFSET DoNothing
    DW    OFFSET L23
    DW    OFFSET L24
    DW    OFFSET L25
    DW    OFFSET L26
    DW    OFFSET L27
    DW    OFFSET L28
    DW    OFFSET L29
    DW    OFFSET L2A
    DW    OFFSET L2B
    DW    OFFSET L2C
    DW    OFFSET L2D
    DW    OFFSET L2E
    DW    OFFSET L2F

    DW    OFFSET L30
    DW    OFFSET L31
    DW    OFFSET DoNothing
    DW    OFFSET L33
    DW    OFFSET L34
    DW    OFFSET L35
    DW    OFFSET L36
    DW    OFFSET L37
    DW    OFFSET L38
    DW    OFFSET L39
    DW    OFFSET DoNothing
    DW    OFFSET L3B
    DW    OFFSET L3C
    DW    OFFSET L3D
    DW    OFFSET L3E
    DW    OFFSET L3F

    DW    OFFSET L40
    DW    OFFSET L41
    DW    OFFSET DoNothing
    DW    OFFSET L43
    DW    OFFSET L44
    DW    OFFSET L45
    DW    OFFSET L46
    DW    OFFSET L47
    DW    OFFSET L48
    DW    OFFSET L49
    DW    OFFSET L4A
    DW    OFFSET L4B
    DW    OFFSET L4C
    DW    OFFSET L4D
    DW    OFFSET L4E
    DW    OFFSET L4F

    DW    OFFSET L50
    DW    OFFSET L51
    DW    OFFSET DoNothing
    DW    OFFSET L53
    DW    OFFSET L54
    DW    OFFSET L55
    DW    OFFSET L56
    DW    OFFSET L57
    DW    OFFSET L58
    DW    OFFSET L59
    DW    OFFSET DoNothing
    DW    OFFSET L5B
    DW    OFFSET L5C
    DW    OFFSET L5D
    DW    OFFSET L5E
    DW    OFFSET L5F

    DW    OFFSET L60
    DW    OFFSET L61
    DW    OFFSET DoNothing
    DW    OFFSET L63
    DW    OFFSET L64
    DW    OFFSET L65
    DW    OFFSET L66
    DW    OFFSET L67
    DW    OFFSET L68
    DW    OFFSET L69
    DW    OFFSET L6A
    DW    OFFSET L6B
    DW    OFFSET L6C
    DW    OFFSET L6D
    DW    OFFSET L6E
    DW    OFFSET L6F

    DW    OFFSET L70
    DW    OFFSET L71
    DW    OFFSET DoNothing
    DW    OFFSET L73
    DW    OFFSET L74
    DW    OFFSET L75
    DW    OFFSET L76
    DW    OFFSET L77
    DW    OFFSET L78
    DW    OFFSET L79
    DW    OFFSET DoNothing
    DW    OFFSET L7B
    DW    OFFSET L7C
    DW    OFFSET L7D
    DW    OFFSET L7E
    DW    OFFSET L7F

    DW    OFFSET L80
    DW    OFFSET L81
    DW    OFFSET L82
    DW    OFFSET L83
    DW    OFFSET L84
    DW    OFFSET L85
    DW    OFFSET L86
    DW    OFFSET L87
    DW    OFFSET L88
    DW    OFFSET DoNothing
    DW    OFFSET L8A
    DW    OFFSET L8B
    DW    OFFSET L8C
    DW    OFFSET L8D
    DW    OFFSET L8E
    DW    OFFSET L8F

    DW    OFFSET L90
    DW    OFFSET L91
    DW    OFFSET DoNothing
    DW    OFFSET L93
    DW    OFFSET L94
    DW    OFFSET L95
    DW    OFFSET L96
    DW    OFFSET L97
    DW    OFFSET L98
    DW    OFFSET L99
    DW    OFFSET L9A
    DW    OFFSET L9B
    DW    OFFSET L9C
    DW    OFFSET L9D
    DW    OFFSET L9E
    DW    OFFSET L9F

    DW    OFFSET LA0
    DW    OFFSET LA1
    DW    OFFSET LA2
    DW    OFFSET LA3
    DW    OFFSET LA4
    DW    OFFSET LA5
    DW    OFFSET LA6
    DW    OFFSET LA7
    DW    OFFSET LA8
    DW    OFFSET LA9
    DW    OFFSET LAA
    DW    OFFSET LAB
    DW    OFFSET LAC
    DW    OFFSET LAD
    DW    OFFSET LAE
    DW    OFFSET LAF

    DW    OFFSET LB0
    DW    OFFSET LB1
    DW    OFFSET DoNothing
    DW    OFFSET LB3
    DW    OFFSET LB4
    DW    OFFSET LB5
    DW    OFFSET LB6
    DW    OFFSET LB7
    DW    OFFSET LB8
    DW    OFFSET LB9
    DW    OFFSET LBA
    DW    OFFSET LBB
    DW    OFFSET LBC
    DW    OFFSET LBD
    DW    OFFSET LBE
    DW    OFFSET LBF

    DW    OFFSET LC0
    DW    OFFSET LC1
    DW    OFFSET LC2
    DW    OFFSET LC3
    DW    OFFSET LC4
    DW    OFFSET LC5
    DW    OFFSET LC6
    DW    OFFSET LC7
    DW    OFFSET LC8
    DW    OFFSET LC9
    DW    OFFSET LCA
    DW    OFFSET LCB
    DW    OFFSET LCC
    DW    OFFSET LCD
    DW    OFFSET LCE
    DW    OFFSET LCF

    DW    OFFSET LD0
    DW    OFFSET LD1
    DW    OFFSET DoNothing
    DW    OFFSET LD3
    DW    OFFSET LD4
    DW    OFFSET LD5
    DW    OFFSET LD6
    DW    OFFSET LD7
    DW    OFFSET LD8
    DW    OFFSET LD9
    DW    OFFSET DoNothing
    DW    OFFSET LDB
    DW    OFFSET LDC
    DW    OFFSET LDD
    DW    OFFSET LDE
    DW    OFFSET LDF

    DW    OFFSET LE0
    DW    OFFSET LE1
    DW    OFFSET LE2
    DW    OFFSET LE3
    DW    OFFSET LE4
    DW    OFFSET LE5
    DW    OFFSET LE6
    DW    OFFSET LE7
    DW    OFFSET LE8
    DW    OFFSET LE9
    DW    OFFSET DoNothing
    DW    OFFSET LEB
    DW    OFFSET LEC
    DW    OFFSET LED
    DW    OFFSET LEE
    DW    OFFSET LEF

    DW    OFFSET LF0
    DW    OFFSET LF1
    DW    OFFSET DoNothing
    DW    OFFSET LF3
    DW    OFFSET LF4
    DW    OFFSET LF5
    DW    OFFSET LF6
    DW    OFFSET LF7
    DW    OFFSET LF8
    DW    OFFSET LF9
    DW    OFFSET DoNothing
    DW    OFFSET LFB
    DW    OFFSET LFC
    DW    OFFSET LFD
    DW    OFFSET LFE
    DW    OFFSET LFF
@Fill:
    MOV   CX,100h
    SUB   BX,BX
    MOV   SI,OFFSET @FillStart
    CLD
@FillLoop:
    MOV   AX,WORD PTR CS:[SI]
    MOV   WORD PTR Locations[BX],AX
    ADD   SI,2
    ADD   BX,2
    LOOP  @FillLoop
    MOV   DI,WORD PTR Start
    ADD   DI,OFFSET AtariSeg
    MOV   AL,BYTE PTR X
    MOV   AH,BYTE PTR Y
    MOV   CL,BYTE PTR A
    MOV   CH,BYTE PTR P
    MOV   DH,BYTE PTR S
    DEC   DI
DoNothing:
    INC   DI
EmulateLoop:
    DEC   WORD PTR Game.ReadTime
    JNZ   NoReadTime
{
    PUSH  AX
    PUSH  DX
    PUSH  CX
    PUSH  DI
}


    MOV   BYTE PTR Game._6507_P,CH
    MOV   BYTE PTR Game._6507_A,CL
    MOV   BYTE PTR Game._6507_X,AL
    MOV   BYTE PTR Game._6507_Y,AH
    MOV   BYTE PTR Game._6507_S,DH
    MOV   WORD PTR Game._6507_PC,DI
    SUB   WORD PTR Game._6507_PC,OFFSET AtariSeg





    DB    _32BIT_OPERAND
    PUSH  AX
    DB    _32BIT_OPERAND
    PUSH  BX
    DB    _32BIT_OPERAND
    PUSH  CX
    DB    _32BIT_OPERAND
    PUSH  DX
    DB    _32BIT_OPERAND
    PUSH  SI
    DB    _32BIT_OPERAND
    PUSH  DI
    DB    _32BIT_OPERAND
    PUSH  BP
    PUSH  DS
    PUSH  ES
    PUSHF
    CALL  GetControllers
    POPF
    POP   ES
    POP   DS
    DB    _32BIT_OPERAND
    POP   BP
    DB    _32BIT_OPERAND
    POP   DI
    DB    _32BIT_OPERAND
    POP   SI
    DB    _32BIT_OPERAND
    POP   DX
    DB    _32BIT_OPERAND
    POP   CX
    DB    _32BIT_OPERAND
    POP   BX
    DB    _32BIT_OPERAND
    POP   AX


{    CALL  Handle_Input}
    MOV   WORD PTR Game.ReadTime,Read_Delay

    MOV   AL,BYTE PTR AtariSeg[SWCHA1]
    MOV   BYTE PTR AtariSeg[SWCHA2],AL
    MOV   AL,BYTE PTR AtariSeg[SWCHB1]
    MOV   BYTE PTR AtariSeg[SWCHB2],AL

@CheckEsc:

{
    POP   DI
    POP   CX
    POP   DX
    POP   AX
}

    MOV   CH,BYTE PTR Game._6507_P
    MOV   CL,BYTE PTR Game._6507_A
    MOV   AL,BYTE PTR Game._6507_X
    MOV   AH,BYTE PTR Game._6507_Y
    MOV   DH,BYTE PTR Game._6507_S
    MOV   DI,WORD PTR Game._6507_PC
    ADD   DI,OFFSET AtariSeg


    TEST  BYTE PTR Exiting,0FFh
{    TEST  BYTE PTR Key[kESC],0FFh}
    JZ    BackToLoop

    JMP   L02
{
    MOV   BYTE PTR X,AL
    MOV   BYTE PTR Y,AH
    MOV   BYTE PTR A,CL
    MOV   BYTE PTR P,CH
    MOV   BYTE PTR S,DH
    SUB   DI,OFFSET AtariSeg
    MOV   WORD PTR Start,DI}
  End; { Asm }
{  _P     := P;
  _A     := A;
  _X     := X;
  _Y     := Y;
  _S     := S;
  _Start := Start;
  Exit;}
BackToLoop:

  Asm
{
    MOV   CH,BYTE PTR Game._6507_P
    MOV   CL,BYTE PTR Game._6507_A
    MOV   AL,BYTE PTR Game._6507_X
    MOV   AH,BYTE PTR Game._6507_Y
    MOV   DH,BYTE PTR Game._6507_S
    MOV   DI,WORD PTR Game._6507_PC
    ADD   DI,OFFSET AtariSeg
}
{
    POP   DI
    POP   CX
    POP   DX
    POP   AX
}
NoReadTime:


(*
    CMP   WORD PTR Game.TimerInterval,0
    JE    @GetOut
    MOV   BX,WORD PTR Game.AddCycle
    TEST  BYTE PTR TimerDone,0FFh
    JNZ   @LTimerDone
    MOV   SI,WORD PTR Game.TimerInterval
    ADD   WORD PTR Game.TimerValue,BX
    MOV   BX,WORD PTR Game.TimerValue
    CMP   BX,SI
    JL    @GetOut
    MOV   WORD PTR Game.TimerValue,0
    SUB   BX,SI
    SUB   BYTE PTR AtariSeg[INTTIM1],1
    JC    @Done
    ADD   WORD PTR Game.TimerValue,BX
    JMP   @GetOut
@Done:
    MOV   BYTE PTR TimerDone,1
@LTimerDone:
    SUB   BYTE PTR AtariSeg[INTTIM1],BL
@GetOut:
*)



    { The write cycle is the last of the instruction cycles; add the }
    { instruction cycles first.                                      }

    DB    _32BIT_OPERAND
    MOV   BX,WORD PTR Game.AddCycle
    DB    _32BIT_ADDRESS,8Dh,1Ch,5Bh   { LEA BX,[EBX + EBX * 2] }
    ADD   WORD PTR Game.TIA_Count,BX

    { Now handle a write to the TIA }

    TEST  BYTE PTR Game.Write_TIA,0FFh
    JZ    @NoWriteTIA

    { If the write was to WSYNC, then Handle_IO has already properly set }
    { Game.TIA_Count, don't add the instruction time to it.                   }

    CMP   BYTE PTR Game.Write_TIA,2
    JNE   @NotWSYNC
    SUB   WORD PTR Game.TIA_Count,BX
@NotWSYNC:
    PUSH  AX
    PUSH  DX
    PUSH  CX
    PUSH  DI



    MOV   BX,WORD PTR Game.Save_BX
    CMP   BX,NUSIZ0
    JB    @AddDelay
    CMP   BX,NUSIZ1
    JA    @AddDelay
    TEST  WORD PTR Game.DoHMOVE,0FFh
    JZ    @AddDelay
    CMP   WORD PTR Game.TIA_Count,8
    JGE   @AddDelay
    SUB   BX,BX
@AddDelay:
    ADD   BX,BX
    MOV   BX,WORD PTR TIA_Delay[BX]

    CMP   BX,4
    JNE   @No
{    MOV   SI,WORD PTR Game.TIA_Count
    AND   SI,3
    SUB   BX,SI}
    SUB   BX,WORD PTR Game.TIA_Count
    DEC   BX
    AND   BX,3

    MOV   BL,BYTE PTR PFDelay[BX]

{    INC   BX


    CMP   BX,1
    JNE   @No
    MOV   BX,5}

@No:

    MOV   SI,WORD PTR Game.TIA_Count
    ADD   WORD PTR Game.TIA_Count,BX
    PUSH  SI
    CALL  Handle_TIA
    POP   SI
    MOV   WORD PTR Game.TIA_Count,SI


{    MOV   WORD PTR Game.Old_TIA_Count,SI}
{    SUB   WORD PTR Game.TIA_Count,BX}
{
    CMP   BX,GRP0
    JB    @NormalTIA
    CMP   BX,GRP1
    JA    @NormalTIA
    INC   WORD PTR Game.TIA_Count
    CALL  Handle_TIA
    DEC   WORD PTR Game.TIA_Count
    JMP   @Continue
@NormalTIA:
    CALL  Handle_TIA
@Continue:
}
    MOV   BX,WORD PTR Game.Save_BX
    MOV   AL,BYTE PTR AtariSeg[BX]
    MOV   BYTE PTR Game.TIA_Regs[BX],AL
    CALL  Handle_IO_After
    POP   DI
    POP   CX
    POP   DX
    POP   AX

    { See if an object's position has been reset }

    TEST  WORD PTR Game.ObjectSet,0FFh
    JZ    @NoObjectsSet

    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  AX

    CALL  SetObjectLocations

    POP   AX
    POP   DX
    POP   CX
    POP   BX

@NoObjectsSet:


    { If the write was to WSYNC, then the delay time has already been     }
    { figured into the correct Game.TIA_Count.  Don't subtract the delay time. }

    CMP   BYTE PTR Game.Write_TIA,2
    JE    @WSYNC
@WSYNC:
    MOV   BYTE PTR Game.Write_TIA,0
@NoWriteTIA:

    MOV   WORD PTR Game.ResetOfs,0

    CMP   BYTE PTR Game.Controller,crPaddle
    JNE   @NoPaddle

    TEST  BYTE PTR AtariSeg[VBLANK],80h
    JNZ   @NoPaddle

    CALL  SetPaddlePositions


@NoPaddle:

    { Get the next instruction here to avoid a Pentium AGI }
    { (Address Generation Interlock)                       }

    MOV   SI,WORD PTR [DI]   {U}
    MOV   BX,160             {V}   { This sets BH to ZERO (IMPORTANT!) }
    AND   SI,0FFh            {U}






    { Debug test }
(*
    TEST  BYTE PTR Debugger,0FFh
    JZ    @NoHalt1
{
    CMP   WORD PTR Game.TIA_Scan,-7
    JNE   @NoHalt1
    CMP   WORD PTR Game.TIA_Latch_Scan[RESBL * 2],NoLatchScan
    JE    @NoHalt1
}

{    CMP   WORD PTR Game.TIA_Scan,-7
    JNE   @NoHalt1}
    CMP   WORD PTR Game.TIA_Scan,0
    JGE   @NoHalt1
    CMP   WORD PTR Game.TIA_Scan,-9
    JLE   @NoHalt1
    CMP   WORD PTR Game.TIA_Latch_Scan[RESBL * 2],NoLatchScan
    JE    @NoHalt1
    CMP   WORD PTR Game.TIA_Latch_Count[RESBL * 2],10
    JGE   @NoHalt1
{
    CMP   WORD PTR Game.ObjectLoc[BallSet * 2],158
    JNE   @NoHalt1
}
{
    CMP   DI,OFFSET AtariSeg + 1E49h
    JNE   @NoHalt1
    CMP   WORD PTR Game.TIA_Count,154
    JE    @NoHalt1
}
    PUSH  AX
    MOV   AX,SI
    MOV   BYTE PTR Game.OldByte,AL
    MOV   BYTE PTR [DI],BreakInstruction
    MOV   SI,BreakInstruction
    MOV   AX,DI
    SUB   AX,OFFSET AtariSeg
    MOV   WORD PTR Game.OldStart,AX
    POP   AX
@NoHalt1:
*)

    { Handle break on expression (check for null segment) }

    TEST  WORD PTR BreakExpColl[2],0FFFFh
    JZ    @NoBreakOnExp

    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX

    PUSH  SI  { Save this for later }
    PUSH  DI  { Save this for later }

    DB    _32BIT_OPERAND
    PUSH  WORD PTR BreakExpColl
    DB    _32BIT_OPERAND
    PUSH  WORD PTR ASeg
    PUSH  WORD PTR Game.ObjectLoc[Player0Set * 2]
    PUSH  WORD PTR Game.ObjectLoc[Player1Set * 2]
    PUSH  WORD PTR Game.ObjectLoc[Missile0Set * 2]
    PUSH  WORD PTR Game.ObjectLoc[Missile1Set * 2]
    PUSH  WORD PTR Game.ObjectLoc[BallSet * 2]
    SUB   BH,BH
    MOV   BL,AL  { reg X }
    PUSH  BX
    MOV   BL,AH  { reg Y }
    PUSH  BX
    MOV   BL,CL  { reg A }
    PUSH  BX
    MOV   BL,CH  { reg P }
    PUSH  BX
    MOV   BL,DH  { reg S }
    PUSH  BX
    SUB   DI,OFFSET AtariSeg
    PUSH  DI
    ADD   DI,OFFSET AtariSeg
    PUSH  WORD PTR Game.TIA_Count
    PUSH  WORD PTR Game.TIA_Scan
    PUSH  OFFSET ExpError
    PUSH  DS
    CALL  Evaluate
    POP   DI
    POP   SI

    TEST  AX,AX
    JZ    @NoBreakOnExp1

    MOV   AX,SI
    MOV   BYTE PTR Game.OldByte,AL
    MOV   BYTE PTR [DI],BreakInstruction
    MOV   SI,BreakInstruction
    MOV   AX,DI
    SUB   AX,OFFSET AtariSeg
    MOV   WORD PTR Game.OldStart,AX

@NoBreakOnExp1:
    POP   DX
    POP   CX
    POP   BX
    POP   AX
@NoBreakOnExp:

    { Check to see if we've reached the end of the scan line }

    CMP   WORD PTR Game.TIA_Count,BX         {U}
    JL    @NoNewLine                           {V}

    CMP   WORD PTR SoundQueue_Num,1022
    JAE   @NoQueue
    DB    _32BIT_OPERAND
    PUSHA
    CALL  QueueSoundSample
    DB    _32BIT_OPERAND
    POPA
@NoQueue:

    CMP   WORD PTR Game.Old_TIA_Count,BX
    JL    @NoOldAdjust
    MOV   WORD PTR Game.Old_TIA_Count,BX
@NoOldAdjust:

    MOV   BL,BYTE PTR Game.DoHMOVE
    MOV   BYTE PTR Game.OldDoHMOVE,BL

    ADD   WORD PTR Game.TimerElapsed,76
    ADC   WORD PTR Game.TimerElapsed[2],0
    DB    _32BIT_OPERAND
    MOV   BX,WORD PTR Game.TimerX
    DB    _32BIT_OPERAND
    ADD   WORD PTR Game.TimerElapsed,BX
    DB    _32BIT_OPERAND
    SUB   BX,BX
    DB    _32BIT_OPERAND
    MOV   WORD PTR Game.TimerX,BX


    DB    _32BIT_OPERAND
    MOV   BX,228
    DW    0
    PUSH  AX
    PUSH  DX
    PUSH  CX
    PUSH  DI
    PUSH  SI
    PUSH  DI
    CALL  Handle_TIA
    POP   DI




    { Change the background color every scan line }
{
    ADD   BYTE PTR Game.ColorLum[6],2
    ADD   BYTE PTR Game.ColorLum[7],2
}




    MOV   BX,WORD PTR Game.OldPlayer0Size128
    MOV   WORD PTR Game.Player0Size128,BX
    MOV   BX,WORD PTR Game.OldPlayer1Size128
    MOV   WORD PTR Game.Player1Size128,BX

    MOV   BX,WORD PTR Game.OldMissile0SizeNum
    MOV   WORD PTR Game.Missile0SizeNum,BX
    MOV   BX,WORD PTR Game.OldMissile1SizeNum
    MOV   WORD PTR Game.Missile1SizeNum,BX

{
    INC   WORD PTR BufScan
    TEST  WORD PTR BufScan,07h
    JNZ   @NoFillBuffer
    PUSHA
    CALL  FillBuffer
    POPA
@NoFillBuffer:
}


    MOV   BX,WORD PTR Game.TIA_Scan         { Ensure that BH = 0! }
    CMP   BX,WORD PTR MaxScan{222}
    JGE   @DoneLines
    INC   BX
@DoneLines:
    CMP   BX,0
    JGE   @NotNegative
    CMP   WORD PTR Game.HMOVECount,94
    JG    @NotNegative
    MOV   BYTE PTR Game.DoHMOVE,0
    MOV   BYTE PTR Game.OldDoHMOVE,0
@NotNegative:

    { If a player object was reset and this caused the first copy }
    { to disappear, cause the copy to reappear                    }

    CMP   WORD PTR Game.ResetPlayer0Size128,0
    JE    @CheckResetP1
    MOV   AX,WORD PTR Game.OldPlayer0Size128
    MOV   WORD PTR Game.Player0Size128,AX
@CheckResetP1:
    CMP   WORD PTR Game.ResetPlayer1Size128,0
    JE    @CheckResetDone
    MOV   AX,WORD PTR Game.OldPlayer1Size128
    MOV   WORD PTR Game.Player1Size128,AX
@CheckResetDone:
    MOV   WORD PTR Game.ResetPlayer0Size128,0
    MOV   WORD PTR Game.ResetPlayer1Size128,0

    { See if the debugger is set to halt at this scan line }

    TEST  BYTE PTR Debugger,0FFh
    JZ    @NoHalt
    CMP   BX,WORD PTR HaltLine
    JNE   @NoHalt
@Stop:
    POP   SI
    MOV   AX,SI
    MOV   BYTE PTR Game.OldByte,AL
    MOV   BYTE PTR [DI],BreakInstruction
    MOV   SI,BreakInstruction
    PUSH  SI
    MOV   AX,DI
    SUB   AX,OFFSET AtariSeg
    MOV   WORD PTR Game.OldStart,AX
@NoHalt:

    { See if the emulator needs to be forced to slow down.  This is }
    { necessary every 262/314 scan lines if VSYNC is never asserted }

    PUSH  BX
    MOV   BX,WORD PTR Game.LineDelayMax
    INC   WORD PTR Game.LineDelay
    CMP   WORD PTR Game.LineDelay,700  { Arbitrary value, should be big }
    JL    @SeeIfForceDelay

    { If a VSYNC hasn't happened by now, assume that one isn't going to }
    { happen ever, and assume NTSC/60Hz                                 }

    MOV   BYTE PTR Game.LineDelayFirst,1
@SeeIfForceDelay:
    TEST  BYTE PTR Game.LineDelayFirst,0FFh
    JZ    @NoForceDelay
@ForceDelay:
    CMP   WORD PTR Game.LineDelay,BX
    JLE   @NoForceDelay
    MOV   WORD PTR Game.LineDelay,0
    DB    _32BIT_OPERAND
    PUSHA
    CALL  SlowDown
    DB    _32BIT_OPERAND
    POPA
@NoForceDelay:
    POP   BX

    { Go to the next scan line }

    CMP   BX,WORD PTR Game.MaxRows{200}
    JAE   @Negative
    CMP   WORD PTR Config.MaxCols,320
    JE    @MaxColsIs320
    MOV   AX,BX
    SHL   AX,5
    PUSH  BX
    SHL   BX,7
    ADD   AX,BX
    POP   BX
    JMP   @SetAddress
@MaxColsIs320:
    MOV   AX,BX
    SHL   AX,6
    ADD   AH,BL
@SetAddress:
    MOV   WORD PTR Game.Addr,AX
    MOV   WORD PTR Game.LineStart,AX
{    MOV   BYTE PTR Game.DoHMOVE,0}


{    JMP   @NoSend}


@Negative:


(*
    PUSH  AX
    PUSH  BX
    PUSH  CX
    PUSH  DX
    PUSH  SI
    PUSH  DI
    CALL  SendScreen
    POP   DI
    POP   SI
    POP   DX
    POP   CX
    POP   BX
    POP   AX

@NoSend:
*)


(*
    PUSH  BX
  MOV   AL,BYTE PTR AtariSeg[CTRLPF]
  MOV   BYTE PTR Game.TIA_Regs[CTRLPF],AL
  MOV   BYTE PTR Game._CTRLPF,AL
  MOV   AL,BYTE PTR Game.TIA_Regs[CTRLPF]
  MOV   SI,AX
  SHR   SI,4
  AND   SI,3
  MOV   CL,BYTE PTR MissileSize[SI]
  SUB   CH,CH
  MOV   WORD PTR Game.BallSize,CX

  SUB   CX,160
  MOV   WORD PTR Game.BallSize160,CX
  MOV   CX,WORD PTR Game.ColorLum[0]
  MOV   DX,WORD PTR Game.ColorLum[2]
  MOV   BX,WORD PTR Game.ColorLum[4]
  TEST  AL,2
  JZ    @LCPF1
  MOV   WORD PTR Game.CLW,CX
  MOV   WORD PTR Game.CLW[2],CX
  MOV   WORD PTR Game.CRW,DX
  MOV   WORD PTR Game.CRW[2],DX
  JMP   @LCPF2
@LCPF1:
  MOV   WORD PTR Game.CLW,BX
  MOV   WORD PTR Game.CLW[2],BX
  MOV   WORD PTR Game.CRW,BX
  MOV   WORD PTR Game.CRW[2],BX
@LCPF2:
    POP   BX
*)
(*
    MOV   AL,BYTE PTR GRP0Latch
    MOV   BYTE PTR AtariSeg[GRP0],AL
    AND   BYTE PTR Game.DispJump,0DFh
    TEST  AL,0FFh
    JZ    @LGRP0A
    OR    BYTE PTR Game.DispJump,20h
@LGRP0A:

    MOV   AL,BYTE PTR GRP1Latch
    MOV   BYTE PTR AtariSeg[GRP1],AL
    AND   BYTE PTR Game.DispJump,0F7h
    TEST  AL,0FFh
    JZ    @LGRP1A
    OR    BYTE PTR Game.DispJump,8
@LGRP1A:
*)
    MOV   AL,BYTE PTR Game.BallLatch
    MOV   BYTE PTR AtariSeg[ENABL],AL
    AND   BYTE PTR Game.DispJump,0FDh
    TEST  AL,2
    JZ    @LVDELBL
    OR    BYTE PTR Game.DispJump,2h
@LVDELBL:


    MOV   AX,WORD PTR AtariSeg[GRP0]
    MOV   WORD PTR Game.TIA_Regs[GRP0],AX

    SUB   WORD PTR Game.TIA_Count,228
{    SUB   WORD PTR Game.Old_TIA_Count,228}
    MOV   WORD PTR Game.Old_TIA_Count,-68
{
    JL    @DoneLines
    MOV   BX,-41
    MOV   WORD PTR Game.Addr,0
@DoneLines:
    INC   BX
}
{
    CMP   BX,200
    JAE   @Negative
    MOV   AX,BX
    SHL   AX,6
    ADD   AH,BL
    MOV   WORD PTR Game.Addr,AX
@Negative:
}
{
    CMP   BX,200
    JGE   @DoneLines
    INC   BX
@DoneLines:
    OR    BX,BX
    JS    @Negative
    MOV   AX,BX
    SHL   AX,6
    ADD   AH,BL
    MOV   WORD PTR Game.Addr,AX
@Negative:
}
    POP   SI
    POP   DI
    POP   CX
    POP   DX
    POP   AX
    MOV   WORD PTR Game.TIA_Scan,BX                              {U}
{    OR    BX,BX
    JNS   @Positive}
    SUB   BH,BH                                                    {V}
{@Positive:}
    AND   BYTE PTR Game.DispJump,0FDh      { Turn ball off }     {U}
    TEST  BYTE PTR AtariSeg[ENABL],2                                       {U}
    JZ    @NoNewLine                                               {V}
    OR    BYTE PTR Game.DispJump,2         { Display the ball }  {U}
@NoNewLine:
    MOV   DL,BYTE PTR Cycles[SI]                                   {U}
    ADD   SI,SI                                                    {V}
    MOV   BYTE PTR Game.AddCycle,DL                              {U}
    JMP   WORD PTR Locations[SI]                           {U}
  End; { Asm }

{ --------------------------- Assembly emulator --------------------------- }

L00:                 { BRK }

  Asm
    DEC    DH
    MOV    BL,DH
{    MOV    BH,1}            { A 6502 would have this, but not an Atari }

    ADD    DI,2
{
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    MOV    BYTE PTR AtariSeg[BX],AL
    INC    BL
    MOV    BYTE PTR AtariSeg[BX],AH
    DEC    BL
    ADD    DI,OFFSET AtariSeg
    POP    AX
}
    SUB    DI,OFFSET AtariSeg

    PUSH   DI
    AND    WORD PTR Game.Hi3,0E000h
    OR     DI,WORD PTR Game.Hi3
    MOV    WORD PTR AtariSeg[BX],DI
    POP    DI

    ADD    DI,OFFSET AtariSeg


    MOV    WORD PTR Game.ResetOfs,-12

    INC    BL
    PUSH   BX
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    POP    BX
    DEC    BL

    PUSH   BX
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    POP    BX

    DEC    BL
    MOV    BYTE PTR AtariSeg[BX],CH

    PUSH   BX
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    POP    BX

    SUB    DH,2
    OR     CH,014h
    MOV    DI,WORD PTR AtariSeg[1FFEh]        { 6502: [0FFFEh] }

    MOV    WORD PTR Game.Hi3,DI

    AND    DI,01FFFh         { Atari can only address 8K }
    ADD    DI,OFFSET AtariSeg
    JMP    EmulateLoop
  End; { Asm }

L01:                 { ORA ind. x }

 Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    OR     CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    OR     CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L02:                 { Breakpoint instruction }

  Asm
    MOV   BYTE PTR X,AL
    MOV   BYTE PTR Y,AH
    MOV   BYTE PTR A,CL
    MOV   BYTE PTR P,CH
    MOV   BYTE PTR S,DH
    SUB   DI,OFFSET AtariSeg
    MOV   WORD PTR Start,DI
    JMP   GetOut
{    INC    DI
    JMP    EmulateLoop}
  End; { Asm }

L03:                 { SLO ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }
    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Ch
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2
    OR     CH,1
  @L2:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2a
    OR     CH,1
  @L2a:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L04:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L05:                 { ORA zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    AND    CH,07Dh

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    OR     CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    OR     CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L06:                 { ASL zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    OR     CH,3

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX

    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    SHL    DL,1

    JC     @L2A
    AND    CH,0FEh
  @L2A:
    OR     DL,DL
    JZ     @L1A
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1A:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop

@NotCrit:
    OR     CH,3
    SHL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L07:                 { SLO zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Ch
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2
    OR     CH,1
  @L2:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2a
    OR     CH,1
  @L2a:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L08:                 { PHP }

  Asm
    MOV    BL,DH
{    MOV    BH,1}

    TEST   BYTE PTR Game.BankSwitch[BX + 100h],0FFh
    JZ     @NoSwitch
    ADD    BX,100h
    CALL   SwitchBank
    SUB    BX,100h
@NoSwitch:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CH
    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    DEC    DH
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L09:                 { ORA immediate }

  Asm
    OR     CL,BYTE PTR [DI+1]
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    ADD    DI,2
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    OR     CH,02h
    JMP    EmulateLoop
  End; { Asm }

L0A:                 { ASL accum. }

  Asm
    OR     CH,3
    ADD    CL,CL
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    INC    DI
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L0B:                 { ANC immediate - UNDOCUMENTED }

  Asm
    AND    CL,BYTE PTR [DI+1]
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    ADD    DI,2
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    OR     CH,02h
    JMP    EmulateLoop
  End; { Asm }

L0C:                 { SKW Quasi-Opcode }

  Asm
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L0D:                { ORA absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    OR     CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    OR     CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L0E:                 { ASL absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }


    CMP    BX,1000h
    JB     @NotROM

    CMP    BYTE PTR Game.Cart,ctStarpath
    JE     @NotROM
    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JNZ    @NotROM
    ADD    DI,3
    JMP    EmulateLoop
@NotROM:

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L0F:                 { SLO absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Ch
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2
    OR     CH,1
  @L2:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2a
    OR     CH,1
  @L2a:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L10:                 { BPL }

  Asm
    TEST   CH,80h
    JNZ    @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR Game.AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR Game.AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L11:                 { ORA ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
{    ADC    BH,0}
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    OR     CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    OR     CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L12:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L13:                 { SLO ind. y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    MOV    BL,BYTE PTR [DI+1]
    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Ch
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2
    OR     CH,1
  @L2:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2a
    OR     CH,1
  @L2a:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L14:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L15:                 { ORA z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    OR     CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    OR     CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L16:                 { ASL z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    OR     CH,3
    SHL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L17:                 { SLO z. page x - UNDOCUMENTED }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    MOV    BL,BYTE PTR [DI+1]
    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Ch
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2
    OR     CH,1
  @L2:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2a
    OR     CH,1
  @L2a:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L18:                 { CLC }

  Asm
    AND    CH,0FEh
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L19:                 { ORA abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    OR     CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    OR     CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L1A:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L1B:                 { SLO abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    CMP    BX,1000h
    JB     @NotROM

    CMP    BYTE PTR Game.Cart,ctStarpath
    JE     @NotROM
    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JNZ    @NotROM
    ADD    DI,3
    JMP    EmulateLoop
@NotROM:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Ch
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2
    OR     CH,1
  @L2:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2a
    OR     CH,1
  @L2a:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L1C:                 { SKW Quasi-Opcode }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BYTE PTR Game.AddCycle,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L1D:                 { ORA abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    OR     CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    OR     CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L1E:                 { ASL abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    CMP    BX,1000h
    JB     @NotROM
    CMP    BYTE PTR Game.Cart,ctStarpath
    JE     @NotROM
    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JNZ    @NotROM

    OR     CH,3
    MOV    DL,BYTE PTR AtariSeg[BX]
    SHL    DL,1
    JMP    @L3

{    ADD    DI,3
    JMP    EmulateLoop}
@NotROM:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L3:
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L1F:                 { SLO abs. x - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Ch
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2
    OR     CH,1
  @L2:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCL    DL,1
    JNC    @L2a
    OR     CH,1
  @L2a:
    OR     DL,CL
    MOV    BYTE PTR AtariSeg[BX],DH
    JZ     @L1
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L20:                 { JSR }

  Asm
    DEC    DH
    MOV    BL,DH
{    MOV    BH,1}
    SUB    DI,OFFSET AtariSeg

    PUSH   DI
    AND    WORD PTR Game.Hi3,0E000h
    OR     DI,WORD PTR Game.Hi3
    MOV    WORD PTR AtariSeg[BX],DI
    POP    DI

    ADD    DI,OFFSET AtariSeg
    ADD    WORD PTR AtariSeg[BX],2
    DEC    DH

    MOV    DI,WORD PTR [DI+1]

    MOV    WORD PTR Game.Hi3,DI

{    AND    DI,1FFFh}          { Atari can only address 8K }
(*
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }
    PUSH   BX
    SUB    BH,BH
    MOV    BL,DH
    INC    BL
*)
    TEST   BYTE PTR Game.BankSwitch[BX + 100h],0FFh
    JZ     @NoActivision
    CMP    BYTE PTR Game.Cart,ctPitfall2
    JNE    @NoPitfall2
    XOR    DI,2000h        { Pitfall II Game.BankSwitching is reversed }
@NoPitfall2:
    TEST   DI,2000h
    JZ     @Act1
    CMP    BYTE PTR Game.CurrentBank,0
    JNE    @Act1a
    MOV    BYTE PTR Game.BankSwitch[BX + 100h],1     { Already at 1 }
    JMP    @Act2
@Act1A:
    MOV    BYTE PTR Game.BankSwitch[BX + 100h],31    { Switching to 1 }
    JMP    @Act2

@Act1:
    CMP    BYTE PTR Game.CurrentBank,4
    JNE    @Act2a
    MOV    BYTE PTR Game.BankSwitch[BX + 100h],5     { Already at 2 }
    JMP    @Act2
@Act2a:
    MOV    BYTE PTR Game.BankSwitch[BX + 100h],30    { Switching to 2 }
@Act2:
    ADD    BX,100h
    ADD    DI,OFFSET AtariSeg
    CALL   SwitchBank
    SUB    DI,OFFSET AtariSeg
    SUB    BX,100h
@NoActivision:



    AND    DI,1FFFh          { Atari can only address 8K }
    ADD    DI,OFFSET AtariSeg
    JMP    EmulateLoop
  End; { Asm }

L21:                 { AND ind. x }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    AND    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    AND    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End;{ Asm }

L22:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L23:                 { RLA ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX

    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L24:                 { BIT zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    BL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    MOV    DL,BL
    AND    DL,CL
    JZ     @L1
    AND    CH,3Dh
    AND    BL,0C0h
    OR     CH,BL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    BL,BYTE PTR AtariSeg[BX]
    MOV    DL,BL
    AND    DL,CL
    JZ     @L1
    AND    CH,3Dh
    AND    BL,0C0h
    OR     CH,BL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    AND    CH,3Fh
    AND    BL,0C0h
    OR     CH,BL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L25:                 { AND zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    AND    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    AND    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L26:                 { ROL zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L27:                 { RLA zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L28:                 { PLP }

  Asm
    INC    DH
    MOV    BL,DH
{    MOV    BH,1}

    TEST   BYTE PTR Game.BankSwitch[BX + 100h],0FFh
    JZ     @NoSwitch
    ADD    BX,100h
    CALL   SwitchBank
    SUB    BX,100h
@NoSwitch:

    MOV    CH,BYTE PTR AtariSeg[BX]



    OR     CH,20h



    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L29:                 { AND immediate }

  Asm
    AND    CL,BYTE PTR [DI+1]
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    ADD    DI,2
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    OR     CH,02h
    JMP    EmulateLoop
  End; { Asm }

L2A:                 { ROL accum. }

  Asm
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    CL,1
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    INC    DI
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L2B:                 { ANC immediate - UNDOCUMENTED }

  Asm
    AND    CL,BYTE PTR [DI+1]
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    ADD    DI,2
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    OR     CH,02h
    JMP    EmulateLoop
  End; { Asm }

L2C:                 { BIT absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    BL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    MOV    DL,BL
    AND    DL,CL
    JZ     @L1
    AND    CH,3Dh
    AND    BL,0C0h
    OR     CH,BL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    BL,BYTE PTR AtariSeg[BX]
    MOV    DL,BL
    AND    DL,CL
    JZ     @L1
    AND    CH,3Dh
    AND    BL,0C0h
    OR     CH,BL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    AND    CH,3Fh
    AND    BL,0C0h
    OR     CH,BL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L2D:                 { AND absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    AND    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    AND    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L2E:                 { ROL absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L2F:                 { RLA absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L30:                 { BMI }

  Asm
    TEST   CH,80h
    JZ     @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
{    ADD    DI,BX
    INC    WORD PTR Game.AddCycle}
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR Game.AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR Game.AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L31:                 { AND ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    AND    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    AND    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L32:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L33:                 { RLA ind. y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX

    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:

    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L34:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L35:                 { AND z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    AND    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    AND    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L36:                 { ROL z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:

    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L37:                 { RLA z. page x - UNDOCUMENTED }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:

    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L38:                 { SEC }

  Asm
    OR     CH,01h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L39:                 { AND abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    AND    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    AND    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L3A:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L3B:                 { RLA abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX

    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:

    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L3C:                 { SKW Quasi-Opcode }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BYTE PTR Game.AddCycle,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L3D:                 { AND abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    AND    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    AND    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L3E:                 { ROL abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L3F:                 { RLA abs. x - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    RCL    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCL    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    AND    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L40:                 { RTI }

  Asm
    INC    DH
    MOV    BL,DH
{    MOV    BH,1}
    MOV    CH,BYTE PTR AtariSeg[BX]


    OR     CH,20h



    INC    BL
    MOV    DI,WORD PTR AtariSeg[BX]

    MOV    WORD PTR Game.Hi3,DI

    AND    DI,01FFFh         { Atari can only address 8K }
    ADD    DI,OFFSET AtariSeg
    ADD    DH,2
    JMP    EmulateLoop
  End; { Asm }

L41:                 { EOR ind. x }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    XOR    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    XOR    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L42:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L43:                 { SRE ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:
    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    XOR    CL,DL
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L44:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L45:                 { EOR zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,07Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    XOR    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    XOR    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L46:                 { LSR zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L47:                 { SRE zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    XOR    CL,DL
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L48:                 { PHA }

  Asm
    MOV    BL,DH
{    MOV    BH,1}

    TEST   BYTE PTR Game.BankSwitch[BX + 100h],0FFh
    JZ     @NoSwitch
    ADD    BX,100h
    CALL   SwitchBank
    SUB    BX,100h
@NoSwitch:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CL
    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    DEC    DH
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L49:                 { EOR immediate }

  Asm
    XOR    CL,BYTE PTR [DI+1]
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    ADD    DI,2
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    OR     CH,02h
    JMP    EmulateLoop
  End; { Asm }

L4A:                 { LSR accum. }

  Asm
    OR     CH,3
    SHR    CL,1
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    INC    DI
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L4B:                 { ASR immediate - UNDOCUMENTED }

  Asm
    XOR    CL,BYTE PTR [DI+1]
    OR     CH,3
    SHR    CL,1
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    ADD    DI,2
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    OR     CH,02h
    JMP    EmulateLoop
  End; { Asm }

L4C:                 { JMP absolute }

  Asm
    MOV    DI,WORD PTR [DI+1]

    MOV    WORD PTR Game.Hi3,DI

    AND    DI,1FFFh          { Atari can only address 8K }
    ADD    DI,OFFSET AtariSeg
    JMP    EmulateLoop
  End; { Asm }

L4D:                 { EOR absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    XOR    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    XOR    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L4E:                 { LSR absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    CMP    BX,1000h
    JB     @NotROM
    CMP    BYTE PTR Game.Cart,ctStarpath
    JE     @NotROM
    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JNZ    @NotROM
@ReadOnly:
    OR     CH,3
    MOV    DL,BYTE PTR AtariSeg[BX]
    SHR    DL,1
    JMP    @L3

{    ADD    DI,3
    JMP    EmulateLoop}
@NotROM:
    CMP    BX,100h
    JB     @ReadWrite
    CMP    BX,1000h
    JAE    @ReadWrite
    JMP    @ReadOnly

@ReadWrite:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
@L3:
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L4F:                 { SRE absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    XOR    CL,DL
    MOV    Dl,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L50:                 { BVC }

  Asm
    TEST   CH,040h
    JNZ    @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
{    ADD    DI,BX
    INC    WORD PTR Game.AddCycle}
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR Game.AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR Game.AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L51:                 { EOR ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    XOR    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    XOR    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L52:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L53:                 { SRE ind. y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:
    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    XOR    CL,DL
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L54:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L55:                 { EOR z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    XOR    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    XOR    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L56:                 { LSR z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L57:                 { SRE z. page x - UNDOCUMENTED }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    XOR    CL,DL
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L58:                 { CLI }

  Asm
    AND    CH,0FBh
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L59:                 { EOR abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    XOR    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    XOR    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L5A:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L5B:                 { SRE abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    XOR    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L5C:                 { SKW Quasi-Opcode }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BYTE PTR Game.AddCycle,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L5D:                 { EOR abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    XOR    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    XOR    CL,BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L5E:                 { LSR abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L5F:                 { SRE abs. x - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    OR     CH,3
    SHR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    XOR    CL,DL
    MOV    DL,CL
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L60:                 { RTS }

  Asm
    MOV    SI,DI

    INC    DH
    MOV    BL,DH
{    MOV    BH,1}



{    TEST   BYTE PTR Game.BankSwitch[BX + 100h],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:
    TEST   BYTE PTR Game.BankSwitch[BX + 101h],0FFh
    JZ     @NoSwitch1
    INC    BX
    CALL   SwitchBank
    DEC    BX
@NoSwitch1:}

    MOV    DI,WORD PTR AtariSeg[BX]
    INC    DI

    MOV    WORD PTR Game.Hi3,DI

    AND    DI,01FFFh         { Atari can only address 8K }
    ADD    DI,OFFSET AtariSeg
{
    CMP    DI,103Fh
    JA     @NoSwitch1
}
    TEST   BYTE PTR Game.BankSwitch[BX + 100h],0FFh
    JZ     @NoSwitch
    ADD    BX,100h
    PUSH   SI
    CALL   SwitchBank
    POP    SI
    SUB    BX,100h
@NoSwitch:
    TEST   BYTE PTR Game.BankSwitch[BX + 101h],0FFh
    JZ     @NoSwitch1
    ADD    BX,101h
    PUSH   SI
    CALL   SwitchBank
    POP    SI
    SUB    BX,101h
@NoSwitch1:
    INC    DH


    CMP    BYTE PTR Game.Cart,ctStarpath
    JNE    @NotStarpath
    CMP    SI,(OFFSET AtariSeg) + 1FF8h
    JNE    @NotStarpath
    CALL   HandleStarpathRTS
@NotStarpath:


    JMP    EmulateLoop
  End; { Asm }

L61:                 { ADC ind. x }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,43h{3}
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    ADC    CL,BYTE PTR Game.Input_Byte[BX]

    PUSH   AX
    LAHF
    JO     @L1
    AND    CH,0BFh
@L1:
    MOV    DL,AH
    AND    CH,7Ch
    AND    AH,81h
    SHR    DL,5
    OR     CH,AH
    AND    DL,2
    OR     CH,DL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop

{
    PUSHF
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
}
@NotCrit:
    POPF
    ADC    CL,BYTE PTR AtariSeg[BX]

    PUSH   AX
    LAHF
    JO     @L1a
    AND    CH,0BFh
@L1a:
    MOV    DL,AH
    AND    CH,7Ch
    AND    AH,81h
    SHR    DL,5
    OR     CH,AH
    AND    DL,2
    OR     CH,DL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop

{
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
}
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR Game.Input_Byte[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6a
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR AtariSeg[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L62:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L63:                 { RRA ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    MOV    SI,BX
    MOV    BL,DL
    RCR    DL,1
    MOV    BH,BL                 { Set the overflow flag  }
    XOR    BH,DL                 { V=(New OR Old) AND 40h }
    AND    BH,40h
    AND    CH,0BFh
    OR     CH,BH
    TEST   CH,8                  { See if we're in decimal mode }
    JNZ    @BCD
    ROL    BL,1                  { Set carry flag = (Old AND 80h) }
    AND    BL,1
    AND    CH,0FEh
    OR     CH,BL
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
@BCD:
    MOV    BH,BL                 { BCD fixup 1 }
    AND    BH,0Fh
    CMP    BH,4
    JLE    @BCD1
    MOV    BH,DL
    ADD    BH,6
    AND    BH,0Fh
    AND    DL,0F0h
    OR     DL,BH
@BCD1:
    AND    CH,0FEh
    CMP    BL,4Fh
    JLE    @BCD2
    ADD    DL,60h
    OR     CH,1
@BCD2:
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L64:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L65:                 { ADC zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,43h{3}
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    ADC    CL,BYTE PTR Game.Input_Byte[BX]

    PUSH   AX
    LAHF
    JO     @L1
    AND    CH,0BFh
@L1:
    MOV    DL,AH
    AND    CH,7Ch
    AND    AH,81h
    SHR    DL,5
    OR     CH,AH
    AND    DL,2
    OR     CH,DL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop
{
    PUSHF
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
}
@NotCrit:
    POPF
    ADC    CL,BYTE PTR AtariSeg[BX]

    PUSH   AX
    LAHF
    JO     @L1a
    AND    CH,0BFh
@L1a:
    MOV    DL,AH
    AND    CH,7Ch
    AND    AH,81h
    SHR    DL,5
    OR     CH,AH
    AND    DL,2
    OR     CH,DL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop
{
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
}
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR Game.Input_Byte[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6a
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR AtariSeg[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L66:                 { ROR zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    RCR    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L67:                 { RRA zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    JMP    @L4
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    MOV    SI,BX
    MOV    BL,DL
    RCR    DL,1
    MOV    BH,BL                 { Set the overflow flag  }
    XOR    BH,DL                 { V=(New OR Old) AND 40h }
    AND    BH,40h
    AND    CH,0BFh
    OR     CH,BH
    TEST   CH,8                  { See if we're in decimal mode }
    JNZ    @BCD
    ROL    BL,1                  { Set carry flag = (Old AND 80h) }
    AND    BL,1
    AND    CH,0FEh
    OR     CH,BL
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
@BCD:
    MOV    BH,BL                 { BCD fixup 1 }
    AND    BH,0Fh
    CMP    BH,4
    JLE    @BCD1
    MOV    BH,DL
    ADD    BH,6
    AND    BH,0Fh
    AND    DL,0F0h
    OR     DL,BH
@BCD1:
    AND    CH,0FEh
    CMP    BL,4Fh
    JLE    @BCD2
    ADD    DL,60h
    OR     CH,1
@BCD2:
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L68:                 { PLA }

  Asm
    INC    DH
    AND    CH,7Dh
    MOV    BL,DH
{    MOV    BH,1}

    TEST   BYTE PTR Game.BankSwitch[BX + 100h],0FFh
    JZ     @NoSwitch
    ADD    BX,100h
    CALL   SwitchBank
    SUB    BX,100h
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    INC    DI
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    INC    DI
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L69:                 { ADC immediate }

  Asm
    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    OR     CH,43h{3}
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    ADC    CL,BYTE PTR [DI+1]

    PUSH   AX
    LAHF
    JO     @L1
    AND    CH,0BFh
@L1:
    MOV    DL,AH
    AND    CH,7Ch
    AND    AH,81h
    SHR    DL,5
    OR     CH,AH
    AND    DL,2
    OR     CH,DL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop
{
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
}
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }

    MOV    DL,BYTE PTR [DI+1]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR [DI+1]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L6A:                 { ROR accum. }

  Asm
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCR    CL,1
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    CH,7Dh
    AND    DL,80h
    INC    DI
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L6B:                 { ARR immediate - UNDOCUMENTED }

  Asm
    TEST   CH,8
    JNZ    @BCD
    AND    CH,3Ch
    AND    CL,BYTE PTR [DI+1]
    RCR    CL,1
    TEST   CL,CL     { Set the zero flag }
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    DL,CL     { Set the negative flag }
    AND    DL,80h
    OR     CH,DL
    MOV    DL,CL     { Set the carry flag }
    SHR    DL,6
    AND    DL,1
    OR     CH,DL
    MOV    DL,CL     { Set the overflow flag }
    SHL    DL,1
    XOR    DL,CL
    AND    DL,40h
    OR     CH,DL
    INC    DI
    JMP    EmulateLoop
@BCD:
    AND    CH,3Ch
    MOV    DL,CL
    AND    DL,BYTE PTR [DI+1]
    MOV    BL,CH     { Set the negative flag }
    ROR    BL,1
    AND    BL,80h
    OR     CH,BL
    MOV    BH,DL     { Set the zero flag -- note that it's reversed }
    SHR    BH,1
    OR     BH,BL
    MOV    CL,BH
    TEST   CL,CL
    JZ     @L2
    OR     CH,2
@L2:
    MOV    BL,DL     { Set the overflow flag }
    XOR    BL,CL
    AND    BL,40h
    OR     CH,BL

    MOV    BH,CL     { BCD fixup 1 -- low nibble }
    MOV    BL,CL
    AND    BX,0F01h
    ADD    BL,BH
    CMP    BL,5
    JLE    @L3
    AND    CL,0F0h
    ADD    BH,6
    AND    BH,0Fh
    OR     CL,BH
@L3:
    MOV    BH,CL     { BCD fixup 2 -- high nibble }
    MOV    BL,CL
    AND    BX,0F010h
    ADD    BL,BH
    CMP    BL,50h
    JLE    @L4
    OR     CH,1
    ADD    CL,60h
@L4:
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L6C:                 { JMP indirect }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh              { Atari can only address 8K }
    CMP    BX,200h
    JAE    @NoChop
    SUB    BH,BH
@NoChop:
    MOV    DL,BYTE PTR AtariSeg[BX]
    INC    BL
    MOV    BH,BYTE PTR AtariSeg[BX]
    MOV    BL,DL
    MOV    DI,BX

    MOV    WORD PTR Game.Hi3,DI

    AND    DI,1FFFh              { Atari can only address 8K }
    ADD    DI,OFFSET AtariSeg
    JMP    EmulateLoop
  End; { Asm }

L6D:                 { ADC absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,43h{3}
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    ADC    CL,BYTE PTR Game.Input_Byte[BX]

    PUSH   AX
    LAHF
    JO     @L1
    AND    CH,0BFh
@L1:
    MOV    DL,AH
    AND    CH,7Ch
    AND    AH,81h
    SHR    DL,5
    OR     CH,AH
    AND    DL,2
    OR     CH,DL
    POP    AX
    ADD    DI,3
    JMP    EmulateLoop
{
    PUSHF
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
}
@NotCrit:
    POPF
    ADC    CL,BYTE PTR AtariSeg[BX]

    PUSH   AX
    LAHF
    JO     @L1a
    AND    CH,0BFh
@L1a:
    MOV    DL,AH
    AND    CH,7Ch
    AND    AH,81h
    SHR    DL,5
    OR     CH,AH
    AND    DL,2
    OR     CH,DL
    POP    AX
    ADD    DI,3
    JMP    EmulateLoop
{
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
}
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR Game.Input_Byte[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6a
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR AtariSeg[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L6E:                 { ROR absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    RCR    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
    CMP    BX,SWCHB1
    JNE    @L3
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
    RCR    DL,1
    JMP    @L4
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L6F:                 { RRA absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    MOV    SI,BX
    MOV    BL,DL
    RCR    DL,1
    MOV    BH,BL                 { Set the overflow flag  }
    XOR    BH,DL                 { V=(New OR Old) AND 40h }
    AND    BH,40h
    AND    CH,0BFh
    OR     CH,BH
    TEST   CH,8                  { See if we're in decimal mode }
    JNZ    @BCD
    ROL    BL,1                  { Set carry flag = (Old AND 80h) }
    AND    BL,1
    AND    CH,0FEh
    OR     CH,BL
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,3
    JMP    EmulateLoop
@BCD:
    MOV    BH,BL                 { BCD fixup 1 }
    AND    BH,0Fh
    CMP    BH,4
    JLE    @BCD1
    MOV    BH,DL
    ADD    BH,6
    AND    BH,0Fh
    AND    DL,0F0h
    OR     DL,BH
@BCD1:
    AND    CH,0FEh
    CMP    BL,4Fh
    JLE    @BCD2
    ADD    DL,60h
    OR     CH,1
@BCD2:
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L70:                 { BVS }

  Asm
    TEST   CH,40h
    JZ     @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
{    ADD    DI,BX
    INC    WORD PTR Game.AddCycle}
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR Game.AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR Game.AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L71:                 { ADC ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,43h{3}
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    ADC    CL,BYTE PTR Game.Input_Byte[BX]

    PUSH   AX
    LAHF
    JO     @L1
    AND    CH,0BFh
@L1:
    MOV    DL,AH
    AND    CH,7Ch
    AND    AH,81h
    SHR    DL,5
    OR     CH,AH
    AND    DL,2
    OR     CH,DL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop
{
    PUSHF
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
}
@NotCrit:
    POPF
    ADC    CL,BYTE PTR AtariSeg[BX]

    PUSH   AX
    LAHF
    JO     @L1a
    AND    CH,0BFh
@L1a:
    MOV    DL,AH
    AND    CH,7Ch
    AND    AH,81h
    SHR    DL,5
    OR     CH,AH
    AND    DL,2
    OR     CH,DL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop
{
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
}
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR Game.Input_Byte[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6a
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR AtariSeg[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L72:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L73:                 { RRA ind. y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    MOV    SI,BX
    MOV    BL,DL
    RCR    DL,1
    MOV    BH,BL                 { Set the overflow flag  }
    XOR    BH,DL                 { V=(New OR Old) AND 40h }
    AND    BH,40h
    AND    CH,0BFh
    OR     CH,BH
    TEST   CH,8                  { See if we're in decimal mode }
    JNZ    @BCD
    ROL    BL,1                  { Set carry flag = (Old AND 80h) }
    AND    BL,1
    AND    CH,0FEh
    OR     CH,BL
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
@BCD:
    MOV    BH,BL                 { BCD fixup 1 }
    AND    BH,0Fh
    CMP    BH,4
    JLE    @BCD1
    MOV    BH,DL
    ADD    BH,6
    AND    BH,0Fh
    AND    DL,0F0h
    OR     DL,BH
@BCD1:
    AND    CH,0FEh
    CMP    BL,4Fh
    JLE    @BCD2
    ADD    DL,60h
    OR     CH,1
@BCD2:
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L74:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L75:                 { ADC z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,43h{3}
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    ADC    CL,BYTE PTR Game.Input_Byte[BX]

    PUSH   AX
    LAHF
    JO     @L1
    AND    CH,0BFh
@L1:
    MOV    DL,AH
    AND    CH,7Ch
    AND    AH,81h
    SHR    DL,5
    OR     CH,AH
    AND    DL,2
    OR     CH,DL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop
{
    PUSHF
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
}
@NotCrit:
    POPF
    ADC    CL,BYTE PTR AtariSeg[BX]

    PUSH   AX
    LAHF
    JO     @L1a
    AND    CH,0BFh
@L1a:
    MOV    DL,AH
    AND    CH,7Ch
    AND    AH,81h
    SHR    DL,5
    OR     CH,AH
    AND    DL,2
    OR     CH,DL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop
{
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
}
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR Game.Input_Byte[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6a
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR AtariSeg[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L76:                 { ROR z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    RCR    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L77:                 { RRA z. page x - UNDOCUMENTED }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    JMP    @L4
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    MOV    SI,BX
    MOV    BL,DL
    RCR    DL,1
    MOV    BH,BL                 { Set the overflow flag  }
    XOR    BH,DL                 { V=(New OR Old) AND 40h }
    AND    BH,40h
    AND    CH,0BFh
    OR     CH,BH
    TEST   CH,8                  { See if we're in decimal mode }
    JNZ    @BCD
    ROL    BL,1                  { Set carry flag = (Old AND 80h) }
    AND    BL,1
    AND    CH,0FEh
    OR     CH,BL
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
@BCD:
    MOV    BH,BL                 { BCD fixup 1 }
    AND    BH,0Fh
    CMP    BH,4
    JLE    @BCD1
    MOV    BH,DL
    ADD    BH,6
    AND    BH,0Fh
    AND    DL,0F0h
    OR     DL,BH
@BCD1:
    AND    CH,0FEh
    CMP    BL,4Fh
    JLE    @BCD2
    ADD    DL,60h
    OR     CH,1
@BCD2:
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L78:                 { SEI }

  Asm
    OR     CH,04h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L79:                 { ADC abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,43h{3}
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    ADC    CL,BYTE PTR Game.Input_Byte[BX]

    PUSH   AX
    LAHF
    JO     @L1
    AND    CH,0BFh
@L1:
    MOV    DL,AH
    AND    CH,7Ch
    AND    AH,81h
    SHR    DL,5
    OR     CH,AH
    AND    DL,2
    OR     CH,DL
    POP    AX
    ADD    DI,3
    JMP    EmulateLoop
{
    PUSHF
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
}
@NotCrit:
    POPF
    ADC    CL,BYTE PTR AtariSeg[BX]

    PUSH   AX
    LAHF
    JO     @L1a
    AND    CH,0BFh
@L1a:
    MOV    DL,AH
    AND    CH,7Ch
    AND    AH,81h
    SHR    DL,5
    OR     CH,AH
    AND    DL,2
    OR     CH,DL
    POP    AX
    ADD    DI,3
    JMP    EmulateLoop
{
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
}
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR Game.Input_Byte[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6a
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR AtariSeg[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L7A:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L7B:                 { RRA abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    MOV    SI,BX
    MOV    BL,DL
    RCR    DL,1
    MOV    BH,BL                 { Set the overflow flag  }
    XOR    BH,DL                 { V=(New OR Old) AND 40h }
    AND    BH,40h
    AND    CH,0BFh
    OR     CH,BH
    TEST   CH,8                  { See if we're in decimal mode }
    JNZ    @BCD
    ROL    BL,1                  { Set carry flag = (Old AND 80h) }
    AND    BL,1
    AND    CH,0FEh
    OR     CH,BL
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,3
    JMP    EmulateLoop
@BCD:
    MOV    BH,BL                 { BCD fixup 1 }
    AND    BH,0Fh
    CMP    BH,4
    JLE    @BCD1
    MOV    BH,DL
    ADD    BH,6
    AND    BH,0Fh
    AND    DL,0F0h
    OR     DL,BH
@BCD1:
    AND    CH,0FEh
    CMP    BL,4Fh
    JLE    @BCD2
    ADD    DL,60h
    OR     CH,1
@BCD2:
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }


L7C:                 { SKW Quasi-Opcode }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BYTE PTR Game.AddCycle,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L7D:                 { ADC abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,43h{3}
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    ADC    CL,BYTE PTR Game.Input_Byte[BX]

    PUSH   AX
    LAHF
    JO     @L1
    AND    CH,0BFh
@L1:
    MOV    DL,AH
    AND    CH,7Ch
    AND    AH,81h
    SHR    DL,5
    OR     CH,AH
    AND    DL,2
    OR     CH,DL
    POP    AX
    ADD    DI,3
    JMP    EmulateLoop
{
    PUSHF
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
}
@NotCrit:
    POPF
    ADC    CL,BYTE PTR AtariSeg[BX]
    PUSH   AX
    LAHF
    JO     @L1a
    AND    CH,0BFh
@L1a:
    MOV    DL,AH
    AND    CH,7Ch
    AND    AH,81h
    SHR    DL,5
    OR     CH,AH
    AND    DL,2
    OR     CH,DL
    POP    AX
    ADD    DI,3
    JMP    EmulateLoop

{
    PUSHF
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
}
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR Game.Input_Byte[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6a
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   ADC_BCD
(*
    ADC    AL,BYTE PTR AtariSeg[BX]
    DAA
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JNC    @L6
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L7E:                 { ROR abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    RCR    DL,1
    JC     @L2a
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    RCR    BYTE PTR AtariSeg[BX],1
    MOV    DL,BYTE PTR AtariSeg[BX]
    JC     @L2
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L7F:                 { RRA abs. x - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    MOV    SI,BX
    MOV    BL,DL
    RCR    DL,1
    MOV    BH,BL                 { Set the overflow flag  }
    XOR    BH,DL                 { V=(New OR Old) AND 40h }
    AND    BH,40h
    AND    CH,0BFh
    OR     CH,BH
    TEST   CH,8                  { See if we're in decimal mode }
    JNZ    @BCD
    ROL    BL,1                  { Set carry flag = (Old AND 80h) }
    AND    BL,1
    AND    CH,0FEh
    OR     CH,BL
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,3
    JMP    EmulateLoop
@BCD:
    MOV    BH,BL                 { BCD fixup 1 }
    AND    BH,0Fh
    CMP    BH,4
    JLE    @BCD1
    MOV    BH,DL
    ADD    BH,6
    AND    BH,0Fh
    AND    DL,0F0h
    OR     DL,BH
@BCD1:
    AND    CH,0FEh
    CMP    BL,4Fh
    JLE    @BCD2
    ADD    DL,60h
    OR     CH,1
@BCD2:
    MOV    BYTE PTR AtariSeg[SI],DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L80:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L81:                 { STA ind. x }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh        { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    JMP    @NotTimer
@NotTIA:
    CMP    BX,400h
    JAE    @NotTimer
    CMP    BX,200h
    JB     @NotTimer
    AND    BX,29Fh
    OR     BL,80h
    MOV    BL,BYTE PTR Timer_And[BX - 280h];
@NotTimer:

    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L82:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L83:                 { SAX ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh        { Atari can only address 8K }
    MOV    DL,CL
    AND    DL,AL

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],DL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L84:                 { STY zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    BYTE PTR AtariSeg[BX],AH

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    BYTE PTR AtariSeg[BX],AH

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch1
    CALL   SwitchBank
@NoSwitch1:

    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L85:                 { STA zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch1
    CALL   SwitchBank
@NoSwitch1:

    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L86:                 { STX zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    BYTE PTR AtariSeg[BX],AL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    BYTE PTR AtariSeg[BX],AL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch1
    CALL   SwitchBank
@NoSwitch1:

    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L87:                 { SAX zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    DL,CL
    AND    DL,AL
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    BYTE PTR AtariSeg[BX],DL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    BYTE PTR AtariSeg[BX],DL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch1
    CALL   SwitchBank
@NoSwitch1:

    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L88:                 { DEY }

  Asm
    DEC    AH
    JZ     @L1
    MOV    DL,AH
    AND    CH,7Dh
    AND    DL,80h
    INC    DI
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    OR     CH,2
    JMP    EmulateLoop
  End; { Asm }

L89:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L8A:                 { TXA }

  Asm
    MOV    CL,AL
    OR     BH,AL   { BH = 0 at start }
    JZ     @L1
    AND    BH,80h
    AND    CH,7Dh
    ADD    CH,BH
    INC    DI
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    OR     CH,2
    JMP    EmulateLoop
  End; { Asm }

L8B:                 { ANE immediate - UNDOCUMENTED }

  Asm
    OR     CL,0EEh
    AND    CL,AL
    AND    CL,BYTE PTR [DI+1]
    AND    CH,7Dh
    OR     BH,CL
    JZ     @L1
    AND    BH,80h
    ADD    DI,2
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L8C:                 { STY absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    CMP    BX,400h
    JAE    @NotTimer
    CMP    BX,200h
    JB     @NotTimer
    AND    BX,29Fh
    OR     BL,80h
    MOV    BL,BYTE PTR Timer_And[BX - 280h];
@NotTimer:
    MOV    BYTE PTR AtariSeg[BX],AH

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L8D:                 { STA absolute }
  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    JMP    @NotTimer
@NotTIA:
    CMP    BX,400h
    JAE    @NotTimer
    CMP    BX,200h
    JB     @NotTimer
    AND    BX,29Fh
    OR     BL,80h
    MOV    BL,BYTE PTR Timer_And[BX - 280h];
@NotTimer:

    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L8E:                 { STX absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    CMP    BX,400h
    JAE    @NotTimer
    CMP    BX,200h
    JB     @NotTimer
    AND    BX,29Fh
    OR     BL,80h
    MOV    BL,BYTE PTR Timer_And[BX - 280h];
@NotTimer:
    MOV    BYTE PTR AtariSeg[BX],AL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L8F:                 { SAX absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }
    MOV    DL,CL
    AND    DL,AL

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],DL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L90:                 { BCC }

  Asm
    TEST   CH,01
    JNZ    @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
{    ADD    DI,BX
    INC    WORD PTR Game.AddCycle}
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR Game.AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR Game.AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L91:                 { STA ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
{    ADC    BH,0}
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    JMP    @NotTimer
@NotTIA:
    CMP    BX,400h
    JAE    @NotTimer
    CMP    BX,200h
    JB     @NotTimer
    AND    BX,29Fh
    OR     BL,80h
    MOV    BL,BYTE PTR Timer_And[BX - 280h];
@NotTimer:

    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L92:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L93:                 { SHA ind. y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    MOV    DL,BH
    INC    DL
    AND    DL,AL
    AND    DL,CL
    JNC    @L1
    INC    BYTE PTR Game.AddCycle
    MOV    BH,DL
@L1:
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L94:                 { STY z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],AH
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L95:                 { STA z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CL
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L96:                 { STX z. page y }

  Asm
    MOV    BL,AH
    ADD    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],AL
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L97:                 { SAX z. page y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AH
    MOV    DL,CL
    AND    DL,AL
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    CMP    BX,02Ch
    JA     @NotCrit
    MOV    BYTE PTR AtariSeg[BX],DL
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    BYTE PTR AtariSeg[BX],DL
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L98:                 { TYA }

  Asm
    MOV    CL,AH
    OR     BH,AH   { BH = 0 at start }
    JZ     @L1
    AND    BH,80h
    AND    CH,7Dh
    ADD    CH,BH
    INC    DI
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    OR     CH,2
    JMP    EmulateLoop
  End; { Asm }

L99:                 { STA abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    CMP    BX,1000h
    JB     @NotROM
    CMP    BYTE PTR Game.Cart,ctStarpath
    JE     @NotROM
    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JNZ    @NotROM
    ADD    DI,3
    JMP    EmulateLoop
@NotROM:

    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    JMP    @NotTimer
@NotTIA:
    CMP    BX,400h
    JAE    @NotTimer
    CMP    BX,200h
    JB     @NotTimer
    AND    BX,29Fh
    OR     BL,80h
    MOV    BL,BYTE PTR Timer_And[BX - 280h];
@NotTimer:

    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L9A:                 { TXS }

  Asm
    MOV    DH,AL
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

L9B:                 { SHS ind. y - UNDOCUMENTED }

  Asm
    MOV    DH,AL
    AND    DH,CL
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    MOV    DL,BH
    INC    DL
    AND    DL,DH
    JNC    @L1
    INC    BYTE PTR Game.AddCycle
    MOV    BH,DL
@L1:
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

L9C:                 { SHY abs. x - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    MOV    DL,BH
    INC    DL
    AND    DL,AH
    JNC    @L1
    INC    BYTE PTR Game.AddCycle
    MOV    BH,DL
@L1:
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L9D:                 { STA abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    JMP    @NotTimer
@NotTIA:
    CMP    BX,400h
    JAE    @NotTimer
    CMP    BX,200h
    JB     @NotTimer
    AND    BX,29Fh
    OR     BL,80h
    MOV    BL,BYTE PTR Timer_And[BX - 280h];
@NotTimer:

    CMP    BX,1000h
    JB     @NotROM
    CMP    BYTE PTR Game.Cart,ctStarpath
    JE     @NotROM
    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JNZ    @NotROM
    ADD    DI,3
    JMP    EmulateLoop
@NotROM:

    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L9E:                 { SHX abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    MOV    DL,BH
    INC    DL
    AND    DL,AL
    JNC    @L1
    INC    BYTE PTR Game.AddCycle
    MOV    BH,DL
@L1:
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

L9F:                 { SHA abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    MOV    DL,BH
    INC    DL
    AND    DL,AL
    AND    DL,CL
    JNC    @L1
    INC    BYTE PTR Game.AddCycle
    MOV    BH,DL
@L1:
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
@NotTIA:
    MOV    BYTE PTR AtariSeg[BX],CL

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   BX,0FC00h
    JNZ    @NotCrit
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
@NotCrit:
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LA0:                 { LDY immediate }

  Asm
    MOV    AH,BYTE PTR [DI+1]
    AND    CH,7Dh
    OR     BH,AH
    JZ     @L1
    AND    BH,80h
    ADD    DI,2
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA1:                 { LDA ind. x }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA2:                 { LDX immediate }

  Asm
    MOV    AL,BYTE PTR [DI+1]
    AND    CH,7Dh
    OR     BH,AL
    JZ     @L1
    AND    BH,80h
    ADD    DI,2
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA3:                 { LAX ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,CL

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    MOV    AL,CL
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA4:                 { LDY zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AH,BYTE PTR Game.Input_Byte[BX]

    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    AH,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA5:                 { LDA zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA6:                 { LDX zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,BYTE PTR Game.Input_Byte[BX]

    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    AL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA7:                 { LAX zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,CL

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    MOV    AL,CL
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LA8:                 { TAY }

  Asm
    MOV    AH,CL
    AND    CH,7Dh
    OR     BH,AH
    JZ     @L1
    AND    BH,80h
    INC    DI
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LA9:                 { LDA immediate }

  Asm
    MOV    CL,BYTE PTR [DI+1]
    AND    CH,7Dh
    OR     BH,CL
    JZ     @L1
    AND    BH,80h
    ADD    DI,2
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LAA:                 { TAX }

  Asm
    MOV    AL,CL
    AND    CH,7Dh
    OR     BH,AL
    JZ     @L1
    AND    BH,80h
    INC    DI
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LAB:                 { LXA immed + a - UNDOCUMENTED }

  Asm
    ADD    CL,BYTE PTR [DI+1]
    MOV    AL,CL
    AND    CH,7Dh
    OR     BH,CL
    JZ     @L1
    AND    BH,80h
    ADD    DI,2
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LAC:                 { LDY absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AH,BYTE PTR Game.Input_Byte[BX]

    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    AH,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LAD:                 { LDA absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LAE:                 { LDX absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,BYTE PTR Game.Input_Byte[BX]

    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    AL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LAF:                 { LAX absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,CL

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    MOV    AL,CL
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LB0:                 { BCS }

  Asm
    TEST   CH,01
    JZ     @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
{    ADD    DI,BX
    INC    WORD PTR Game.AddCycle}
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR Game.AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR Game.AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LB1:                 { LDA ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    PUSHF
    ADC    BH,0
    POPF
    ADC    WORD PTR Game.AddCycle,0
{    ADC    WORD PTR Game.AddCycle,0
    ADD    BH,BYTE PTR Game.AddCycle}
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LB2:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LB3:                 { LAX ind. y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    PUSHF
    ADC    BH,0
    POPF
    ADC    WORD PTR Game.AddCycle,0
{    ADC    WORD PTR Game.AddCycle,0
    ADD    BH,BYTE PTR Game.AddCycle}
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,CL

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    MOV    AL,CL
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LB4:                 { LDY z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AH,BYTE PTR Game.Input_Byte[BX]

    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    AH,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LB5:                 { LDA z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LB6:                 { LDX z. page y }

  Asm
    MOV    BL,AH
    ADD    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,BYTE PTR Game.Input_Byte[BX]

    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    AL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LB7:                 { LAX z. page y - UNDOCUMENTED }

  Asm
    MOV    BL,AH
    ADD    BL,BYTE PTR [DI+1]
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,CL

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    MOV    AL,CL
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LB8:                 { CLV }

  Asm
    AND    CH,0BFh
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LB9:                 { LDA abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LBA:                 { TSX }

  Asm
    MOV    AL,DH
    AND    CH,7Dh
    OR     BH,AL
    JZ     @L1
    AND    BH,80h
    INC    DI
    ADD    CH,BH
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LBB:                 { LAS (abs. y) and s - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX
    AND    CL,DH
    MOV    AL,CL
    MOV    DH,CL

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LBC:                 { LDY abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AH,BYTE PTR Game.Input_Byte[BX]

    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    AH,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AH,AH
    JZ     @L1
    MOV    DL,AH
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LBD:                 { LDA abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LBE:                 { LDX abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,BYTE PTR Game.Input_Byte[BX]

    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    AL,BYTE PTR AtariSeg[BX]
    AND    CH,7Dh
    OR     AL,AL
    JZ     @L1
    MOV    DL,AL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LBF:                 { LAX abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    MOV    CL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    DX
    POP    AX
    MOV    AL,CL

    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    MOV    CL,BYTE PTR AtariSeg[BX]
    MOV    AL,CL
    AND    CH,7Dh
    OR     CL,CL
    JZ     @L1
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LC0:                 { CPY immediate }

  Asm
    MOV    DL,AH
    OR     CH,3
    SUB    DL,BYTE PTR [DI+1]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC1:                 { CMP ind. x }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC2:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC3:                 { DCP ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    DEC    BYTE PTR Game.Input_Byte[BX]
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC4:                 { CPY zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,AH
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC5:                 { CMP zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC6:                 { DEC zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    POP    BX
    DEC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    DEC    BYTE PTR AtariSeg[BX]
@Continue:
    PUSHF
    CMP    BX,02Ch
    JA     @NotCrit
    PUSH   BX
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    POP    BX
@NotCrit:
    POPF
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC7:                 { DCP zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    DEC    BYTE PTR Game.Input_Byte[BX]
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LC8:                 { INY }

  Asm
    INC    AH
    JZ     @L1
    MOV    DL,AH
    AND    CH,7Dh
    AND    DL,80h
    INC    DI
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    OR     CH,2
    JMP    EmulateLoop
  End; { Asm }

LC9:                 { CMP immediate }

  Asm
    MOV    DL,CL
    OR     CH,3
    SUB    DL,BYTE PTR [DI+1]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LCA:                 { DEX }

  Asm
    DEC    AL
    JZ     @L1
    MOV    DL,AL
    AND    CH,7Dh
    AND    DL,80h
    INC    DI
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    OR     CH,2
    JMP    EmulateLoop
  End; { Asm }

LCB:                 { SBX immediate - UNDOCUMENTED }

  Asm
    MOV    DL,CL
    AND    DL,AL
    OR     CH,3
    SUB    DL,BYTE PTR [DI+1]
    MOV    AL,DL
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LCC:                 { CPY absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,AH
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LCD:                 { CMP absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LCE:                 { DEC absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    POP    BX
    DEC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    DEC    BYTE PTR AtariSeg[BX]
@Continue:
    PUSHF
    TEST   BX,0FC00h
    JNZ    @NotCrit
    PUSH   BX
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    POP    BX
@NotCrit:
    POPF
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LCF:                 { DCP absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    DEC    BYTE PTR Game.Input_Byte[BX]
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LD0:                 { BNE }

  Asm
    TEST   CH,02
    JNZ    @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
{    ADD    DI,BX
    INC    WORD PTR Game.AddCycle}
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR Game.AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR Game.AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LD1:                 { CMP ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    PUSHF
    ADC    BH,0
    POPF
    ADC    WORD PTR Game.AddCycle,0
{    ADC    WORD PTR Game.AddCycle,0
    ADD    BH,BYTE PTR Game.AddCycle}
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LD2:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LD3:                 { DCP ind. y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    PUSHF
    ADC    BH,0
    POPF
    ADC    WORD PTR Game.AddCycle,0
{    ADC    WORD PTR Game.AddCycle,0
    ADD    BH,BYTE PTR Game.AddCycle}
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    DEC    BYTE PTR Game.Input_Byte[BX]
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LD4:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LD5:                 { CMP z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LD6:                 { DEC z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    POP    BX
    DEC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    DEC    BYTE PTR AtariSeg[BX]
@Continue:
    PUSHF
    CMP    BX,02Ch
    JA     @NotCrit
    PUSH   BX
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    POP    BX
@NotCrit:
    POPF
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LD7:                 { DCP z. page x - UNDOCUMENTED }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    DEC    BYTE PTR Game.Input_Byte[BX]
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LD8:                 { CLD }

  Asm
    AND    CH,0F7h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LD9:                 { CMP abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LDA:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LDB:                 { DCP abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    DEC    BYTE PTR Game.Input_Byte[BX]
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LDC:                 { SKW Quasi-Opcode }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BYTE PTR Game.AddCycle,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LDD:                 { CMP abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LDE:                 { DEC abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    TEST   BX,0FC00h
    JNZ    @NotCrit
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    POP    BX
    DEC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    DEC    BYTE PTR AtariSeg[BX]
@Continue:
    JZ     @L1a
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1a:
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LDF:                 { DCP abs. x - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,CL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    DEC    BYTE PTR Game.Input_Byte[BX]
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    DEC    BYTE PTR AtariSeg[BX]
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LE0:                 { CPX immediate }

  Asm
    MOV    DL,AL
    OR     CH,3
    SUB    DL,BYTE PTR [DI+1]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE1:                 { SBC ind. x }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    SBB    CL,BYTE PTR Game.Input_Byte[BX]
    PUSHF
    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    POPF
    SBB    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF


    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    CALL   SBC_BCD

(*
    SBB    AL,BYTE PTR Game.Input_Byte[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6a              { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   SBC_BCD

(*
    SBB    AL,BYTE PTR AtariSeg[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE2:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE3:                 { ISB ind. x - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    ADD    BL,AL
    MOV    BX,WORD PTR AtariSeg[BX]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    AND    CH,03Ch         { Turn sign, overflow, and zero bits off }
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    PUSH   AX
    SUB    AX,AX

    MOV    AL,CL
    SUB    AL,DL
    SBB    AH,0
    MOV    BL,CH
    AND    BL,1
    XOR    BL,1
    SUB    AL,BL
    SBB    AH,0
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    BL,AL
    AND    BL,80h
    OR     CH,BL

    MOV    BL,AL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    MOV    BL,DL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    OR     CH,40h
@L2:
    TEST   CH,8
    JZ     @NotBCD

    PUSH   CX
    MOV    BL,CL
    AND    BL,0Fh
    AND    CH,1
    ADD    BL,CH
    MOV    CH,DL
    AND    CH,0Fh
    CMP    BL,CH
    JGE    @L5
    SUB    AX,6
@L5:
    POP    CX
    CMP    AX,99h
    JLE    @NotBCD
    SUB    AX,60h
@NotBCD:
    TEST   AH,AH
    JNZ    @L6
    OR     CH,1
@L6:
    MOV    CL,AL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE4:                 { CPX zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,AL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE5:                 { SBC zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    SBB    CL,BYTE PTR Game.Input_Byte[BX]
    PUSHF
    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    POPF
    SBB    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    CALL   SBC_BCD

(*
    SBB    AL,BYTE PTR Game.Input_Byte[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6a              { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR AtariSeg[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE6:                 { INC zero page }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    POP    BX
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    INC    BYTE PTR AtariSeg[BX]
@Continue:
    PUSHF
    CMP    BX,02Ch
    JA     @NotCrit
    PUSH   BX
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    POP    BX
@NotCrit:
    POPF
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE7:                 { ISB zero page - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    AND    CH,03Ch         { Turn sign, overflow, and zero bits off }
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    PUSH   AX
    SUB    AX,AX

    MOV    AL,CL
    SUB    AL,DL
    SBB    AH,0
    MOV    BL,CH
    AND    BL,1
    XOR    BL,1
    SUB    AL,BL
    SBB    AH,0
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    BL,AL
    AND    BL,80h
    OR     CH,BL

    MOV    BL,AL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    MOV    BL,DL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    OR     CH,40h
@L2:
    TEST   CH,8
    JZ     @NotBCD

    PUSH   CX
    MOV    BL,CL
    AND    BL,0Fh
    AND    CH,1
    ADD    BL,CH
    MOV    CH,DL
    AND    CH,0Fh
    CMP    BL,CH
    JGE    @L5
    SUB    AX,6
@L5:
    POP    CX
    CMP    AX,99h
    JLE    @NotBCD
    SUB    AX,60h
@NotBCD:
    TEST   AH,AH
    JNZ    @L6
    OR     CH,1
@L6:
    MOV    CL,AL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LE8:                 { INX }

  Asm
    INC    AL
    JZ     @L1
    MOV    DL,AL
    AND    CH,7Dh
    AND    DL,80h
    INC    DI
    ADD    CH,DL
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    INC    DI
    OR     CH,2
    JMP    EmulateLoop
  End; { Asm }

LE9:                 { SBC immediate }
  Asm
    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    OR     CH,3
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    SBB    CL,BYTE PTR [DI+1]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }

    MOV    DL,BYTE PTR [DI+1]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR [DI+1]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LEA:                 { NOP }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LEB:                 { SBC immediate - UNDOCUMENTED }

  Asm
    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    OR     CH,3
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    SBB    CL,BYTE PTR [DI+1]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }

    MOV    DL,BYTE PTR [DI+1]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR [DI+1]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LEC:                 { CPX absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    MOV    DL,AL
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    PUSH   DX
    CALL   Handle_TIA
    POP    DX
    POP    CX
    POP    BX
    SUB    DL,BYTE PTR Game.Input_Byte[BX]
    POP    DI
    POP    AX

    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    SUB    DL,BYTE PTR AtariSeg[BX]
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     DL,DL
    JZ     @L1
    AND    CH,7Dh
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LED:                 { SBC absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    SBB    CL,BYTE PTR Game.Input_Byte[BX]
    PUSHF
    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    POPF
    SBB    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR Game.Input_Byte[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6a              { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR AtariSeg[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LEE:                 { INC absolute }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    CMP    BX,1000h
    JB     @NotROM
    CMP    BYTE PTR Game.Cart,ctStarpath
    JE     @NotROM
    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JNZ    @NotROM
    ADD    DI,3
    JMP    EmulateLoop
@NotROM:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    POP    BX
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    INC    BYTE PTR AtariSeg[BX]
@Continue:
    PUSHF
    TEST   BX,0FC00h
    JNZ    @NotCrit
    PUSH   BX
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    POP    BX
@NotCrit:
    POPF
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,2
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LEF:                 { ISB absolute - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    AND    CH,03Ch         { Turn sign, overflow, and zero bits off }
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    PUSH   AX
    SUB    AX,AX

    MOV    AL,CL
    SUB    AL,DL
    SBB    AH,0
    MOV    BL,CH
    AND    BL,1
    XOR    BL,1
    SUB    AL,BL
    SBB    AH,0
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    BL,AL
    AND    BL,80h
    OR     CH,BL

    MOV    BL,AL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    MOV    BL,DL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    OR     CH,40h
@L2:
    TEST   CH,8
    JZ     @NotBCD

    PUSH   CX
    MOV    BL,CL
    AND    BL,0Fh
    AND    CH,1
    ADD    BL,CH
    MOV    CH,DL
    AND    CH,0Fh
    CMP    BL,CH
    JGE    @L5
    SUB    AX,6
@L5:
    POP    CX
    CMP    AX,99h
    JLE    @NotBCD
    SUB    AX,60h
@NotBCD:
    TEST   AH,AH
    JNZ    @L6
    OR     CH,1
@L6:
    MOV    CL,AL
    POP    AX
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LF0:                 { BEQ }

  Asm
    TEST   CH,02
    JZ     @L1
    DB     0Fh,0BEh,05Dh,01h    { MOVSX BX,BYTE PTR [DI+1] }
    ADD    DI,2
{    ADD    DI,BX
    INC    WORD PTR Game.AddCycle}
    PUSH   AX
    SUB    DI,OFFSET AtariSeg
    MOV    AX,DI
    ADD    DI,BX
    INC    WORD PTR Game.AddCycle
    MOV    BX,DI
    ADD    DI,OFFSET AtariSeg
    CMP    BH,AH
    JE     @L2
    INC    WORD PTR Game.AddCycle
  @L2:
    POP    AX
    JMP    EmulateLoop
  @L1:
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LF1:                 { SBC ind. y }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    PUSHF
    ADC    BH,0
    POPF
    ADC    WORD PTR Game.AddCycle,0
{    ADC    WORD PTR Game.AddCycle,0
    ADD    BH,BYTE PTR Game.AddCycle}
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    SBB    CL,BYTE PTR Game.Input_Byte[BX]
    PUSHF
    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    POPF
    SBB    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR Game.Input_Byte[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6a              { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR AtariSeg[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LF2:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LF3:                 { ISB ind. Y - UNDOCUMENTED }

  Asm
    MOV    BL,BYTE PTR [DI+1]
    MOV    BX,WORD PTR AtariSeg[BX]
    ADD    BL,AH
    PUSHF
    ADC    BH,0
    POPF
    ADC    WORD PTR Game.AddCycle,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    AND    CH,03Ch         { Turn sign, overflow, and zero bits off }
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    PUSH   AX
    SUB    AX,AX

    MOV    AL,CL
    SUB    AL,DL
    SBB    AH,0
    MOV    BL,CH
    AND    BL,1
    XOR    BL,1
    SUB    AL,BL
    SBB    AH,0
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    BL,AL
    AND    BL,80h
    OR     CH,BL

    MOV    BL,AL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    MOV    BL,DL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    OR     CH,40h
@L2:
    TEST   CH,8
    JZ     @NotBCD

    PUSH   CX
    MOV    BL,CL
    AND    BL,0Fh
    AND    CH,1
    ADD    BL,CH
    MOV    CH,DL
    AND    CH,0Fh
    CMP    BL,CH
    JGE    @L5
    SUB    AX,6
@L5:
    POP    CX
    CMP    AX,99h
    JLE    @NotBCD
    SUB    AX,60h
@NotBCD:
    TEST   AH,AH
    JNZ    @L6
    OR     CH,1
@L6:
    MOV    CL,AL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LF4:                 { SKB Quasi-Opcode }

  Asm
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LF5:                 { SBC z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    SBB    CL,BYTE PTR Game.Input_Byte[BX]
    PUSHF
    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit:
    POPF
    SBB    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,2
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR Game.Input_Byte[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6a              { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR AtariSeg[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LF6:                 { INC z. page x }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]
    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    POP    BX
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    INC    BYTE PTR AtariSeg[BX]
@Continue:
    PUSHF
    CMP    BX,02Ch
    JA     @NotCrit
    PUSH   BX
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    POP    BX
@NotCrit:
    POPF
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,2
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LF7:                 { ISB z. page x - UNDOCUMENTED }

  Asm
    MOV    BL,AL
    ADD    BL,BYTE PTR [DI+1]

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    AND    CH,03Ch         { Turn sign, overflow, and zero bits off }
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    PUSH   AX
    SUB    AX,AX

    MOV    AL,CL
    SUB    AL,DL
    SBB    AH,0
    MOV    BL,CH
    AND    BL,1
    XOR    BL,1
    SUB    AL,BL
    SBB    AH,0
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    BL,AL
    AND    BL,80h
    OR     CH,BL

    MOV    BL,AL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    MOV    BL,DL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    OR     CH,40h
@L2:
    TEST   CH,8
    JZ     @NotBCD

    PUSH   CX
    MOV    BL,CL
    AND    BL,0Fh
    AND    CH,1
    ADD    BL,CH
    MOV    CH,DL
    AND    CH,0Fh
    CMP    BL,CH
    JGE    @L5
    SUB    AX,6
@L5:
    POP    CX
    CMP    AX,99h
    JLE    @NotBCD
    SUB    AX,60h
@NotBCD:
    TEST   AH,AH
    JNZ    @L6
    OR     CH,1
@L6:
    MOV    CL,AL
    POP    AX
    ADD    DI,2
    JMP    EmulateLoop
  End; { Asm }

LF8:                 { SED }

  Asm
    OR     CH,08h
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LF9:                 { SBC abs. y }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF
    SBB    CL,BYTE PTR Game.Input_Byte[BX]
    PUSHF
    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
    POPF
    SBB    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  @BCD:
{     INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR Game.Input_Byte[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6a              { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR AtariSeg[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LFA:                 { Nothing }

  Asm
    INC    DI
    JMP    EmulateLoop
  End; { Asm }

LFB:                 { ISB abs. y - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AH
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    AND    CH,03Ch         { Turn sign, overflow, and zero bits off }
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    PUSH   AX
    SUB    AX,AX

    MOV    AL,CL
    SUB    AL,DL
    SBB    AH,0
    MOV    BL,CH
    AND    BL,1
    XOR    BL,1
    SUB    AL,BL
    SBB    AH,0
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    BL,AL
    AND    BL,80h
    OR     CH,BL

    MOV    BL,AL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    MOV    BL,DL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    OR     CH,40h
@L2:
    TEST   CH,8
    JZ     @NotBCD

    PUSH   CX
    MOV    BL,CL
    AND    BL,0Fh
    AND    CH,1
    ADD    BL,CH
    MOV    CH,DL
    AND    CH,0Fh
    CMP    BL,CH
    JGE    @L5
    SUB    AX,6
@L5:
    POP    CX
    CMP    AX,99h
    JLE    @NotBCD
    SUB    AX,60h
@NotBCD:
    TEST   AH,AH
    JNZ    @L6
    OR     CH,1
@L6:
    MOV    CL,AL
    POP    AX
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LFC:                 { SKW Quasi-Opcode }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BYTE PTR Game.AddCycle,DL
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LFD:                 { SBC abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    DB     0Fh,92h,0C2h              { SETC DL }
    ADD    BH,DL
    ADD    BYTE PTR Game.AddCycle,DL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,284h           { There are multiple timer copies }
    JB     @NotPIA
    CMP    BX,400h
    JAE    @NotPIA
    AND    BX,285h

    CALL   Handle_Timer

@NotPIA:
    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    TEST   CH,8
    JNZ    @BCD
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    SBB    CL,0
{    PUSHF}
    OR     CH,3
    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

{    POPF}
    SUB    CL,BYTE PTR Game.Input_Byte[BX]
    PUSHF
    JNC    @L2a              { Note the difference! }
    AND    CH,0FEh
  @L2a:
    OR     CH,40h
    POPF
    JO     @L4a
    AND    CH,0BFh
  @L4a:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit:
{    POPF}
    SUB    CL,BYTE PTR AtariSeg[BX]
    PUSHF
    JNC    @L2               { Note the difference! }
    AND    CH,0FEh
  @L2:
    OR     CH,40h
    POPF
    JO     @L4
    AND    CH,0BFh
  @L4:
    OR     CL,CL
    JZ     @L1
    AND    CH,7Dh
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    AND    CH,7Fh
    ADD    DI,3
    JMP    EmulateLoop
  @BCD:
{    INC    WORD PTR Game.AddCycle}

{    PUSH   AX
    MOV    AL,CL}
    MOV    DL,CH
    XOR    DL,1
    DB     0C0h,0EAh,1       { SHR   DL,imm8 is only 2 cycles on 486 }
    PUSHF
    CMP    BX,80h
    JAE    @NotCrit1
    AND    BX,0Fh

    PUSH   AX
    PUSH   BX
    PUSH   CX
    PUSH   DX
    PUSH   DI
    CALL   Handle_TIA
    POP    DI
    POP    DX
    POP    CX
    POP    BX
    POP    AX

    POPF

    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR Game.Input_Byte[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6a              { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6a:
    JNO    @L7a
    OR     CH,40h
  @L7a:
    OR     CL,CL
    JNZ    @L8a
    OR     CH,2
  @L8a:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
@NotCrit1:
    POPF

    MOV    DL,BYTE PTR AtariSeg[BX]
    CALL   SBC_BCD
(*
    SBB    AL,BYTE PTR AtariSeg[BX]
    DAS
    MOV    CL,AL
    POP    AX
    PUSHF
    AND    CH,03Ch
    POPF
    JC     @L6               { Note the difference! }
    PUSHF
    OR     CH,1
    POPF
  @L6:
    JNO    @L7
    OR     CH,40h
  @L7:
    OR     CL,CL
    JNZ    @L8
    OR     CH,2
  @L8:
    MOV    DL,CL
    AND    DL,80h
    ADD    CH,DL
*)
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LFE:                 { INC abs. x }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    ADC    BH,0
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    AND    CH,7Dh
    CMP    BX,80h
    JAE    @NotTIA
    MOV    BL,BYTE PTR TIA_And[BX]
    PUSH   BX
    AND    BX,0Fh
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    POP    BX
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    JMP    @Continue
@NotTIA:
    INC    BYTE PTR AtariSeg[BX]
@Continue:
    PUSHF
    TEST   BX,0FC00h
    JNZ    @NotCrit
    PUSH   BX
    MOV    WORD PTR Game.Save_BX,BX
    CALL   Handle_IO
    POP    BX
@NotCrit:
    POPF
    JZ     @L1
    MOV    DL,BYTE PTR AtariSeg[BX]
    AND    DL,80h
    ADD    CH,DL
    ADD    DI,3
    JMP    EmulateLoop
  @L1:
    OR     CH,02h
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

LFF:                 { ISB abs. X - UNDOCUMENTED }

  Asm
    MOV    BX,WORD PTR [DI+1]
    ADD    BL,AL
    AND    BX,1FFFh          { Atari can only address 8K }

    CMP    BX,200h
    JAE    @NotStack
    SUB    BH,BH
@NotStack:

    TEST   BYTE PTR Game.BankSwitch[BX],0FFh
    JZ     @NoSwitch
    CALL   SwitchBank
@NoSwitch:

    CMP    BX,80h
    JAE    @NotCrit
    AND    BX,0Fh
    PUSH   AX
    PUSH   DX
    PUSH   DI
    PUSH   BX
    PUSH   CX
    CALL   Handle_TIA
    POP    CX
    POP    BX
    POP    DI
    POP    DX
    POP    AX
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR Game.Input_Byte[BX]
    JMP    @L4
@NotCrit:
    CMP    BX,400h
    JAE    @L3
    AND    BX,2FFh
  @L3:
    MOV    DL,CH
    OR     CH,3
    SHR    DL,1
    MOV    DL,BYTE PTR AtariSeg[BX]
  @L4:
    AND    CH,03Ch         { Turn sign, overflow, and zero bits off }
    INC    DL
    MOV    BYTE PTR AtariSeg[BX],DL
    PUSH   AX
    SUB    AX,AX

    MOV    AL,CL
    SUB    AL,DL
    SBB    AH,0
    MOV    BL,CH
    AND    BL,1
    XOR    BL,1
    SUB    AL,BL
    SBB    AH,0
    JNZ    @L1
    OR     CH,2
@L1:
    MOV    BL,AL
    AND    BL,80h
    OR     CH,BL

    MOV    BL,AL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    MOV    BL,DL
    XOR    BL,CL
    TEST   BL,80h
    JZ     @L2
    OR     CH,40h
@L2:
    TEST   CH,8
    JZ     @NotBCD

    PUSH   CX
    MOV    BL,CL
    AND    BL,0Fh
    AND    CH,1
    ADD    BL,CH
    MOV    CH,DL
    AND    CH,0Fh
    CMP    BL,CH
    JGE    @L5
    SUB    AX,6
@L5:
    POP    CX
    CMP    AX,99h
    JLE    @NotBCD
    SUB    AX,60h
@NotBCD:
    TEST   AH,AH
    JNZ    @L6
    OR     CH,1
@L6:
    MOV    CL,AL
    POP    AX
    ADD    DI,3
    JMP    EmulateLoop
  End; { Asm }

(*
LFF:                 { Nothing }

  Asm
    MOV   BYTE PTR X,AL
    MOV   BYTE PTR Y,AH
    MOV   BYTE PTR A,CL
    MOV   BYTE PTR P,CH
    MOV   BYTE PTR S,DH
    SUB   DI,OFFSET AtariSeg
    MOV   WORD PTR Start,DI
  End; { Asm }
*)
GetOut:
  _P     := P;
  _A     := A;
  _X     := X;
  _Y     := Y;
  _S     := S;
  _Start := Start;
  If AVIFile.Opened Then AVIFile.Close;
End; { Interpret }

(*
Procedure Test;
Var
  I,J,K,L,M                      : Word;
  Iterations                     : Word;
  RR,T,UU,V                      : Real;
  A,X,Y,P,S                      : Byte;
  Clock                          : Boolean;
  Clock_Ticks                    : Integer;
  Number_Bytes                   : Integer;
  Work_Byte                      : Array[1..100] Of Byte;

Begin
  Write('How many bytes for test opcode: ');
  ReadLn(Number_Bytes);
  Write('How many normal clock ticks per iteration: ');
  ReadLn(Clock_Ticks);
  For I := 1 To Number_Bytes Do
  Begin
    Write('Enter test opcode #',I,': ');
    ReadLn(Work_Byte[I]);
  End;
  Iterations := 65530 Div Number_Bytes;
  WriteLn(Iterations,' iterations x ',Passes,' passes.');
  For I := 0 To Iterations - 1 Do
  Begin
    J := I * Number_Bytes;
    If (I And $F) = 0 Then
    Begin
      GotoXY(37,12);
      Write(J);
    End;
    For K := 1 To Number_Bytes Do
     Mem[Lo_Seg:J + K - 1] := Work_Byte[K];
  End; { For I }
  WriteLn;
{  FillChar(C64LoSeg^,-4,Chr(Work_Byte));} { Fill with 10000 NOP's for time test }
  I := Iterations * Number_Bytes;
  Mem[Lo_Seg:I] := BreakInstruction;
  MemW[Lo_Seg:I + 1] := $4350;
  WriteLn('Speed check...');

  Clock := True;   { I am shutting off the clock to achieve speed }

  P := 0;          { set up registers }
  X := 0;
  Y := 0;
  S := 0;
  A := 0;

{  InLine($FA);}                     { CLI }
  RR := Timer;
{  For I := 1 To Passes Do Interpret(0,0,0,0,0,0);}   { (0,P,A,X,Y,S) }

{ ------------------------------------------------------------------------- }

  FillChar(AtariSeg^,SizeOf(AtariSeg^),0);  { Blank area with nulls again }

{ ------------------------------------------------------------------------- }

  UU := Timer;
{  InLine($FB);}                     { STI }

  T := (UU - RR) / (Passes + 1);     { To account for call and loop, }
                                     { add 1 for every 50 passes }
  WriteLn;
  If Clock Then
  Begin
    V := (Clock_Ticks * Iterations) / T;
    Work_Real := (V / 1022727.0) * 100;
    WriteLn('Effective clock speed is ',V:10:2,' Hz.');
    WriteLn('Commodore 64 runs at     1022727    Hz.');
    WriteLn('You are runnning at ',Work_Real:6:2,'% of true speed.');
    WriteLn;
    WriteLn('Elapsed time is ',(UU - RR):6:2,' seconds.');
  End
  Else WriteLn('Clock was shut off.  Rate incalculable.');
  WriteLn;
  { each NOP is 2 clock cycles, so it is 20000 / time taken }
  FillChar(AtariSeg^,SizeOf(AtariSeg^),0);  { Blank area with nulls }
End; { Test }
*)


{$F+}
(*
  Procedure DeAllocSound; Far;
  Begin
{    If SBuf[1] <> Nil Then FreeMem(SBuf[1],SoundBufSize + 64);
    If SBuf[0] <> Nil Then FreeMem(SBuf[0],SoundBufSize * 2 + 64);}
  End; { DeAllocSound }
*)
  Procedure InitSound; Far;
  Var I,J,FP: LongInt;
  Begin
    SoundQueue_In  := 0;
    SoundQueue_Out := 0;
    SoundQueue_Num := 0;
    TIA_Sound_Init(Sample_Freq,Playback_Freq);
(*
    GetMem(SBuf[0],SoundBufSize * 2 + 64);
    GetMem(SBuf[1],SoundBufSize + 64);
    SoundBuf[0] := SBuf[0];
    SoundBuf[1] := SBuf[1];
    If Ofs(SoundBuf[0]^) <> 0 Then SoundBuf[0] := Ptr(Seg(SoundBuf[0]^) + (Ofs(SoundBuf[0]^) Shr 4) + 1,0);
    If Ofs(SoundBuf[1]^) <> 0 Then SoundBuf[1] := Ptr(Seg(SoundBuf[1]^) + (Ofs(SoundBuf[1]^) Shr 4) + 1,0);
    PhysAddr0 := SegOffToPhys(SoundBuf[0]);
    PhysAddr1 := SegOffToPhys(Ptr(Seg(SoundBuf[0]^),Ofs(SoundBuf[0]^) + SoundBufSize));
    FillChar(SoundBuf[0]^,SoundBufSize * 2,#0);
    FillChar(SoundBuf[1]^,SoundBufSize,#0);
    If XMS.Init Then
    Begin
      Config.DoSound := False;
      Exit;
    End;
    If XMS.GetFreeXM(TotalFree,LargestFree) Then
    Begin
      Config.DoSound := False;
      Exit;
    End;
    If Handle.AllocXM(32 * 16 * 4) Then
    Begin
      Config.DoSound := False;
      Exit;
    End;
    LockXMS := Not Handle.LockXM(PhysAddr);
    Update_TIA_Sound(AUDV0,15);
    For I := 0 To 15 Do
    Begin
      Update_TIA_Sound(AUDC0,I);
      For J := 0 To 31 Do
      Begin
        Update_TIA_Sound(AUDF0,J);
        ProcessSound(SoundBuf[0],SoundBufSize);
{        TIA_Process1(SoundBuf[0],SoundBufSize);}
        FP := (I * 32 + J) * SoundBufSize;
        If LockXMS Then XMS.RawMove(PhysAddr + FP,SegOffToPhys(SoundBuf[0]),Even(SoundBufSize)) Else
        Begin
          MovePacket.Length     := SoundBufSize;
          MovePacket.srcHandle  := 0;
          MovePacket.srcOffset  := DWord(SoundBuf[0]);
          MovePacket.destHandle := Handle.Handle;
          MovePacket.destOffset := FP;
          XMS.MoveXM(MovePacket);
        End;
      End; { For J }
    End; { For I }
    Update_TIA_Sound(AUDV0,0);
    Update_TIA_Sound(AUDC0,0);
    Update_TIA_Sound(AUDF0,0);
    FillChar(SoundBuf[0]^,SoundBufSize * 2,#0);
    FillChar(SoundBuf[1]^,SoundBufSize,#0);
*)
  End; { InitSound }
{$F-}

Procedure Emulate;
{Type
  RGB = Record
    R,G,B: Byte;
  End;}

Var
  F         : File;
{  TextFile  : Text;}
{  Pal       : Array[0..127] Of RGB;}
  I,J,K     : Word;
{  B1,B2     : Word;}
  St        : String[80];
  St1       : String[80];
  Start     : Word;
  T1,T2     : Real;
  P,A,X,Y,S : Byte;
  Buffer    : Pointer;
  Loaded    : LongInt;
  FP        : LongInt;
  WorkCh    : Char;
  Blaster   : String;
  _SHL      : LongInt;
  _SHR      : LongInt;
  Param     : String[80];
  M0,M1,M2  : Integer;
  CurPath   : String;

  Procedure LoadROM(Address,Amount: Word);
  Begin
    BlockRead(F,AtariSeg[Address],Amount);
  End; { LoadROM }


  Procedure ExtractWord(Var St: String; Blaster: String; I: Word);
  Var Ch: Char;
  Begin
    St := '';
    Repeat
      Ch := Blaster[I];
      Inc(I);
      If Ch <> ' ' Then St := St + Ch;
    Until (Ch = ' ') Or (I > Length(Blaster));
  End; { ExtractWord }

Begin
  Pos200 := NoPosSet;
  Pos204 := NoPosSet;
  Pos215 := NoPosSet;
  Pos250 := NoPosSet;
  Pos305 := NoPosSet;
  New(SetAdjust);
  Game.Controller := crJoystick;
{  LockXMS          := False;}
{  MouseInit;}
{  If MouseVisible Then ToggleMouseVisibility;}
  Top           := 0;
  Sel           := 0;
{  SoundBuf[0]   := Nil;
  SoundBuf[1]   := Nil;
  SBuf[0]       := Nil;
  SBuf[1]       := Nil;}

  { Initialize/load the config file }

  InitConfig(Config,SoundBufSize,Playback_Freq,Version);

{  MouseInit(Config.MaxCols,Config.MaxRows,2,1,False);}

  SoundBufSize  := Config.SoundBufSize;
{
  JoyCenterX    := Config.JoyCenterX;
  JoyCenterY    := Config.JoyCenterY;
  JoyMinX       := (JoyCenterX  + Config.MinJoyX) Div 2;
  JoyMinY       := (JoyCenterY  + Config.MinJoyY) Div 2;
  JoyMaxX       := (JoyCenterX  + Config.MaxJoyX) Div 2;
  JoyMaxY       := (JoyCenterY  + Config.MaxJoyY) Div 2;
  JoyCenterX2   := Config.JoyCenterX2;
  JoyCenterY2   := Config.JoyCenterY2;
  JoyMinX2      := (JoyCenterX2 + Config.MinJoyX2) Div 2;
  JoyMinY2      := (JoyCenterY2 + Config.MinJoyY2) Div 2;
  JoyMaxX2      := (JoyCenterX2 + Config.MaxJoyX2) Div 2;
  JoyMaxY2      := (JoyCenterY2 + Config.MaxJoyY2) Div 2;
}
  Playback_Freq := Config.PlaybackRate;
(*
  { Set up the BCD table }

  For I := 0 To 255 Do
  Begin
    BCDTable[0,I] := (I Shr 4) * 10 + (I And $F);
    BCDTable[1,I] := (((I Mod 100) Div 10) Shl 4) Or (I Mod 10);
  End; { For I }
*)
  { Set up the masks }

  Asm
    CLI
    SUB   DX,DX
@L1:
    MOV   AX,DX
    MOV   BX,DX
    RCR   AL,1
    RCL   AH,1
    RCR   AL,1
    RCL   AH,1
    RCR   AL,1
    RCL   AH,1
    RCR   AL,1
    RCL   AH,1
    RCR   AL,1
    RCL   AH,1
    RCR   AL,1
    RCL   AH,1
    RCR   AL,1
    RCL   AH,1
    RCR   AL,1
    RCL   AH,1
    MOV   BYTE PTR BitSwap[BX],AH
    INC   DX
    CMP   DX,256
    JL    @L1
    STI
  End; { Asm }
  For I := 0 To 228 Do Div3[I] := I Div 3;
  _SHR := $80000;
  _SHL := 1;
  For I := 0 To 19 Do
  Begin
    BitTest[I]      := _SHR;
    BitTest[I + 20] := _SHR;
    BitTest[I + 64] := _SHR;
    BitTest[I + 84] := _SHL;
    Asm
      DB    _32BIT_OPERAND
      SHL   WORD PTR _SHL,1
      DB    _32BIT_OPERAND
      SHR   WORD PTR _SHR,1
    End; { Asm }
(*
    BitTest[I]      := $80000 Shr I;
    BitTest[I + 20] := $80000 Shr I;
    BitTest[I + 64] := $80000 Shr I;
    BitTest[I + 84] := LongInt(1) Shl I;  { Need the type cast!!! }
*)
  End; { For I }

  InitMissileTable(MissileTable);

  InitByteShift(ByteShift);

  FillChar(ExtraAdd,SizeOf(ExtraAdd),#0);
(*
  ExtraAdd[-8] := 14;       { For Escape From the MindMaster }
  ExtraAdd[-2] := 8;        { For Double Dragon }
{  ExtraAdd[-1] := 7;
  ExtraAdd[0]  := 6;
  ExtraAdd[1]  := 5;
  ExtraAdd[2]  := 4;
  ExtraAdd[3]  := 3;}
  ExtraAdd[4]  := 2;        { For Grand Prix }
{  ExtraAdd[5]  := 1;}
*)
{  For K := 5 DownTo -8 Do ExtraAdd[K] := 6 - K;}

  For M0 := -53 To 7 Do ExtraAdd[M0] := (M0 + 53) Shr 2;


{  For M0 := -54 To 8 Do ExtraAdd[M0] := (M0 + 54) Shr 2;}


  For I := 0 To 15 Do   { Old motion }
  Begin
    For J := 0 To 15 Do { New motion }
    Begin
      For K := 0 To 75 Do { Position }
      Begin
        M0 := I;
        Asm
          SHL   WORD PTR M0,12
          SAR   WORD PTR M0,12
        End; { Asm }
        M1 := J;
        Asm
          SHL   WORD PTR M1,12
          SAR   WORD PTR M1,12
        End; { Asm }
        M0 := -M0;   { Left = negative }
        M1 := -M1;   { Left = negative }
  {
        If K < 0 Then
        Begin
          Inc(K,(J - 2) Div 4);
          If K > -1 Then K := -1;
        End
        Else If K > 0 Then
        Begin
          Dec(K,(J - 2) Div 4);
          If K < 1 Then K := 1;
        End;
  }
  {      Dec(K,2);}

  (*      If{ (J In [33..36]) And} (K = -2) Then Dec(K);*)
  (*
        Case J Of
          9..12: If K > 7  Then K := 7;
         13..16: If K > 6  Then K := 6;
         17..20: If K > 5  Then K := 5;
         21..24: If K > 4  Then K := 4;
         25..28: If K > 3  Then K := 3;
         29..32: If K > 2  Then K := 2;
         33..36: If K > 1  Then K := 1;
         37..40: If K > 0  Then K := 0;
         41..44: If K > -1 Then K := -1;
         45..48: If K > -2 Then K := -2;
         49..52: If K > -3 Then K := -3;
         53..56: If K > -4 Then K := -4;
         57..60: If K > -5 Then K := -5;
         61..64: If K > -6 Then K := -6;
         65..68: If K > -7 Then K := -7;
        End; { Case }
  *)
  (*
        Case J Of
          9..12: If K < -7 Then K := -7;
         13..16: If K < -6 Then K := -6;
         17..20: If K < -5 Then K := -5;
         21..24: If K < -4 Then K := -4;
         25..28: If K < -3 Then K := -3;
         29..32: If K < -2 Then K := -2;
         33..36: If K < -1 Then K := -1;
         37..40: If K < 0  Then K := 0;
         41..44: If K < 1  Then K := 1;
         45..48: If K < 2  Then K := 2;
         49..52: If K < 3  Then K := 3;
         53..56: If K < 4  Then K := 4;
         57..60: If K < 5  Then K := 5;
         61..64: If K < 6  Then K := 6;
         65..68: If K < 7  Then K := 7;
        End; { Case }
  *)

  {      SetAdjust[J * 16 + I] := K;}

        Case K Of
          0..17: M2 := 0;
         18..47: Begin
                   If M1 <= 0 Then
                   Begin
                     If M0 <= 0 Then M2 := M1 - M0
                     Else If M0 < 8 Then
                     Begin
                       If K < 18 + (8 - M0) * 4 Then M2 := M1 - M0 Else M2 := 0;
                     End;
                   End
                   Else
                   Begin
                     If M0 <= 0 Then
                     Begin
                       If K < 18 + (8 - M1) * 4 Then M2 := M1 - M0 Else M2 := 0;
                     End
                     Else If M0 < 8 Then
                     Begin
                       If K < 18 + (8 - M0) * 4 Then M2 := M1 - M0 Else M2 := 0;
                     End;
                   End;
                 End;
         48..75: Begin
                   If (M1 <= 0) And (M0 <= 0) Then
                   Begin
                     If K < 48 + (0 - M0) * 4 Then
                     Begin
                       M2 := M1 - M0;
                       If (M2 > 0) And (K > 48 + (0 - M1) * 4) Then M2 := 0;
                     End
                     Else M2 := 0;
                   End
                   Else M2 := 0;
                 End;
        End; { Case }

        { Copy all cases where M1 = 8 (i.e. J = 8) }

        If J = 8 Then SetAdjust^[K * 256 + J * 16 + I] :=
                      SetAdjust^[K * 256 + J * 16 + I - 16] Else
         SetAdjust^[K * 256 + J * 16 + I] := M2;
        If I = 8 Then SetAdjust^[K * 256 + J * 16 + I] := 0;



  {
        If (J <= 53) Or (I <= 1) Or (I >= 15)
         Then SetAdjust[J * 16 + I] := K
         Else SetAdjust[J * 16 + I] := 0;
  }

  {      SetAdjust[J * 16 + I] := Round(K * (66 - J) / 66);}
      End; { For K }
    End; { For J }
  End; { For I }




{  For K := 5 DownTo -68 Do ExtraAdd[K] := 6 - K;}

{  DeAllocSound;}
  InitSound;
  Blaster := GetEnv('BLASTER');
  If Blaster <> '' Then
  Begin
    For I := 1 To Length(Blaster) Do Blaster[I] := UpCase(Blaster[I]);
    Blaster := Trim(Blaster);
  End;
  If Blaster <> '' Then
  Begin

    { Get the port number }

    I := Pos('A',Blaster) + 1;
    ExtractWord(St,Blaster,I);
    I := 1;
    _IO_Addx := 0;
    For J := 1 To Length(St) Do
    Begin
      WorkCh := UpCase(St[Length(St) - (J - 1)]);
      If WorkCh In ['0'..'9']
       Then _IO_Addx := _IO_Addx + I * (Ord(WorkCh) - Ord('0'))
       Else _IO_Addx := _IO_Addx + I * (Ord(WorkCh) - Ord('A') + 10);
      I := I * 16;
    End; { For J }

    { Get the IRQ }

    I := Pos('I',Blaster) + 1;
    ExtractWord(St,Blaster,I);
    Val(St,_Intr_Num,I);

    { Get the DMA }

    I := Pos('D',Blaster) + 1;
    ExtractWord(St,Blaster,I);
    Val(St,_DMA,I);
  End
  Else
  Begin
    _IO_Addx      := SBPort;
    _Intr_Num     := SBInt;
    _DMA          := SBDMA;
  End;

  UseMenu := False;
  T1      := 0;
  T2      := 0;

  Game.Controller  := crJoystick;
  Debugger    := False;
  Repeat
    Game.Palette     := 0;
    Game.CurrentBank := 0;
    Game.BankStart   := $1000;
    Game.BankSize    := 1024;    { Size in dwords }
    Game.Cart        := ct4k;
    Game.TigerLimit  := 0;
    Game.SCLimit     := 0;
    FillChar(AtariSeg,SizeOf(AtariSeg),#0);  { Blank them with nulls }
    FillChar(Game.BankSwitch,SizeOf(Game.BankSwitch),#0);
    ClrScr;
    Game.MegaBoyNum := 0;

    GetDir(0,CurPath);
    If FileExists('PCAE.PA0') Then
    Begin
      Assign(F,'PCAE.PA0');
      Reset(F,1);
      BlockRead(F,Pal,SizeOf(Pal));
      Close(F);
    End
    Else
    Begin
      ErrorFileNotFound(CurPath,'PCAE.PA0');
      Exit;
    End;

    If FileExists('PCAE.PA1') Then
    Begin
      Assign(F,'PCAE.PA1');
      Reset(F,1);
      BlockRead(F,Pal1,SizeOf(Pal1));
      Close(F);
    End
    Else
    Begin
      ErrorFileNotFound(CurPath,'PCAE.PA1');
      Exit;
    End;

    If (ParamCount = 0) Or
       ((ParamCount > 0) And Not FileExists(ParamStr(1)))
     Then ROMFileName := Menu(Config,Version,Top,Sel,
                              Playback_Freq,
                              Debugger,Config.DoSound,UseMenu,
                              Pos200,Pos204,Pos215,Pos250,Pos305,ProfileRec,
                              Game)
     Else ROMFileName := ParamStr(1);

    If (ROMFileName <> '') And FileExists(ROMFileName) Then
    Begin
      If Pos('.PAL',UpperCase(ROMFileName)) <> 0 Then Game.Palette := 1;
      Disasm := False;
      If ParamCount > 1 Then
      Begin
        For I := 2 To ParamCount Do
        Begin
          Param := UpperCase(ParamStr(I));
          If Param = 'PROFILE' Then
          Begin
            Game.Cart := FindProfile(ROMFileName,Game.Controller,Pos200,Pos204,Pos215,Pos250,Pos305,ProfileRec);
            Case Game.Cart Of
              ct8k: Param := 'BANK';
             ct16k: Param := 'BANK16';
       ctSuperChip: Param := 'BANKSC';
      ctParkerBros: Param := 'BANKP';
        ctMNetwork: Param := 'BANKM';
        ctStarpath: Param := 'BANKSP';
             ctCBS: Param := 'BANKC';
     ctTigerVision: Param := 'BANKT';
        ctPitfall2: Param := 'BANK2';
      ctActivision: Param := 'BANKA';
         ctMegaBoy: Param := 'BANKG';
           ct32In1: Param := 'BANK3';
            Else
              Param := '';
            End; { Case }
          End;
          If Param = 'DISASM' Then Disasm := True;
          If Param = 'BANK'   Then SetBankInfo('8',Game);
          If Param = 'BANKC'  Then SetBankInfo('C',Game);
          If Param = 'BANK16' Then SetBankInfo('6',Game);
          If Param = 'BANKSC' Then SetBankInfo('R',Game);
          If Param = 'BANKSP' Then SetBankInfo('S',Game);
          If Param = 'BANKA'  Then SetBankInfo('A',Game);
          If Param = 'BANKP'  Then SetBankInfo('P',Game);
          If Param = 'BANKM'  Then SetBankInfo('M',Game);
          If Param = 'BANKT'  Then SetBankInfo('T',Game);
          If Param = 'BANK2'  Then SetBankInfo('2',Game);
          If Param = 'BANKG'  Then SetBankInfo('G',Game);
          If Param = 'BANK3'  Then Game.Cart := ct32In1;
          If Copy(Param,1,8) = '32IN1NUM' THen
          Begin
            St1 := Param;
            St1 := Copy(St1,9,Length(St1) - 8);
            Val(St1,Game.MegaBoyNum,J);
            If J <> 0
             Then Game.MegaBoyNum := 0
             Else Game.MegaBoyNum := Game.MegaBoyNum And $1F;
          End;

          If Param = 'DEBUG'   Then Debugger   := True;
          If Param = 'KB'      Then Game.Controller := crKeyboard;
          If Param = 'BOOSTER' Then Game.Controller := crBooster;
          If Param = 'INDY500' Then Game.Controller := crDriving;
          If Param = 'VTP'     Then Game.Controller := crVTP;
          If Param = 'PADDLE'  Then Game.Controller := crPaddle;
          If Copy(Param,1,5) = 'FRAME' Then
          Begin
            St1 := Param;
            St1 := Copy(St1,6,Length(St1) - 5);
            Val(St1,Config.FrameRate,J);
            If J <> 0 Then Config.FrameRate := 0;
            If Config.FrameRate < 0 Then Config.FrameRate := 0;
          End;
        End;
      End;
      Assign(F,ROMFileName);
      Reset(F,1);
      Game.ROMSize := FileSize(F);
      If Game.ROMSize > 65520 Then Game.ROMSize := 65520;
      If (Game.Cart = ctMNetwork) And (Game.ROMSize <= 65520 - 2048)
       Then GetMem(ROMBackup,Game.ROMSize + 2048)
       Else GetMem(ROMBackup,Game.ROMSize);
      If Game.ROMSize < 4096 Then
      Begin
        I := 0;
        While I * Game.ROMSize < 4096 Do
        Begin
          Seek(F,0);
          If (I + 1) * Game.ROMSize <= 4096
           Then Loaded := Game.ROMSize
           Else Loaded := 4096 - I * Game.ROMSize;
          LoadROM($1000 + I * Game.ROMSize,Loaded);
          Inc(I);
        End; { While }
      End
      Else LoadROM($1000,4096);
      If (Game.ROMSize = 8192) And (Game.Cart = ct8k) Then
      Begin
        Seek(F,4096);
        LoadROM($1000,4096);
      End;

{
      If (ROMSize = 16384) And (Cart = ct16k) Then
      Begin
        Seek(F,3 * 4096);
        LoadROM($1000,4096);
        Game.CurrentBank := 8;
      End;
}


{
      If Cart = ctMegaBoy Then
      Begin
        Seek(F,Game.MegaBoyNum * 2048);
        LoadROM($1000,2048);
        Seek(F,Game.MegaBoyNum * 2048);
        LoadROM($1800,2048);
      End;
}
      If Game.Cart = ct32In1 Then
      Begin
        Seek(F,Game.MegaBoyNum * 2048);
        LoadROM($1000,2048);
        Seek(F,Game.MegaBoyNum * 2048);
        LoadROM($1800,2048);
      End;
      If (Game.ROMSize >= 8192) And (Game.Cart = ctParkerBros) Then
      Begin
        Seek(F,7168);
        LoadROM($1C00,1024);
        Game.BankSize := 256;    { Size in dwords }
      End;
      If Game.Cart = ctTigerVision Then
      Begin
        Seek(F,Game.ROMSize - 2048);
        Game.TigerLimit := (Game.ROMSize - 2048) Shr 11;
        LoadROM($1800,2048);
      End;
{
      If Activision Then
      Begin
        Seek(F,4096);
        LoadROM($1000,4096);
      End;
}
      If (Game.ROMSize = 16384) And (Game.Cart = ctMNetwork) Then
      Begin
        Seek(F,14 * 1024);
        LoadROM($1800,2048);
        Game.BankSize := 512;    { Size in dwords }
      End;

      { Load 2nd 4k for SuperChip }

      If Game.Cart = ctSuperChip Then
      Begin
        Seek(F,4 * 1024);
        LoadROM($1000,4096);
        I := Game.ROMSize Shr 12;
        Case I Of
           0..2: J := $1FF8;
           3..4: J := $1FF6;
           5..8: J := $1FF4;
          9..15: J := $1FEC;
        End; { Case }
        For I := J To J + (Game.ROMSize Shr 12) - 1 Do Game.BankSwitch[I] := $40 + (I - J);
      End;
(*
      If (ROMSize = 16384) And (Game.BankSize = 1024 - 64) Then
      Begin
        Seek(F,4 * 1024);
        LoadROM($1000,4096);
      End;
      If ROMSize = 32768 Then
      Begin
        Game.BankSwitch[$1FF4] := 1 + $40;
        Game.BankSwitch[$1FF5] := 5 + $40;
        Game.BankSwitch[$1FF6] := 9 + $40;
        Game.BankSwitch[$1FF7] := 13 + $40;
        Game.BankSwitch[$1FF8] := 17 + $40;
        Game.BankSwitch[$1FF9] := 21 + $40;
        Game.BankSwitch[$1FFA] := 25 + $40;
        Game.BankSwitch[$1FFB] := 29 + $40;
        For J := $1000 To $107F Do Game.BankSwitch[J] := $5F;
      End;
*)
      Seek(F,0);
      If Game.Cart <> ctStarpath
       Then BlockRead(F,ROMBackup^,Game.ROMSize)
       Else LoadStarpath(F,ROMBackup,Game.ROMSize);
      If (Game.Cart In [ctMegaBoy,ct32In1]) And (FileSize(F) = Game.ROMSize + 16) Then BlockRead(F,Game.MegaBoy,16);
      Close(F);
      If Disasm Then Disassemble(AtariSeg,Game.BankSwitch,ROMBackup,Game.Cart,Game.ROMSize);

{      Go_Mode($13);}

{      SetPalette;}

{      FillChar(FMChanOn,SizeOf(FMChanOn),#0);}
{      FillChar(FMFeedBack,SizeOf(FMFeedBack),#0);}
{      FillChar(FMBaseLevel,SizeOf(FMBaseLevel),#0);}
{      FillChar(FMScale,SizeOf(FMScale),#0);}
      FillChar(Game.FMFreq,SizeOf(Game.FMFreq),#0);
      FillChar(Game.FMRealScale,SizeOf(Game.FMRealScale),#0);
      FillChar(Game.FMVoc,SizeOf(Game.FMVoc),#0);

{
      InitFM;
      SetFM(0,True);
      SetFM(1,True);
      SetFM(2,True);
      SetFM(3,True);
}
{      WriteFM(1,$20);}



      If Game.Cart <> ctStarPath
       Then Start := MemW[Seg(AtariSeg):Ofs(AtariSeg) + $1FFC] And $1FFF
       Else Start := MemW[Seg(ROMBackup^):Ofs(ROMBackup^) + $2000] And $1FFF;
      If (Game.Cart = ctPitfall2) And (Game.ROMSize = 8192 + 2048 + 255) Then
       FillDump(ROMBackup);

      If Game.Cart = ctStarPath Then
      Begin
        SPSearch := 0;
        Asm
          LES   DI,DWORD PTR ROMBackup
          MOV   BL,ES:[DI+2002h]


{
          LES   DI,DWORD PTR AtariSeg
          MOV   BYTE PTR ES:[DI+80h],BL
}
          MOV   BYTE PTR AtariSeg[80h],BL
{          MOV   BYTE PTR ES:[DI+1FF8h],BL}

          MOV   DL,BL
{          MOV   BH,0F0h}
          MOV   WORD PTR Game.StarpathLastAddr,0 {BX}
          SHR   BL,1
          AND   BL,0Eh
          SUB   BH,BH

          MOV   AX,WORD PTR SP1[BX]
          MOV   CX,200h

{          LES   DI,DWORD PTR AtariSeg}

          MOV   DI,DS
          MOV   ES,DI
          MOV   DI,OFFSET AtariSeg

          PUSH  DS
          LDS   SI,DWORD PTR ROMBackup
          ADD   DI,1000h
          ADD   SI,AX
          CLD
          DB    _32BIT_OPERAND
          REP   MOVSW
          POP   DS

          MOV   AX,WORD PTR SP2[BX]
          MOV   CX,200h

{          LES   DI,DWORD PTR AtariSeg}

          MOV   DI,DS
          MOV   ES,DI
          MOV   DI,OFFSET AtariSeg

          PUSH  DS
          LDS   SI,DWORD PTR ROMBackup
          ADD   DI,1800h
          ADD   SI,AX
          CLD
          DB    _32BIT_OPERAND
          REP   MOVSW
          POP   DS

{          LES   DI,DWORD PTR AtariSeg}
          MOV   BYTE PTR Game.SPBankNum,DL{ES:[DI+1FF8h],DL}
        End; { Asm }
      End;
      P := $20;
      A := 0;
      X := 0;
      Y := 0;
      S := $FF;{0;}
      FillChar(Key,SizeOf(Key),#0);
      InitEmulator;
      Game.OldByte  := AtariSeg[Start];
      Game.OldStart := Start;
      Go_Mode($13);
      FillChar(Mem[$A000:0],65535,0);


      If Game.Palette = 0 Then SetPalette(Pal) Else SetPalette(Pal1);


      Game.Hi3 := 0;

      SPBoot   := False;
      HaltLine := 999;
      Case (Config.MaxRows - 200) Of
         0: Game.UserSetPos := Pos200;
         4: Game.UserSetPos := Pos204;
        15: Game.UserSetPos := Pos215;
        50: Game.UserSetPos := Pos250;
       105: Game.UserSetPos := Pos305;
      Else
        Game.UserSetPos := Pos200;
      End; { Case }

      { There is no initial break expression.  Initialize the pointer. }

      BreakExpColl := Nil;

      Repeat
        If Game.OldStart <> 0 Then
        Begin
          Game.OldByte  := AtariSeg[Game.OldStart];
          If Debugger Then AtariSeg[Game.OldStart] := BreakInstruction;
        End;
{        KBFlag  := Mem[0:$417];}
{        InitKeyboard;}
        If Config.DoSound Then
        Begin
          InitSound;

          ProcessPf2 := (Game.Cart = ctPitfall2);
{          ProcessPf2 := False;}

{          InitFM;}

{          SetFM(0,True);}
{          SetFM(1,True);}
{          SetFM(2,True);
          SetFM(3,True);}

          Delay(10);

          Tia_sound_init(sample_freq,playback_freq);
{
          FillChar(SoundBuf[0]^,SoundBufSize * 2,#0);
          FillChar(SoundBuf[1]^,SoundBufSize,#0);
}
{          OpenSB(playback_freq,num_bufs,SoundBufSize);}



          _CTV_Card_Here;



          _CTV_Detect;
(*
          { Reset the Sound Blaster }

          Port[_IO_Addx + 6] := 1;
          Delay(1);
          Port[_IO_Addx + 6] := 0;
          J := 0;
          Repeat
            Repeat
            Until (Port[_IO_Addx + $E] And $80) <> 0;
            I := Port[_IO_Addx + $A];
            Inc(J);
          Until (I = $AA) Or (J > 100);
          Delay(2);
*)
          _Voice_Status := 0;

{
          ExitKeyboard;
          TextMode(C80);
          WriteLn('About to start sound...hit a key');
          WriteLn;
          WriteLn('Free memory = ',MemAvail);
          WriteLn;
          WriteLn('SoundBuf[0] = ',HexWord(Seg(SoundBuf[0]^)),':',HexWord(Ofs(SoundBuf[0]^)));
          WriteLn('SoundBuf[1] = ',HexWord(Seg(SoundBuf[1]^)),':',HexWord(Ofs(SoundBuf[1]^)));
          ReadKey;
}
          BufPlaying := 0;
          BufToFill  := 0;
{          ProcessPF2 := False;}
          FillChar(Pf2Buf,SizeOf(Pf2Buf),#0);
          FillChar(SmallSoundBuf,SizeOf(SmallSoundBuf),#0);

          FillChar(Old_WaveLen,SizeOf(Old_WaveLen),#255);
          FillChar(Old_Pulse,SizeOf(Old_Pulse),#255);
          FillChar(Old_Phase,SizeOf(Old_Phase),#255);
          FillChar(Old_Signal,SizeOf(Old_Signal),#255);
          FillChar(Old_Wave,SizeOf(Old_Wave),#255);

          _CTV_Output(PSmallSoundBuf,256,Playback_Freq);

{          _CTV_Output(SoundBuf[1],SoundBufSize,Playback_Freq);}



{
          WriteLn('Sound started.  Hit a key');
          ReadKey;
          Go_Mode($13);
          InitKeyboard;
}
        End;


{        Go_Mode($93);}
        If Config.MaxCols = 160 Then
        Begin
          If Config.GameResolution <= gr160x305A
           Then Go_Mode($8D)
           Else Go_Mode($93);
          If Game.Palette = 0 Then SetPalette(Pal) Else SetPalette(Pal1);
          If Config.GameResolution <= gr160x305A
           Then Set160ColsA
           Else Set160ColsB;
          If Config.MaxRows <> 200 Then SetRows(Config.MaxRows);
          Game.MaxRows := Config.MaxRows;
        End
        Else
        Begin
          If Config.MaxRows <> 200 Then
          Begin
            Go_Mode($93);
            If Game.Palette = 0 Then SetPalette(Pal) Else SetPalette(Pal1);
            SetRows(204);
            Game.MaxRows := 204;
          End
          Else Game.MaxRows := 200;
        End;

        MouseInit(Config.MaxCols,Config.MaxRows,2,1,False);

{        FillChar(SendBuf^,64000,#0);}
        InitKeyboard;
        Time0   := Clock;
        TimeErr := 0;

        If Config.DoSound Then
        Begin
{          SetVolume(0,Game.FMRealScale[0]);
          SetFrequency(0,Game.FMFreq[0]);
          SetVoice(0,Game.FMVoc[0]);
          SetVolume(1,Game.FMRealScale[1]);
          SetFrequency(1,Game.FMFreq[1]);
          SetVoice(1,Game.FMVoc[1]);}
        End;
{
        NumFrames    := 0;
        ElapsedTime0 := Clock;
}

        MaxScan := 250;
        If ((Game.Palette <> 0) And (Config.MaxRows >= 215)) Or
           (Config.MaxRows > 215) Then MaxScan := 275;
        If Config.MaxRows >= 250 Then MaxScan := 330;

        InterfaceHandler^.ActivateInterfaces;

        Interpret(Start,P,A,X,Y,S);   { (0,P,A,X,Y,S) }

        InterfaceHandler^.DeactivateInterfaces;
{
        ElapsedTime1 := Clock - ElapsedTime0;
}
        Key[kESC] := 0;
        ExitKeyboard;

        MouseClose;

        If Config.MaxCols = 160 Then
        Begin
          Asm
            MOV   AX,93h
            INT   10h
          End; { Asm }
          If Game.Palette = 0 Then SetPalette(Pal) Else SetPalette(Pal1);
        End;

        If Config.DoSound Then
        Begin
          _CTV_Halt;
          _CTV_Uninstall;
          ProcessPf2 := False;
        End;
        If Game.OldStart <> 0 Then AtariSeg[Game.OldStart] := Game.OldByte;
        HaltLine := 999;
      Until (Not Debugger) Or Not
       Debug(@AtariSeg,Start,P,A,X,Y,S,
             ROMBackup,Config.GameResolution,HaltLine,BreakExpColl,Game);
{             Game.FixTimer,Game.FixTimerNum);
             Game.TimerElapsed + ((Game.TIA_Count + 68) Div 3) + Game.AddCycle,AtariSeg[INTTIM1]);}
             {Game.LineDelay,Game.LineDelayMax,0,0);}

{      If Config.UseRealControllers Then Port[Config.LPT1Port + 2] := $B;}

      { Get rid of the break expresion PCollection }

      If BreakExpColl <> Nil Then
      Begin
        Dispose(BreakExpColl,Done);
        BreakExpColl := Nil;
      End;

      If Game.Cart = ctMNetwork Then FreeMem(ROMBackup,Game.ROMSize + 2048) Else FreeMem(ROMBackup,Game.ROMSize);
      TextMode(C80);
    End;
  Until Not UseMenu;
  TextMode(C80);
{  If LockXMS Then Handle.UnlockXM;
  Handle.FreeXM;
  DeAllocSound;}
  Dispose(SetAdjust);
End; { Emulate }

Begin
  AVIFile.Init;
  Handle_IO_Latch_Ptr := @Handle_IO_Latch;
  ProcessPf2 := False;
  PFillBuffer := @FillBuffer;
  PSmallSoundBuf := @SmallSoundBuf;
  If (LongInt(PSmallSoundBuf) And 3) <> 0 Then
   PSmallSoundBuf := Pointer((LongInt(PSmallSoundBuf) + 4) And $FFFFFFFC);


{  AsyncInit(2);}
{  GetMem(SendBuf,64000);
  FillChar(SendBuf^,64000,#0);}
{
  Assign(LogFile,'PCAE.LOG');
  ReWrite(LogFile);
}
  FileMode := 0;
  TextMode(C80);
  TextColor(LightGray);
  ClrScr;
  WriteLn('Atari 2600 Emulator');
  WriteLn;
  WriteLn('Setting up system');
  WriteLn;
  ASeg := @AtariSeg;

  Emulate;
{
  Close(LogFile);
}


{  FreeMem(SendBuf,64000);}
{  AsyncShutDown;}
{  WriteLn('Average speed = ',(NumFrames / (ElapsedTime1 / 1000)):10:6,' FPS');}
  If AVIFile.Opened Then AVIFile.Close;
End.

// ----------------------------------------------------------------------
// PCAE - PC Atari Emulator - Atari 2600 Emulator for MS-DOS
// Copyright (C) 2000 John Dullea
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
// ----------------------------------------------------------------------
